
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program sfinder
!__________________________________________________________________________________________________________________________________
!
! Find sources in a set of single-scale detection images.
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!
! Return codes:
!
!   10-29 ... problems with the input parameters
!   30-49 ... non-existing files or directories
!   50-69 ... problems with reading/writing files or values
!   70-89 ... problems with memory allocation
!   90-99 ... other code-specific problems
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       lunix, lfname1, lfname2, lfname3, lfname4, lfname5, lfname6, lfname7, laccelerate, ledgeszero, lcornerpos, l1st
     &             , lfoots, ldebug, lfname, lallsourcesdone, lfnvers, ltiming, ltime, lfoundold, linside, ldone
                    !!!, lnotsource
                          
       character*2   cnscale, cnscaleo, cnscaleoo, cnscalen
       character*3   cl, dot
       character*5   chan, cnx1, cnx1o, cny1, cny1o
       character*6   cfitsversion, csscale, csscaleo, csscaleoo, csscalen, cnobj, cverbose, cfmt
       character*7   cns, cne, cnn, cng, clibname, cx, cy, cnx, cny
       character*8   ctime, cpix, cpixx, cfpptime
       character*10  cdate
       character*11  crotangle
       character*12  restname
       character*21  compda, funits
       character*80  object, creator, ctype1, ctype2, bunit, cwave, history
       character*141 getstitle
       character*300 cfgline(1000)
       character*500 imagename, oldsegm, newsegm, catname, oldcat, segmentl, imagel, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8
     &             , arg9, argA, argB, argC, argD, argE, oldimage, ooldimage, footprint, individs, cfgfile, segmentln, imageln
     &             , swcatname, filewithswnames, sswname, versfile, domaskname, simagename, soldimage, sooldimage, snewimage
     &             , unrotname
       character*999 cline, cscales, cproblem

       integer       lastc, lasts, isp1, ifn, ins, isk, iik, ndate, iotty, nx, ny, irc, lb, ia1, ia2, ia3, ia4, ia5, ia6, ia7, lpix
     &             , blank, nextr, nextrmax, i, j, lev, m, nlevs, iocat, n, is, js, ios, nhead, ioc, iu, nscale, nscaleo
     &             , idot1, idot2, im1, jm1, ip1, jp1, nextro, ioi, ind, lcns, ifp, isl, lcfg, idm, kk, ncfglines, k
     &             , fu, nextroldscale, iskn, iikn, ia8, nmaxscale4newsrc, nextrnew, ns1min, ia9, iaA, iaB, iswc, idot3, jsa
     &             , noisesources, iss, nfiles, nheadf, ifwn, lver, n1xmin, n2xmax, n1ymin, n2ymax, iaC, ioo, l, ktouch, nlevsmin
     &             , isfn, isoi, isoo, maxtouch, nxco, nyco, icp, n1y, n2y, nxminn, nxmaxn, nyminn, nymaxn, imiddle, ncn, nscaleoo 
     &             , jmiddle, nlevsact, wchours, wcmins, wcsecs, cpuhours, cpumins, cpusecs, iaD, imx, jmx, isa, nxn, nyn, iun
     &             , lnx1o, lny1o, nx1, ny1, icre, iaE, ncx, ncy, nscalen, nscalenc, isn, icl, nmaxscale4sfinder, ncne, ncnn, ncng
!!     &             , nr, l1, l2, m1, m2

       parameter   ( iotty = 6, nextrmax = 30000, maxtouch = 1000 )

       real          fitsvers
       
       real*8        cpu_filling_old, cpu_filling_new, cput_filling_old, cput_filling_new, cpu_checkisolation, cpu_measuring
     &             , cput_checkisolation, cput_measuring, cpu_identifynoise, cput_identifynoise, cpu_measurespecial
     &             , cput_measurespecial, cpu_sum, cpu_checkmerging, cput_checkmerging, cpu_reading_images, cpu_writing_images
     &             , cput_reading_images, cput_writing_images, timer, cputot, wctot

       real*8        walt_filling_old, walt_filling_new, walt_checkisolation, walt_measuring, walt_identifynoise
     &             , walt_measurespecial, wal_sum, walt_checkmerging, walt_reading_images, walt_writing_images, wal_filling_old
     &             , wal_filling_new, wal_checkisolation, wal_measuring, wal_identifynoise, wal_measurespecial, wal_checkmerging
     &             , wal_reading_images, wal_writing_images

       real*8        dx, dy, crpix1, crpix2, crval1, crval2, ra, dec, beam, funmin, funmax, pi, crota1, crota2, equinox
     &             , bzero, bscale, datamin, datamax, sscale, newpixval, boupixval, almostzero, delta, sscaleo, sfactor, imgmin
     &             , imgmax, imglev, obsbeammin, ratio, contranoise, wave, wavef, sourcearea, sqpixel, cosrota, dlogmaxmin, sigma
     &             , maximgmax, tfluxradius, sscaleoo, mxconmk, myconmk, pixels, rotangle, sinrota, oldpixels, pixmin, pixadd
     &             , factortotal, cd11, cd12, cd21, cd22, smax, dxdeg, dydeg, crpix1n, crpix2n, cd11n, cd12n, cd21n, cd22n, mxcomin
     &             , mycomin, mxcomax, mycomax, deblended, deblendedo, deblendedoo, deblendedn, sscalen, srcpixels, srcpixmin
!!     &             , maxradedge, maxradedge2, dxco2, dyco2, rxy2, factincrease
                                                                                                                      
       logical    , allocatable :: lisolated(:), lgotanother(:), lcoordsdone(:)
       character*1, allocatable :: flag(:), flago(:)
       integer    , allocatable :: ns1(:), ns2(:), nsx(:), nxmin(:), nxmax(:), nymin(:), nymax(:), nonzero(:), nimglev(:), flg(:)
     &                           , ntouching(:,:), ntouchino(:,:), ktouching(:), n1x(:), n2x(:), nxmino(:), nxmaxo(:), nymino(:)
     &                           , nymaxo(:), flm(:)
       real*8     , allocatable :: image(:,:), iworker(:,:), osegm(:,:), nsegm(:,:), fluxpeak(:), momxx(:), momyy(:), fluxtot(:)
     &                           , afwhm(:), bfwhm(:), atheta(:), equivrad(:), foomajor(:), sigmono(:), mxco(:)
     &                           , myco(:), fluxpo(:), fluxto(:), dfpdso(:), elongationo(:), contramin(:), dfpds(:), elongation(:)
     &                           , fxpbest(:), fxtbest(:), mxcor(:), mycor(:), scalensx(:), contrast(:), fluxalter(:), foominor(:)
     &                           , fxperror(:), fxterror(:), sigglob(:), factnoise(:), detectomask(:,:), foots(:,:), segmen(:,:)
     &                           , intenstouch(:,:), simage(:,:), simageo(:,:), simageoo(:,:), momxy(:), deltx(:), delty(:), good(:)
     &                           , foota(:,:), unrotated(:,:), footfact(:), simagen(:,:), dfpdsn(:)

       parameter   ( laccelerate = .true., ldebug = .false., ltiming = .false. )

       parameter   ( boupixval = 0.0d0, nlevsmin = 30, pi = 3.14159265358979d0, almostzero = 1.0d-30, dot = '•' )

       external      lastc, rfits, wfits, when, getnumpix, fillarea, fillleft, fillright, scanhi, scanlo, pop, push, timer, osystem
     &             , ftvers, lasts, skipcomm, linescolumns, getfitshead, measure, checkmerging, checkisolation, identifynoise
     &             , deblend, makefoots
!__________________________________________________________________________________________________________________________________
!
! Determine operating acttem

       call osystem ( lunix )
       call ftvers ( fitsvers )
       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       cfpptime = cfpptime(1:5)
       compda = __DATE__//' '//cfpptime
       
! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )
       
! Get command line parameters (file names).

       call getarg (  1, arg1 )
       call getarg (  2, arg2 )
       call getarg (  3, arg3 )
       call getarg (  4, arg4 )
       call getarg (  5, arg5 )
       call getarg (  6, arg6 )
       call getarg (  7, arg7 )
       call getarg (  8, arg8 )
       call getarg (  9, arg9 )
       call getarg ( 10, argA )
       call getarg ( 11, argB )
       call getarg ( 12, argC )
       call getarg ( 13, argD )
       call getarg ( 14, argE )

       ia1 = lastc ( arg1 )
       ia2 = lastc ( arg2 )
       ia3 = lastc ( arg3 )
       ia4 = lastc ( arg4 )
       ia5 = lastc ( arg5 )
       ia6 = lastc ( arg6 )
       ia7 = lastc ( arg7 )
       ia8 = lastc ( arg8 )
       ia9 = lastc ( arg9 )
       iaA = lastc ( argA )
       iaB = lastc ( argB )
       iaC = lastc ( argC )
       iaD = lastc ( argD )
       iaE = lastc ( argE )
       
       cverbose = '-verb2'
       if (iaE .gt. 0 .and. argE(1:iaE-1) .eq. '-verb') cverbose = argE(1:iaE)
       if (iaD .gt. 0 .and. argD(1:iaD-1) .eq. '-verb') cverbose = argD(1:iaD)
       if (iaC .gt. 0 .and. argC(1:iaC-1) .eq. '-verb') cverbose = argC(1:iaC)
       if (iaB .gt. 0 .and. argB(1:iaB-1) .eq. '-verb') cverbose = argB(1:iaB)
       if (iaA .gt. 0 .and. argA(1:iaA-1) .eq. '-verb') cverbose = argA(1:iaA)
       if (ia9 .gt. 0 .and. arg9(1:ia9-1) .eq. '-verb') cverbose = arg9(1:ia9)
       ifwn = 0
       oldpixels = 0.0d0
       
       if (cverbose .eq. '-verb2') then
         write (iotty,'( )')
         if (arg1(1:ia1) .eq. ':') write (iotty,'(a$)') '  '
         write (iotty,'(a$)') ' SFINDER '//dot//' Detect Sources in Single Scales '//dot//' '//compda
       endif
       if (arg1(1:ia1) .eq. ':') stop
       if (cverbose .eq. '-verb2') write (iotty,'()')
       if (cverbose .eq. '-verb2') write (iotty,'( a)') ' Alexander Men’shchikov, DAp IRFU CEA Saclay, France.'
       if (cverbose .eq. '-verb2') write (iotty,'( a)') ' Using '//clibname(lb:7)//' library version'//cfitsversion
     &                                                //' by William D Pence.'
       if (ia8 .eq. 0) then
         write (iotty,'(/a)') ' USAGE: sfinder <waveband> <obsbeammin> <contranoise> <factortotal>'
     &                      //' <nmaxscale4newsrc> <nmaxscale4sfinder> <detectomask> <image>'
     &                      //' [<oldimage> <ooldimage> <oldsegm>] [-o <newsegm>] [-verb{0|1|2}]'
         stop 11
       endif  

       cwave = arg1(1:ia1)
       read (cwave(1:ia1),*,err=2) wave     !<-- wavelength (microns)
       goto 3
  2    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading WAVELENGTH: '//cwave(1:ia1)
       stop 51
  3    continue
       if (cwave(1:ia1) .eq. '0') then
         cwave = 'sw'
         ia1 = lastc ( cwave )
       endif

       read (arg2(1:ia2),*,err=4) obsbeammin    !<-- beam size (arcsec)
       goto 5
  4    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading BEAMSIZE: '//arg2(1:ia2)
       stop 52
  5    continue

       read (arg3(1:ia3),*,err=6) contranoise   !<-- intensity ratio for removing noise peaks
       goto 7
  6    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading CONTRANOISE: '//arg3(1:ia3)
       stop 53
  7    continue

       read (arg4(1:ia4),*,err=83) factortotal   !<-- factor defining footprint size from FWHM
       goto 84
 83    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading FACTORTOTAL: '//arg4(1:ia4)
       stop 54
 84    continue

       read (arg5(1:ia5),*,err=8) nmaxscale4newsrc     !<-- maximum scale at which find new sources
       goto 9
  8    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading NMAXSCALE4NEWSRC: '//arg5(1:ia5)
       stop 55
  9    continue

       read (arg6(1:ia6),*,err=81) nmaxscale4sfinder     !<-- maximum scale to analyze
       goto 82
  81   write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading NMAXSCALE4SFINDER: '//arg6(1:ia6)
       stop 56
  82   continue

       domaskname = arg7(1:ia7)
       imagename = arg8(1:ia8)
       if (ia9 .gt. 0) then
         if (arg9(1:2) .ne. '-o' .and. arg9(1:ia9-1) .ne. '-verb') then
           oldimage = arg9(1:ia9)
           ooldimage = argA(1:iaA)
           oldsegm = argB(1:iaB)
         else
           oldimage = 'none'
           ooldimage = 'none'
           oldsegm = 'none'
         endif
       else
         oldimage = 'none'
         ooldimage = 'none'
         oldsegm = 'none'
       endif
       
       ios = lastc ( oldsegm )
       ioi = lastc ( oldimage )
       ioo = lastc ( ooldimage )
       ifn = lastc ( imagename )
       idm = lastc ( domaskname )
       
       if (ltiming) then
         inquire ( file='+timing.sfinder', exist=ltime )
         open ( 60, file='+timing.sfinder', status='unknown' )
         if (ltime) then
           do 
             read (60,'()',end=61)
           enddo
  61       backspace ( 60 )
         endif
         write (60,'(/a)') ' SFINDER started: '//cdate//' '//ctime//' Image: '//imagename(1:ifn)

         cput_reading_images = 0.0d0
         walt_reading_images = 0.0d0
         cput_filling_old = 0.0d0
         walt_filling_old = 0.0d0
         cput_filling_new = 0.0d0
         walt_filling_new = 0.0d0
         cput_checkisolation = 0.0d0
         walt_checkisolation = 0.0d0
         cput_checkmerging = 0.0d0
         walt_checkmerging = 0.0d0
         cput_measuring = 0.0d0
         walt_measuring = 0.0d0
         cput_identifynoise = 0.0d0
         walt_identifynoise = 0.0d0
         cput_measurespecial = 0.0d0
         walt_measurespecial = 0.0d0
         cput_writing_images = 0.0d0
         walt_writing_images = 0.0d0
         cpu_sum = 0.0d0
         wal_sum = 0.0d0
       endif
       
! Check if the input files exist.

       inquire ( file=domaskname(1:idm), exist=lfname1 )
       if (.not.lfname1) then
         domaskname = domaskname(1:idm)//'.fits'
         idm = lastc ( domaskname )
         inquire ( file=domaskname(1:idm), exist=lfname1 )
       endif

       inquire ( file=imagename(1:ifn), exist=lfname2 )
       if (.not.lfname2) then
         imagename = imagename(1:ifn)//'.fits'
         ifn = lastc ( imagename )
         inquire ( file=imagename(1:ifn), exist=lfname2 )
       endif

! The combined "an" images are used to detect sources and follow their footprint evolution across scales.
       
       isp1 = lasts ( imagename ) + 1
       newsegm = imagename(isp1:ifn-5)//'.m.fits'

! The combined "as" images are used only to determine characteristic scales and footprints of sources.

       simagename = imagename(1:ifn-10)//'.as.m.fits'
       isfn = lastc ( simagename )
       
       idot1 = index ( imagename, '.' )
       idot2 = index ( imagename(idot1+1:ifn), '.' ) + idot1
       idot3 = index ( imagename(idot2+1:ifn), '.' ) + idot2

       if (lfname2) then
         cnscale = imagename(idot3+1:idot3+2)
         read (cnscale,*,err=38) nscale
         csscale = imagename(idot3+5:idot3+10)
         read (csscale,*,err=38) sscale
         goto 39
 38      write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading scale from '//imagename(idot3+1:idot3+10)
         stop 55
 39      continue

! Define name of a file listing all file names for single-scale combined detection images.

         filewithswnames = imagename(1:idot3-1)//'.combine'
         ifwn = lastc ( filewithswnames )
         inquire ( file=filewithswnames(1:ifwn), exist=lfname5 )
         if (.not.lfname5) then
           write (iotty,'(/a)') '   SFINDER: ERROR: File '//filewithswnames(1:ifwn)//' not found.'
           stop 30
         endif
       endif
       nscaleo = 0
       nscaleoo = 0
       sscaleoo = sscale
       sscaleo = sscale
       sscalen = sscale
       sfactor = 1.05d0
       
! Check if the input file exists and open it.

       if (oldimage .ne. 'none') then

         inquire ( file=oldimage(1:ioi), exist=lfname3 )
         if (.not.lfname3 .and. oldimage(ioi-4:ioi) .ne. '.fits') then
           oldimage = oldimage(1:ioi)//'.fits'
           ioi = lastc ( oldimage )
           inquire ( file=oldimage(1:ioi), exist=lfname3 )
         endif

         idot1 = index ( oldimage, '.' )
         idot2 = index ( oldimage(idot1+1:ioi), '.' ) + idot1
         idot3 = index ( oldimage(idot2+1:ioi), '.' ) + idot2

         swcatname = 'sm.sw.'//oldimage(1:idot1)//'sw.nn.smf.cat'
         iswc = lastc ( swcatname )

         if (lfname3) then
           cnscaleo = oldimage(idot3+1:idot3+2)
           read (cnscaleo,*,err=48) nscaleo
           csscaleo = oldimage(idot3+5:idot3+10)
           read (csscaleo,*,err=48) sscaleo
           goto 49
 48        write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading old scale from '//oldimage(idot3+1:idot3+10)
           stop 56
 49        continue
           nscaleoo = nscaleo - 1
         endif

         inquire ( file=oldsegm(1:ios), exist=lfname4 )
         if (.not.lfname4 .and. oldsegm(ios-4:ios) .ne. '.fits') then
           oldsegm = oldsegm(1:ios)//'.fits'
           ios = lastc ( oldsegm )
           inquire ( file=oldsegm(1:ios), exist=lfname4 )
         endif

         if (argB(1:2) .eq. '-o') then
           newsegm = argC
         else if (argC(1:2) .eq. '-o') then
           newsegm = argD
         endif
       else
         lfname3 = .true.
         lfname4 = .true.
         if (argA(1:2) .eq. '-o') newsegm = argB
       endif

       if (sscale .gt. sscaleo + almostzero) sfactor = sscale / sscaleo

       if (ooldimage .ne. 'none') then

         inquire ( file=ooldimage(1:ioo), exist=lfname6 )
         if (.not.lfname6 .and. ooldimage(ioo-4:ioo) .ne. '.fits') then
           ooldimage = ooldimage(1:ioo)//'.fits'
           ioo = lastc ( ooldimage )
           inquire ( file=ooldimage(1:ioo), exist=lfname6 )
         endif

         idot1 = index ( ooldimage, '.' )
         idot2 = index ( ooldimage(idot1+1:ioo), '.' ) + idot1
         idot3 = index ( ooldimage(idot2+1:ioo), '.' ) + idot2

         if (lfname6) then
           cnscaleoo = ooldimage(idot3+1:idot3+2)
           read (cnscaleoo,*,err=58) nscaleoo
           csscaleoo = ooldimage(idot3+5:idot3+10)
           read (csscaleoo,*,err=58) sscaleoo
           goto 59
 58        write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading oold scale from '//ooldimage(idot3+1:idot3+10)
           stop 57
 59        continue
         else
           nscaleoo = 0
         endif
       else
         lfname6 = .true.
         nscaleoo = 0
       endif
       
       sooldimage = ooldimage(1:ioi-10)//'.as.m.fits'
       isoo = lastc ( sooldimage )
       
       soldimage = oldimage(1:ioi-10)//'.as.m.fits'
       isoi = lastc ( soldimage )

       snewimage = imagename(1:ifn-10)//'.as.m.fits'
       isn = lastc ( snewimage )
       lfname7 = .true.
       
       if (lfname2) then
         open ( 25, file=filewithswnames(1:ifwn), status='old' )

! Read all file names for single-scale combined detection images.
       
         call skipcomm     ( 25, filewithswnames(1:ifwn), nheadf )
         call linescolumns ( 25, filewithswnames(1:ifwn), nheadf, nfiles )
        
         rewind ( 25 )
         do m=1,nheadf
           read (25,'(a)')
         enddo
         nscalen = nscale + 1
         do m=1,nfiles
           read (25,*) cline
           if (m .eq. nscalen) then
             icl = lastc ( cline )
             isl = lasts ( cline )
             idot1 = index ( cline(isl+1:icl), '.' ) + isl
             idot2 = index ( cline(idot1+1:icl), '.' ) + idot1
             idot3 = index ( cline(idot2+1:icl), '.' ) + idot2
             read (cline(idot3+1:idot3+13),'(a12)') restname
             snewimage = cline(isl+1:idot3)//restname//'.as.fits'
             isn = lastc ( snewimage )
             inquire ( file=snewimage(1:isn), exist=lfname7 )
             if (lfname7) then
               idot1 = index ( snewimage, '.' )
               idot2 = index ( snewimage(idot1+1:isn), '.' ) + idot1
               idot3 = index ( snewimage(idot2+1:isn), '.' ) + idot2
               cnscalen = snewimage(idot3+1:idot3+2)
               read (cnscalen,*,err=46) nscalenc
               if (nscalenc .ne. nscalen) goto 46
               csscalen = snewimage(idot3+5:idot3+10)
               read (csscalen,*,err=46) sscalen
               goto 47
 46            write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading new scale from '//snewimage(idot3+1:idot3+10)
               stop 56
 47            continue
             endif
             exit
           endif
         enddo
         close ( 25 )
       endif

       ins = lastc ( newsegm )
       if (newsegm(ins-4:ins) .ne. '.fits') then
         newsegm = newsegm(1:ins)//'.fits'
         ins = lastc ( newsegm )
       endif

       footprint = newsegm(1:ins-5)//'.fp.fits'
       ifp = lastc ( footprint )

       if (cverbose .eq. '-verb1') 
     &   write (iotty,'(/a)') ' SFINDER: '//cwave(1:ia1)//' '//arg2(1:ia2)//' '//arg3(1:ia3)//' '//arg4(1:ia4)//' '//arg5(1:ia5)
     &                               //' '//arg6(1:ia6)//' '//arg7(1:ia7)//' '//arg8(1:ia8)//' '//arg9(1:ia9)//' '//argA(1:iaA)
  
       if (.not.lfname1) then
         write (iotty,'(/a)') '   SFINDER: ERROR: File '''//domaskname(1:idm)//''' not found.'
         stop 31
       endif
       if (.not.lfname2) then
         write (iotty,'(/a)') '   SFINDER: ERROR: File '''//imagename(1:ifn)//''' not found.'
         stop 32
       endif
       if (.not.lfname3) then
         if (nscaleo .eq. 0) then
           if (nscale .gt. 1 .and. cverbose .eq. '-verb2') 
     &       write (iotty,'(/a)') '   SFINDER: WARNING: Old image file not specified or not existing.'
         else  
           write (iotty,'(/a)') '   SFINDER: ERROR: File '''//oldimage(1:ioi)//''' not found.'
           stop 33
         endif
         oldimage = 'none'
       endif
       if (.not.lfname6) then
         if (nscaleoo .eq. 0) then
           if (nscale .gt. 2 .and. cverbose .eq. '-verb2') 
     &       write (iotty,'(/a)') '   SFINDER: WARNING: Oold image file not specified or not existing.'
         else  
           write (iotty,'(/a)') '   SFINDER: ERROR: File '''//ooldimage(1:ioo)//''' not found.'
           stop 34
         endif
         ooldimage = 'none'
       endif
       if (.not.lfname4) then
         if (nscaleo .eq. 0) then
           if (nscale .gt. 1 .and. cverbose .eq. '-verb2') 
     &       write (iotty,'(/a)') '   SFINDER: WARNING: Old segmentation file not specified or not existing.'
         else  
           write (iotty,'(/a)') '   SFINDER: ERROR: File '''//oldsegm(1:ios)//''' not found.'
           stop 35
         endif
         oldsegm = 'none'
       endif
       if (.not.lfname7) then
         write (iotty,'(/a)') '   SFINDER: ERROR: File '''//snewimage(1:isn)//''' not found.'
         stop 36
       endif

! Check whether subdirectory of current directory exists.
       
       individs = 'sources'
       ind = lastc ( individs )

       if (cverbose .eq. '-verb2') write (iotty,'()')

! Read in the configuration file of GETSF just for documenting catalogs.

       inquire ( file='+getsf.cfg', exist=lfname )
       if (.not.lfname) then
         inquire ( file='+GETSF.CFG', exist=lfname )
         if (.not.lfname) then
           inquire ( file='+getsf.'//cwave(1:ia1)//'.cfg', exist=lfname )
           if (.not.lfname) then
             inquire ( file='+GETSF.'//cwave(1:ia1)//'.CFG', exist=lfname )
             if (.not.lfname) then
               write (iotty,'(/a)') '   SFINDER: WARNING: Config file for GETSF not found.'
               cfgfile = ''
             else
               cfgfile='+GETSF.'//cwave(1:ia1)//'.CFG'
             endif
           else
             cfgfile='+getsf.'//cwave(1:ia1)//'.cfg'
           endif
         else
           cfgfile = '+GETSF.CFG'
         endif                  
       else
         cfgfile = '+getsf.cfg'
       endif
       lcfg = lastc ( cfgfile )
       ncfglines = 0
              
       if (lfname) then
         open ( 25, file=cfgfile(1:lcfg), status='old' )
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading configuration file '''//cfgfile(1:lcfg)//''''
         do i=1,1000
           read (25,'(a)',end=98,err=90) cfgline(i)
         enddo
  90     continue
         close (25)
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading file '''//cfgfile(1:lcfg)//'''.'
         stop 58
  98     continue
         close (25)
         ncfglines = i - 1
       endif

       versfile='+log.VERSION'
       lver = lastc ( versfile )
       getstitle='# GETSF • GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men''shchikov,'
     &         //' DAp IRFU CEA Saclay'
       inquire ( file=versfile(1:lver), exist=lfnvers )
       if (lfnvers) then
         open ( 25, file=versfile(1:lver), status='old' )
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading version file '''//versfile(1:lver)//''''
         do i=1,3
           read (25,'(a)',end=97,err=91) getstitle
         enddo
         getstitle = getstitle(1:1)//getstitle(4:)
         goto 97
  91     continue
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading file '''//versfile(1:lver)//'''.'
         close (25)
         stop 59
  97     continue
         close (25)
       else        
         write (iotty,'(/a)') '   SFINDER: WARNING: Version file for GETSF not found.'
       endif

! Determine numbers of pixels in the FITS image.

       call getfitshead ( imagename(1:ifn), nx, ny, dx, dy, bunit )

       write (cx,'(i7)') nx
       write (cy,'(i7)') ny
       ncx = int ( log10 ( dble ( nx ) ) ) + 1
       ncy = int ( log10 ( dble ( ny ) ) ) + 1

! Allocate the image arrays.
       
       allocate ( image(nx,ny), iworker(nx,ny), osegm(nx,ny), nsegm(nx,ny), segmen(nx,ny), foots(nx,ny), n1x(ny), n2x(ny)
     &          , simage(nx,ny), simageo(nx,ny), simageoo(nx,ny), simagen(nx,ny), foota(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (71).'
         stop 71
       endif

       allocate ( detectomask(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (72).'
         stop 72
       endif

       if (cverbose .eq. '-verb2') write (iotty,'(a,f5.2)') '   Required minimum contrast to identify noise peaks:', contranoise
       
       if (ltiming) then
         cpu_reading_images = timer ( 'cpu', 0.0d0 )
         wal_reading_images = timer ( 'wal', 0.0d0 )
       endif

       if (ooldimage .ne. 'none') then
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                  //sooldimage(1:isoo)//''''

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simageoo, dx, dy, object, ra, dec
     &              , sooldimage(1:isoo), iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )

         if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif

       if (oldimage .ne. 'none') then

         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                  //soldimage(1:isoi)//''''

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simageo, dx, dy, object, ra, dec
     &              , soldimage(1:isoi), iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )

         if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif

       if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                //simagename(1:isfn)//''''

       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simage, dx, dy, object, ra, dec
     &            , simagename(1:isfn), iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )

       if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax

       if (lfname7) then
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                    //snewimage(1:isn)//''''
         
         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simagen, dx, dy, object, ra, dec
     &              , snewimage(1:isn), iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )
         
         if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif
                                   
       if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                //imagename(1:ifn)//''''

       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, image, dx, dy, object, ra, dec
     &            , imagename(1:ifn), iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )

       if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
                                   
       iu = lastc ( bunit )

       if (bunit(1:iu) .ne. 'MJy/sr' .and. bunit(1:iu) .ne. 'H2/cm^2') then
         iu = lastc ( bunit )
         write (iotty,'(/a)') '   SFINDER: ERROR: Unknown intensity units in the image.'
         write (iotty,'(a )') '   BUNIT must be ''MJy/sr'' or ''H2/cm^2''.'
         stop 90
       endif
       if (bunit(1:iu) .eq. 'MJy/sr' ) funits = 'Jy'
       if (bunit(1:iu) .eq. 'H2/cm^2') funits = 'H2/cm^2*arcsec^2'
       fu = lastc ( funits )

       sqpixel = dx * dy
       dxdeg = dx / 3600.0d0
       dydeg = dy / 3600.0d0

       if (oldsegm .ne. 'none') then
         write (cx,'(i7)') nx
         write (cy,'(i7)') ny
         ncx = int ( log10 ( dble ( nx ) ) ) + 1
         ncy = int ( log10 ( dble ( ny ) ) ) + 1

         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                  //oldsegm(1:ios)//''''

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, osegm, dx, dy, object, ra, dec
     &              , oldsegm(1:ios), iotty, 0, creator, beam, datamin, datamax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )

         if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', datamin, datamax
       else
         do j=1,ny
           do i=1,nx
             osegm(i,j) = 0.0d0
           enddo
         enddo
       endif
       
       write (cx,'(i7)') nx
       write (cy,'(i7)') ny
       ncx = int ( log10 ( dble ( nx ) ) ) + 1
       ncy = int ( log10 ( dble ( ny ) ) ) + 1

       if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                                //domaskname(1:idm)//''''
       
       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, detectomask, dx, dy, object, ra, dec
     &            , domaskname(1:idm), iotty, 0, creator, beam, datamin, datamax, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wavef, datamin, datamax, history, cverbose )
       
       if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', datamin, datamax

       if (ltiming) then
         cput_reading_images = cput_reading_images + timer ( 'cpu', cpu_reading_images )
         walt_reading_images = walt_reading_images + timer ( 'wal', wal_reading_images )
       endif

       n1xmin = nx
       n2xmax = 1
       do j=1,ny
         n1x(j) = 0
         do i=1,nx
           if (detectomask(i,j) .gt. 0.5d0) then
             n1x(j) = max ( i - 2, 1 )
             if (n1x(j) .lt. n1xmin) n1xmin = n1x(j)
             exit
           endif
         enddo
         n2x(j) = 0
         do i=nx,1,-1
           if (detectomask(i,j) .gt. 0.5d0) then
             n2x(j) = min ( i + 2, nx )
             if (n2x(j) .gt. n2xmax) n2xmax = n2x(j)
             exit
           endif
         enddo
       enddo
       n1ymin = ny
       n2ymax = 1
       do i=1,nx
         do j=1,ny
           if (detectomask(i,j) .gt. 0.5d0) then
             n1y = max ( j - 2, 1 )
             if (n1y .lt. n1ymin) n1ymin = n1y
             exit
           endif
         enddo
         do j=ny,1,-1
           if (detectomask(i,j) .gt. 0.5d0) then
             n2y = min ( j + 2, ny )
             if (n2y .gt. n2ymax) n2ymax = n2y
             exit
           endif
         enddo
       enddo
       if (n1ymin .eq. ny) n1ymin = 1
       if (n2ymax .eq. 1 ) n2ymax = 1
       do j=1,ny
         if (n1x(j) .eq. 0) n1x(j) = 1
         if (n2x(j) .eq. 0) n2x(j) = 1
       enddo
       
       allocate ( mxco(nextrmax), myco(nextrmax), fluxpeak(nextrmax), fluxtot(nextrmax), afwhm(nextrmax), bfwhm(nextrmax)
     &          , atheta(nextrmax), equivrad(nextrmax), foomajor(nextrmax), foominor(nextrmax), sigmono(nextrmax), ns1(nextrmax)
     &          , ns2(nextrmax), flag(nextrmax), flago(nextrmax), nxmin(nextrmax), nxmax(nextrmax), nymin(nextrmax), nymax(nextrmax)
     &          , nonzero(nextrmax), fluxpo(nextrmax), fluxto(nextrmax), dfpds(nextrmax), dfpdso(nextrmax), elongationo(nextrmax)
     &          , elongation(nextrmax), contramin(nextrmax), nsx(nextrmax), fxpbest(nextrmax), fxtbest(nextrmax), fxperror(nextrmax)
     &          , fxterror(nextrmax), mxcor(nextrmax), mycor(nextrmax), scalensx(nextrmax), contrast(nextrmax), fluxalter(nextrmax)
     &          , sigglob(nextrmax), flg(nextrmax), factnoise(nextrmax), ktouching(maxtouch), deltx(nextrmax), good(nextrmax)
     &          , delty(nextrmax), nxmino(nextrmax), nxmaxo(nextrmax), nymino(nextrmax), nymaxo(nextrmax), flm(nextrmax)
     &          , footfact(nextrmax), dfpdsn(nextrmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (73).'
         open ( 9, file='.notenoughmem73', status='unknown' )
         write (9,'(a)') 'Trouble allocating memory.'
         close ( 9 )
         stop
       endif
       
       allocate ( lisolated(nextrmax), lgotanother(nextrmax), ntouching(nextrmax,nextrmax), ntouchino(nextrmax,nextrmax)
     &          , intenstouch(nextrmax,nextrmax), nimglev(nextrmax), momxx(nextrmax), momyy(nextrmax), momxy(nextrmax)
     &          , lcoordsdone(nextrmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (74).'
         open ( 9, file='.notenoughmem74', status='unknown' )
         write (9,'(a)') 'Trouble allocating memory.'
         close ( 9 )
         stop
       endif
       
! Initialize.
                                   
       do n=1,nextrmax
         ns1  (n) = nscale
         ns2  (n) = nscale
         nsx  (n) = 0
         flag (n) = ' '
         flago(n) = ' '
         mxco (n) = -1.0d0     
         myco (n) = -1.0d0     
         mxcor(n) = -1.0d0     
         mycor(n) = -1.0d0     
         sigglob  (n) = 0.0d0
         flg      (n) = 0
         good     (n) = 0.0d0
         sigmono  (n) = 0.0d0
         flm      (n) = 0
         fxpbest  (n) = 0.0d0
         fxperror (n) = 0.0d0
         fxtbest  (n) = 0.0d0
         fxterror (n) = 0.0d0
         fluxalter(n) = 0.0d0
         scalensx (n) = 0.0d0
         afwhm    (n) = 0.0d0
         bfwhm    (n) = 0.0d0
         atheta   (n) = 0.0d0
         equivrad (n) = 0.0d0
         footfact (n) = 0.0d0
         foomajor (n) = 0.0d0
         foominor (n) = 0.0d0
         fluxpeak (n) = 0.0d0
         fluxtot  (n) = 0.0d0
         contrast (n) = 0.0d0
         fluxpo   (n) = 0.0d0
         fluxto   (n) = 0.0d0
         dfpdso   (n) = 0.0d0
         dfpds    (n) = 0.0d0
         dfpdsn   (n) = 0.0d0
         elongationo(n) = 0.0d0
         nxmin(n) = n1xmin
         nxmax(n) = n2xmax
         nymin(n) = n1ymin
         nymax(n) = n2ymax
         nxmino(n) = nxmin(n)
         nxmaxo(n) = nxmax(n)
         nymino(n) = nymin(n)
         nymaxo(n) = nymax(n)
       enddo
       do k=1,maxtouch
         ktouching(k) = 0
       enddo
       datamin = 0.0d0
       datamax = 0.0d0
       nextr = 0
       lfoots = .false.

       if (nscale .le. 9) write (cns,'('' ['',i1'']'')') nscale
       if (nscale .gt. 9) write (cns,'('' ['',i2'']'')') nscale
       lcns = lastc ( cns )

       cscales = '# SCALES:'
       noisesources = 0
         
! If old segmentation image exists, read it and corresponding catalog.

       if (oldsegm .ne. 'none') then
         oldcat = oldsegm(1:ios-5)//'.cat'
         ioc = lastc ( oldcat )

         open ( 15, file=oldcat(1:ioc), status='old' )

         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading catalog '''//oldcat(1:ioc)//''''
       
         call skipcomm     ( 15, oldcat(1:ioc), nhead )
         call linescolumns ( 15, oldcat(1:ioc), nhead, nextr )
         
! Read previous catalog.

         do m=1,nextr
           read (15,'(i6,3i3,2x,a,2(f11.4),2(f13.7),i3,2(1pe11.3),i5,22(1pe11.3),3(e10.2),4i7,1x,i3,1000i6)',err=19) 
     &          n, ns1(n), ns2(n), nsx(n), flag(n), mxco(n), myco(n), mxcor(n), mycor(n), flg(n), sigglob(n), good(n), flm(n)
     &        , sigmono(n), equivrad(n), fxpbest(n), fxperror(n), fxtbest(n), fxterror(n), sigmono(n), scalensx(n), afwhm(n)
     &        , bfwhm(n), afwhm(n), bfwhm(n), atheta(n), footfact(n), foomajor(n), foominor(n), fluxpeak(n), fluxtot(n)
     &        , elongationo(n), factnoise(n), contramin(n), contrast(n), dfpdso(n), dfpds(n), dfpdsn(n), nxmin(n), nxmax(n)
     &        , nymin(n), nymax(n), kk, (ktouching(k),k=1,kk)
     
           goto 20
  19       continue
             close ( 15 )
             write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading file '//oldcat(1:ioc)
             stop 62
  20       continue

           if (kk .gt. 0) then
             do k=1,nextr
               ktouch = 0
               do l=1,kk
                 if (k .eq. abs ( ktouching(l) )) then
                   ktouch = ktouching(l)
                   exit
                 endif
               enddo
               if (k .ne. n .and. k .eq. abs ( ktouch )) then
                 if (ktouch .gt. 0) then
                   ntouchino(n,k) = 1
                   ntouching(n,k) = 1
                 else
                   ntouchino(n,k) = 2
                   ntouching(n,k) = 2
                 endif
               else
                 ntouchino(n,k) = 0
                 ntouching(n,k) = 0
               endif            
             enddo
           else
             do k=1,nextr
               ntouchino(n,k) = 0
               ntouching(n,k) = 0
             enddo
           endif
           lcoordsdone(n) = .true.
           lisolated(n) = .false.
           fluxpo(n) = fluxpeak(n)
           fluxto(n) = fluxtot (n)
           elongation(n) = elongationo(n)
           sourcearea = pi * equivrad(n)**2
           nonzero(n) = nint ( sourcearea / sqpixel )
           if (flag(n) .eq. 'n') noisesources = noisesources + 1
           nxmino(n) = nxmin(n)
           nxmaxo(n) = nxmax(n)
           nymino(n) = nymin(n)
           nymaxo(n) = nymax(n)
         enddo
         
         rewind ( 15 )

         do m=1,nhead
           read (15,'(a)') cline
           if (cline(1:9) .eq. '# SCALES:') then
             cscales = cline
             exit
           endif
         enddo
         
         close ( 15 )
       endif             

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading names of images from '''//filewithswnames(1:ifwn)//''''
     
       open ( 25, file=filewithswnames(1:ifwn), status='old' )

! Read all file names for single-scale combined detection images.
       
       call skipcomm     ( 25, filewithswnames(1:ifwn), nheadf )
       call linescolumns ( 25, filewithswnames(1:ifwn), nheadf, nfiles )
     
       rewind ( 25 )
       do m=1,nheadf
         read (25,'(a)')
       enddo
                
       do m=1,nfiles
         read (25,*) sswname, sigma
         iss = lastc ( sswname )
         if (index ( sswname(1:iss-5), imagename(1:ifn-5-2) ) .gt. 0) exit
         if (m .eq. nfiles) then
           write (iotty,'(/a)') '   SFINDER: ERROR: Trouble finding image name in '//filewithswnames(1:ifwn)//':'
           write (iotty,'(a)' ) '                  ' //imagename(1:ifn-5)//' '//sswname(1:iss-5)//'.m'
           stop 60
         endif
       enddo
     
       close ( 25 )

       isl = lastc ( cscales )
       nextro = nextr
       nextroldscale = nextr

! When a source number becomes exactly equal to the pixel value, it creates problems with detection using the tint fill algorithm.
! Here I take care of this to avoid any possibility of such problems.

       imgmin =  1.0d+30
       imgmax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (image(i,j) .gt. almostzero) then
             imgmin = min ( imgmin, image(i,j) )
             imgmax = max ( imgmax, image(i,j) )
             if (imgmax .ge. 1.0d0) then
               write (iotty,'(/a)') '   SFINDER: ERROR: Detection image is not normalized to 1.0: '//imagename(1:ifn)
               stop 91
             endif
           endif
         enddo
       enddo

       do j=1,ny
         do i=1,nx
           if (image(i,j) .lt. imgmin) image(i,j) = 0.0d0
           if (oldimage .eq. 'none') simageo(i,j) = simage(i,j)
           if (ooldimage .eq. 'none') simageoo(i,j) = simage(i,j)
           foots(i,j) = 0.0d0
           foota(i,j) = 0.0d0
         enddo
       enddo

       ns1min = 999
       do n=1,nextr
         ns1min = min ( ns1(n), ns1min )
       enddo
         
       lallsourcesdone = .false.
       delta = 0.01d0

       if (nextr .eq. 0) then
         nscaleo = 0
         nscaleoo = 0
         do n=1,nextrmax
           contrast(n) = 1.0d-1
           contramin(n) = 0.0d0
           factnoise(n) = 0.0d0
         enddo
       else

! Check whether we are done.

         do n=1,nextr
           if ((ns2(n) .eq. nscaleo .or. nscaleo .eq. 0) .and. (flag(n) .eq. ' ' .or. nsx(n) .eq. 0)) goto 68
         enddo
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   SFINDER: All existing sources have been footprinted.'
         lallsourcesdone = .true.
 68      continue
       endif
       
       if (contranoise .lt. almostzero) goto 666

       if (nscaleo .eq. 0) then
         do j=1,ny
           do i=1,nx
             osegm(i,j) = 0.0d0
           enddo
         enddo
       endif

!!! Attempt to find remaining large-scale sources.
!!
!!       if (nscale .eq. nmaxscale4newsrc - 1) then
!!         do j=1,ny
!!           do i=1,nx
!!             osegm(i,j) = 0.0d0
!!           enddo
!!         enddo
!!       endif

       do j=1,ny
         do i=1,nx
           nsegm(i,j) = osegm(i,j)
         enddo
       enddo

       maximgmax = imgmax

       dlogmaxmin = max ( log ( maximgmax ) - log ( imgmin ), 0.0d0 )
   
       nlevs = nint ( dlogmaxmin / delta )

       if (nlevs .lt. nlevsmin) then
         nlevs = nlevsmin
         delta = dlogmaxmin / dble ( nlevs )
       endif
       
       pixmin = max ( (1.0d0 / 3.0d0) * pi * (sscale / 2.0d0)**2 / sqpixel, 9.0d0 )
       
       write (cnn,'(i7)') nlevs
       ncn = int ( log10 ( dble ( nlevs ) ) ) + 1
       write (cny,'(i7)') nint ( pixmin )
       ncy = int ( log10 ( dble ( nint ( pixmin ) ) ) ) + 1

       if (cverbose .ne. '-verb0') then
         write (iotty,'(/a,f6.3,a)') '   Number of sub-levels: '//cnn(7-ncn+1:7)//', relative spacing:', delta
     &                             , ', minimum new pixels: '//cny(7-ncy+1:7)
       endif
       
! NOTE: 'iworker' is the same as the single-scale image only here, in the beginning, before filling. 
! Calls to FILLAREA will replace initial intensity values with the segmentation mask values, so better be careful and
! do not interpret 'iworker' as a simple map of intensities.

       nlevsact = nlevs

       do lev=1,nlevs

         write (cl,'(i3)') lev
         if (cl(1:1) .eq. ' ') cl(1:1) = '0'
         if (cl(2:2) .eq. ' ') cl(2:2) = '0'
         segmentl = newsegm(1:ins-5)//'.'//cl//'.old.fits'
         isk = lastc( segmentl )
         segmentln = newsegm(1:ins-5)//'.'//cl//'.new.fits'
         iskn = lastc( segmentln )
         imagel = imagename(1:ifn-5)//'.'//cl//'.old.fits'
         iik = lastc( imagel )
         imageln = imagename(1:ifn-5)//'.'//cl//'.new.fits'
         iikn = lastc( imageln )
         catname = 'catalog.'//cl//'.cat'
         iocat = lastc ( catname )
         pixels = 0.0d0
                                      
         imglev = exp ( log ( imgmin * 0.9999d0 ) + dble ( nlevs - lev ) * delta )
         
         do j=1,ny
           do i=1,nx
             if (image(i,j) .ge. imglev) then
               iworker(i,j) = image(i,j)
               pixels = pixels + 1.0d0
             else
               iworker(i,j) = 0.0d0
             endif
             segmen(i,j) = iworker(i,j)
             osegm(i,j) = nsegm(i,j)
           enddo
         enddo

! If the current level has the same number of pixels as the previous one, skip it to save time.

         if (lev .gt. 1 .and. lev .lt. nlevs) then
           pixadd = pixels - oldpixels
           if (pixadd .le. pixmin) then
             nlevsact = nlevsact - 1
             write (cnn,'(i7.7)') lev
             ncn = int ( log10 ( dble ( nlevs ) ) ) + 1
             write (cny,'(i7.7)') nint ( pixadd )
             ncy = int ( log10 ( dble ( nint ( pixmin ) ) ) ) + 1
             write (cnx,'(i7.7)') nlevsact
             ncx = int ( log10 ( dble ( max ( nlevs, 1 ) ) ) ) + 1
             if (cverbose .ne. '-verb0') then
               write (iotty,'(a)') '   Level '//cnn(7-ncn+1:7)//' added only '//cny(7-ncy+1:7)
     &                           //' new pixels ~> skipping & reducing to '//cnx(7-ncx+1:7)//' levels'
             endif
             goto 999
           endif
         endif
         oldpixels = pixels

! Correct pixel intensities in situations when they are zero under non-zero segmentation mask. To make sure that area filling
! works correctly, one needs to make the pixels non-zero, to make the entire segmentation mask for the source fully 4-connected
! in both intensities iworker(i,j) and segmentation values nsegm(i,j). An arbitrary value (better lower than 1) will work, as the
! filling method is 'positive'.

         l1st = .true.
         do n=1,nextr
           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
             do j=nymin(n),nymax(n)
               do i=nxmin(n),nxmax(n)
                 if (nsegm(i,j) .gt. almostzero) then
                   if (iworker(i,j) .lt. almostzero) then
                     if (cverbose .eq. '-verb2' .and. l1st) then
                       if (l1st) write (iotty,'(a)') '   Re-connecting image pixels for some sources'
                       l1st = .false.
                     endif
                     iworker(i,j) = imgmin
                   endif
                 endif
               enddo
             enddo
           endif
         enddo
         
! Zero out the input image pixels that are connected to the others by only their corners, 
! but do that only in the areas still unoccupied (nsegm = 0) by detected sources.
! Here 'segmen' is a copy of 'iworker' to avoid possible problems.
         
         l1st = .true.
         do j=n1ymin,n2ymax
           jm1 = max (  1, j - 1 )
           jp1 = min ( ny, j + 1 )
           do i=n1x(j),n2x(j)
             if (nsegm(i,j) .lt. almostzero) then
               if (segmen(i,j) .gt. almostzero) then
                 im1 = max (  1, i - 1 )
                 ip1 = min ( nx, i + 1 )
                 ledgeszero = segmen(im1, j ) .le. almostzero .and. segmen(ip1, j ) .le. almostzero .and. 
     &                        segmen( i ,jm1) .le. almostzero .and. segmen( i ,jp1) .le. almostzero
                 lcornerpos = segmen(im1,jp1) .gt. almostzero .or.  segmen(ip1,jp1) .gt. almostzero .or. 
     &                        segmen(ip1,jm1) .gt. almostzero .or.  segmen(im1,jm1) .gt. almostzero
             
                 if (ledgeszero .and. lcornerpos) then
                   if (cverbose .eq. '-verb2') then
                     if (l1st) write (iotty,'(a)') '   Wiping out free isolated pixels'
                     l1st = .false.
                   endif
                   iworker(i,j) = 0.0d0
                 endif
               endif
             endif
           enddo
         enddo
         
! Debugging output.

         if (ldebug) then
           if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//imagel(1:iik)//''''
           
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, iworker, dx, dy, object
     &                , crval1, crval2, imagel(1:iik), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21
     &                , cd22, equinox, bzero, bscale, wave, datamin, datamax, history )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (cverbose .eq. '-verb2') write (iotty,'(a,$)') '   Analyzing old segmentation masks at sub-level '//cl

         if (ltiming) then
           cpu_filling_old = timer ( 'cpu', 0.0d0 )
           wal_filling_old = timer ( 'wal', 0.0d0 )
         endif

! First seed the sources found previously at smaller scales, if they are still visible at current scale.

         nextro = nextr
         cproblem = ':'
         
         do n=1,nextr
           if (mxco(n) .gt. 0.0d0 .and. myco(n) .gt. 0.0d0) then
             lcoordsdone(n) = .true.
           else
             lcoordsdone(n) = .false.
           endif       
           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
             if (lcoordsdone(n)) then
               do k=1,nextr
                 if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                   if (ntouching(n,k) .ge. 1) then
                     if (k .ne. n .and. lcoordsdone(k)) then
                       mxconmk = mxco(n) - mxco(k)
                       myconmk = myco(n) - myco(k)
                       imiddle = nint ( (mxco(n) + mxco(k)) / 2.0d0 )
                       jmiddle = nint ( (myco(n) + myco(k)) / 2.0d0 )
                       deltx(k) = 2.0d0 * (imiddle - mxco(k)) - mxconmk
                       delty(k) = 2.0d0 * (jmiddle - myco(k)) - myconmk
                     endif
                   endif
                 endif
               enddo
               nxco = nint ( mxco(n) )
               nyco = nint ( myco(n) )

               lfoundold = .false.
               if (nint ( nsegm(nxco,nyco) ) .eq. n .and. iworker(nxco,nyco) .gt. almostzero) then
                 is = nxco
                 js = nyco
                 lfoundold = .true.
                 goto 555
               endif
               do j=nymino(n),nymaxo(n)
                 do i=nxmino(n),nxmaxo(n)
                   if (nint ( nsegm(i,j) ) .eq. n .and. iworker(i,j) .gt. almostzero) then
                     is = i
                     js = j
                     lfoundold = .true.
                     goto 555
                   endif
                 enddo
               enddo
!!               if (lev .eq. nlevs) then
!!                 write (iotty,'(/a,8i5,1x,a3)') '   SFINDER: ERROR: Seed pixel for an old source not found: '
!!     &                                        , lev, n, nxco, nyco, nxmin(n), nxmax(n), nymin(n), nymax(n), '"'//flag(n)//'"'
!!                 stop 98
!!               endif
  555          continue
             
               if (lfoundold) then
                 newpixval = dble ( n )
              
                 call fillarea ( .true., is, js, nextrmax, nextr, newpixval, 'positive', almostzero, boupixval, nx, ny, n1x, n2x
     &                         , n1ymin, n2ymax, nxmin(n), nxmax(n), nymin(n), nymax(n), iworker, nsegm, osegm, mxco, myco, deltx
     &                         , delty, ntouching, nsx )
               
                 if (.not.laccelerate) then
                   nxmin(n) = n1xmin
                   nxmax(n) = n2xmax
                   nymin(n) = n1ymin
                   nymax(n) = n2ymax
                 endif

! Check if all segmentation pixels for this sources have been filled.
! Zero out those not filled in above with newpixval, as they must be detached from (not connected to) the main segmentation area.
                 
                 nxminn = min ( nxmin(n), nxmino(n) )
                 nxmaxn = max ( nxmax(n), nxmaxo(n) )
                 nyminn = min ( nymin(n), nymino(n) )
                 nymaxn = max ( nymax(n), nymaxo(n) )
             
                 chan = ' '
                 l1st = .true.
                 do j=nyminn,nymaxn
                   do i=nxminn,nxmaxn
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       if (iworker(i,j) .gt. almostzero) then
                         if (iworker(i,j) .lt. 1.0d0) then
                           if (l1st) then
                             l1st = .false.
                             write (chan,'(i5)') n
                           endif
                           nsegm(i,j) = 0.0d0
                         endif
                       endif
                     endif
                   enddo
                 enddo
                 nxmino(n) = nxmin(n)
                 nxmaxo(n) = nxmax(n)
                 nymino(n) = nymin(n)
                 nymaxo(n) = nymax(n)
             
                 icp = lastc ( cproblem )
                 cproblem = cproblem(1:icp)//chan
               endif
             endif
           endif
         enddo
         
         write (cnn,'(i7)') nextr
         ncn = int ( log10 ( dble ( max ( nextr, 1 ) ) ) ) + 1
         if (cverbose .eq. '-verb2') write (iotty,'(a,$)') cnn(7-ncn+1:7)//' sources'
         write (cnn,'(i7)') noisesources
         ncn = int ( log10 ( dble ( max ( noisesources, 1 ) ) ) ) + 1
         if (cverbose .eq. '-verb2') write (iotty,'(a,$)') ' (-'//cnn(7-ncn+1:7)//')'
         if (cverbose .eq. '-verb2') write (iotty,'()')

         icp = lastc ( cproblem )
         if (cverbose .ne. '-verb0' .and. icp .gt. 1) then
           write (iotty,'(/a/)') '     WARNING: SOME OLD SOURCES WERE SPLIT (FIXED)'//cproblem(1:icp)
         endif

         if (ltiming) then
           cput_filling_old = cput_filling_old + timer ( 'cpu', cpu_filling_old )
           walt_filling_old = walt_filling_old + timer ( 'wal', wal_filling_old )
         endif
         
! Debugging output.

         if (ldebug) then

! NOTE: 'iworker' is the same as the single-scale image only in the beginning. 
! Calls to FILLAREA replace initial intensity values with the segmentation mask values, so better be careful and
! do not interpret 'iworker' as simple intensity image.

           if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//imageln(1:iikn)//''''
          
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, iworker, dx, dy, object
     &                , crval1, crval2, imageln(1:iikn), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

           if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//segmentl(1:isk)//''''
        
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, nsegm, dx, dy, object
     &                , crval1, crval2, segmentl(1:isk), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )
         endif

         if ((nscale .lt. nmaxscale4newsrc .and. nscale .lt. nmaxscale4sfinder) .or. nmaxscale4newsrc .eq. 0) then

           if (cverbose .eq. '-verb2') write (iotty,'(a,$)') '   Analyzing new segmentation masks at sub-level '//cl
                 
           if (ltiming) then
             cpu_filling_new = timer ( 'cpu', 0.0d0 )
             wal_filling_new = timer ( 'wal', 0.0d0 )
           endif

! Now look for new sources in addition to the previously found ones: find new sources and fill their segmentation areas.
     
           do js=n1ymin,n2ymax
             do is=n1x(js),n2x(js)
               if (iworker(is,js) .gt. almostzero .and. nsegm(is,js) .lt. almostzero) then
                 nextr = nextr + 1
                 if (nextr .gt. nextrmax) then
                   write (iotty,'(//a,i5)') '   SFINDER: ERROR: Number of sources reached NEXTRMAX = ', nextrmax
                   write (iotty,'(a     )') '            Increase the value, recompile SFINDER, and restart the detection.'
                   open ( 9, file='.toomanysources', status='unknown' )
                   write (9,'(a)') 'Number of sources reached NEXTRMAX.'
                   close ( 9 )
                   stop
                 endif
                 newpixval = dble ( nextr )
             
                 call fillarea ( .false., is, js, nextrmax, nextro, newpixval, 'positive', almostzero, boupixval, nx, ny, n1x, n2x
     &                         , n1ymin, n2ymax, nxmin(nextr), nxmax(nextr), nymin(nextr), nymax(nextr), iworker, nsegm, osegm, mxco
     &                         , myco, deltx, delty, ntouching, nsx )

                 ns1(nextr) = nscale
                 ns2(nextr) = nscale
               endif
             enddo
           enddo                   
                                          
           nextrnew = nextr - nextro
           write (cnn,'(i7)') nextrnew
           ncn = int ( log10 ( dble ( max ( nextrnew, 1 ) ) ) ) + 1
           if (cverbose .eq. '-verb2') write (iotty,'(a)') cnn(7-ncn+1:7)//' new sources'
          
           if (ltiming) then
             cput_filling_new = cput_filling_new + timer ( 'cpu', cpu_filling_new )
             walt_filling_new = walt_filling_new + timer ( 'wal', wal_filling_new )
           endif

! Debugging output.

           if (ldebug) then
             if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//segmentln(1:iskn)//''''
        
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, nsegm, dx, dy, object
     &                  , crval1, crval2, segmentln(1:iskn), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &                  , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )
           endif
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (nextr .gt. nextro) then
           do n=nextro+1,nextr
             if (.not.laccelerate) then
               nxmin(n) = n1xmin
               nxmax(n) = n2xmax
               nymin(n) = n1ymin
               nymax(n) = n2ymax
             endif
             do k=1,nextr
               ntouchino(n,k) = 0
               ntouching(n,k) = 0
             enddo
             lisolated(n) = .true.
             lgotanother(n) = .false.
             lcoordsdone(n) = .false.
             nxmino(n) = nxmin(n)
             nxmaxo(n) = nxmax(n)
             nymino(n) = nymin(n)
             nymaxo(n) = nymax(n)
           enddo
         
! Measure and catalog parameters of *new* sources using intensity moments.
                                 
           if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Measuring properties of new sources'
         
           call measure ( iotty, nextro+1, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image
     &                  , nsegm, dx, dy, mxco, myco, mxcor, mycor, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta
     &                  , equivrad, elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, .true.
     &                  , cverbose )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         do n=1,nextr
           if (flag(n) .eq. ' ' .or. flag(n) .eq. 'm') then
             nonzero(n) = 0
             nimglev(n) = 0
             do j=nymin(n),nymax(n)
               do i=nxmin(n),nxmax(n)
                 if (nint ( nsegm(i,j) ) .eq. n) then
                   if (image(i,j) .gt. almostzero) nonzero(n) = nonzero(n) + 1
                   if (image(i,j) .gt. imglev) nimglev(n) = nimglev(n) + 1
                 endif
               enddo
             enddo
           endif
         enddo
         
!-----------------------------------------------------------------------------------------------------------------------------------

         if (nscaleo .gt. 0) then
           if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Identifying merging sources'
           
           if (ltiming) then
             cpu_checkmerging = timer ( 'cpu', 0.0d0 )
             wal_checkmerging = timer ( 'wal', 0.0d0 )
           endif
           
           call checkmerging ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, mxco, myco, nx, ny, image, nsegm, almostzero, nonzero
     &                       , flag, ntouching, lisolated, lcoordsdone )
           
           if (ltiming) then
             cput_checkmerging = cput_checkmerging + timer ( 'cpu', cpu_checkmerging )
             walt_checkmerging = walt_checkmerging + timer ( 'wal', wal_checkmerging )
           endif
         endif
         
!-----------------------------------------------------------------------------------------------------------------------------------

         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Checking isolation of all sources'
       
         if (ltiming) then
           cpu_checkisolation = timer ( 'cpu', 0.0d0 )
           wal_checkisolation = timer ( 'wal', 0.0d0 )
         endif

         call checkisolation ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, flag, nx, ny, image, nsegm, nonzero, imglev, ntouching
     &                       , intenstouch, lisolated, lcoordsdone )

         if (ltiming) then
           cput_checkisolation = cput_checkisolation + timer ( 'cpu', cpu_checkisolation )
           walt_checkisolation = walt_checkisolation + timer ( 'wal', wal_checkisolation )
         endif
         
!-----------------------------------------------------------------------------------------------------------------------------------

         do n=1,nextr
           flago(n) = flag(n)
         enddo
       
         do n=1,nextr
           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
             if (lcoordsdone(n)) then
               if (nonzero(n) .gt. 0) then
                 ns2(n) = nscale
               else 
                 if (flag(n) .eq. ' ' .or. flag(n) .eq. 'm') then
                   flag(n) = 'z'
                 endif
               endif
             endif
           endif
         enddo

!-----------------------------------------------------------------------------------------------------------------------------------
         
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Measuring parameters of all sources'

         if (ltiming) then
           cpu_measuring = timer ( 'cpu', 0.0d0 )
           wal_measuring = timer ( 'wal', 0.0d0 )
         endif

         call measure ( iotty, 1, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image, nsegm
     &                , dx, dy, mxco, myco, mxcor, mycor, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad
     &                , elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, .true., cverbose )
                               
         if (ltiming) then
           cput_measuring = cput_measuring + timer ( 'cpu', cpu_measuring )
           walt_measuring = walt_measuring + timer ( 'wal', wal_measuring )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Detecting and marking noise peaks'
       
         if (ltiming) then
           cpu_identifynoise = timer ( 'cpu', 0.0d0 )
           wal_identifynoise = timer ( 'wal', 0.0d0 )
         endif

         call identifynoise ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, n1x, n2x, n1ymin, n2ymax, nscale, mxco, myco, deltx
     &                      , delty, almostzero, flag, flago, ns1, ns2, nsx, nx, ny, dx, dy, image, nsegm, segmen, nonzero, contrast
     &                      , contramin, factnoise, contranoise, imglev, ntouching, ntouchino, intenstouch, lisolated, lgotanother
     &                      , lcoordsdone )
        
         if (ltiming) then
           cput_identifynoise = cput_identifynoise + timer ( 'cpu', cpu_identifynoise )
           walt_identifynoise = walt_identifynoise + timer ( 'wal', wal_identifynoise )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Measuring parameters of special sources'

         if (ltiming) then
           cpu_measurespecial = timer ( 'cpu', 0.0d0 )
           wal_measurespecial = timer ( 'wal', 0.0d0 )
         endif

         call measure ( iotty, 1, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image, nsegm
     &                , dx, dy, mxco, myco, mxcor, mycor, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad
     &                , elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, .false., cverbose )
                               
         if (ltiming) then
           cput_measurespecial = cput_measurespecial + timer ( 'cpu', cpu_measurespecial )
           walt_measurespecial = walt_measurespecial + timer ( 'wal', wal_measurespecial )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         do n=1,nextr
           if (nonzero(n) .eq. 0) then
             if (lcoordsdone(n)) then
               l1st = .true.
               do j=nymin(n),nymax(n)
                 do i=nxmin(n),nxmax(n)
                   if (nint ( nsegm(i,j) ) .eq. n) then
                     if (l1st) then        
                       if (n .lt. 1000000) then
                         write (cnobj,'(i6.6)') n
                       else 
                         cnobj = 'xxxxxx'
                       endif
                       if (cverbose .eq. '-verb2') then
                         write (iotty,'(a)') '   Wiping out segmentation for fainted source # '//cnobj
                       endif
                       l1st = .false.
                     endif
                     nsegm(i,j) = 0.0d0
                   endif
                 enddo
               enddo
             endif
           endif
         enddo
  
!-----------------------------------------------------------------------------------------------------------------------------------
                                 
         if (lev .eq. nlevs) then

           do n=1,nextr
           
             ldone = .false.
          
! Compute first derivatives of the peak flux for every source.

             if (nsx(n) .eq. 0) then
           
               if (flag(n) .eq. ' ') then

                 ratio = fluxpeak(n) / sigma
                 if (ratio .gt. sigglob(n)) sigglob(n) = ratio

                 if (lcoordsdone(n)) then
                   
! Require that the maximum intensity over the source segmentation is separated from the segmentation border
! by at least one pixel on all sides. Otherwise, the source must be footprinted immediately.

!!                   if (nonzero(n) .ge. 16) then
                     smax = 0.0d0
                     imx = 0
                     jmx = 0
                     do j=nymin(n),nymax(n)
                       do i=nxmin(n),nxmax(n)
                         if (nint ( nsegm(i,j) ) .eq. n .and. abs ( image(i,j) ) .gt. smax) then
                           smax = abs ( image(i,j) )
                           imx = i
                           jmx = j
                         endif
                       enddo
                     enddo
                     linside = (nint ( nsegm(imx-1,jmx-1) ) .eq. n .or. nint ( nsegm(imx-1,jmx-1) ) .eq. 0) .and. 
     &                         (nint ( nsegm(imx  ,jmx-1) ) .eq. n .or. nint ( nsegm(imx  ,jmx-1) ) .eq. 0) .and.
     &                         (nint ( nsegm(imx+1,jmx-1) ) .eq. n .or. nint ( nsegm(imx+1,jmx-1) ) .eq. 0) .and. 
     &                         (nint ( nsegm(imx-1,jmx  ) ) .eq. n .or. nint ( nsegm(imx-1,jmx  ) ) .eq. 0) .and.
     &                         (nint ( nsegm(imx+1,jmx  ) ) .eq. n .or. nint ( nsegm(imx+1,jmx  ) ) .eq. 0) .and. 
     &                         (nint ( nsegm(imx-1,jmx+1) ) .eq. n .or. nint ( nsegm(imx-1,jmx+1) ) .eq. 0) .and.
     &                         (nint ( nsegm(imx  ,jmx+1) ) .eq. n .or. nint ( nsegm(imx  ,jmx+1) ) .eq. 0) .and. 
     &                         (nint ( nsegm(imx+1,jmx+1) ) .eq. n .or. nint ( nsegm(imx+1,jmx+1) ) .eq. 0)
                     
                     isa = nint ( mxcor(n) )                
                     jsa = nint ( mycor(n) )
                    
                     if (.not.linside .and. (imx .ne. isa .or. jmx .ne. jsa) .and. sscale .gt. obsbeammin) then
                       flag(n) = 'f'
!!                       scalensx(n) = sscaleo
!!                       nsx(n) = nscaleo
                       scalensx(n) = sscale
                       nsx(n) = nscale
                       ldone = .true.
                     endif
!!                   endif

! If the above special case did not apply, check the usual conditions to footprint a source.

                   is = nint ( mxco(n) )                
                   js = nint ( myco(n) )
                   
                   if (.not.ldone) then

! This debledning part needs optimization: only the current and new scales have to be deblended;
! derivatives from the old scales should be taken from detection catalogs at previous scales.

                     dfpdso(n) = 0.0d0

                     if (abs ( dfpds(n) ) .gt. almostzero) then
                       dfpdso(n) = dfpds(n)
                     else
                       if (oldimage .ne. 'none' .and. simageo(is,js) .gt. almostzero) then
                       
                         call deblend ( n, max ( sscaleo, equivrad(n) ), nx, ny, dx, dy, nextr, mxco, myco, simageo, detectomask
     &                                , factortotal, almostzero, deblendedo )
                       
                         if (ooldimage .ne. 'none' .and. simageoo(is,js) .gt. almostzero) then
                           
                           call deblend ( n, max ( sscaleoo, equivrad(n) ), nx, ny, dx, dy, nextr, mxco, myco, simageoo, detectomask
     &                                  , factortotal, almostzero, deblendedoo )
        
                           dfpdso(n) = deblendedo - deblendedoo
                           if (dfpdso(n) .lt. -almostzero .and. dfpds(n) .gt. almostzero) then
                             dfpdso(n) = dfpds(n)
                           endif
                         endif
                       endif
                     endif

                     dfpds(n) = 0.0d0

                     if (abs ( dfpdsn(n) ) .gt. almostzero) then
                       dfpds(n) = dfpdsn(n)
                     else
                       if (simage(is,js) .gt. almostzero) then
                       
                         call deblend ( n, max ( sscale, equivrad(n) ), nx, ny, dx, dy, nextr, mxco, myco, simage, detectomask
     &                                , factortotal, almostzero, deblended )
                         
                         if (oldimage .ne. 'none' .and. simageo(is,js) .gt. almostzero) then
                         
                           call deblend ( n, max ( sscaleo, equivrad(n) ), nx, ny, dx, dy, nextr, mxco, myco, simageo, detectomask
     &                                  , factortotal, almostzero, deblendedo )
                        
                           dfpds(n) = deblended - deblendedo
                         endif
                       endif
                     endif

                     dfpdsn(n) = 0.0d0

                     if (simagen(is,js) .gt. almostzero) then
                       
                       call deblend ( n, max ( sscalen, equivrad(n) ), nx, ny, dx, dy, nextr, mxco, myco, simagen, detectomask
     &                              , factortotal, almostzero, deblendedn )

                       if (simage(is,js) .gt. almostzero) then
        
                         call deblend ( n, max ( sscale, equivrad(n) ), nx, ny, dx, dy, nextr, mxco, myco, simage, detectomask
     &                                , factortotal, almostzero, deblended )

                         dfpdsn(n) = deblendedn - deblended
                       endif
                     endif
                     
! 2020-07-30: Do not footprint those peaks that have too few pixels.

                     srcpixels = pi * equivrad(n)**2 / sqpixel
                     srcpixmin = max ( 3.0d0, 0.5d0 * sscale * sfactor**(ns1(n) - nscale) / dx )

                     if (srcpixels .ge. srcpixmin) then
                       if (dfpdso(n) .gt. -almostzero .and. dfpds(n) .lt. -almostzero .and. dfpdsn(n) .lt. -almostzero .and.
     &                     nscale .ge. ns1(n) + 1) then
                         nsx(n) = nscale
                         scalensx(n) = sscale
                         flag(n) = 'f'
                         ldone = .true.
                       endif
                       if (dfpdso(n) .lt. -almostzero .and. dfpds(n) .lt. -almostzero .and. dfpdsn(n) .lt. -almostzero .and.
     &                     nscale .le. ns1(n) + 1) then
                         nsx(n) = nscale
                         scalensx(n) = sscale
                         flag(n) = 'f'
                         ldone = .true.
                       endif
                     endif
                   endif

! If the coordinates of a source point to another one, this source is bad and marked as noise.

                   if (n .ne. nint ( nsegm(is,js) )) then
                     flag(n) = 'n'
                     ldone = .false.
                     do j=nymin(n),nymax(n)
                       do i=nxmin(n),nxmax(n)
                         if (nint ( nsegm(i,j) ) .eq. n) then
                           nsegm(i,j) = 0.0d0
                         endif
                       enddo
                     enddo
                   endif
                 endif
               endif

! 2019-06-17: Next fragment contained some old stuff increasing estimate of the characteristic scale; now removed.

               if (flag(n) .eq. 'm') then
                 scalensx(n) = sscale
                 nsx(n) = nscale
               endif

               if (flag(n) .eq. 'n') then
                 scalensx(n) = sscale
                 nsx(n) = nscale
                 ns2(n) = nsx(n)
                 ldone = .false.
               endif
               
               if (flag(n) .eq. 'z') then
                 scalensx(n) = sscale
                 nsx(n) = nscale
                 ns2(n) = nsx(n)
                 ldone = .true.

! 2018-02-04 FIX A.B.M: Those "sources" that appear and disappear on one scale, must be considered noise and not be footprinted. 
! Otherwise, they may interfere with the same source (same position!), which could appear on later scales.

                 if (ns2(n) .le. ns1(n) + 2) then
                   flag(n) = 'n'
                   ldone = .false.
                 endif
               endif
             endif
             
             if (flag(n) .eq. 'm' .and. nsx(n) .eq. nscale) then
               ldone = .true.
             endif

             if (nscale .eq. nmaxscale4sfinder .and. (flag(n) .eq. ' ' .or. nsx(n) .eq. 0)) then  !! .or. flag(n) .eq. 'z'
               nsx(n) = ns2(n)
               scalensx(n) = sscale
!!               flag(n) = 'f'
               flag(n) = 'n'
               ldone = .false.
             endif

             if (flag(n) .eq. 'n') then
               ldone = .false.
             endif

! Outer sizes of an elliptical footprint for calculating total fluxes.

             if (flag(n) .ne. 'n') then
               tfluxradius = factortotal * max ( obsbeammin, scalensx(n) ) / 2.0d0
               footfact(n) = factortotal
               foomajor(n) = 2.0d0 * tfluxradius
               foominor(n) = foomajor(n)

!!! Test and discard sources too close to the mask edges: they must all be noise or unusable.
!!
!!               if (lcoordsdone(n)) then
!!                 maxradedge = max ( obsbeammin, scalensx(n) ) / 2.0d0
!!                 maxradedge2 = maxradedge**2
!!                 nr = nint ( maxradedge / min ( dx, dy ) )
!!                 l1 = max ( nint ( mxco(n) ) - nr, 1 )
!!                 l2 = min ( nint ( mxco(n) ) + nr, nx )
!!                 m1 = max ( nint ( myco(n) ) - nr, 1 )
!!                 m2 = min ( nint ( myco(n) ) + nr, ny )
!!                 do m=m1,m2
!!                   dyco2 = ((dble ( m ) - myco(n)) * dy)**2
!!                   do l=l1,l2
!!                     dxco2 = ((dble ( l ) - mxco(n)) * dx)**2
!!                     rxy2 = dxco2 + dyco2
!!                     if (rxy2 .le. maxradedge2) then
!!                       if (detectomask(l,m) .lt. 0.9d0) then
!!                         flag(n) = 'n'
!!                         ldone = .false.
!!                         goto 454
!!                       endif
!!                     endif
!!                   enddo
!!                 enddo
!! 454             continue
!!               endif
             endif

! Create footprints of done sources.

             if (ldone) then

               call makefoots ( n, mxco, myco, tfluxradius, dx, dy, nx, ny, foots )

               lfoots = .true.
             endif
           enddo
         endif

         if (nscale .eq. nmaxscale4sfinder) then
           lallsourcesdone = .true.
         endif
 999     continue    
       enddo

       deallocate ( detectomask )

 666   continue

! If no sources have been detected, create one fictitious source to allow further processing.
       
       if (contranoise .lt. almostzero .or. (lallsourcesdone .and. nextr .eq. 0)) then
         lallsourcesdone = .true.
         nextr = 1
         delta = 0.0d0
         nlevs = 0
         ns1       (1) = 1
         ns2       (1) = 1
         nsx       (1) = 1
         flag      (1) = 'n'
         mxco      (1) = dble ( nx ) / 2.0d0
         myco      (1) = dble ( ny ) / 2.0d0
         mxcor     (1) = mxco(1)
         mycor     (1) = myco(1)
         sigglob   (1) = 1.0d0
         flg       (1) = 0
         good      (1) = 1.0d-1
         sigmono   (1) = 1.0d-1
         flm       (1) = 0
         fxpbest   (1) = 1.0d0
         fxperror  (1) = 1.0d0
         fxtbest   (1) = 1.0d0
         fxterror  (1) = 1.0d0
         fluxalter (1) = 1.0d0
         scalensx  (1) = 1.0d0
         afwhm     (1) = 1.0d0
         bfwhm     (1) = 1.0d0
         atheta    (1) = 1.0d0
         equivrad  (1) = 1.0d0
         footfact  (1) = 1.0d0
         foomajor  (1) = 1.0d0
         foominor  (1) = 1.0d0
         fluxpeak  (1) = 1.0d0
         fluxtot   (1) = 1.0d0
         elongation(1) = 1.0d0
         factnoise (1) = 1.0d0
         contramin (1) = 1.0d0
         contrast  (1) = 1.0d0
         dfpdso    (1) = 1.0d0
         dfpds     (1) = 1.0d0
         dfpdsn    (1) = 1.0d0
         nxmin     (1) = 1
         nxmax     (1) = nx
         nymin     (1) = 1
         nymax     (1) = ny
         ktouching (1) = 0
         ntouching (1,1) = 0
       endif

       if (ltiming) then
         cpu_writing_images = timer ( 'cpu', 0.0d0 )
         wal_writing_images = timer ( 'wal', 0.0d0 )
       endif

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing segmentation image '''//newsegm(1:ins)//''''
       
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, nsegm, dx, dy, object, crval1
     &            , crval2, newsegm(1:ins), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )

       deallocate ( nsegm )
       
       if (lfoots) then
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing footprints image '''//footprint(1:ifp)//''''
       
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, foots, dx, dy, object, crval1
     &              , crval2, footprint(1:ifp), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wave, datamin, datamax, history )
       endif

       deallocate ( foots )
       
       if (ltiming) then
         cput_writing_images = cput_writing_images + timer ( 'cpu', cpu_writing_images )
         walt_writing_images = walt_writing_images + timer ( 'wal', wal_writing_images )
       endif

       catname = newsegm(1:ins-5)//'.cat'
       iocat = lastc ( catname )

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing detection catalog '''//catname(1:iocat)//''''

       write (cpix,'(f8.5)') sqrt ( dx * dy )
       cpixx = cpix
       if (cpix(1:1) .eq. ' ') cpixx = cpix(2:8)
       lpix = lastc ( cpixx )

       write (cnx,'(i7)') nx
       write (cny,'(i7)') ny
       ncx = int ( log10 ( dble ( nx ) ) ) + 1
       ncy = int ( log10 ( dble ( ny ) ) ) + 1
       write (cne,'(i7)') nextr
       ncne = int ( log10 ( dble ( max ( nextr, 1 ) ) ) ) + 1
       write (cnn,'(i7)') noisesources
       ncnn = int ( log10 ( dble ( max ( noisesources, 1 ) ) ) ) + 1
       write (cng,'(i7)') nextr - noisesources
       ncng = int ( log10 ( dble ( max ( nextr - noisesources, 1 ) ) ) ) + 1

       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi

       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rotangle = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rotangle = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rotangle = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rotangle = - rotangle
       endif
       write (crotangle,'(1pe11.3)') rotangle
       icre = 11
!!       if (crotangle(1:1) .eq. ' ' .or. crotangle(1:1) .eq. '-') icr = 1
!!       if (crotangle(2:2) .eq. ' ' .or. crotangle(2:2) .eq. '-') icr = 2
       if (rotangle .ge. 0.0d0) crotangle(1:2) = '- '
       if (rotangle .lt. 0.0d0) crotangle(1:2) = '+ '
!!       if (abs ( rotangle ) .lt. almostzero) then
!!         icr = 1
!!         icre = 2
!!         crotangle(icr:icr) = '+'
!!         crotangle(icre:icre) = '0'
!!       endif

! Compute coordinates in an un-rotated image to feed them later to the XY2SKY utility to calculate world coordinates.

       if (lallsourcesdone) then
         mxcomin = +1.0e+30
         mxcomax = -1.0e+30
         mycomin = +1.0e+30
         mycomax = -1.0e+30

         do n=1,nextr
           mxcor(n) = - ( mxco(n) - crpix1 ) * cd11 / dxdeg - ( myco(n) - crpix2 ) * cd12 / dydeg
           mycor(n) =   ( mxco(n) - crpix1 ) * cd21 / dxdeg + ( myco(n) - crpix2 ) * cd22 / dydeg
           if (mxcor(n) .lt. mxcomin) mxcomin = mxcor(n)
           if (mxcor(n) .gt. mxcomax) mxcomax = mxcor(n)
           if (mycor(n) .lt. mycomin) mycomin = mycor(n)
           if (mycor(n) .gt. mycomax) mycomax = mycor(n)
         enddo
         mxcomin = mxcomin - 1.0d0
         mxcomax = mxcomax
         mycomin = mycomin - 1.0d0
         mycomax = mycomax
         
         crpix1n = dble ( max ( - int ( mxcomin ), 1 ) + 1 ) + (crpix1 - dble ( int ( crpix1 ) ))
         crpix2n = dble ( max ( - int ( mycomin ), 1 ) + 1 ) + (crpix2 - dble ( int ( crpix2 ) ))
         nxn = nint ( crpix1n + mxcomax )
         nyn = nint ( crpix2n + mycomax )
         
         allocate ( unrotated(nxn,nyn), stat=irc )

         if (irc .ne. 0) then
           write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (77).'
           stop 77
         endif
  
         do j=1,nyn
           do i=1,nxn
             unrotated(i,j) = 0.0d0
           enddo
         enddo
  
         do n=1,nextr
           mxcor(n) = mxcor(n) + crpix1n
           mycor(n) = mycor(n) + crpix2n
           nxco = nint ( mxcor(n) )
           nyco = nint ( mycor(n) )
           unrotated(nxco,nyco) = float ( n ) 
         enddo

         nx1 = nint ( crpix1 + mxcomin )
         ny1 = nint ( crpix2 + mycomin )
       else
         do n=1,nextr
           mxcor(n) = mxco(n)
           mycor(n) = myco(n)
         enddo
         nx1 = 1
         ny1 = 1
       endif

       write (cnx1,'(i5)') nx1
       cnx1o = cnx1
       if (cnx1(1:1) .eq. ' '    ) cnx1o = cnx1(2:5)
       if (cnx1(1:2) .eq. '  '   ) cnx1o = cnx1(3:5)
       if (cnx1(1:3) .eq. '   '  ) cnx1o = cnx1(4:5)
       if (cnx1(1:4) .eq. '    ' ) cnx1o = cnx1(5:5)
       lnx1o = lastc ( cnx1o )

       write (cny1,'(i5)') ny1
       cny1o = cny1
       if (cny1(1:1) .eq. ' '    ) cny1o = cny1(2:5)
       if (cny1(1:2) .eq. '  '   ) cny1o = cny1(3:5)
       if (cny1(1:3) .eq. '   '  ) cny1o = cny1(4:5)
       if (cny1(1:4) .eq. '    ' ) cny1o = cny1(5:5)
       lny1o = lastc ( cny1o )
         
       open ( 55, file=catname(1:iocat), status='unknown' )

       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'
       write (55,'(a)') getstitle
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'
       write (55,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by SFINDER compiled on '//compda
       write (55,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (55,'(a)') '# Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                //'(william.d.pence@nasa.gov)'
       write (55,'(a)') '#'
       write (55,'(a)') '# DETECTION TABLE for image '''//imagename(1:ifn)//''' (pixel: '//cpixx(1:lpix)//' arcsec,'
     &                //' size: '//cnx(7-ncx+1:7)//' x '//cny(7-ncy+1:7)//' pixels)'
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       if (ncfglines .gt. 0) then
         write (55,'(a)') '#'
         write (55,'(a)') '# CONFIGURATION PARAMETERS USED BY GETSF:'
         write (55,'(a)') '#'
         do i=1,ncfglines
           if (cfgline(i)(1:1) .ne. '#' .and. cfgline(i)(1:1) .ne. '!') then
             lcfg = lastc ( cfgline(i) )
             if (index ( cfgline(i)(1:lcfg), '| usm ...' ) .gt. 0) exit
             write (55,'(a)') '#'//cfgline(i)(1:lcfg)
           endif
         enddo
         write (55,'(a)') '#_______________________________________________________________________________________________'
     &                  //'____________________________________'  
       endif
       write (55,'(a)') '#'
       write (55,'(a)') cscales(1:isl)//cns(1:lcns)//' '//csscale
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'
       write (55,'(a,f6.3,a,i3,a)') '# TABULATED QUANTITIES, TOTAL OF '//cne(7-ncne+1:7)//' SOURCES ('
     &                //cng(7-ncng+1:7)//' GOOD + '//cnn(7-ncnn+1:7)//' NOISE); delta:', delta,', sub-levels: ', nlevs,'.'
       write (55,'(a)') '#'
       write (55,'(a)') '#   NO ............ Source running number ....................................'
       write (55,'(a)') '#   S1 ............ Number of the smallest scale where source first appears ..'
       write (55,'(a)') '#   S2 ............ Number of the largest scale where source still exists ....'
       write (55,'(a)') '#   SX ............ Number of the footprinting scale for current source ......'
       write (55,'(a)') '#   F ............. Detection flag (m: merged, z: fainted, f: footprinted, n: noise)'
       write (55,'(a)') '#   XCO_PIXEL ..... X-coordinate relative to the lower-left pixel (1,1) ...... (pixels)'
       write (55,'(a)') '#   YCO_PIXEL ..... Y-coordinate relative to the lower-left pixel (1,1) ...... (pixels)'
       write (55,'(a)') '#   XCO_PIXRO ..... X-coordinate (un-rotated) ................................ (pixels)'
     &                //' relative to the pixel ('//cnx1o(1:lnx1o)//','//cny1o(1:lny1o)//')'
       write (55,'(a)') '#   YCO_PIXRO ..... Y-coordinate (un-rotated) ................................ (pixels)'
     &                //' relative to the pixel ('//cnx1o(1:lnx1o)//','//cny1o(1:lny1o)//')'
       write (55,'(a)') '#   FG ............ Flag describing global properties over all wavelengths ...'
     &                //' see definitions below'
       write (55,'(a)') '#   SIGN .......... Global detection significance over all wavelengths ....... SIGN ='
     &                //' sqrt ( sum ( SIGNM^2 ) )'
       write (55,'(a)') '#   GOOD .......... Global goodness combining significance and S/N ........... GOOD ='
     &                //' sqrt ( sum ( GOODM^2 ) )'
       write (55,'(a)') '#   FM ............ Flag describing monochromatic properties .................'
     &                //' see definitions below'
       write (55,'(a)') '#   SIGNM ......... Detection significance from monochromatic single scales .. SIGNM = SSPEAK / SSTDEV'
     &                //' single-scale analog of S/N ratio'
       write (55,'(a)') '#   GOODM ......... Monochromatic goodness combining significance and S/N ....'
     &                //' GOODM = (SIGNM / SIGNM_MIN) * sqrt ( SNRP / SNRP_MIN * SNRT / SNRT_MIN ) * (BFWHM / AFWHM)'
       write (55,'(a)') '#   FXP_BST ....... Peak intensity ........................................... ('//bunit(1:iu)//')'
       write (55,'(a)') '#   FXP_ERR ....... Peak intensity error ..................................... ('//bunit(1:iu)//')'
       write (55,'(a)') '#   FXT_BST ....... Total flux ............................................... ('//funits(1:fu)//')'
       write (55,'(a)') '#   FXT_ERR ....... Total flux error ......................................... ('//funits(1:fu)//')'
       write (55,'(a)') '#   FXT_ALT ....... Total flux (Gaussian) or MASS ............................ ('//funits(1:fu)//')'
       write (55,'(a)') '#   SCALE_SX ...... Characteristic size (FWHM) or ALPHABE .................... (arcsec)'
       write (55,'(a)') '#   AFWHM_INT ..... Major size at half-maximum (FWHM) ........................ (arcsec) interpolated'
     &                //' from intensities at half-maximum'
       write (55,'(a)') '#   BFWHM_INT ..... Minor size at half-maximum (FWHM) ........................ (arcsec) interpolated'
     &                //' from intensities at half-maximum'
       write (55,'(a)') '#   ASIZE_MOM ..... Major size from intensity moments ........................ (arcsec) below half'
     &                //'-maximum for non-Gaussian sources'
       write (55,'(a)') '#   BSIZE_MOM ..... Minor size from intensity moments ........................ (arcsec) below half'
     &                //'-maximum for non-Gaussian sources'
       write (55,'(a)') '#   THETA_MOM ..... Angle of the major axis (east of vertical) ............... (degrees) position angle'
     &                //' PA = THETA '//crotangle(1:icre)//' (east of north)'
       write (55,'(a)') '#   FOOT_FACT ..... Footprint expansion or shrinkage scaling factor .......... "negative" for sources'
     &                //' with completed footprints'
       write (55,'(a)') '#   FOOAMAJOR ..... Full major axis of an elliptical footprint ............... (arcsec)'
       write (55,'(a)') '#   FOOBMINOR ..... Full minor axis of an elliptical footprint ............... (arcsec)'
       write (55,'(a)') '#   PEAKFLUX ...... Peak intensity at current scale .......................... ('//bunit(1:iu)//')'
       write (55,'(a)') '#   TOTALFLUX ..... Total flux at current scale .............................. ('//funits(1:fu)//')'
       write (55,'(a)') '#   NXMIN ......... Minimum X-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#   NXMAX ......... Maximum X-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#   NYMIN ......... Minimum Y-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#   NYMAX ......... Maximum Y-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'                                                           
       write (55,'(a)') '#   NO S1 S2 SX  F  XCO_PIXEL  YCO_PIXEL   XCO_PIXRO    YCO_PIXRO  FG    SIGN       GOOD      FM'
     &                //'    SIGNM      GOODM     FXP_BST    FXP_ERR    FXT_BST    FXT_ERR    FXT_ALT   SCALE_SX   AFWHM_INT'
     &                //'  BFWHM_INT  ASIZE_MOM  BSIZE_MOM  THETA_MOM  FOOT_FACT  FOOAMAJOR  FOOBMINOR  PEAKFLUX'
     &                //'   TOTALFLUX  ELONGATIO  FACTNOISE  CONTRAMIN  CONTRAST    dPFdSo    dPFdS     dPFdSn'              
     &                //'   NXMIN  NXMAX  NYMIN  NYMAX'
       write (55,'(a)') '#'

       do n=1,nextr
         kk = 0
         do k=1,nextr
           if (k .ne. n) then
             if (ntouching(n,k) .ge. 1 .or. ntouchino(n,k) .ge. 1) then
               kk = kk + 1
               if (kk .gt. maxtouch) then
                 write (iotty,'(/a,i5)') '   SFINDER: ERROR: Too many sources touching the source # ', n
                 stop 92
               endif
               if (ntouching(n,k) .eq. 2) then
                 ktouching(kk) = -k
               else
                 ktouching(kk) = k
               endif
             endif
           endif     
         enddo
         write (cfmt,'(i6)') kk + 1

         write (55,'(i6,3i3,2x,a,2(f11.4),2(f13.7),i3,2(1pe11.3),i5,22(1pe11.3),3(e10.2),4i7,1x,i3,'//cfmt//'i6)') 
     &         n, ns1(n), ns2(n), nsx(n), flag(n), mxco(n), myco(n), mxcor(n), mycor(n), flg(n), sigglob(n), good(n), flm(n)
     &       , sigmono(n), equivrad(n), fxpbest(n), fxperror(n), fxtbest(n), fxterror(n), fluxalter(n), scalensx(n), afwhm(n)
     &       , bfwhm(n), afwhm(n), bfwhm(n), atheta(n), footfact(n), foomajor(n), foominor(n), fluxpeak(n), fluxtot(n)
     &       , elongation(n), factnoise(n), contramin(n), contrast(n), dfpdso(n), dfpds(n), dfpdsn(n), nxmin(n), nxmax(n)
     &       , nymin(n), nymax(n), kk, (ktouching(k), k=1,kk)
       enddo

       close ( 55 )

       if (lallsourcesdone) then
         idot1 = index ( imagename, '.' )
         idot2 = index ( imagename(idot1+1:ifn), '.' ) + idot1
         idot3 = index ( imagename(idot2+1:ifn), '.' ) + idot2
         unrotname = 'sm.'//imagename(1:idot3-1)//'.unrotated.fits'
         iun = lastc ( unrotname )
  
! Rotation matrix set to no-rotation values.

         cd11n = - dx / 3600.0d0
         cd12n = 0.0d0
         cd21n = 0.0d0
         cd22n = dy / 3600.0d0
  
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing unrotated image '''//unrotname(1:iun)//''''
         
         call wfits ( cfitsversion, nxn, nyn, bunit, ctype1, ctype2, crpix1n, crpix2n, crval1, crval2, unrotated, dx, dy, object
     &              , crval1, crval2, unrotname(1:iun), cdate, ctime, creator, beam, blank, crota1, crota2, cd11n, cd12n, cd21n
     &              , cd22n, equinox, bzero, bscale, wave, datamin, datamax, history )

         deallocate ( unrotated )
       endif

       deallocate ( lisolated, lgotanother, ntouching, ntouchino, intenstouch, nimglev, momxx, momyy, momxy, lcoordsdone )

       deallocate ( mxco, myco, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad, foomajor, foominor, sigmono, ns1, ns2, flag
     &            , flago, nxmin, nxmax, nymin, nymax, nonzero, fluxpo, fluxto, dfpds, dfpdso, elongationo, elongation, contramin
     &            , nsx, fxpbest, fxtbest, fxperror, fxterror, mxcor, mycor, scalensx, contrast, fluxalter, sigglob, flg
     &            , factnoise, ktouching, deltx, delty, nxmino, nxmaxo, nymino, nymaxo, flm, good, footfact, dfpdsn )

       deallocate ( image, iworker, osegm, segmen, n1x, n2x, simage, simageo, simageoo, simagen, foota )

       if (cverbose .eq. '-verb2') write (iotty,'(/a)') ' Done.'

       if (ltiming) then
         cpu_sum = cpu_sum + cput_reading_images + cput_filling_old + cput_filling_new + cput_checkmerging
     &                     + cput_checkisolation + cput_measuring + cput_identifynoise + cput_measurespecial
     &                     + cput_writing_images
         wal_sum = wal_sum + walt_reading_images + walt_filling_old + walt_filling_new + walt_checkmerging
     &                     + walt_checkisolation + walt_measuring + walt_identifynoise + walt_measurespecial
     &                     + walt_writing_images

! Total cpu usage, expressed in hours, minutes, and seconds.

         cputot = cpu_sum
         cpuhours = int ( cputot / 3600.0d0 )
         cpumins  = int ( cputot / 60.0d0 ) -  60 * cpuhours
         cpusecs  = int ( cputot + 0.5d0 ) - 3600 * cpuhours - 60 * cpumins

! Final wall clock time, expressed in hours, minutes, and seconds.

         wctot  = wal_sum
         wchours  = int ( wctot / 3600.0d0 )
         wcmins   = int ( wctot / 60.0d0 ) -  60 * wchours
         wcsecs   = int ( wctot + 0.5d0 ) - 3600 * wchours - 60 * wcmins

         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' Total ''READING IMAGES''  CPU',cput_reading_images,' REAL',walt_reading_images,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FILLING OLD''     CPU',cput_filling_old   ,' REAL',walt_filling_old   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FILLING NEW''     CPU',cput_filling_new   ,' REAL',walt_filling_new   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''CHECK MERGING''   CPU',cput_checkmerging  ,' REAL',walt_checkmerging  ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''CHECK ISOLATION'' CPU',cput_checkisolation,' REAL',walt_checkisolation,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''MEASURE PARAMS''  CPU',cput_measuring     ,' REAL',walt_measuring     ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''IDENTIFY NOISE''  CPU',cput_identifynoise ,' REAL',walt_identifynoise ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''MEASURE SPECIAL'' CPU',cput_measurespecial,' REAL',walt_measurespecial,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''WRITING IMAGES''  CPU',cput_writing_images,' REAL',walt_writing_images,' sec'
         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' ACCUMULATED CPU & REAL TIME' ,cpu_sum             ,' sec ',wal_sum            ,' sec'
         write (60,'(a,i3.2,a,i2.2,a,i2.2,a,i3.2,a,i2.2,a,i2.2,a,f7.2,a)')
     &             ' ---------------------------',cpuhours,':',cpumins,':',cpusecs,' ----',wchours,':',wcmins,':',wcsecs,' ---'
  
         call when ( lunix, ctime, cdate, ndate, 4 )
  
         write (60,'(a)') ' SFINDER finished: '//cdate//' '//ctime
         close ( 60 )
       endif
       
       if (lallsourcesdone) then
         open ( 9, file='.allsourcesdone', status='unknown' )
         write (9,'(a)') 'All sources footprinted.'
         close ( 9 )
       endif

!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine deblend

     &            ( nsrc, effsize, nx, ny, dx, dy, nextr, mxco, myco, simage, maskimage, factortotal, almostzero, deblended )
!__________________________________________________________________________________________________________________________________
!
! Deblend peak intensities of overlapping sources (in iterations).
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       
       logical       inellipse, lconverged, lallsmall
       
       integer       nx, ny, k, nextr, iter, nxco, nyco, nsrc
       
       real*8        dx, dy, almostzero, changemax, qsign, funn, funksum, argexp, argexpm, gaussfun, relerror, deblendfactor
     &             , peakiter, peakini, footk, footk2, angle, sigma2, deblended, effsize, factortotal, dlog4h, sqpixel
     
       parameter   ( relerror = 0.001d0, changemax = 0.3d0, dlog4h = log ( 4.0d0 ) / 2.0d0 )
       
       real*8        mxco(*), myco(*), convdelta(99), simage(nx,ny), maskimage(nx,ny), dist2(nextr)
       
       external      inellipse
!__________________________________________________________________________________________________________________________________
!
       nxco = nint ( mxco(nsrc) )
       nyco = nint ( myco(nsrc) )
       peakiter = simage(nxco,nyco)
       peakini = peakiter
       lconverged = .false.
       sqpixel = dx * dy
       footk = factortotal * effsize
       footk2 = footk**2 / sqpixel
       sigma2 = (effsize / 2.0d0)**2 / sqpixel
       angle = 0.0d0

       do k=1,nextr
         if (k .ne. nsrc) then
           dist2(k) = (mxco(k) - mxco(nsrc))**2 + (myco(k) - myco(nsrc))**2
         endif
       enddo

       iter = 0
  111  continue
       iter = iter + 1

       if (.not.lconverged) then
         deblended = 0.0d0
         if (maskimage(nxco,nyco) .gt. 0.9d0) then
           funn = peakiter
           funksum = 0.0d0
           do k=1,nextr
             if (k .ne. nsrc) then
               if (dist2(k) .lt. footk2) then
                 if (inellipse ( mxco(nsrc), myco(nsrc), dx, dy, mxco(k), myco(k), footk, footk, angle )) then
                   argexp = dist2(k) / sigma2
                   argexpm = min ( argexp * dlog4h, 100.0d0 )
                   gaussfun = peakiter * exp ( - argexpm )
                   funksum = funksum + gaussfun
                 endif
               endif
             endif
           enddo
           deblendfactor = 1.0d0
           if (funn + funksum .ne. 0.0d0) then
             deblendfactor = funn / (funn + funksum)
           endif
           deblended = peakini * deblendfactor
         endif
       endif

! Check convergence, limiting possible drastic changes in the quantities to reasonable values.

       lallsmall = .true.
       
       convdelta(iter) = 0.0d0
       if (.not.lconverged) then
         lconverged = .true.
         if (maskimage(nxco,nyco) .gt. 0.9d0) then
           if (abs ( deblended - peakiter ) .gt. changemax * abs ( peakiter )) then
             qsign = sign ( 1.0d0, deblended - peakiter )
             convdelta(iter) = qsign * changemax
             peakiter = (1.0d0 + qsign * changemax) * peakiter
           else
             convdelta(iter) = (deblended - peakiter) / (peakiter + almostzero)
             peakiter = deblended
           endif
           if (abs ( convdelta(iter) ) .gt. relerror) then
             lconverged = .false.
             lallsmall = .false.
           endif
         endif
       endif

       if (.not.lallsmall .and. iter .lt. 99) goto 111

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine checkmerging
         
     &            ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, mxco, myco, nx, ny, image, nsegm, almostzero, nonzero, flag
     &            , ntouching, lisolated, lcoordsdone )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, DAp IRFU CEA Saclay, France, on May 18, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       lisolated(*), lcoordsdone(*), lpeakatedge
       character*(*) flag(*)
       integer       lastc, i, j, n, nx, ny, nextr, ipvmax, jpvmax, ipvmaxm1, ipvmaxp1, jpvmaxm1, jpvmaxp1, iminz, jminz, numpixmin
     &             , iotty, nextrmax, nxco, nyco, axco, ayco
                                                                                                              
       parameter   ( iotty = 6, numpixmin = 9 )
                                                                                                              
       logical       lothertouch(4)
       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), nonzero(*), ntouching(nextrmax,*), asource(4)
       real*8        imagemin, pixvalmax, almostzero, image(nx,ny), nsegm(nx,ny), innsegm(4), inimage(4), mxco(*), myco(*)

       external      lastc, findmin
!__________________________________________________________________________________________________________________________________
!                    
       do n=1,nextr
              
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'm' .and. flag(n) .ne. 'z') then
           if (.not.lisolated(n)) then
             if (nonzero(n) .ge. numpixmin) then
               if (lcoordsdone(n)) then
                 pixvalmax = 0.0d0
                 ipvmax = 0
                 jpvmax = 0
             
! Find the source's peak intensity (at this scale) and its pixel; full single-scale image (not above the level) must be used here.

                 do j=nymin(n),nymax(n)
                   do i=nxmin(n),nxmax(n)
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       if (image(i,j) .gt. pixvalmax) then
                         pixvalmax = image(i,j)
                         ipvmax = i
                         jpvmax = j
                       endif
                     endif
                   enddo
                 enddo
         
! Find if the source has its peak intensity located at the edge of the segmentation mask. 

                 if (ipvmax .gt. 0 .and. jpvmax .gt. 0) then
                   nxco = nint ( mxco(n) )
                   nyco = nint ( myco(n) )
                   if (ipvmax .ne. nxco .and. jpvmax .ne. nyco) then
       
! Check if there is a saddle point somewhere between the source position and the brightest pixel.

                     call findmin ( mxco(n), myco(n), dble ( ipvmax ), dble ( jpvmax ), nx, ny, image, iminz, jminz, imagemin )
       
                     if (imagemin .gt. almostzero .and. iminz .eq. nxco .and. jminz .eq. nyco) then

! Look at the 4-connected pixels around the brightest pixel within the segmentation mask of the current source n.

                       ipvmaxm1 = max (  1, ipvmax - 1 )
                       ipvmaxp1 = min ( nx, ipvmax + 1 )
                       jpvmaxm1 = max (  1, jpvmax - 1 )
                       jpvmaxp1 = min ( ny, jpvmax + 1 )
                  
! Determine the touching source number from the 4-connected pixels; full single-scale image (not above the level) must be used here.

                       inimage(1) = image(ipvmaxm1,jpvmax  )
                       inimage(2) = image(ipvmaxp1,jpvmax  )
                       inimage(3) = image(ipvmax  ,jpvmaxm1)
                       inimage(4) = image(ipvmax  ,jpvmaxp1)
                   
                       innsegm(1) = nsegm(ipvmaxm1,jpvmax  )
                       innsegm(2) = nsegm(ipvmaxp1,jpvmax  )
                       innsegm(3) = nsegm(ipvmax  ,jpvmaxm1)
                       innsegm(4) = nsegm(ipvmax  ,jpvmaxp1)
                   
                       asource(1) = nint ( innsegm(1) )
                       asource(2) = nint ( innsegm(2) )
                       asource(3) = nint ( innsegm(3) )
                       asource(4) = nint ( innsegm(4) )

! The condition for a source n to have the brightest pixel right at the edge of its segmentation mask.
! If so, it must be merging with a brighter touching source. 

                       lothertouch(1) = asource(1) .ne. n .and. innsegm(1) .ge. 1.0d0
                       lothertouch(2) = asource(2) .ne. n .and. innsegm(2) .ge. 1.0d0
                       lothertouch(3) = asource(3) .ne. n .and. innsegm(3) .ge. 1.0d0
                       lothertouch(4) = asource(4) .ne. n .and. innsegm(4) .ge. 1.0d0
                
                       lpeakatedge = lothertouch(1) .or. lothertouch(2) .or. lothertouch(3) .or. lothertouch(4)

! Flag the current source n as merged with a more prominent touching source.

                       if (lpeakatedge) then
                         if (lothertouch(1)) then
                           axco = nint ( mxco(asource(1)) )
                           ayco = nint ( myco(asource(1)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(1),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                         if (lothertouch(2)) then
                           axco = nint ( mxco(asource(2)) )
                           ayco = nint ( myco(asource(2)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(2),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                         if (lothertouch(3)) then
                           axco = nint ( mxco(asource(3)) )
                           ayco = nint ( myco(asource(3)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(3),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                         if (lothertouch(4)) then
                           axco = nint ( mxco(asource(4)) )
                           ayco = nint ( myco(asource(4)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(4),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                       endif
                     endif
                   endif
                 endif
               endif
             endif
           endif               
         endif
       enddo  
       
       return
       end
        
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine checkisolation
         
     &            ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, flag, nx, ny, image, nsegm, nonzero, imglev, ntouching, intenstouch
     &            , lisolated, lcoordsdone )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, DAp IRFU CEA Saclay, France, on May 18, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       lisolated(*), lcoordsdone(*)
       character*(*) flag(*)
       integer       i, j, l, k, n, nx, ny, nextr, im1, ip1, jm1, jp1, iotty, nextrmax
                                            
       parameter   ( iotty = 6 )

       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), nonzero(*), ntouching(nextrmax,*), asource(4)
       real*8        imglev, image(nx,ny), nsegm(nx,ny), innsegm(4), inimage(4), intenstouch(nextrmax,*)
!__________________________________________________________________________________________________________________________________
!                    
       do n=1,nextr
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (lcoordsdone(n)) then
             do k=n,nextr
               if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                 if (lcoordsdone(k)) then
                   intenstouch(n,k) = imglev
                   intenstouch(k,n) = imglev
                 endif
               endif
             enddo
           endif
         endif
       enddo
         
! Make a list of all sources touching any pixel along the outer edge of every source.

       do n=1,nextr
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (lcoordsdone(n)) then
             do j=nymin(n),nymax(n)
               jm1 = max ( 1, j - 1 )
               jp1 = min ( ny, j + 1 )
               do i=nxmin(n),nxmax(n)
                 if (image(i,j) .ge. imglev) then
                   if (nint ( nsegm(i,j) ) .eq. n) then
                     im1 = max ( 1, i - 1 )
                     ip1 = min ( nx, i + 1 )
                   
                     inimage(1) = image(im1,j  )
                     inimage(2) = image(ip1,j  )
                     inimage(3) = image(i  ,jm1)
                     inimage(4) = image(i  ,jp1)
                   
                     innsegm(1) = nsegm(im1,j  )
                     innsegm(2) = nsegm(ip1,j  )
                     innsegm(3) = nsegm(i  ,jm1)
                     innsegm(4) = nsegm(i  ,jp1)
                   
                     asource(1) = nint ( innsegm(1) )
                     asource(2) = nint ( innsegm(2) )
                     asource(3) = nint ( innsegm(3) )
                     asource(4) = nint ( innsegm(4) )

! Go over all surrounding pixels of the current pixel (i,j) and determine if any other source touches current source (n).

                     do l=1,4
                       if (inimage(l) .ge. imglev) then
                         if (innsegm(l) .ge. 1.0d0) then
                           if (asource(l) .ne. n) then
                             if (flag(asource(l)) .ne. 'n' .and. flag(asource(l)) .ne. 'z') then
                               if (lcoordsdone(asource(l))) then
                                 ntouching(n,asource(l)) = 1
                                 if (inimage(l) .gt. intenstouch(n,asource(l))) then
                                   intenstouch(n,asource(l)) = inimage(l)
                                 endif
                               endif
                             endif
                           endif
                         endif
                       endif
                     enddo
                   endif
                 endif
               enddo
             enddo
           endif
         endif
       enddo
            
       do n=1,nextr
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (lcoordsdone(n)) then
             if (flag(n) .eq. 'm') then
               lisolated(n) = .false.
             else
               lisolated(n) = .true.
             endif
             do k=1,nextr
               if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                 if (lcoordsdone(k)) then
!!!!                   if (k .ne. n .and. ntouching(n,k) .ge. 1) then
                   if (k .ne. n .and. ntouching(n,k) .ge. 1 .and. flag(k) .eq. ' ') then
                     lisolated(n) = .false.
                     exit
                   endif
                 endif
               endif
             enddo
             do k=n,nextr
               if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                 if (lcoordsdone(k)) then
                   if (ntouching(n,k) .eq. 1) then
                     if (ntouching(k,n) .eq. 0) then
                       if (nonzero(n) .gt. 0 .and. nonzero(k) .gt. 0) then
                         write (iotty,'(/a,14i5)') '   SFINDER: ERROR: No symmetry in touching: '
     &                               , n, k, ntouching(n,k), ntouching(k,n), nxmin(n), nxmax(n), nymin(n), nymax(n)
     &                               , nxmin(k), nxmax(k), nymin(k), nymax(k), nonzero(n), nonzero(k)
                         stop 93
                       endif
                     endif
                     intenstouch(n,k) = min ( intenstouch(n,k), intenstouch(k,n) )
                   endif
                 endif
               endif
             enddo
           endif
         endif
       enddo
         
       return
       end
        
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine identifynoise
         
     &            ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, n1x, n2x, n1ymin, n2ymax, nscale, mxco, myco, deltx, delty
     &            , almostzero, flag, flago, ns1, ns2, nsx, nx, ny, dx, dy, image, nsegm, segmen, nonzero, contrast, contramin
     &            , factnoise, contranoise, imglev, ntouching, ntouchino, intenstouch, lisolated, lgotanother, lcoordsdone )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, DAp IRFU CEA Saclay, France, on May 18, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       lisolated(*), lgotanother(*), lcoordsdone(*)
       character*(*) flag(*), flago(*)
       integer       lastc, i, j, k, n, l, nx, ny, nextr, nmaxflux, nscale, ipvmax, jpvmax, npix, irc, iotty, n1ymin, n2ymax, nxxmin
     &             , nxxmax, nyymin, nyymax, nextrmax, nxco, nyco, nkacc, nkaccel(nextr)
       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), nonzero(*), ns1(*), ns2(*), nsx(*), ntouching(nextrmax,*)
     &             , ntouchino(nextrmax,*), n1x(*), n2x(*)
       real*8        sqpixel, dx, dy, almostzero, imglev, contranoise, pi, fluxmax, intensmin, fluxtotn, newpixval, boupixval
     &             , fluxtotk, fluxedge, dxn2, dyn2, dxk2, dyk2, radpixn2, radpixk2, radpixk2min, radpixn2min, radpixmin, radpixn
     &             , radpixk, elongationbarrier, factnoisebarrier, intenstouchm, pixvalmax
       real*8        image(nx,ny), nsegm(nx,ny), segmen(nx,ny), mxco(*), myco(*), contrast(*), contramin(*), factnoise(*)
     &             , intenstouch(nextrmax,*), deltx(*), delty(*)
                                                      
       real*8 , allocatable :: worker(:,:), distn2kmin(:)

       parameter   ( pi = 3.14159265358979d0, boupixval = 0.0d0, iotty = 6 )

       external      lastc, round1d, fillarea
!__________________________________________________________________________________________________________________________________
!                    
! Identify and mark noise peaks. 

       sqpixel = dx * dy
       
       do n=1,nextr

         lgotanother(n) = .false.
         
         if (lcoordsdone(n) .and. flag(n) .ne. 'n' .and. flag(n) .ne. 'z' .and. flag(n) .ne. 'm' .and. nsx(n) .eq. 0) then
           
           pixvalmax = 0.0d0
           ipvmax = 0
           jpvmax = 0
             
! Find the source's peak intensity (at this scale) and its pixel; full single-scale image (not above the level) must be used here.

           do j=nymin(n),nymax(n)
             do i=nxmin(n),nxmax(n)
               if (nint ( nsegm(i,j) ) .eq. n) then
                 if (image(i,j) .gt. pixvalmax) then
                   pixvalmax = image(i,j)
                   ipvmax = i
                   jpvmax = j
                 endif
               endif
             enddo
           enddo

           nxco = nint ( mxco(n) )
           nyco = nint ( myco(n) )

           if (.not.lisolated(n) .and. image(ipvmax,jpvmax) .ge. imglev) then

! Check all other sources touching the current source for the first time.

             intensmin = 1.0d+33
             fluxmax = 0.0d0
             nmaxflux = 0
          
             do k=1,nextr                                                                         
               
               if (k .ne. n .and. lcoordsdone(k) .and. flago(k) .ne. 'n' .and. flago(k) .ne. 'z') then
                 
                 if (nsx(k) .eq. 0 .and. ntouching(n,k) .ge. 1 .and. ntouchino(n,k) .eq. 0) then
          
                   ntouchino(n,k) = ntouching(n,k)
                        
                   intenstouchm = min ( intenstouch(n,k), intenstouch(k,n) )
                   if (intenstouchm .lt. intensmin) intensmin = intenstouchm
          
! New contact of the current source 'n' with another source 'k' is detected.
! Find the total flux of the source 'k' over its segmentation above the current sub-level.
                  
                   fluxtotn = 0.0d0
                   do j=nymin(n),nymax(n)
                     do i=nxmin(n),nxmax(n)
                       if (nint ( nsegm(i,j) ) .eq. n .and. image(i,j) .ge. intenstouch(n,k)) then
                         fluxtotn = fluxtotn + image(i,j)
                       endif
                     enddo
                   enddo
                   if (fluxtotn .gt. fluxmax) then
                     fluxmax = fluxtotn
                     nmaxflux = n
                   endif
          
                   fluxtotk = 0.0d0
                   do j=nymin(k),nymax(k)
                     do i=nxmin(k),nxmax(k)
                       if (nint ( nsegm(i,j) ) .eq. k .and. image(i,j) .ge. intenstouch(k,n)) then
                         fluxtotk = fluxtotk + image(i,j)
                       endif
                     enddo
                   enddo
                   if (fluxtotk .gt. fluxmax) then
                     fluxmax = fluxtotk
                     nmaxflux = k
                   endif
                 endif
               endif
             enddo
          
             if (intensmin .lt. almostzero) then
               write (iotty,'(/a,2(1pd10.2),i5,2(d10.2),4i5)') '   IDENTIFYNOISE: ERROR: INTENSMIN is too small: '
     &                     , intensmin, imglev, n, mxco(n), myco(n), nxmin(n), nxmax(n), nymin(n), nymax(n)
               do k=1,nextr
                 if (max ( ntouching(n,k), ntouching(k,n) ) .ge. 1) then
                   write (iotty,'(5i5,2(1pd10.2))') n, k, ntouchino(n,k), ntouching(n,k), ntouching(k,n)
     &                                            , intenstouch(n,k), intenstouch(k,n)
                 endif
               enddo
               stop 94
             endif

! If the current source has a lower total flux than another touching source, it is possibly a noise peak.
! Do more tests to decide.

             if (nmaxflux .gt. 0 .and. n .ne. nmaxflux) then    !!!!!!!!! .and. fluxmax / fluxtotn .gt. 1.5d0
             
               npix = 0
               fluxtotn = 0.0d0
               do j=nymin(n),nymax(n)
                 do i=nxmin(n),nxmax(n)
                   if (image(i,j) .ge. intensmin) then
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       npix = npix + 1
                       fluxtotn = fluxtotn + image(i,j)
                     endif
                   endif
                 enddo
               enddo
          
               if (fluxtotn .lt. almostzero) then
                 write (iotty,'(/a,3(1pd10.2),2i5,2(d10.2),4i5)') '   IDENTIFYNOISE: ERROR: FLUXTOTN is too small: '
     &                       , fluxtotn, imglev, intensmin, n, npix, mxco(n), myco(n), nxmin(n), nxmax(n), nymin(n), nymax(n)
                 do k=1,nextr
                   if (max ( ntouching(n,k), ntouching(k,n) ) .ge. 1) then
                     write (iotty,'(5i5)') n, k, ntouchino(n,k), ntouching(n,k), ntouching(k,n)
                   endif
                 enddo
                 stop 95
               endif
          
               allocate ( worker(nx,ny), distn2kmin(nextr), stat=irc )
          
               if (irc .ne. 0) then
                 write (iotty,'(/a)') '   IDENTIFYNOISE: ERROR: Trouble allocating memory (75).'
                 stop 75
               endif
          
               do j=1,ny
                 do i=1,nx
                   worker(i,j) = image(i,j)
                   segmen(i,j) = 0.0d0
                 enddo
               enddo
          
               newpixval = dble ( n )
                 
               call fillarea ( .false., nxco, nyco, nextrmax, nextr, newpixval, 'positive', almostzero, boupixval, nx, ny, n1x, n2x
     &                       , n1ymin, n2ymax, nxxmin, nxxmax, nyymin, nyymax, worker, segmen, segmen, mxco, myco, deltx, delty
     &                       , ntouching, nsx )
          
               do j=nyymin,nyymax
                 do i=nxxmin,nxxmax
                   if (image(i,j) .ge. intensmin) then
                     if (nint ( segmen(i,j) ) .eq. n .and. nint ( nsegm(i,j) ) .eq. n) then
                       segmen(i,j) = 0.0d0
                     endif
                   endif
                 enddo
               enddo

               nkacc = 0
               do k=1,nextr
                 if (k .ne. n .and. lcoordsdone(k) .and. flago(k) .ne. 'n' .and. flago(k) .ne. 'z') then
                   nkacc = nkacc + 1
                   nkaccel(nkacc) = k
                 endif
               enddo
          
               do l=1,nkacc                                                                         
                 k = nkaccel(l)
                 radpixk2min = 1.0e+33
                 radpixn2min = 1.0e+33
                 do j=nyymin,nyymax
                   do i=nxxmin,nxxmax
                     if (image(i,j) .ge. intensmin) then
                       if (nint ( nsegm(i,j) ) .eq. n) then
                         radpixk2 = (dble ( i ) - mxco(k))**2 + (dble ( j ) - myco(k))**2
                         if (radpixk2 .lt. radpixk2min) radpixk2min = radpixk2
                       endif
                       if (nint ( nsegm(i,j) ) .eq. k .and. nint ( segmen(i,j) ) .eq. n) then
                         radpixn2 = (dble ( i ) - mxco(n))**2 + (dble ( j ) - myco(n))**2
                         if (radpixn2 .lt. radpixn2min) radpixn2min = radpixn2
                       endif
                     endif
                   enddo
                 enddo
                 distn2kmin(k) = sqrt ( radpixn2min / radpixk2min )
               enddo
               
               do l=1,nkacc                                                                         
                 k = nkaccel(l)
                 do j=nyymin,nyymax
                   do i=nxxmin,nxxmax
                     if (image(i,j) .ge. intensmin) then
                       if (nint ( segmen(i,j) ) .eq. n .and. nint ( nsegm(i,j) ) .eq. k) then
                         segmen(i,j) = 0.0d0
                       endif
                     endif
                   enddo
                 enddo
               enddo
          
               fluxedge = 0.0d0
               do j=nyymin,nyymax
                 dyn2 = (dble ( j ) - myco(n))**2
                 do i=nxxmin,nxxmax
                   if (nint ( segmen(i,j) ) .eq. n) then
                     dxn2 = (dble ( i ) - mxco(n))**2
                     radpixn = sqrt ( dxn2 + dyn2 )
                     radpixmin = 1.0e+33
                     do l=1,nkacc                                                                         
                       k = nkaccel(l)
                       dyk2 = (dble ( j ) - myco(k))**2
                       dxk2 = (dble ( i ) - mxco(k))**2
                       radpixk = sqrt ( dxk2 + dyk2 ) * distn2kmin(k)
                       if (radpixk .lt. radpixmin) radpixmin = radpixk
                     enddo
                     if (radpixn .le. radpixmin) then
                       fluxedge = fluxedge + image(i,j)
                     endif
                   endif
                 enddo
               enddo
               
               deallocate ( worker, distn2kmin )
          
               factnoise(n) = fluxedge / fluxtotn
                                                              
               factnoisebarrier = max ( factnoise(n) / 2.0d0, 1.0d0 )
                                                              
               elongationbarrier = 1.0d0
                                                              
               contramin(n) = contranoise * max ( factnoisebarrier * elongationbarrier, 1.0d0 )
          
               contrast(n) = image(ipvmax,jpvmax) / intensmin

! Check if the source is actually a noise peak. 
! Round the computed contrast values to only 2 digits as it makes no sense to use more of the "precision".

               call round1d ( contrast (n), 1, 3 )
               call round1d ( contramin(n), 1, 3 )
                     
               if (contrast(n) .lt. contramin(n)) then
             
                 flag(n) = 'n'
                 flago(n) = flag(n)
                 ns2(n) = nscale
          
! Assign the noise peak pixels to the other touching source that eats it.
                     
                 nxmin(nmaxflux) = min ( nxmin(n), nxmin(nmaxflux) )
                 nxmax(nmaxflux) = max ( nxmax(n), nxmax(nmaxflux) )
                 nymin(nmaxflux) = min ( nymin(n), nymin(nmaxflux) )
                 nymax(nmaxflux) = max ( nymax(n), nymax(nmaxflux) )
             
                 do j=nymin(nmaxflux),nymax(nmaxflux)
                   do i=nxmin(nmaxflux),nxmax(nmaxflux)
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       nsegm(i,j) = nmaxflux
                     endif
                   enddo
                 enddo

! Re-compute a new number of non-zero pixels for the source which ate the noise peak.

                 nonzero(nmaxflux) = 0
                 do j=nymin(nmaxflux),nymax(nmaxflux)
                   do i=nxmin(nmaxflux),nxmax(nmaxflux)
                     if (nint ( nsegm(i,j) ) .eq. nmaxflux .and. image(i,j) .gt. almostzero) then
                       nonzero(nmaxflux) = nonzero(nmaxflux) + 1
                     endif
                   enddo
                 enddo
          
!!!!                 lgotanother(nmaxflux) = .true.
!!!!                 ns1(nmaxflux) = nscale
                 ns1(nmaxflux) = ns1(nmaxflux)
          
                 nxmin(n) = -1
                 nxmax(n) = -1
                 nymin(n) = -1
                 nymax(n) = -1
               endif
             endif
           endif
         endif
       enddo

       return
       end
        
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine measure 
       
     &            ( iotty, nbeg, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image, segmn, dx
     &            , dy, momxco, momyco, npxcoa, npycoa, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad
     &            , elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, lfirstpass, cverbose )
!__________________________________________________________________________________________________________________________________
!
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       lfirstpass, lisolated(*), lgotanother(*), lcoordsdone(*)
       character*(*) flag(*), cverbose

       integer       n, nx, ny, l, m, nextr, irc, nbeg, nscale, iotty, nxco, nyco, npm
       integer       nonzero(*), nimglev(*), ns1(*), nsx(*), nxmin(*), nxmax(*), nymin(*), nymax(*)
 
       real*8        dx, dy, pi, sqpixel, sourcearea, dblm, dbll, sscale, sfactor, intensmax, convtodegrees, sqreightlogtwo, pixel
     &             , intsxx, intsyy, intsxy, xcorsc, ycorsc, momp2, momm2, sqrmo, asig, bsig, intsd, ints0m, ints0, almostzero
     &             , intx, inty, int0, int0m, intd, asize, bsize, xcent, ycent
     
       real*8        image(nx,ny), segmn(nx,ny), momxco(*), momyco(*), fluxpeak(*), fluxtot(*), afwhm(*), bfwhm(*), atheta(*)
     &             , equivrad(*), elongation(*), momxx(*), momyy(*), momxy(*), npxcoa(*), npycoa(*)

       logical, allocatable :: lgetcoord(:)

       parameter   ( pi = 3.14159265358979d0, convtodegrees = 180.0d0 / pi )
!__________________________________________________________________________________________________________________________________
!                  
       sqreightlogtwo = sqrt ( 8.0d0 * log ( 2.0d0 ) )
       asig = 0.0d0
       bsig = 0.0d0

       allocate ( lgetcoord(nextr), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   MEASURE: ERROR: Trouble allocating memory (76).'
         stop 76
       endif

       sqpixel = dx * dy
       pixel = sqrt ( sqpixel )
       sscale = sscale
       nxco = 1
       nyco = 1

! Compute coordinates only when current scale is not too big compared to the scale where source first appeared
! and only until the source gets footprinted.
       
       do n=nbeg,nextr
         
         lgetcoord(n) = .false.

         if (flag(n) .eq. ' ' .and. nsx(n) .eq. 0) then 

           if (lfirstpass) then
             lgetcoord(n) = nimglev(n) .gt. 0 .and. lisolated(n) .and. sfactor**(nscale - ns1(n)) .le. 2.0d0
           endif

           if (nimglev(n) .gt. 0) then

! Compute total flux in the single-scale image over the segmentation mask.

             fluxtot(n) = 0.0d0
             
             do m=nymin(n),nymax(n)
               do l=nxmin(n),nxmax(n)
                 
                 if (n .eq. nint ( segmn(l,m) )) then
                   
                   if (image(l,m) .gt. almostzero) then
                     fluxtot(n) = fluxtot(n) + image(l,m) * sqpixel
                   endif
                 endif
               enddo
             enddo

! Find maximum intensity in the single-scale image over the segmentation mask.

             intensmax = -1.0d0
             
             do m=nymin(n),nymax(n)
               do l=nxmin(n),nxmax(n)
                 
                 if (n .eq. nint ( segmn(l,m) )) then
                   
                   if (image(l,m) .gt. intensmax) then
                     nxco = l
                     nyco = m
                     intensmax = image(nxco,nyco)
                   endif
                 endif
               enddo
             enddo
             if (intensmax .ge. 0.0d0) then
               fluxpeak(n) = max ( intensmax, 0.0d0 )
             endif
           
! Update the source coordinates.

             if (lgetcoord(n) .and. intensmax .gt. almostzero) then                
               intx = 0.0d0
               inty = 0.0d0
               int0 = 0.0d0
               xcent = 0.0d0
               ycent = 0.0d0
               npm = 0
               
               do m=nymin(n),nymax(n)              
                 dblm = dble ( m )                 
                 do l=nxmin(n),nxmax(n)            
                   dbll = dble ( l )               
                   
                   if (n .eq. nint ( segmn(l,m) )) then
                     
                     if (image(l,m) .ge. fluxpeak(n) / 1.3d0) then
                       intd = image(l,m) * sqpixel
                       int0 = int0 + intd
                       intx = intx + dbll * intd
                       inty = inty + dblm * intd
                       xcent = xcent + dbll
                       ycent = ycent + dblm
                       npm = npm + 1
                     endif
                   endif
                 enddo
               enddo
               
               int0m = int0 + almostzero
               momxco(n) = intx / int0m
               momyco(n) = inty / int0m
               if (npm .gt. 0) then
                 momxco(n) = xcent / dble ( npm )
                 momyco(n) = ycent / dble ( npm )
               endif
               npxcoa(n) = dble ( nxco )
               npycoa(n) = dble ( nyco )
               lcoordsdone(n) = .true.
             endif  
           endif
         endif  
       enddo
       
! Compute second moments.

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Computing second intensity moments for each segmentation mask'

       do n=nbeg,nextr

         if (lfirstpass .or. lgotanother(n)) then
           ints0 = 0.0d0
           intsxx = 0.0d0
           intsyy = 0.0d0
           intsxy = 0.0d0           
!!           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (flag(n) .eq. ' ' .and. nsx(n) .eq. 0) then
             
             do m=nymin(n),nymax(n)
               dblm = dble ( m )
               do l=nxmin(n),nxmax(n)
                 dbll = dble ( l )       
                 
                 if (n .eq. nint ( segmn(l,m) )) then
                   intsd = segmn(l,m) * sqpixel
                   ints0 = ints0 + intsd
                   xcorsc = dbll - momxco(n)
                   ycorsc = dblm - momyco(n)
                   intsxx = intsxx + xcorsc * xcorsc * intsd
                   intsyy = intsyy + ycorsc * ycorsc * intsd
                   intsxy = intsxy + xcorsc * ycorsc * intsd
                 endif
               enddo
             enddo
           endif
           ints0m = ints0 + 1.0d-30
           momxx(n) = intsxx / ints0m
           momyy(n) = intsyy / ints0m
           momxy(n) = intsxy / ints0m
         endif
       enddo

! Compute FWHM sizes using the intensity moments.

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Computing FWHM sizes of segmentation masks using intensity moments'
       
       do n=nbeg,nextr
         
         if (lfirstpass .or. lgotanother(n)) then
!!           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           
           if (flag(n) .eq. ' ' .and. nsx(n) .eq. 0) then
             momp2 = (momxx(n) + momyy(n)) / 2.0d0
             momm2 = (momxx(n) - momyy(n)) / 2.0d0
      
             if (abs ( momxy(n) ) .lt. almostzero) then
               if (momxx(n) .gt. momyy(n)) then
                 momp2 = momxx(n)
                 momm2 = momyy(n)
                 atheta(n) = 90.0d0
               else
                 momp2 = momyy(n)
                 momm2 = momxx(n)
                 atheta(n) = 0.0d0
               endif
               sqrmo = sqrt ( momm2**2 + momxy(n)**2 )
               asig  = sqrt ( momp2 + sqrmo ) * pixel
               if (momp2 .gt. sqrmo) then 
                 bsig = sqrt ( momp2 - sqrmo ) * pixel
               else
                 asig = 0.0d0
                 bsig = 0.0d0
               endif
             else       
               sqrmo = sqrt ( momm2**2 + momxy(n)**2 )
               if (momp2 + sqrmo .ge. 0.0d0) then 
                 asig  = sqrt ( momp2 + sqrmo ) * pixel
               endif
               if (momp2 - sqrmo .ge. 0.0d0) then 
                 bsig  = sqrt ( momp2 - sqrmo ) * pixel
               endif
               if (momp2 + sqrmo .lt. 0.0d0 .or. momp2 - sqrmo .lt. 0.0d0) then 
                 asig = 0.0d0
                 bsig = 0.0d0
               endif
               atheta(n) = 180.0d0 - atan2 ( sqrmo + momm2, momxy(n) ) * convtodegrees
             endif                                        

             asize = sqreightlogtwo * max ( asig, pixel )
             bsize = sqreightlogtwo * max ( bsig, pixel )

             afwhm(n) = max ( asize, sscale )
             bfwhm(n) = max ( bsize, sscale )

             elongation(n) = asize / bsize
           endif
      
           if (.not.lgotanother(n)) then
             sourcearea = dble ( nonzero(n) ) * sqpixel
             equivrad(n) = sqrt ( sourcearea / pi )
           endif
         endif
       enddo

       deallocate ( lgetcoord )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine makefoots

     &            ( n, mxco, myco, maxradius, dx, dy, nx, ny, foots )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, DAp IRFU CEA Saclay, France, on April 20, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       integer       n, nx, ny, nr, l, m, l1, l2, m1, m2
       real*8        maxradius, maxradius2, rxy2, dxco2, dyco2, dx, dy
       real*8        mxco(*), myco(*), foots(nx,ny)
!__________________________________________________________________________________________________________________________________
!                     
! Make footprint for a source. 

       if (mxco(n) .gt. 0.0d0 .and. myco(n) .gt. 0.0d0) then
         maxradius2 = maxradius**2
         nr = nint ( maxradius / min ( dx, dy ) )
         l1 = max ( nint ( mxco(n) ) - nr, 1 )
         l2 = min ( nint ( mxco(n) ) + nr, nx )
         m1 = max ( nint ( myco(n) ) - nr, 1 )
         m2 = min ( nint ( myco(n) ) + nr, ny )
         do m=m1,m2
           dyco2 = ((dble ( m ) - myco(n)) * dy)**2
           do l=l1,l2
             dxco2 = ((dble ( l ) - mxco(n)) * dx)**2
             rxy2 = dxco2 + dyco2
             if (rxy2 .le. maxradius2) then
               foots(l,m) = foots(l,m) + dble ( n )
             endif
           enddo
         enddo
       endif
       
       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine limitbox 

     &            ( n, nx, ny, segmentation, n1x, n2x, n1xmin, n2xmax, n1ymin, n2ymax, nxmin, nxmax, nymin, nymax, laccelerate )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, DAp IRFU CEA Saclay, France, on April 6, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       laccelerate
       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), n1x(*), n2x(*), nx, ny, i, j, n, n1xmin, n2xmax, n1ymin, n2ymax
       real*8        segmentation(nx,ny)
!__________________________________________________________________________________________________________________________________
!                     
       if (laccelerate) then
         
         nxmin(n) = 100000      
         nxmax(n) = 0
         nymin(n) = 100000
         nymax(n) = 0
         
         do j=n1ymin,n2ymax
           do i=n1x(j),n2x(j)
         
             if (nint ( segmentation(i,j) ) .eq. n) then
               nxmin(n) = min ( i, nxmin(n) )
               nxmax(n) = max ( i, nxmax(n) )
               nymin(n) = min ( j, nymin(n) )
               nymax(n) = max ( j, nymax(n) )
             endif
           enddo
         enddo
         
         if (nxmin(n) .eq. 100000) nxmin(n) = n1xmin
         if (nxmax(n) .eq. 0     ) nxmax(n) = n2xmax
         if (nymin(n) .eq. 100000) nymin(n) = n1ymin
         if (nymax(n) .eq. 0     ) nymax(n) = n2ymax
       else
         nxmin(n) = n1xmin
         nxmax(n) = n2xmax
         nymin(n) = n1ymin
         nymax(n) = n2ymax
       endif
       
       return
       end
       
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, iotty, iolog, creator
     &            , beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamn, datamx
     &            , history, cverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, bunit, object, history, cverbose
       character*3   cnan
       character*25  cdatetime
       character*80  comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, iotty, iolog, maxdim, rw
     &             , nfound, blank, stat05, stat06, stat07, stat08, stat09, stat10, stat11, stat12, stat13, stat14, stat15, stat16
     &             , stat17, stat18, stat19, stat20, stat21, stat22, stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30
     &             , stat31, stat32, stat0
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22, almostzero, as2deg, datamx, datamn, sign1, arg1, arg2, argm
     &             , sinrota, cosrota, pi, angle
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr, ftgkyj, ftg2dd
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

!!       call ftgphx ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, bscale, bzero, blank, nblank, stat )

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:21) .eq. 'Alexander Menshchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'SFINDER'
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. Maybe
! there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat0 = stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15 + stat16 + stat17 + stat18
     &       + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28 + stat30 + stat31

       if (cverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = '<Name>'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       if (stat17 .ne. 0) then
         rot2 = 0.0d0
       endif
       rot1 = rot2

       if (stat29 .eq. 0 .and. stat30 .ne. 0) then
         equinox = epoch
       endif

! CDELT* is absent or error.

       if (stat24 .ne. 0 .or. stat25 .ne. 0) then

! CD1* and CD2* are defined correctly: determine CDELT* and ROTA*.

         if (stat18 .eq. 0 .and. stat19 .eq. 0 .and. stat20 .eq. 0 .and. stat21 .eq. 0) then
           sign1 = sign ( 1.0d0, cd11 * cd22 - cd12 * cd21 )
           dxdeg = sign1 * sqrt ( cd11**2 + cd21**2 )
           dydeg = sqrt ( cd12**2 + cd22**2 )
           arg1 = sign1 * cd12 / cd22
           arg2 = -sign1 * cd21 / cd11
           argm = (arg1 + arg2) / 2.0d0
           if (abs ( arg1 - arg2 ) / argm .gt. 1.0d-10) then
             write (iotty,'(/a/)') '   RFITS: WARNING: Coordinate axes are not orthogonal'
           endif
           rot2 = atan ( argm )
           sinrota = sin ( rot2 )
           cosrota = cos ( rot2 )
           rot2 = rot2 * 180.0d0 / pi
           if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
             rot1 = rot2
           elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
             rot1 = 180.0d0 - rot2
           elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
             rot1 = 180.0d0 + rot2
           elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
             rot1 = - rot2
           endif
           rot2 = rot1
         endif
       endif

! CD1* and CD2* are absent or error.

       if (stat18 .ne. 0 .or. stat19 .ne. 0 .or. stat20 .ne. 0 .or. stat21 .ne. 0) then

! CDELT* are defined correctly: determine CD1* and CD2*.

         if (stat24 .eq. 0 .and. stat25 .eq. 0) then
           angle = rot2 * pi / 180.0d0
           cd11 = dxdeg * cos ( angle )
           cd12 = abs ( dydeg ) * sign ( 1.0d0, dxdeg ) * sin ( angle )
           cd21 = - abs ( dxdeg ) * sign ( 1.0d0, dydeg ) * sin ( angle )
           cd22 = dydeg * cos ( angle )
           if (abs ( cd12 ) .lt. almostzero) cd12 = 0.0d0
           if (abs ( cd21 ) .lt. almostzero) cd21 = 0.0d0
         endif
       endif

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       cnan = 'NAN'
       do j=1,ny
         do i=1,nx
           if (.not.isnan ( fun(i,j) )) then  
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
           if (int ( fun(i,j) ) .eq. blank .and. blank .ne. 0) then  
             read (cnan,*) fun(i,j)
           endif
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, cdate
     &            , ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamn, datamx
     &            , history )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, rot1, rot2, equinox, datamn, datamx, dxdeg
     &             , dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      fdelete, ftgiou, ftinit, ftphpr, ftpkys, ftpcom, ftpkyd, ftpkyj, ftphis, ftp2dd, ftclos, ftfiou, printerr
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           if (.not.isnan ( fun(i,j) )) then
             if (fun(i,j) .lt. datamn ) datamn = fun(i,j)
             if (fun(i,j) .gt. datamx ) datamx = fun(i,j)
           endif
         enddo
       enddo

! When packing numbers using the formulas below, I got values of the function different in the 5-th digit from DATAMIN and
!  DATAMAX placed in the header when writing the data. From now on I will use bzero = 0 bscale = 1 and bitpix = -32, as these
! seem to cure the problem.

cc!      bitpix = 16
cc!      bzero  = 0.5d0 * (funmin + funmax)
cc!      bscale = dabs ( funmax - bzero ) / 32767.0d0

       bitpix = -32     !<-- single precision floating-point values
       bzero  = 0.0d0
       bscale = 1.0d0
       blank = blank

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Menshchikov, DAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = - dx * as2deg
       dydeg = dy * as2deg

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
!!       if  (blank .gt. 0)
!!     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , dxdeg , 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, 'equinox', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||