
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program finalcat
!__________________________________________________________________________________________________________________________________
!
! Produce final extraction catalogs.
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay   
!
! Return codes:
!
!   10-29 ... problems with the input parameters
!   30-49 ... non-existing files or directories
!   50-69 ... problems with reading/writing files or values
!   70-89 ... problems with memory allocation
!   90-99 ... other code-specific problems
!__________________________________________________________________________________________________________________________________
!                 
       implicit      none

       integer       iotty, nwavemax, ncolmax

       parameter   ( nwavemax=300, ncolmax = 100, iotty = 6 )

       logical       inellipse, lfname, lunix, lbgnoisefluctuation, lpositionoccupied, lfnvers  !!, ldone, lok
     &             , lfinishing_mode, lfirstiteration, ltiming, ltime, liter_phase1, liter_phase2, liter_phase3  !!, lnotdetection
     &             , lcreate_profiles_images, lhandlesubstruc, lfnamefc, lalldiffsmall, lfdone(nwavemax), lwcscoord, lfoot
     &             , ldetectionwave(nwavemax), lherschel(nwavemax), lnewapproach, lmysimsky !!, lhighsigmono, ltoobigorelong
     &             , lconverged, ltoofaintorbigorelong, ldetectedtoofewaves, lsurfdens, lintens

       logical     , allocatable :: lnormalsigm(:,:), lmeasurable(:,:), lsubatwave(:,:), lnormalsize(:,:), lnormalgood(:,:)

       character*1   converge(100,nwavemax)
       character*2   cwav, cnwaves  !!, cnwavs
       character*3   colskip, cfmon, dot, cfsflag  !!, c1, color, cwave1, cwave2
       character*4   cwave(nwavemax),cwave0(nwavemax), celongmx
       character*5   cnextrbad, cnextrgood, cnextr !!, cgood
       character*6   cfitsversion, czno, czok, cocc, fmtwcs, cverbose, cfto 
       character*7   clibname
       character*8   ctime, cfpptime, creldiffmax   
       character*10  cdate
       character*11  cncolc, convfact
       character*12  cncolf          
       character*13  colhead(ncolmax), colheadout(ncolmax)
       character*14  ccrpix1, ccrpix2, ccrval1, ccrval2, imgunits
       character*21  compda, peakfunits(nwavemax)
       character*80  object, creator, ctype1, ctype2, bunit, history, cbadwave, csubwave, clowwave, prefix, calphabe
       character*127 cbarf(nwavemax)
       character*128 cobeam, csnt, csnr, csn1, csn2, cnwd, cowave, crdf, csrcmaxsize(nwavemax), callsrcmaxsizes, cmaxsize
       character*132 coccup
       character*134 formt
       character*141 getstitle
       character*165 cbars
       character*182 cbar(nwavemax)
       character*500 finalcatname, finalcatokname !!, finalcolorscat
     &             , arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, versfile, catsubstruc, detimagestring, footitname
     &             , cfgfile, coordinates, deblendname, obsindname, addcatalogrelitent  !!, addcatalogrelitentok
     &             , individintpro, individimages, filecombo, originpath
       
       character*1000 adopteddistance, conversionfacts
       character*60000 headcols, numbcols

       character*1 , allocatable :: flag(:,:), badsource(:,:)
       character*5 , allocatable :: cfmflag(:)
       character*6 , allocatable :: cno(:)
       character*200 , allocatable :: comment(:)
       character*100000, allocatable :: catline(:,:), catlinerelitent(:) !!, colorlinerelitent(:)
       character*500, allocatable :: cat(:), detimageline(:), obsfscbname(:), obsimagestring(:), obsname(:), obsfsname(:)
     &             , obsfsbsname(:), obscbname(:), obscbsmoname(:), bsomaskname(:), finfootname(:), subsfootpr(:)
       character*2000, allocatable :: headline(:,:), headfpitline(:), addhead(:)
       character*100000, allocatable :: headlineout(:), headrelitent(:)
       character*400, allocatable :: cfgline(:)

       integer       firstb, lastc, lastp, last, i, j, k, l, m, jj,kk, lh, ic, ifrt, ia1, ia2, ia3, id, ie, ik, nhead(nwavemax)
     &             , nwaves, icat(nwavemax), lencolh(ncolmax), lencolhout(ncolmax), ncolhead(ncolmax), ibad, imu
     &             , iob(nwavemax), nheadout, lhl, lhlo, ndate, ide, lcw, ncolumn, nquantities, ifui, irc, ir, iri, lfti, iopa
     &             , nextrbad, igood, lb, lcno, ibo, isnt, isnr, inwd, idot1, idot2, idot3, iow, isigg, nx, ihfp, iocc, ibs, lcl
     &             , ny, blank, idot4, nplus, nbra1, nbra2, nextrgood, nextrgoodold, nextrbadold, itot, ihc, irdf, ifto
     &             , ixcopx, iycopx, ixcoas, iycoas, isigm, ifxpb, ifxpe, ifxtb, ifxte, ifxtg, iscsx, ifooa, iafwh, ibfwh, ibe
     &             , igodm, ifoob, itent, idott, inc, ncol, mm, nn, ithet !!, icwf, ire  !!, idotf
     &             , nextrgoodvold, nextrbadvold, ifrtok, nhrt, icrt, iel, icol !!, icort, ifcrt, ifcrtok
     &             , iobs(nwavemax), nxco, nyco, kmax, iro, nhrtstand, indint, indimg, icrp1, icrp2, icrv1, ih  !!, nhart
     &             , icrv2, ica, beta, idb, ll, iart, kmx, ifmt, ncolskipfoo, nextr(nwavemax), iocb(nwavemax) !!, iartok
     &             , nwavesdetect, nr, isn1, nheadfc, idim1, idim2, ndetwaves, ismx, icats, nheadfpit, it, iocbs(nwavemax) !, icatr
     &             , nfpiter, itfp(100), nextrgoodit(100), nextrbadit(100), l0, m0, l1, l2, m1, m2, iff(nwavemax), icsw
     &             , isf(nwavemax), ibm(nwavemax), iflag, fsflag, lcfg, ncfglines, nconfigend, ncolskipfsflg, lver, iasiz, ibsiz
     &             , ncolskipssx, icbw, nsubstruc, nextrbadnew, nextrgoodnew, iasmx, nwdetectionlevel
     &             , iclw, iter_phase(100), wchours, wcmins, wcsecs, cpuhours, cpumins, cpusecs, nnoisebgr, nnotdetec
     &             , nspurious, nposition, ifmon, ncolskipfmflg, fmflag, igodn, imx1, imx2, ifn(nwavemax)  !!, nwtoobigorelong
     &             , ntoolarge, isn2, ifofa, lcf, kxco, kyco, iobsfs(nwavemax), iobsfsbs(nwavemax), iobsfscb(nwavemax), ncolskipasi
     &             , nhdefs1, nhdefs2, ncolskipsigg, ntoofaintorbigorelong(nwavemax), nwtoofaintorbigorelong, nwacceptablelevel

       integer     , allocatable :: no(:,:), ns1(:,:), ns2(:,:), nsx(:,:), nok(:), mok(:), intersection(:), intersectionff(:)
     &             , sfm(:,:), sfg(:), ellipsearea(:,:)

       real          fitsvers

       real*8        cpu_flagsources, wal_flagsources, cput_flagsources, walt_flagsources, cpu_substructured, wal_substructured
     &             , cput_substructured, walt_substructured, cpu_semifinalcat, wal_semifinalcat, cput_semifinalcat, cputot, wctot
     &             , walt_semifinalcat, cpu_finalcats, wal_finalcats, cput_finalcats, walt_finalcats, cpu_additioncats, dsize, dlnr
     &             , wal_additioncats, cput_additioncats, walt_additioncats, cpu_profimages, wal_profimages, cput_profimages, aak
     &             , walt_profimages, cpu_updatefoots, wal_updatefoots, cput_updatefoots, walt_updatefoots, cpu_updatecats, cpu_sum
     &             , wal_updatecats, cput_updatecats, walt_updatecats, cpu_backfitsrc, wal_backfitsrc, cput_backfitsrc, wal_sum
     &             , walt_backfitsrc, radfwhm, radfoot, factortotal, bbk, cck, deblendfactor, argexpm, maxelong  !! , signvar

       real*8        timer, signmin, goodmin, obsbeam(nwavemax), obswave(nwavemax), qq, dxcon2, dycon2, rxy2 !!,elongation1
     &             , dx, dy, wave, crpix1, crpix2, crval1, crval2, ra, dec, beamd, funmin, funmax, crota1, crota2, equinox
     &             , bzero, bscale, datamin, datamax, correct, pi !!,color(nwavemax,nwavemax),colerr(nwavemax,nwavemax),elongation2
     &             , angle, aa, bb, cc, sigmaa2, sigmab2, dxcon, dycon, argexp, dbll, dblm, convtoradians, ff, cosa2, sina2, xMsun
     &             , sin2a, funn, funksum, dxcok, dycok, dxcok2, dycok2, obsbeammax, sizemean, smoobeam, valij, cd11, distpc, au2cm
     &             , sq_arcsecs_per_sterad, sq_arcsecs_per_beam_area, convertunitperbeam, almostzero, pixsize, dist2, xmu, xmH
     &             , reldiffmax, dfootarea(nwavemax)  !!, cm2_per_beam_area
     &             , semimajor, snr1min, snr2min, snratio1min, obsbeammin, footobsbeam, SPIRE_250_beamarea, cd12, snratio
     &             , SPIRE_350_beamarea, SPIRE_500_beamarea, oldfootarea(nwavemax), newfootarea(nwavemax), sourcemaxsize(nwavemax)
     &             , sq_arcsecs_per_beam_area_approx, sterad_per_beam_area, sizemax(nwavemax), cd21, footratio, goodminvar
     &             , rxy, snratio2min, cd22, convertsdmass, elongation, elonfact, correction, gravconst, soundspeed10K !!, sizefact
     &             , sizeratio, corrfactpeak, corrfactflux
                    !!, siggnorm, snrpnorm, snrtnorm, sizeratioa, sizeratiob

       real*8      , allocatable :: quantity(:,:,:), factor(:,:,:), foots(:,:), obsimage(:,:), obsfsbsimage(:,:), profileob(:,:)
     &             , profilebs(:,:), profilebd(:,:), rad(:), rad2(:), npts(:), dxco2(:), dyco2(:), individ(:,:), deblended(:,:)
     &             , factsmoo(:,:), backgint(:,:), backgsmoint(:,:), profilebdrms(:,:), obscbimage(:,:), obscbsmoimage(:,:)
     &             , bsomask(:,:), strongfoot(:,:), profileob3rd(:,:), flatfoots(:,:), dist2peaks(:) !!, snrtglob(:)
     &             , dist2foots(:), profileob1st(:,:), profileob2nd(:,:), profileod(:,:), subsfp(:,:), xx(:), yy(:), alphabe(:)
     &             , nfootareait(:,:), dfootareait(:,:)

       parameter   ( beta = 10, correct = 2.0d0**(1.0d0 / dble ( beta )) - 1.0d0, pi = 3.14159265358979d0, almostzero = 1.0d-30
     &             , convtoradians = pi / 180.0d0, sq_arcsecs_per_sterad = 3282.80635d0 * 3600.0d0**2, gravconst = 6.67259d-8 )

       parameter   ( ltiming = .false., dot = '•', lnewapproach = .false., maxelong = 2.0d0, soundspeed10K = 2.0d4 )

       parameter   ( xmu = 2.8, xmH = 1.6726E-24, au2cm = 1.495978707e13, xMsun = 1.98892e+33 )   !!, pc2cm = 3.085678e+18
       
!!! VERY IMPORTANT !!! IF YOU MODIFY THE SPIRE 'BEAMAREA' VALUES BELOW, DON'T FORGET TO MODIFY THEM IN 'PREPOBS' ACCORDINGLY
! Beam areas from SPIRE Observer's Manual v.2.2 (Nov. 2010), page 75: 426, 771, 1626 arcsec^2
! Beam areas for SPIRE (Feb. 2013, N. Schneider): 465, 822, 1769 arcsec^2

       data          SPIRE_250_beamarea / 426 /, SPIRE_350_beamarea / 771 /, SPIRE_500_beamarea / 1626 /

       external      firstb, lastc, lastp, last, timer, when, sortarr, osystem, ftvers, skipcomm, linescolumns, getfitshead
     &             , round1d, inellipse, fitshapesintensities, rfits, wfits, updatecatsflagbads
!__________________________________________________________________________________________________________________________________
!
! Determine operating system

       call osystem ( lunix )
       call ftvers ( fitsvers )
       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       cfpptime = cfpptime(1:5)
       compda = __DATE__//' '//cfpptime

       write (celongmx,'(f4.1)') maxelong
       
       if (celongmx(3:4) .eq. '.0') then
         celongmx(3:4) = '  '
       endif
       iel = lastc ( celongmx )
       icol = 0

! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )

! Get command line parameters.

       call getarg ( 1, arg1 )
       call getarg ( 2, arg2 )
       call getarg ( 3, arg3 )
       call getarg ( 4, arg4 )
       call getarg ( 5, arg5 )
       call getarg ( 6, arg6 )
       call getarg ( 7, arg7 )
       call getarg ( 8, arg8 )

       isnt = lastc ( arg1 )
       isnr = lastc ( arg2 )
       isn1 = lastc ( arg3 )
       isn2 = lastc ( arg4 )
       inwd = lastc ( arg5 )
       ifto = lastc ( arg6 )
       irdf = lastc ( arg7 )
       iopa = lastc ( arg8 )
       
       csnt = arg1(1:isnt)
       csnr = arg2(1:isnr)
       csn1 = arg3(1:isn1)
       csn2 = arg4(1:isn2)
       cnwd = arg5(1:inwd)
       cfto = arg6(1:ifto)
       crdf = arg7(1:irdf)

       ia1 = 0
       ia2 = 0
       inc = 0
       iasmx = 0
       idot4 = 0
       ide = 0
       ifui = 0
       lfirstiteration = .false.
       lwcscoord = .false.
       sq_arcsecs_per_beam_area = 0.0d0
       snratio1min = 0.0d0
       snratio2min = 0.0d0
       radfoot = 0.0d0
       radfwhm = 0.0d0
       
       originpath = arg8(1:iopa)
       cverbose = '-verb2'

       allocate ( cat(nwavemax), detimageline(nwavemax), obsfscbname(nwavemax), obsimagestring(nwavemax), obsname(nwavemax)
     &          , obsfsname(nwavemax), obsfsbsname(nwavemax), obscbname(nwavemax), obscbsmoname(nwavemax), bsomaskname(nwavemax)
     &          , finfootname(nwavemax), subsfootpr(nwavemax), headline(nwavemax,1000), headfpitline(100), addhead(100)
     &          , headlineout(1000), headrelitent(1000), cfgline(1000), nfootareait(100,nwavemax), dfootareait(100,nwavemax)
     &          , stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory.'
         stop
       endif

       if (isnt .gt. 0 .and. csnt(1:isnt) .ne. ':') then

         do i=1,nwavemax
           call getarg ( i+8, cat(i) )
           icat(i) = lastc ( cat(i) )
           read (cat(i),*,end=1,err=1) qq
           exit
  1        continue
           if (i .eq. nwavemax) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Too many wavecats, try increasing NWAVEMAX and recompiling me.'
             goto 195
           endif
         enddo
         nwaves = i - 1
       
         read (csnt(1:isnt),*,end=4,err=4) signmin
         goto 5
  4      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SIGNMIN: '//csnt(1:isnt)
         goto 195
  5      continue
         read (csnr(1:isnr),*,end=6,err=6) goodmin
         goto 7
  6      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SRELIABLE: '//csnr(1:isnr)
         goto 195
  7      continue
         read (csn1(1:isn1),*,end=8,err=8) snr1min
         goto 9
  8      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SNR1MIN: '//csn1(1:isn1)
         goto 195
  9      continue
         read (csn2(1:isn2),*,end=28,err=28) snr2min
         goto 29
 28      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SNR2MIN: '//csn2(1:isn2)
         goto 195
 29      continue
         if (cnwd(1:1) .eq. '0') then
           lfirstiteration = .true.
           read (cnwd(2:inwd),*,end=10,err=10) nwavesdetect
         else
           read (cnwd(1:inwd),*,end=10,err=10) nwavesdetect
         endif
         goto 11
 10      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading NWAVESDETECT: '//cnwd(1:inwd)
         goto 195
 11      continue
         read (cfto(1:ifto),*,end=12,err=12) factortotal
         goto 13
 12      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading FACTORTOTAL: '//cfto(1:ifto)
         goto 195
 13      continue
         read (crdf(1:irdf),*,end=14,err=14) reldiffmax
         write (creldiffmax,'(f8.5)') reldiffmax
         goto 15
 14      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading RELDIFFMAX: '//crdf(1:irdf)
         goto 195
 15      continue
         
         do i=1,nwaves
           call getarg ( i+8+nwaves, cowave )
           iow = lastc ( cowave )
           lherschel(i) = .false.
           if (cowave(1:1) .eq. '+') then
             lherschel(i) = .true.
           endif
           read (cowave(1:iow),*,err=81) obswave(i)     !<-- wavelength (microns)
           goto 2
 81        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading OBSWAVE: '//cowave(1:iow)
           goto 195
  2        continue
         enddo
         do i=1,nwaves
           call getarg ( i+8+2*nwaves, cobeam )
           ibo = lastc ( cobeam )
           read (cobeam(1:ibo),*,err=82) obsbeam(i)     !<-- beam size (arcsec)
           goto 3
 82        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading BEAMSIZE: '//cobeam(1:ibo)
           goto 195
  3        continue
         enddo
         do i=1,nwaves
           call getarg ( i+8+3*nwaves, csrcmaxsize(i) )
           ismx = lastc ( csrcmaxsize(i) )
!!           iti = index ( csrcmaxsize(i)(1:ismx), '~' )
           read (csrcmaxsize(i)(1:ismx),*,err=83) sourcemaxsize(i)     !<-- maximum size of a source (arcsec)
!!           read (csrcmaxsize(i)(iti+1:ismx),*,err=83) regcol(i)         !<-- DS9 region file colors
!!           icol = lastc ( regcol(i) )
           goto 16
 83        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SRCMAXSIZE: '//csrcmaxsize(i)(1:ismx)
           goto 195
 16        continue
         enddo
         callsrcmaxsizes = ' '
         iasmx = 0
         do i=1,nwaves
           write (cmaxsize,*) sourcemaxsize(i)
           imx2 = last ( '.', cmaxsize ) + 1
           imx1 = last ( ' ', cmaxsize(1:imx2) ) + 1
           callsrcmaxsizes = callsrcmaxsizes(1:iasmx)//' '//cmaxsize(imx1:imx2)
           iasmx = lastc ( callsrcmaxsizes )
         enddo
         callsrcmaxsizes = callsrcmaxsizes(2:iasmx)//' '
         iasmx = lastc ( callsrcmaxsizes )

         call getarg ( 4*nwaves+ 9, arg1 )
         call getarg ( 4*nwaves+10, arg2 )
         call getarg ( 4*nwaves+11, arg3 )
         ia1 = lastc ( arg1 )
         ia2 = lastc ( arg2 )
         ia3 = lastc ( arg3 )
         if (ia3 .gt. 0 .and. arg3(1:ia3-1) .eq. '-verb') cverbose = arg3(1:ia3)
         if (ia2 .gt. 0 .and. arg2(1:ia2-1) .eq. '-verb') cverbose = arg2(1:ia2)
         if (ia1 .gt. 0 .and. arg1(1:ia1-1) .eq. '-verb') cverbose = arg1(1:ia1)
       endif

       if (cverbose .eq. '-verb2') then
         write (iotty,'( )')
         if (arg1(1:isnt) .eq. ':') write (iotty,'(a$)') ' '
         write (iotty,'(a$)') ' FINALCAT '//dot//' Make Final Images & Catalogs '//dot//' '//compda
       endif
       if (csnt(1:isnt) .eq. ':') stop
       if (cverbose .eq. '-verb2') write (iotty,'()')
       if (cverbose .eq. '-verb2') write (iotty,'( a)') ' Alexander Men’shchikov, DAp IRFU CEA Saclay, France.'

       if (icat(1) .eq. 0 .or. nwaves .lt. 1) goto 195
       goto 196
 195   write (iotty,'(/a)') ' USAGE: finalcat <sigt> <sigr> <sn1min> <sn2min> <nwdetect> <factortotal> <rdiffmax>'
     &                    //' <origpath> <cat1> [<cat2> ...] <owave1> [<owave2> ...] <obeam1> [<obeam2> ...] <sxsize1>'
     &                    //' [<sxsize2> ...] [-o <finalcat>] [-verb{0|1|2}]'
       stop 99
 196   continue
       
       if (ia1 .gt. 0 .and. arg1(1:ia1) .ne. '-o' .and. arg1(1:ia1-1) .ne. '-verb') then
         finalcatname = arg1(1:ia1)
       elseif (ia2 .gt. 0 .and. arg1(1:ia1) .eq. '-o' .and. arg2(1:ia2-1) .ne. '-verb') then
         finalcatname = arg2(1:ia2)
       else
         finalcatname = 'sm.catalog.sources.cat'
       endif
       ifrt = lastc ( finalcatname )

       addcatalogrelitent = finalcatname(1:ifrt-4)//'.ok.add.cat'
       iart = lastc ( addcatalogrelitent )

       idott = index ( finalcatname(1:ifrt), '.sources.cat' )

       if (idott .eq. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Output catalog file name is not ''*.sources.cat'','
         write (iotty,'(a )') '             it is: '''//finalcatname(1:ifrt)//''''
         stop 11
       endif

       finalcatokname = finalcatname(1:ifrt-4)//'.ok.cat'
       ifrtok = lastc ( finalcatokname )

!!       idotf = index ( finalcatname(1:ifrt), '.fin' )
!!       finalcolorscat = finalcatname(1:idotf+3)//'.col.cat'
!!       ifcrt = lastc ( finalcolorscat )

       if (ltiming) then
         inquire ( file='+timing.finalcat', exist=ltime )
         open ( 60, file='+timing.finalcat', status='unknown' )
         if (ltime) then
           do 
             read (60,'()',end=71)
           enddo
  71       backspace ( 60 )
         endif
         if (lfirstiteration) then
           write (60,'(/a)') ' FINALCAT started: '//cdate//' '//ctime//' Cat: '//finalcatname(1:ifrt)//' <~ 1ST ITERATION'
         else
           write (60,'(/a)') ' FINALCAT started: '//cdate//' '//ctime//' Cat: '//finalcatname(1:ifrt)
         endif
         write (60,'(a)') ' ------------------------------------------------------'
         
         cput_flagsources   = 0.0d0
         walt_flagsources   = 0.0d0
         cput_substructured = 0.0d0
         walt_substructured = 0.0d0
         cput_semifinalcat  = 0.0d0
         walt_semifinalcat  = 0.0d0
         cput_finalcats     = 0.0d0
         walt_finalcats     = 0.0d0
         cput_additioncats  = 0.0d0
         walt_additioncats  = 0.0d0
         cput_profimages    = 0.0d0
         walt_profimages    = 0.0d0
         cput_updatefoots   = 0.0d0
         walt_updatefoots   = 0.0d0
         cput_updatecats    = 0.0d0
         walt_updatecats    = 0.0d0
         cput_backfitsrc    = 0.0d0
         walt_backfitsrc    = 0.0d0
         cpu_sum = 0.0d0
         wal_sum = 0.0d0
       endif

       lmysimsky = .false.
       lconverged = .false.
       lhandlesubstruc = .false.

       liter_phase1 = .false.
       if (csnt(1:1) .eq. '+') then
         liter_phase1 = .true.
       endif
       liter_phase2 = .false.
       if (csnr(1:1) .eq. '+') then
         liter_phase2 = .true.
       endif
       liter_phase3 = .false.
       if (csn1(1:1) .eq. '+' .or. csn1(1:1) .eq. '-') then
         liter_phase3 = .true.
       endif
       lfinishing_mode = .false.
       if (csn1(1:1) .eq. '-') then
         lfinishing_mode = .true.
       endif
       lcreate_profiles_images = .false.
       if (lfinishing_mode .and. csnr(1:1) .eq. '+') then
         lcreate_profiles_images = .true.
       endif

       if (csnt(1:1) .eq. '+') then
         csnt = csnt(2:isnt)//' '
       endif
       if (csnt(1:1) .eq. '-') then
         signmin = abs ( signmin )
         csnt = csnt(2:isnt)//' '
       endif
       if (csnr(1:1) .eq. '+') then
         csnr = csnr(2:isnr)//' '
       endif
       if (csnr(1:1) .eq. '-') then
         goodmin = abs ( goodmin )
         csnr = csnr(2:isnr)//' '
       endif
       if (csn1(1:1) .eq. '+') then
         csn1 = csn1(2:isn1)//' '
       endif
       if (csn1(1:1) .eq. '-') then
         snr1min = abs ( snr1min )
         csn1 = csn1(2:isn1)//' '
       endif

       if (liter_phase1) then
!!         signvar = 0.6d0 * signmin
         goodminvar = 0.6d0
       else if (liter_phase2) then
!!         signvar = 0.8d0 * signmin
         goodminvar = 0.8d0
       else
!!         signvar = signmin
         goodminvar = goodmin
       endif

       isnt = lastc ( csnt )
       isnr = lastc ( csnr )
       isn1 = lastc ( csn1 )
       
       if (cat(1)(1:3) .ne. 'sm.' .and. cat(1)(1:3) .ne. 'sx.') then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File name does not begin with "sm." or "sx.":'
         write (iotty,'(a )') '             '//cat(1)(1:icat(1))
         stop 12
       endif
       
       do i=1,nwaves
         
         inquire ( file=cat(i)(1:icat(i)), exist=lfname )
         
         if (.not.lfname) goto 91
         idot1 = index ( cat(i)(1:icat(i)), '.' )
         idot2 = index ( cat(i)(idot1+1:icat(i)), '.' ) + idot1
         idot3 = index ( cat(i)(idot2+1:), '.' ) + idot2
         idot4 = index ( cat(i)(idot3+1:), '.' ) + idot3
         if (idot2 .gt. 0 .and. idot3 .gt. 0) then 
           read (cat(i)(idot2+1:idot3-1),*,end=41,err=41) cwave0(i)
           lcw = lastc ( cwave0(i) )
           cwave(i) = cwave0(i)
           if (lcw .eq. 1) cwave(i) = '   '//cwave0(i)(1:1)
           if (lcw .eq. 2) cwave(i) = '  '//cwave0(i)(1:2)
           if (lcw .eq. 3) cwave(i) = ' '//cwave0(i)(1:3)
           goto 42
 41        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading wavelength: "'//cwave(i)//'"'
           stop 51
 42        continue
         else
           write (iotty,'(/a   )') '   FINALCAT: ERROR: Trouble finding wavelength in file name:'
           write (iotty,'(a,2i3)') '             '//cat(i)(1:icat(i)), idot2, idot3
           stop 52
         endif
         if (cwave(i)(1:3) .eq. '000') cwave(i)(1:3) = '   '
         if (cwave(i)(1:2) .eq. '00' ) cwave(i)(1:2) = '  '
         if (cwave(i)(1:1) .eq. '0'  ) cwave(i)(1:1) = ' '
         cbar(i) = '.____________________________________________________________________________________________________________'
     &           //'________________________________________________________________________.'
         cbarf(i) = '.___________________________________________________________________________________________________________'
     &           //'__________________.'
         peakfunits(i) = ''
       enddo
       cbars = '!_______________________________________________________________________________________________________________'
     &       //'_____________________________________________________'
       
       goto 92
 91    continue
       if (.not.lfname) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//cat(i)(1:icat(i))//''' not found.'
         stop 31
       endif
 92    continue
       write (cnwaves,'(i2)') nwaves

       do i=1,nwaves
         bsomaskname(i) = cat(i)(4:idot3-1)//'.bs.omask.fits'
         ibm(i) = lastc ( bsomaskname(i) )
         finfootname(i) = cat(i)(1:idot4-1)//'.foots.fits'
         iff(i) = lastc ( finfootname(i) )
         subsfootpr(i) = cat(i)(1:idot4-1)//'.subsfp.fits'
         isf(i) = lastc ( subsfootpr(i) )
       enddo

       footitname = '+log.FOOTS.iter'
       lfti = lastc ( footitname )

       if (cverbose .eq. '-verb1') write (iotty,'(/a)') ' FINALCAT: '//csnt(1:isnt)//' '//csnr(1:isnr)//' '
     &                                                               //cat(1)(1:icat(1))//' '//finalcatname(1:ifrt)
       if (cverbose .eq. '-verb2') write (iotty,'()')

       versfile='+log.VERSION'
       lver = lastc ( versfile )
       getstitle='# GETSF '//dot//' Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men''shchikov,'
     &                     //' DAp IRFU CEA Saclay'
       inquire ( file=versfile(1:lver), exist=lfnvers )
       if (lfnvers) then
         open ( 25, file=versfile(1:lver), status='old' )
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading version file '''//versfile(1:lver)//''''
         do i=1,3
           read (25,'(a)',end=67,err=61) getstitle
         enddo
         getstitle = getstitle(1:1)//getstitle(4:)
         goto 67
  61     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading file '''//versfile(1:lver)//'''.'
         close (25)
         stop 32
  67     continue
         close (25)
       else        
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   FINALCAT: WARNING: File '''//versfile(1:lver)//''' not found.'
       endif
       
       nextrgoodold = 0
       nextrbadold = 0
       nextrgoodvold = 0
       nextrbadvold = 0

       colhead(1) = 'NO S1 S2'
       lencolh(1) = 8
       colhead(2) = 'S1 S2 '
       lencolh(2) = 6
       colhead(3) = 'S1 S2 '
       lencolh(3) = 6
       colhead(4) = 'SX '
       lencolh(4) = 3
       ixcopx = 5
       colhead(ixcopx) = 'XCO_PIXEL '
       lencolh(ixcopx) = 10
       iycopx = 6
       colhead(iycopx) = 'YCO_PIXEL '
       lencolh(iycopx) = 10
       ixcoas = 7
       colhead(ixcoas) = 'XCO_PIXRO '
       lencolh(ixcoas) = 10
       iycoas = 8
       colhead(iycoas) = 'YCO_PIXRO '
       lencolh(iycoas) = 10
       iflag = 9
       colhead(iflag) = 'FG '
       lencolh(iflag) = 3
       isigg = 10
       colhead(isigg) = 'SIGN '
       lencolh(isigg) = 5
       igodn = 11
       colhead(igodn) = 'GOOD '
       lencolh(igodn) = 5
       ifmon = 12
       colhead(ifmon) = 'FM '
       lencolh(ifmon) = 3
       isigm = 13
       colhead(isigm) = 'SIGNM '
       lencolh(isigm) = 6
       igodm = 14
       colhead(igodm) = 'GOODM '
       lencolh(igodm) = 6
       ifxpb = 15
       colhead(ifxpb) = 'FXP_BST '
       lencolh(ifxpb) = 8
       ifxpe = 16
       colhead(ifxpe) = 'FXP_ERR '
       lencolh(ifxpe) = 8
       ifxtb = 17
       colhead(ifxtb) = 'FXT_BST '
       lencolh(ifxtb) = 8
       ifxte = 18
       colhead(ifxte) = 'FXT_ERR '
       lencolh(ifxte) = 8
       ifxtg = 19
       colhead(ifxtg) = 'FXT_ALT '
       lencolh(ifxtg) = 8
       iscsx = 20
       colhead(iscsx) = 'SCALE_SX '
       lencolh(iscsx) = 9
       iafwh = 21
       colhead(iafwh) = 'AFWHM_INT '
       lencolh(iafwh) = 10
       ibfwh = 22
       colhead(ibfwh) = 'BFWHM_INT '
       lencolh(ibfwh) = 10
       iasiz = 23
       colhead(iasiz) = 'ASIZE_MOM '
       lencolh(iasiz) = 10
       ibsiz = 24
       colhead(ibsiz) = 'BSIZE_MOM '
       lencolh(ibsiz) = 10
       ithet = 25
       colhead(ithet) = 'THETA_MOM '
       lencolh(ithet) = 10
       ifofa = 26
       colhead(ifofa) = 'FOOT_FACT '
       lencolh(ifofa) = 10
       ifooa = 27
       colhead(ifooa) = 'FOOAMAJOR '
       lencolh(ifooa) = 10
       ifoob = 28
       colhead(ifoob) = 'FOOBMINOR '
       lencolh(ifoob) = 10
       nquantities = 28

       open ( 15, file=cat(1)(1:icat(1)), status='old' )
  
       call skipcomm     ( 15, cat(1)(1:icat(1)), nhead(1) )
       call linescolumns ( 15, cat(1)(1:icat(1)), nhead(1), nextr(1) )
  
       close ( 15 )

       allocate ( no(nwaves,nextr(1)), ns1(nwaves,nextr(1)), ns2(nwaves,nextr(1)), nsx(nwaves,nextr(1)), catline(nwaves,nextr(1))
     &          , quantity(nwaves,nextr(1),nquantities), factor(nwaves,nextr(1),nquantities), factsmoo(nwaves,nextr(1))
     &          , cno(nextr(1)), comment(nextr(1)), flag(nwaves,nextr(1)), badsource(nwaves,nextr(1)), backgint(nwaves,nextr(1))
     &          , backgsmoint(nwaves,nextr(1)), nok(nextr(1)), lnormalsigm(nwaves,nextr(1)), lmeasurable(nwaves,nextr(1))
     &          , lnormalsize(nwaves,nextr(1)), lnormalgood(nwaves,nextr(1)), lsubatwave(nwaves,nextr(1))
     &          , dist2peaks(nextr(1)), dist2foots(nextr(1)), sfg(nextr(1)), sfm(nwaves,nextr(1))   !!, snrtglob(nextr(1))
     &          , cfmflag(nwaves), xx(nextr(1)), yy(nextr(1)), mok(nextr(1)), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (71).'
         stop 71
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_flagsources = timer ( 'cpu', 0.0d0 )
         wal_flagsources = timer ( 'wal', 0.0d0 )
       endif

       do i=1,nwavemax
         obsimagestring(i) = '???'
       enddo
       
! Read measurement catalogs at each wavelength.

       do i=1,nwaves       

         do j=1,nextr(1)
           do l=1,nquantities
             factor(i,j,l) = 1.0d0
           enddo
         enddo
         
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading catalog '''//cat(i)(1:icat(i))//''''
       
         open ( 15, file=cat(i)(1:icat(i)), status='old' )

         call skipcomm     ( 15, cat(i)(1:icat(i)), nhead(i) )
         call linescolumns ( 15, cat(i)(1:icat(i)), nhead(i), nextr(i) )
         
         do ir=1,i
           if (nhead(ir) .ne. nhead(1) .or. nextr(ir) .ne. nextr(1)) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Tables differ in numbers of headers or data lines.'
             do iri=1,ir
               write (iotty,'(i5,1x,a,2i5)') iri, cat(iri)(1:icat(iri)), nhead(iri), nextr(iri)
             enddo
             stop 13
           endif
         enddo
         
         rewind ( 15 )

         detimagestring = '???'
         ide = lastc ( detimagestring )
         iob(i) = lastc ( obsimagestring(i) )
         fmtwcs='2f8.1 '

         do k=1,nhead(i)
           read (15,'(a)') headline(i,k)
           lhl = lastc ( headline(i,k) )

! Get names of the files with the detection image and observed (measurement) image.

           ncolumn = index ( headline(i,k)(1:lhl), '# DETECTION TABLE for image ' )
           if (ncolumn .gt. 0) then
             detimagestring = headline(i,k)(ncolumn+28:lhl)
             ide = lastc ( detimagestring )
           endif
    
           ncolumn = index ( headline(i,k)(1:lhl), '#         measurement image ' )
           if (ncolumn .gt. 0) then
             obsimagestring(i) = headline(i,k)(ncolumn+28:lhl)
             ifn(i) = lastc ( obsimagestring(i) )
             iob(i) = lastc ( obsimagestring(i) )
           endif
           
           ncolumn = index ( headline(i,k)(1:lhl), ' | prefix ' )
           if (ncolumn .gt. 0) then
             read(headline(i,k)(2:ncolumn),*) prefix, distpc
             if (distpc .lt. 100.0d0) then
               write (iotty,'(/a)') '   FINALCAT: ERROR: Wrong distance specified after prefix:'
               write (iotty,'(a )') '   '''//headline(i,k)(1:lhl)//''''
               stop 99
             endif
           endif
           
           ncolumn = index ( headline(i,k)(1:lhl), 'WCS_ACOOR' )
           if (ncolumn .gt. 0) then
             lwcscoord = .true.
             colhead(ixcoas) = 'WCS_ACOOR'
             colhead(iycoas) = 'WCS_DCOOR'
             fmtwcs='2f13.7'
           endif
           
           ncolumn = index ( headline(i,k)(1:lhl), colhead(1)(1:lencolh(1)) )
           if (ncolumn .gt. 0) then
             ncolhead(1) = ncolumn
             do l=2,nquantities
               ncolumn = index ( headline(i,k)(1:lhl), colhead(l)(1:lencolh(l)) )
               if (ncolumn .eq. 0 .and. colhead(l)(1:lencolh(l)) .eq. 'FXT_ALT ') then
                 colhead(ifxtg) = 'FXT_GAUSS '
                 ncolumn = index ( headline(i,k)(1:lhl), colhead(l)(1:lencolh(l)) )
               endif
               if (ncolumn .gt. 0) then
                 ncolhead(l) = ncolumn
               else
                 write (iotty,'(/a)') '   FINALCAT: ERROR: Header '''//colhead(l)(1:lencolh(l))//''' not found in the line:'
                 write (iotty,'(a )') '   '''//headline(i,k)(1:133)//''''
                 stop 99
               endif
             enddo
           endif
         enddo
     
         obsname(i) = obsimagestring(i)(2:ifn(i)-6)//'.fits'
         iobs(i) = lastc ( obsname(i) )
         inquire ( file=obsname(i)(1:iobs(i)), exist=lfname )
         if (.not.lfname) goto 93
         goto 897
 93      continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsname(i)(1:iobs(i))//''' not found.'
           stop 33
         endif
 897     continue

         obsfsname(i) = obsimagestring(i)(2:ifn(i)-6)//'.fits'
         iobsfs(i) = lastc ( obsfsname(i) )
         inquire ( file=obsfsname(i)(1:iobsfs(i)), exist=lfname )
         if (.not.lfname) goto 94
         goto 797
 94      continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsfsname(i)(1:iobsfs(i))//''' not found.'
           stop 34
         endif
 797     continue
        
         obsfsbsname(i) = obsimagestring(i)(2:ifn(i)-6)//'.bs.fits'
         iobsfsbs(i) = lastc ( obsfsbsname(i) )
         inquire ( file=obsfsbsname(i)(1:iobsfsbs(i)), exist=lfname )
         if (.not.lfname) goto 95
         goto 697
 95      continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsfsbsname(i)(1:iobsfsbs(i))//''' not found.'
           stop 35
         endif
 697     continue
       
         obsfscbname(i) = obsimagestring(i)(2:ifn(i)-6)//'.cb.fits'
         iobsfscb(i) = lastc ( obsfscbname(i) )
         inquire ( file=obsfscbname(i)(1:iobsfscb(i)), exist=lfname )
         if (.not.lfname) goto 96
         goto 597
 96      continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsfscbname(i)(1:iobsfscb(i))//''' not found.'
           stop 36
         endif
 597     continue

         call getfitshead ( obsname(i)(1:iobs(i)), nx, ny, dx, dy, bunit )

         peakfunits(i) = bunit(1:21)
         pixsize = sqrt ( dx * dy )

         lcl = lastc ( peakfunits(i) )
         obsimagestring(i) = obsimagestring(i)(1:iob(i))//' (units: '//peakfunits(i)(1:lcl)//')'
         iob(i) = lastc ( obsimagestring(i) )

         do j=1,nextr(i)
           read (15,'(a)') catline(i,j)

           read (catline(i,j),'(a1)') badsource(i,j)

           read  (catline(i,j),'(1x,i5)') no(i,j)

           write (colskip,'(i3)') ncolhead(2) - 2
           read  (catline(i,j),'('//colskip//'x,i3)') ns1(i,j)

           write (colskip,'(i3)') ncolhead(3) + 1
           read  (catline(i,j),'('//colskip//'x,i3)') ns2(i,j)

           write (colskip,'(i3)') ncolhead(4) - 2
           read  (catline(i,j),'('//colskip//'x,i3)') nsx(i,j)

           write (colskip,'(i3)') ncolhead(4) + 3
           read  (catline(i,j),'('//colskip//'x,a)') flag(i,j)
           
           do l=ixcopx,iycopx
             write (colskip,'(i3)') ncolhead(l) - 3
             read  (catline(i,j),'('//colskip//'x,f11.4)') quantity(i,j,l)
           enddo

           do l=ixcoas,iycoas
             write (colskip,'(i3)') ncolhead(l) - 4
             if (lwcscoord) then
               read (catline(i,j),'('//colskip//'x,f13.7)') quantity(i,j,l)
             else   
               read (catline(i,j),'('//colskip//'x,f11.4)') quantity(i,j,l)
             endif
           enddo

           ncolskipfsflg = ncolhead(iflag) - 2
           write (colskip,'(i3)') ncolhead(iflag) - 2
           read  (catline(i,j),'('//colskip//'x,a3)') cfsflag
!!           if (index ( cfsflag, '-' ) .eq. 0) then
!!             sfg(j) = 1
!!           else
!!             sfg(j) = -1
!!           endif
           read  (cfsflag,'(i3)') fsflag
           quantity(i,j,iflag) = dble ( abs ( fsflag ) )
           
           ncolskipsigg = ncolhead(isigg) - 5
           write (colskip,'(i3)') ncolhead(isigg) - 5
           read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,isigg)

           write (colskip,'(i3)') ncolhead(igodn) - 5
           read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,igodn)

           ncolskipfmflg = ncolhead(ifmon) - 4
           write (colskip,'(i3)') ncolhead(ifmon) - 4
           read  (catline(i,j),'('//colskip//'x,a5)') cfmflag(i)
           if (index ( cfmflag(i), '-' ) .eq. 0) then
             sfm(i,j) = 1
           else
             sfm(i,j) = -1
           endif
           read (cfmflag(i),'(i5)') fmflag
           quantity(i,j,ifmon) = dble ( abs ( fmflag ) )

           do l=isigm,igodm
             write (colskip,'(i3)') ncolhead(l) - 5
             read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,l)
           enddo

           do l=ifxpb,ifxtg
             write (colskip,'(i3)') ncolhead(l) - 4
             read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,l)
           enddo

           do l=iscsx,nquantities
             write (colskip,'(i3)') ncolhead(l) - 3
             read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,l)
           enddo
           ncolskipssx = ncolhead(iscsx) - 3
           ncolskipasi = ncolhead(iasiz) - 3
           ncolskipfoo = ncolhead(ifooa) - 3

           if (lfinishing_mode) then
             quantity(i,j,ifofa) = -1.0d0 * quantity(i,j,ifofa)
           endif
           quantity(i,j,ifooa) = abs ( quantity(i,j,ifooa) )
           quantity(i,j,ifoob) = abs ( quantity(i,j,ifoob) )
         enddo

         close ( 15 )
       enddo        

       id = index ( detimagestring(1:ide), '.det.' ) + 3
       filecombo = detimagestring(2:id)//'.combined'
       ic = lastc ( filecombo )

       inquire ( file=filecombo(1:ic), exist=lfnamefc )
       if (.not.lfnamefc) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//filecombo(1:ic)//''' not found.'
         stop 32
       endif

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading file '''//filecombo(1:ic)//''''
      
       open ( 25, file=filecombo(1:ic), status='old' )
      
       call skipcomm ( 25, filecombo(1:ic), nheadfc )
       
       ndetwaves = 0
       do i=1,nwaves
         read (25,'(a)',end=77,err=77) detimageline(i)
         ndetwaves= ndetwaves + 1
       enddo
   77  continue

       close ( 25 )

! Mark those wavelengths which were used to create combined detection images.
       
       lintens = .false.
       lsurfdens = .false.
       do i=1,nwaves
         ldetectionwave(i) = .false.
         lcw = lastc ( cwave0(i) )
         do ir=1,ndetwaves
           idim1 = index ( detimageline(ir), '.' )
           idim2 = index ( detimageline(ir), '.det.' )
           if (detimageline(ir)(idim1+1:idim2-1) .eq. cwave0(i)(1:lcw)) then
             ldetectionwave(i) = .true.
             exit
           endif
         enddo
         ifui = lastc ( peakfunits(i) )
         if (peakfunits(i)(1:ifui) .eq. 'MJy/sr') then
           lintens = .true.
         endif
         if (peakfunits(i)(1:ifui) .eq. 'H2/cm^2') then
           lsurfdens = .true.
         endif
       enddo
       
       adopteddistance = ''

       if (lintens) then
         conversionfacts = ' conversion from MJy/sr: '
       endif
       if (lsurfdens) then
         conversionfacts = ' conversion from H2/cm^2: '
         convertsdmass = xmu * xmH * (au2cm * distpc)**2 / xMsun  !<-- total number of H2/cm^2 to mass in Msun
         write (convfact,'(1pe11.4)') convertsdmass
         lcf = lastc ( convfact )
         adopteddistance = ' conversion of FXT_BST to MASS (Msun):'//convfact(1:lcf)
         lcw = lastc ( adopteddistance )
         write (convfact,'(1pe9.2)') distpc
         lcf = lastc ( convfact )
         adopteddistance = adopteddistance(1:lcw)//' for a distance of'//convfact(1:lcf)//' pc'
       endif
       if (lintens .and. lsurfdens) then
         conversionfacts = ' conversion from MJy/sr|H2/cm^2: '
       endif

       do i=1,nwaves
        
         ifui = lastc ( peakfunits(i) )

         if (peakfunits(i)(1:ifui) .eq. 'MJy/sr' .or. peakfunits(i)(1:ifui) .eq. 'H2/cm^2') then

           lcw = lastc ( cwave0(i) )
           sq_arcsecs_per_beam_area_approx = pi * (obsbeam(i) / 2.0)**2 / log ( 2.0d0 )

           if (lherschel(i) .and. peakfunits(i)(1:ifui) .eq. 'MJy/sr' .and.
     &         (cwave0(i)(1:lcw) .eq. '250' .or. cwave0(i)(1:lcw) .eq. '0250' .or. 
     &          cwave0(i)(1:lcw) .eq. '350' .or. cwave0(i)(1:lcw) .eq. '0350' .or. 
     &          cwave0(i)(1:lcw) .eq. '500' .or. cwave0(i)(1:lcw) .eq. '0500')) then
  
             if (cwave0(i)(1:lcw) .eq. '250' .or. cwave0(i)(1:lcw) .eq. '0250') sq_arcsecs_per_beam_area = SPIRE_250_beamarea
             if (cwave0(i)(1:lcw) .eq. '350' .or. cwave0(i)(1:lcw) .eq. '0350') sq_arcsecs_per_beam_area = SPIRE_350_beamarea
             if (cwave0(i)(1:lcw) .eq. '500' .or. cwave0(i)(1:lcw) .eq. '0500') sq_arcsecs_per_beam_area = SPIRE_500_beamarea
           else
             sq_arcsecs_per_beam_area = sq_arcsecs_per_beam_area_approx
           endif

           sterad_per_beam_area = sq_arcsecs_per_beam_area / sq_arcsecs_per_sterad

           if (peakfunits(i)(1:ifui) .eq. 'MJy/sr') then
             convertunitperbeam = 1.0d6 * sterad_per_beam_area  !<~ peak intensity in MJy/sr to Jy/beam
           endif

           if (peakfunits(i)(1:ifui) .eq. 'H2/cm^2') then
             convertunitperbeam = sq_arcsecs_per_beam_area      !<~ peak density in H2/cm^2 to H2/cm^2/beam
           endif
           
           write (convfact,'(1pe11.4)') convertunitperbeam
           
           lcf = lastc ( conversionfacts )
           conversionfacts = conversionfacts(1:lcf)//convfact
           lcf = lastc ( conversionfacts )

           do j=1,nextr(i)

!!             if (liter_phase1) then
!!               quantity(i,j,ifxpe) = 0.1d0 * quantity(i,j,ifxpb)
!!               quantity(i,j,ifxte) = 0.1d0 * quantity(i,j,ifxtb)
!!             endif
      
             if (flag(i,j) .ne. 'n') then

! The following correction factor fixes the problem of overestimated source background that leaves a pedestal and leads to
! underestimated FWHM size, peak flux, and total flux. For unresolved sources, it makes FWHM smaller than the beam size, which
! clearly indicates the problem of oversubtracted background. The correction factors are found empirically by considering a
! Gaussian source and subtracting its faintest parts of varying thickness.

               if (lfinishing_mode) then
                 sizeratio = obsbeam(i) / min ( sqrt ( quantity(i,j,iafwh) * quantity(i,j,ibfwh) ), obsbeam(i) )
                 corrfactpeak = sizeratio**(1.75d0) + 0.35d0 * (1.0d0 - sizeratio)
                 corrfactflux = 1.15d0 * sizeratio**(3.87d0) - 0.0813d0 * (sizeratio - 0.04d0)**(-15)
                 factor(i,j,ifxpb) = corrfactpeak * factor(i,j,ifxpb)
                 factor(i,j,ifxtb) = corrfactflux * factor(i,j,ifxtb)
                 quantity(i,j,iafwh) = quantity(i,j,iafwh) * sizeratio
                 quantity(i,j,ibfwh) = quantity(i,j,ibfwh) * sizeratio
               endif

! Convert peak fluxes from MJy/sr into Jy/beam or from H2/cm^2 to Msun/beam.

               factor(i,j,ifxpb) = factor(i,j,ifxpb) * convertunitperbeam

               if (abs ( quantity(i,j,ifxpb) ) * factor(i,j,ifxpb) .lt. 9.999d-31) then
                 if (abs ( quantity(i,j,ifxpb) ) .gt. 1.0d-90) then
                   quantity(i,j,ifxpb) = sign ( 1.0d0, quantity(i,j,ifxpb) ) * 9.999d-31
                 endif
                 factor(i,j,ifxpb) = 1.0d0
               endif
       
! Convert errors in peak fluxes from MJy/sr into Jy/beam or from H2/cm^2 to Msun/beam.

               factor(i,j,ifxpe) = factor(i,j,ifxpe) * convertunitperbeam
       
               if (quantity(i,j,ifxpe) * factor(i,j,ifxpe) .lt. 9.999d-31) then
                 if (abs ( quantity(i,j,ifxpe) ) .gt. 1.0d-90) then
                   quantity(i,j,ifxpe) = 9.999d-31
                 endif
                 factor(i,j,ifxpe) = 1.0d0
               endif
               
! Verify total fluxes.

               if (abs ( quantity(i,j,ifxtb) ) * factor(i,j,ifxtb) .lt. 9.999d-31) then
                 if (abs ( quantity(i,j,ifxtb) ) .gt. 1.0d-90) then
                   quantity(i,j,ifxtb) = sign ( 1.0d0, quantity(i,j,ifxtb) ) * 9.999d-31
                 endif
                 factor(i,j,ifxtb) = 1.0d0
               endif
    
               if (quantity(i,j,ifxte) * factor(i,j,ifxte) .lt. 9.999d-31) then
                 if (abs ( quantity(i,j,ifxte) ) .gt. 1.0d-90) then
                   quantity(i,j,ifxte) = 9.999d-31
                 endif
                 factor(i,j,ifxte) = 1.0d0
               endif

               if (abs ( quantity(i,j,ifxtg) ) * factor(i,j,ifxtg) .lt. 9.999d-31) then
                 if (abs ( quantity(i,j,ifxtg) ) .gt. 1.0d-90) then
                   quantity(i,j,ifxtg) = sign ( 1.0d0, quantity(i,j,ifxtg) ) * 9.999d-31
                 endif
                 factor(i,j,ifxtg) = 1.0d0
               endif
             endif
           enddo
         endif

!!!! If the total flux is not measurable, then use the Gaussian flux instead, if the latter is higher.
!!!
!!!         do j=1,nextr(i)
!!!    
!!!           if (flag(i,j) .ne. 'n') then
!!!             if (abs ( quantity(i,j,ifxtb) ) .le. snr2min * quantity(i,j,ifxte) .and. 
!!!     &           abs ( quantity(i,j,ifxtg) ) .gt. snr2min * quantity(i,j,ifxte)) then
!!!                 quantity(i,j,ifxtb) = quantity(i,j,ifxtg)
!!!             endif
!!!           endif
!!!         enddo
       enddo

! Find minimum and maximum observational beams.
       
       obsbeammin = 1.0d30
       obsbeammax = 0.0d0
       do i=1,nwaves
         obsbeammin = min ( obsbeam(i), obsbeammin )
         obsbeammax = max ( obsbeam(i), obsbeammax )
       enddo

! Find a factor by which the peak intensity of a source would be lowered due to a convolution with a smoothing beam.

       do i=1,nwaves
         do j=1,nextr(i)
           if (lfinishing_mode) then
             smoobeam = sqrt ( obsbeammax**2 - obsbeam(i)**2 )
             factsmoo(i,j) = quantity(i,j,iafwh) * quantity(i,j,ibfwh) / 
     &                       sqrt ( (quantity(i,j,iafwh)**2 + smoobeam**2) * (quantity(i,j,ibfwh)**2 + smoobeam**2) )
           endif
           lsubatwave(i,j) = .false.
         enddo
       enddo

       do j=1,nextr(1)

!!! 2018-01-30: Re-estimate characteristic sizes (and footprints) more accurately from the measured sizes
!!! (only once, after the very first SMEASURE iteration).
!!
!!         if (lfirstiteration) then
!!           do i=1,nwaves
!!             quantity(i,j,iscsx) = min ( quantity(i,j,iscsx), quantity(i,j,ibfwh) )
!!           enddo
!!         endif

         do i=1,nwaves
           quantity(i,j,isigg) = 0.0d0
           quantity(i,j,igodn) = 0.0d0
           quantity(i,j,igodm) = 8.888d-31
         enddo

! Compute the global significance and goodness from the ones at the individual wavelengths. 
! All wavebands must be used, no matter if they were used for detection or not.

         do i=1,nwaves
           if (flag(i,j) .ne. 'n') then
             if (quantity(i,j,ifxpe) .gt. almostzero .and. quantity(i,j,ifxte) .gt. almostzero) then
               quantity(i,j,igodm) = (quantity(i,j,isigm) / signmin) *
     &                               sqrt ( abs ( quantity(i,j,ifxpb) ) / quantity(i,j,ifxpe) / snr1min *
     &                                      abs ( quantity(i,j,ifxtb) ) / quantity(i,j,ifxte) / snr2min ) *
     &                               (quantity(i,j,ibfwh) / quantity(i,j,iafwh))  !!**2
             else
               quantity(i,j,igodm) = 1.234d-56
             endif
           endif
         enddo

         do i=1,nwaves
           quantity(1,j,isigg) = quantity(1,j,isigg) + quantity(i,j,isigm)**2
           quantity(1,j,igodn) = quantity(1,j,igodn) + quantity(i,j,igodm)**2
         enddo
         quantity(1,j,isigg) = sqrt ( quantity(1,j,isigg) )
         quantity(1,j,igodn) = sqrt ( quantity(1,j,igodn) )

         sfg(j) = 1
       enddo

! Source is bad and rejected if either total fluxes at all waves or sizes from moments are zero or negative.

       nextrbad = 0
       nextrbadnew = 0

       if (cverbose .eq. '-verb2') then
         write (iotty,'(a)') '   Commenting out bad sources at all wavelengths'
       endif
       
       do j=1,nextr(1)

         write (cno(j),'(i6)') no(1,j)
         cno(j)(1:1) = ' '
         comment(j) = '   '
         lcno = 1

         xx(j) = 0.0d0
         yy(j) = 0.0d0
         if (cno(j)(1:1) .ne. '!') then
           xx(j) = abs ( quantity(1,j,igodn) )
           yy(j) = dble ( j )
         endif

         do i=1,nwaves
           quantity(i,j,iflag) = 0.0d0
           quantity(i,j,ifmon) = 0.0d0
         enddo       
         
! Source is too close to another and has almost same size (within a factor of 2) 
! and a lower product of global significance and global S/N ratio and range of scales.
           
         coccup = ' '
         iocc = 0
         lpositionoccupied = .false.

         if (liter_phase3) then

           do i=1,nwaves
             
             if (ldetectionwave(i) .and. flag(i,j) .ne. 'n') then
               
               valij = quantity(1,j,igodn) * quantity(1,j,isigg) * (ns2(1,j) - ns1(1,j))
               
               do k=1,nextr(1)
                 if (k .ne. j .and. flag(i,k) .ne. 'n' .and. badsource(1,k) .ne. '!') then
                   rxy = sqrt ( (quantity(i,j,ixcopx) - quantity(i,k,ixcopx))**2 
     &                        + (quantity(i,j,iycopx) - quantity(i,k,iycopx))**2 )
                   call round1d ( rxy, 1, 2 )
                   
                   if (rxy .lt. 3.3d0 .and. valij .lt. quantity(1,j,igodn) * quantity(1,k,isigg) * (ns2(1,k) - ns1(1,k))) then
                     lpositionoccupied = .true.               !! max ( 3.3d0, obsbeammin / pixsize ) <-- Fix by A.B.M. on 2017-11-21
                     ik = int ( log10 ( dble ( max ( k, 1 ) ) ) ) + 1
                     write (cocc,'(i6)') k
                     coccup = coccup(1:iocc)//' '//cocc(6-ik+1:6)
                     iocc = lastc ( coccup )
                     exit
                   endif
                 endif
               enddo
             endif
           enddo
         endif

         do i=1,nwaves
           ntoofaintorbigorelong(i) = 0
         enddo       
         lbgnoisefluctuation = .true.

         do i=1,nwaves

           if (flag(i,j) .ne. 'n') then

             lbgnoisefluctuation = .false.
             lnormalsize(i,j) = .true.
             lnormalgood(i,j) = .true.

             if (liter_phase3) then

               if (quantity(i,j,igodm) .lt. goodminvar) then
                 lnormalgood(i,j) = .false.
                 ntoofaintorbigorelong(i) = i
               endif

               if (sqrt ( quantity(i,j,iafwh) * quantity(i,j,ibfwh) ) .lt. 0.95d0 * obsbeam(i) .or.
     &             quantity(i,j,iafwh) .gt. 1.4d0 * quantity(i,j,iasiz) .or. 
     &             quantity(i,j,ibfwh) .gt. 1.4d0 * quantity(i,j,ibsiz)) then
                 quantity(i,j,ifmon) = quantity(i,j,ifmon) + 1.0d0
               endif

               sizemean = sqrt ( quantity(i,j,ifooa) * quantity(i,j,ifoob) ) / abs ( quantity(i,j,ifofa) )

               if (sizemean .gt. 1.25d0 * sourcemaxsize(i)) then
                 ntoofaintorbigorelong(i) = i
                 lnormalsize(i,j) = .false.
                 quantity(i,j,ifmon) = quantity(i,j,ifmon) + 2.0d0
               endif

               elongation = quantity(i,j,iafwh) / quantity(i,j,ibfwh)
               footratio = quantity(i,j,ifooa) / quantity(i,j,iafwh)

               if (elongation .gt. maxelong .or. footratio .lt. 1.15d0) then
                 ntoofaintorbigorelong(i) = i
                 lnormalsize(i,j) = .false.
                 quantity(i,j,ifmon) = quantity(i,j,ifmon) + 4.0d0
               endif
             endif
           else
             lnormalsize(i,j) = .false.
             lnormalgood(i,j) = .false.
           endif
         enddo

         nwdetectionlevel = 0
         nwacceptablelevel = 0
         nwtoofaintorbigorelong = 0
         
         do i=1,nwaves

           if (flag(i,j) .ne. 'n') then
             if (ntoofaintorbigorelong(i) .gt. 0) then
               nwtoofaintorbigorelong = nwtoofaintorbigorelong + 1
             else
               if (ldetectionwave(i)) then
                 nwdetectionlevel = nwdetectionlevel + 1
               endif
             endif
           endif
         enddo

         ldetectedtoofewaves = .true.
         ltoofaintorbigorelong = .false.

         if (nwdetectionlevel .ge. max ( nwavesdetect, 1 )) then    !! .or. nwacceptablelevel .ge. 1  
           ldetectedtoofewaves = .false.
         endif
         if (nwtoofaintorbigorelong .ge. nwaves) then
           ltoofaintorbigorelong = .true.
         endif

         if (lbgnoisefluctuation .or. lpositionoccupied .or. ltoofaintorbigorelong .or. ldetectedtoofewaves) then

! Indicate which condition led to the decision to comment the sources out. Count the number of bad sources.
           
           nextrbad = nextrbad + 1
           nextrbadnew = nextrbad
           cno(j)(1:1) = '!'
           comment(j) = '  #'
           lcno = 3

           if (lbgnoisefluctuation) then
             lcno = lastc ( comment(j) )
             comment(j) = comment(j)(1:lcno)//' detected as a background or noise fluctuation,'
           elseif (lpositionoccupied) then
             lcno = lastc ( comment(j) )
             comment(j) = comment(j)(1:lcno)//' source position occupied by other sources:'//coccup(1:iocc)//','
           else
             if (ltoofaintorbigorelong) then
               lcno = lastc ( comment(j) )
               comment(j) = comment(j)(1:lcno)//' source not good enough or too large or too elongated,'
             endif
             if (ldetectedtoofewaves) then
               lcno = lastc ( comment(j) )
               comment(j) = comment(j)(1:lcno)//' source detectable in too few images (< '//cnwd(1:inwd)//'),'
             endif
           endif
         endif
         
         if (liter_phase2) then
           snratio1min = snr1min / 2.0d0
           snratio2min = snr2min / 2.0d0
         endif
         if (liter_phase3) then
           snratio1min = snr1min
           snratio2min = snr2min
         endif
         cbadwave = ' '
         icbw = 0
         
         do i=1,nwaves

           if (liter_phase2 .or. liter_phase3) then

             lmeasurable(i,j) = .false.

             if (flag(i,j) .ne. 'n') then

               if (abs ( quantity(i,j,ifxpb) ) .lt. snratio1min * quantity(i,j,ifxpe) .or.
     &             abs ( quantity(i,j,ifxtb) ) .lt. snratio2min * quantity(i,j,ifxte)) then

                 write (cwav,'(i2.2)') i
                 cbadwave = cbadwave(1:icbw)//' '//cwav
                 icbw = lastc ( cbadwave )

                 if (abs ( quantity(i,j,ifxpb) ) .lt. snratio1min * quantity(i,j,ifxpe)) then
                   quantity(i,j,ifmon) = quantity(i,j,ifmon) + 10.0d0
                 endif

                 if (abs ( quantity(i,j,ifxtb) ) .lt. snratio2min * quantity(i,j,ifxte)) then
                   quantity(i,j,ifmon) = quantity(i,j,ifmon) + 20.0d0
                 endif

                 if (quantity(i,j,ifxpb) .lt.-almostzero .or.
     &               (quantity(i,j,ifxpb) .lt.-almostzero .and. quantity(i,j,ifxtb) .gt. almostzero) .or.
     &               (quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxtb) .lt.-almostzero)) then
                   quantity(i,j,ifmon) = quantity(i,j,ifmon) + 40.0d0
                 endif
               else
                 lmeasurable(i,j) = .true.
               endif
             endif
           else
             lmeasurable(i,j) = .true.
           endif
         enddo

         clowwave = ' '
         iclw = 0

         do i=1,nwaves

!!           lnormalsigm(i,j) = .false.
!!
!!           if (flag(i,j) .ne. 'n') then
!!
!!             if (quantity(i,j,isigm) .ge. signvar) then
!!               lnormalsigm(i,j) = .true.
!!             elseif (quantity(i,j,isigm) .gt. -signvar) then
!!               quantity(i,j,ifmon) = quantity(i,j,ifmon) + 200.0d0
!!               write (cwav,'(i2.2)') i
!!               clowwave = clowwave(1:iclw)//' '//cwav
!!               iclw = lastc ( clowwave )
!!             endif
!!           endif

           lnormalsigm(i,j) = .true.
         enddo
       enddo
       
       call sortarr ( nextr(1), xx, yy )

       do j=1,nextr(1)
         xx(j) = yy(nextr(1)-j+1)
       enddo

       if (ltiming) then
         cput_flagsources = cput_flagsources + timer ( 'cpu', cpu_flagsources )
         walt_flagsources = walt_flagsources + timer ( 'wal', wal_flagsources )
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLAG SOURCES''    CPU',cput_flagsources, ' WALL', cput_flagsources, ' sec'
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       nextrgoodnew = nextr(1) - nextrbadnew
       
! Determine numbers of pixels in the 1st FITS image.

       call getfitshead ( obsname(1)(1:iobs(1)), nx, ny, dx, dy, bunit )

! Determine sources that are blended (overlapping with their footprints by an area larger than 20%) in at least one band.

       if (lfinishing_mode) then

         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Identifying and flagging special cases'
     
         if (ltiming) then
           cpu_substructured = timer ( 'cpu', 0.0d0 )
           wal_substructured = timer ( 'wal', 0.0d0 )
         endif
     
         allocate ( ellipsearea(nwaves,nextr(1)), intersection(nextr(1)), intersectionff(nextr(1)), stat=irc )
         
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (80).'
           stop 80
         endif
     
! Compute areas of the footprint ellipses for all extracted sources.

         do j=1,nextr(1)
        
           if (flag(1,j) .ne. 'n' .and. cno(j)(1:1) .ne. '!') then
        
             do i=1,nwaves
               
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr , 1 )
               l2 = min ( l0 + nr , nx )
               m1 = max ( m0 - nr , 1 )
               m2 = min ( m0 + nr , ny )
               ellipsearea(i,j) = 0
        
               do m=m1,m2
                 dblm = dble ( m )
                 do l=l1,l2
                   dbll = dble ( l )
        
                   if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                           , quantity(i,j,ifoob), quantity(i,j,ithet) )) then
                     ellipsearea(i,j) = ellipsearea(i,j) + 1
                   endif
                 enddo
               enddo
             enddo
           endif
         enddo
         
         ff = 0.50d0
             
         do j=1,nextr(1)
       
           icsw = 0
           if (flag(1,j) .ne. 'n' .and. cno(j)(1:1) .ne. '!') then
             csubwave = ' '
       
             do k=1,nextr(1)
               if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                 dist2peaks(k) = (quantity(1,j,ixcopx) - quantity(1,k,ixcopx))**2 + (quantity(1,j,iycopx) - quantity(1,k,iycopx))**2
               endif
             enddo

! Consider all wavelengths in turn.

             do i=1,nwaves
               
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr , 1 )
               l2 = min ( l0 + nr , nx )
               m1 = max ( m0 - nr , 1 )
               m2 = min ( m0 + nr , ny )

               do k=1,nextr(1)
                 if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                   intersection(k) = 0
                   intersectionff(k) = 0
                   dist2foots(k) = ((quantity(i,j,ifooa) + quantity(i,k,ifooa)) / (dx + dy))**2
                 endif
               enddo
          
               do m=m1,m2
                 dblm = dble ( m )
                 do l=l1,l2
                   dbll = dble ( l )

! Compute intersection area for all sources that intersect with the current source 'j'.

                   if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,j,ixcopx), quantity(1,j,iycopx)
     &                           , quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ithet) )) then
                     do k=1,nextr(1)
                       if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                         if (dist2peaks(k) .lt. dist2foots(k)) then
                           if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,k,ixcopx), quantity(1,k,iycopx)
     &                                   , quantity(i,k,ifooa), quantity(i,k,ifoob), quantity(i,k,ithet) )) then
                             intersection(k) = intersection(k) + 1
                           endif
                         endif
                       endif
                     enddo
                   endif

! Compute full intersection areas of all sources that intersect with the central radial fraction 'ff' of the current source 'j'.

                   if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,j,ixcopx), quantity(1,j,iycopx)
     &                           , ff * quantity(i,j,ifooa), ff * quantity(i,j,ifoob), quantity(i,j,ithet) )) then
                     do k=1,nextr(1)
                       if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                         if (dist2peaks(k) .lt. dist2foots(k)) then
                           if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,k,ixcopx), quantity(1,k,iycopx)
     &                                   , quantity(i,k,ifooa), quantity(i,k,ifoob), quantity(i,k,ithet) )) then
                             intersectionff(k) = intersectionff(k) + 1
                           endif
                         endif
                       endif
                     enddo
                   endif
                 enddo
               enddo

! Flag sub-structured and blended sources. Substructured are also necessarily blended.

               do k=1,nextr(1)
                 if (k .ne. j .and. flag(i,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then

! Sub-structured (footprint of at least one smaller source is fully within the footprint of the large source) in at least one band.

                   if (intersectionff(k) .gt. 0) then
                     if (ellipsearea(i,k) .gt. 0 .and. intersectionff(k) .eq. ellipsearea(i,k)) then
                       quantity(1,j,iflag) = 2.0d0
                       quantity(1,k,iflag) = 3.0d0

! Monochromatic flag for substructured sources is only raised when the substructuring sources are measurable.
     
                       if (quantity(i,k,ifxpb) .gt. almostzero .and. quantity(i,k,ifxpe) .gt. almostzero .and.
     &                     (quantity(i,k,ifxpb) .ge. snratio1min * quantity(i,k,ifxpe) .or.
     &                      quantity(i,k,ifxtb) .ge. snratio2min * quantity(i,k,ifxte))) then
                         quantity(i,j,iflag) = 2.0d0
                         quantity(i,k,iflag) = 3.0d0
                       endif
                     endif
                   endif

! Flag blended sources (overlapping in the one or the other footprint by an area larger than 20%) in at least one band.

                   if (intersection(k) .gt. 0) then
                     if (ellipsearea(i,k) .gt. 0 .and. ellipsearea(i,j) .gt. 0) then 
                       if (dble ( intersection(k) ) .gt. 0.2d0 * dble ( ellipsearea(i,j) ) .or.
     &                     dble ( intersection(k) ) .gt. 0.2d0 * dble ( ellipsearea(i,k) )) then
                         if (nint ( abs ( quantity(i,j,iflag) ) ) .lt. 2) then
                           quantity(i,j,iflag) = 1.0d0
                         endif
                       endif
                     endif
                   endif
                 endif
               enddo      

               if (flag(i,j) .ne. 'n') then
                 if (nint ( abs ( quantity(i,j,iflag) ) ) .eq. 2) then
                   write (cwav,'(i2.2)') i
                   csubwave = csubwave(1:icsw)//' '//cwav
                   icsw = lastc ( csubwave )
                   lsubatwave(i,j) = .true.
                   if (nint ( quantity(i,j,ifmon) ) .lt. 200) then
                     quantity(i,j,ifmon) = quantity(i,j,ifmon) + 100.0d0
                   endif
                 endif
               endif      
             enddo        
           endif          
         enddo
     
         deallocate ( ellipsearea, intersection, intersectionff )
     
         if (ltiming) then
           cput_substructured = cput_substructured + timer ( 'cpu', cpu_substructured )
           walt_substructured = walt_substructured + timer ( 'wal', wal_substructured )
           write (60,'(a,2(1pe9.2,a))') ' Total ''SUBSTRUCTURED''   CPU', cput_substructured, ' WALL', cput_substructured, ' sec'
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (cverbose .eq. '-verb2')
     &     write (iotty,'(a)') '   Computing images of background and fitted sources'
         if (ltiming) then
           cpu_backfitsrc = timer ( 'cpu', 0.0d0 )
           wal_backfitsrc = timer ( 'wal', 0.0d0 )
         endif
 
         call fitshapesintensities ( nx, ny, iotty, cverbose, nwaves, obsname, obsfsname, obsfscbname, obsfsbsname, iobs, iobsfs
     &                             , iobsfscb, iobsfsbs, nextr, cno, quantity, ifooa, ifoob, ithet, ixcopx, iycopx, ifxpb, isigm
     &                             , igodm, iafwh, ibfwh, obsbeam, convtoradians, goodminvar, cfitsversion, cdate, ctime, peakfunits
     &                             , ifxpe, sq_arcsecs_per_sterad, cbars, getstitle, compda, clibname(lb:7), xmu, xmH, au2cm, distpc
     &                             , xMsun, lnormalsigm, lnormalsize, lnormalgood )  !! , lmeasurable
 
         if (ltiming) then
           cput_backfitsrc = cput_backfitsrc + timer ( 'cpu', cpu_backfitsrc )
           walt_backfitsrc = walt_backfitsrc + timer ( 'wal', wal_backfitsrc )
           write (60,'(a,2(1pe9.2,a))') ' Total ''BACKGR FITSRC''   CPU', cput_backfitsrc, ' WALL', cput_backfitsrc, ' sec'
         endif
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_semifinalcat = timer ( 'cpu', 0.0d0 )
         wal_semifinalcat = timer ( 'wal', 0.0d0 )
       endif

       itot = 1
       ibad = 1
       igood = 1
       itent = 1
       ibad = int ( log10 ( dble ( max ( nextrbad, 1 ) ) ) ) + 1
       write (cnextrbad,'(i5)') nextrbad
       nextrgood = nextr(1) - nextrbad
       igood = int ( log10 ( dble ( max ( nextrgood, 1 ) ) ) ) + 1
       write (cnextrgood,'(i5)') nextrgood
       itot = int ( log10 ( dble ( max ( nextr(1), 1 ) ) ) ) + 1
       write (cnextr,'(i5)') nextr(1)
       
! Read in the configuration file of GETSF just for documenting catalogs.

       inquire ( file='+getsf.cfg', exist=lfname )
       if (.not.lfname) then
         inquire ( file='+GETSF.CFG', exist=lfname )
         if (.not.lfname) then
           inquire ( file='+getsf.'//cwave(1)//'.cfg', exist=lfname )
           if (.not.lfname) then
             inquire ( file='+GETSF.'//cwave(1)//'.CFG', exist=lfname )
             if (.not.lfname) then
               write (iotty,'(/a)') '   WARNING: Config file for GETSF not found.'
               cfgfile = ''
             else
               cfgfile='+GETSF.'//cwave(1)//'.CFG'
             endif
           else
             cfgfile='+getsf.'//cwave(1)//'.cfg'
           endif
         else
           cfgfile = '+GETSF.CFG'
         endif                  
       else
         cfgfile = '+getsf.cfg'
       endif
       lcfg = lastc ( cfgfile )
       ncfglines = 0
              
       if (lfname) then
         open ( 25, file=cfgfile(1:lcfg), status='old' )
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading configuration file '''//cfgfile(1:lcfg)//''''
         do i=1,1000
           read (25,'(a)',end=98,err=90) cfgline(i)
         enddo
  90     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading file '''//cfgfile(1:lcfg)//'''.'
         close (25)
         stop 99
  98     continue
         close (25)
         ncfglines = i - 1
       endif

! Prepare header lines for the final output catalog.
       
       m = 0
       do k=1,nhead(1)
         lhl = lastc ( headline(1,k) )
         ncolumn = index ( headline(1,k)(1:lhl), '# Configuration parameters ' )
         if (ncolumn .eq. 0) then
           ncolumn = index ( headline(1,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
         endif
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
           m = m + 1
           headlineout(m) = '!'
           do kk=9,ncfglines-1
             m = m + 1
             lh = lastc ( cfgline(kk) )
             headlineout(m) = '!'//cfgline(kk)(1:lh)
           enddo
           nconfigend = m
           m = m + 1
           lhl = lastc ( headline(1,k-2) )
           headlineout(m) = '!'//headline(1,k-2)(2:lhl)
           m = m + 1
           headlineout(m) = '!'
         endif
         ncolumn = index ( headline(1,k)(1:lhl), '# Tabulated quantities' )
         if (ncolumn .eq. 0) then
           ncolumn = index ( headline(1,k)(1:lhl), '# TABULATED QUANTITIES' )
         endif

         if (ncolumn .gt. 0) then
           nbra2 = index ( headline(1,k)(1:lhl), ' bad):' )
           if (nbra2 .eq. 0) then
             nbra2 = index ( headline(1,k)(1:lhl), ' BAD):' )
           endif
           if (nbra2 .gt. 0) then
             nplus = index ( headline(1,k)(nbra2-15:nbra2), '+' )
             if (nplus .gt. 0) then
               nplus = nbra2 - 16 + nplus
               nbra1 = index ( headline(1,k)(nplus-15:nplus), '(' )
               if (nbra1 .gt. 0) then
                 nbra1 = nplus - 16 + nbra1
                 read (headline(1,k)(nbra1+1:nplus-7),*) nextrgoodold
                 read (headline(1,k)(nplus+2:nbra2-1),*) nextrbadold
                 nbra1 = nbra1 - 2
                 nbra2 = index ( headline(1,k)(nbra1-4:nbra1+3), ' bad)' )
                 if (nbra2 .eq. 0) then
                   nbra2 = index ( headline(1,k)(nbra1-4:nbra1+3), ' BAD)' )
                 endif
                 if (nbra2 .gt. 0) then
                   nbra2 = nbra2 + nbra1 - 4 - 1
                   nplus = index ( headline(1,k)(nbra2-15:nbra2), '+' )
                   if (nplus .gt. 0) then
                     nplus = nbra2 - 16 + nplus
                     nbra1 = index ( headline(1,k)(nplus-15:nplus), '(' )
                     if (nbra1 .gt. 0) then
                       nbra1 = nplus - 16 + nbra1
                       read (headline(1,k)(nbra1+1:nplus-7),*) nextrgoodvold
                       read (headline(1,k)(nplus+2:nbra2-1),*) nextrbadvold
                     endif
                   endif
                 endif
               endif
             endif
           endif
           if (cverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Total number of sources: '//cnextr(5-itot+1:5)
     &                         //' ('//cnextrgood(5-igood+1:5)//' good + '//cnextrbad(5-ibad+1:5)//' bad)'
           endif
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl-1)//' ('//cnextrgood(5-igood+1:5)//' good + '//cnextrbad(5-ibad+1:5)//' bad):'
           m = m + 1
           headlineout(m) = '!'
         endif

         ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(1)(1:2) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
         endif
         ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(2)(1:2) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
         endif
         ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(3)(4:5) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
         endif

! Some of the column headers have to be shortened.
       
         do l=4,nquantities
           ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(l)(1:lencolh(l)) )
           if (ncolumn .gt. 0) then
             m = m + 1
             headlineout(m) = '!'//headline(1,k)(2:lhl)
             if (l .eq. ixcopx .or. l .eq. iycopx) then
               ncolumn = index ( headlineout(m), 'IXEL' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+4) = ' ....'
               endif
             endif
             if (l .eq. ixcoas .or. l .eq. iycoas) then
               ncolumn = index ( headlineout(m), 'XCO_PIXRO' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+9) = 'XCO_R ....'
               endif
               ncolumn = index ( headlineout(m), 'YCO_PIXRO' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+9) = 'YCO_R ....'
               endif
             endif
             if (l .eq. ifxpe .or. l .eq. ifxte) then
               ncolumn = index ( headlineout(m), '_ERROR' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn+5:ncolumn+6) = ' .'
               endif
             endif
             if (l .eq. ifxpb .or. l .eq. ifxpe) then
               lcf = lastc ( conversionfacts )
               ncolumn = index ( headlineout(m), '(MJy/sr)' )
               if (ncolumn .gt. 0) then
                 headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy/beam)'//conversionfacts(1:lcf)
                 if (lsurfdens) then
                   headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy/beam|H2/cm^2/beam)'//conversionfacts(1:lcf)
                 endif
               endif
               ncolumn = index ( headlineout(m), '(H2/cm^2)' )
               if (ncolumn .gt. 0) then
                 headlineout(m) = headlineout(m)(1:ncolumn-1)//'(H2/cm^2/beam)'//conversionfacts(1:lcf)
                 if (lintens) then
                   headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy/beam|H2/cm^2/beam)'//conversionfacts(1:lcf)
                 endif
               endif
             endif
             if (l .eq. ifxtb .or. l .eq. ifxte) then
               ncolumn = index ( headlineout(m), '(Jy)' )
               if (ncolumn .gt. 0) then
                 if (lsurfdens) then
                   headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy|H2/cm^2*arcsec^2)'
                 endif
               endif
               ncolumn = index ( headlineout(m), '(H2/cm^2*arcsec^2)' )
               if (ncolumn .gt. 0) then
                 if (lintens) then
                   headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy|H2/cm^2*arcsec^2)'
                 endif
               endif
             endif
             if (l .eq. ifxtg) then
               ncolumn = index ( headlineout(m), '_ALT' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn+4:ncolumn+5) = ' .'
                 if (lsurfdens) then
                   ncolumn = index ( headlineout(m), '(Jy)' )
                   if (ncolumn .gt. 0) then
                     lcf = lastc ( adopteddistance )
                     headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy|Msun)'//adopteddistance(1:lcf)
                   endif
                   ncolumn = index ( headlineout(m), '(H2/cm^2*arcsec^2)' )
                   if (ncolumn .gt. 0) then
                     lcf = lastc ( adopteddistance )
                     headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Msun)'//adopteddistance(1:lcf)
                   endif
                 endif
                 if (lintens) then
                   ncolumn = index ( headlineout(m), '(H2/cm^2*arcsec^2)' )
                   if (ncolumn .gt. 0) then
                     lcf = lastc ( adopteddistance )
                     headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy|Msun)'//adopteddistance(1:lcf)
                   endif
                 endif
!!               else
!!                 ncolumn = index ( headlineout(m), '_GAUSS' )
!!                 if (ncolumn .gt. 0) then
!!                   headlineout(m)(ncolumn+5:ncolumn+6) = ' .'
!!                 endif
               endif
             endif

             if (l .eq. iscsx) then
               ncolumn = index ( headlineout(m), '_SX' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+3) = ' ...'
               endif
               calphabe = ' ALPHABE = 2.4 * FWHMSIZE * SOUND^2 / GRAVITY / MASS'
               ibe = lastc ( calphabe )
               ncolumn = index ( headlineout(m-1), '(Msun) conversion' )
               if (ncolumn .gt. 0) then
                 ncolumn = index ( headlineout(m), '(arcsec)' )
                 if (ncolumn .gt. 0) then
                   headlineout(m) = headlineout(m)(1:ncolumn-1)//calphabe(2:ibe)
                 endif
               endif
               ncolumn = index ( headlineout(m-1), '(Jy|Msun) conversion' )
               if (ncolumn .gt. 0) then
                 lcf = lastc ( headlineout(m) )
                 headlineout(m) = headlineout(m)(1:lcf)//calphabe(1:ibe)
               endif
             endif

             if (l .ge. iafwh .and. l .le. ibfwh) then
               ncolumn = index ( headlineout(m), '_INT' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+4) = ' ....'
               endif
             endif
             if (l .ge. iasiz .and. l .le. ithet) then
               ncolumn = index ( headlineout(m), '_MOM' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+4) = ' ....'
               endif
             endif
!!             if (l .eq. igodm) then
!!               ncolumn = index ( headlineout(m), 'MONO' )
!!               if (ncolumn .gt. 0) then
!!                 headlineout(m)(ncolumn:ncolumn+5) = ' .....'
!!               endif
!!             endif
             if (l .eq. ifofa) then
               ncolumn = index ( headlineout(m), 'FOOT_FACT' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOFA .........'
               endif
               if (lfinishing_mode) then
                 ncolumn = index ( headlineout(m), 'with completed footprints' )
                 if (ncolumn .gt. 0) then
                   headlineout(m)(ncolumn:ncolumn+25) = 'with unfinished footprints'
                 endif
               endif
             endif
             if (l .eq. ifooa) then
               ncolumn = index ( headlineout(m), 'FOOAMAJOR' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOOA .........'
               endif
             endif
             if (l .eq. ifoob) then
               ncolumn = index ( headlineout(m), 'FOOBMINOR' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOOB .........'
               endif
             endif
           endif
         enddo

! Prepare output line with columns' headers.
       
         ncolumn = index ( headline(1,k)(1:lhl), colhead(1)(1:lencolh(1)) )

         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'
           m = m + 1
           headlineout(m) = '!   '//colhead(1)(1:lencolh(1))//' '//colhead(4)(1:lencolh(4))
           lhlo = 4 + lencolh(1) + lencolh(4) + 3

! Headers for the coordinates columns.

           l = ixcopx
           colheadout(l) = ' '//colhead(l)(1:5)//'  '
           lencolhout(l) = 8
           headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)

           l = iycopx
           colheadout(l) = ' '//colhead(l)(1:5)//'   '
           lencolhout(l) = 9
           headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)
           
           if (lwcscoord) then
             lhlo = lhlo - 1

             l = ixcoas
             colheadout(l) = ' '//colhead(l)(1:9)//'  '
             lencolhout(l) = 12
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)

             l = iycoas
             colheadout(l) = '  '//colhead(l)(1:9)//'  '
             lencolhout(l) = 13
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)
           else
             l = ixcoas
             colheadout(l) = colhead(l)(1:5)//'   '
             lencolhout(l) = 8
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)

             l = iycoas
             colheadout(l) = colhead(l)(1:5)//' '
             lencolhout(l) = 6
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)
           endif
           
           l = iflag
           colheadout(l) = colhead(l)(1:lencolh(l))//'  '
           lencolhout(l) = lencolh(l)
           headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)

           l = isigg
           colheadout(l) = '  '//colhead(l)(1:8)//'  '
           lencolhout(l) = 12
           headlineout(m) = headlineout(m)(1:lhlo)//'  '//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)

           l = igodn
           colheadout(l) = colhead(l)(1:lencolh(l))//'    '
           lencolhout(l) = lencolh(l) + 4
           headlineout(m) = headlineout(m)(1:lhlo)//'   '//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)

           if (lwcscoord) then
             numbcols = '!    1  2  3  4       5       6         7            8      9      10         11'
           else
             numbcols = '!    1  2  3  4       5       6       7       8   9      10         11'
           endif
           nn = 11

! Headers for the fluxes.

           do i=1,nwaves
             
             lhlo = lhlo + 2
             headlineout(m)(lhlo:lhlo) = ' '

             write (colhead(ifmon)(3:4),'(i2.2)') i
             colheadout(ifmon) = colhead(ifmon)(1:lencolh(ifmon)+1)//' '
             lencolhout(ifmon) = 5
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(ifmon)(1:lencolhout(ifmon))
             lhlo = lhlo + lencolhout(ifmon)

             nn = nn + 1
             write (cncolf,'(i9)') nn
             inc = lastc ( numbcols )
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )

             write (colhead(isigm)(6:7),'(i2.2)') i
             colheadout(isigm) = '  '//colhead(isigm)(1:7)//'  '
             lencolhout(isigm) = 11
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(isigm)(1:lencolhout(isigm))
             lhlo = lhlo + lencolhout(isigm)

             nn = nn + 1
             write (cncolf,'(i8)') nn
             inc = lastc ( numbcols )
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )

             write (colhead(igodm)(6:7),'(i2.2)') i
             colheadout(igodm) = '  '//colhead(igodm)(1:7)//'  '
             lencolhout(igodm) = 11
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(igodm)(1:lencolhout(igodm))
             lhlo = lhlo + lencolhout(igodm)

             nn = nn + 1
             write (cncolf,'(i11)') nn
             inc = lastc ( numbcols )
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )
             
             do l=ifxpb,ifxtg
               if (l .eq. ifxtg .or. l .eq. ifxpe .or. l .eq. ifxte) then
                 write (colhead(l)(8:9),'(i2.2)') i
                 colheadout(l) = ' '//colhead(l)(1:lencolh(l)+1)//' '
                 lencolhout(l) = 11
               else
                 write (colhead(l)(lencolh(l):lencolh(l)+1),'(i2.2)') i
                 colheadout(l) = ' '//colhead(l)(1:lencolh(l)+1)//' '
                 if (l .eq. ifxpb .or. l .eq. ifxtb) then
                   lencolhout(l) = lencolh(l) + 3
                 else
                   lencolhout(l) = lencolh(l) + 1
                 endif
               endif
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)
             
               nn = nn + 1
               write (cncolf,'(i11)') nn
               inc = lastc ( numbcols )
               numbcols = numbcols(1:inc)//cncolf
               inc = lastc ( numbcols )
             enddo
                                       
             colheadout(iscsx) = colhead(iscsx)(1:lencolh(iscsx))
             lencolhout(iscsx) = lencolh(iscsx)

             write (colhead(iscsx)(6:7),'(i2.2)') i
             colheadout(iscsx) = '  '//colhead(iscsx)(1:7)//' '
             lencolhout(iscsx) = 10
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(iscsx)(1:lencolhout(iscsx))
             lhlo = lhlo + lencolhout(iscsx)

             nn = nn + 1
             write (cncolf,'(i11)') nn
             inc = lastc ( numbcols )
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )

             do l=iafwh,ibfwh
               colheadout(l) = colhead(l)(1:lencolh(l))
               lencolhout(l) = lencolh(l)
               write (colhead(l)(6:7),'(i2.2)') i
               colheadout(l) = '   '//colhead(l)(1:7)//' '
               lencolhout(l) = 11
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)

               nn = nn + 1
               write (cncolf,'(i11)') nn
               inc = lastc ( numbcols )
               numbcols = numbcols(1:inc)//cncolf
               inc = lastc ( numbcols )
             enddo
             
             do l=iasiz,ithet
               colheadout(l) = colhead(l)(1:lencolh(l))
               lencolhout(l) = lencolh(l)
               write (colhead(l)(6:7),'(i2.2)') i
               colheadout(l) = '   '//colhead(l)(1:7)//' '
               lencolhout(l) = 11
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)

               nn = nn + 1
               write (cncolf,'(i11)') nn
               inc = lastc ( numbcols )
               numbcols = numbcols(1:inc)//cncolf
               inc = lastc ( numbcols )
             enddo
             
! Headers for the remaining part.
    
             do l=ifofa,nquantities
               colheadout(l) = colhead(l)(1:lencolh(l))
               lencolhout(l) = lencolh(l)
               if (l .eq. ifofa) then
                 write (colhead(l)(5:6),'(i2.2)') i
                 colheadout(l) = '   FOFA'//colhead(l)(5:6)//'  '
                 lencolhout(l) = 11
               else
                 write (colhead(l)(5:6),'(i2.2)') i
                 colheadout(l) = '   '//colhead(l)(1:6)//'  '
                 lencolhout(l) = 11
               endif
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)

               nn = nn + 1
               write (cncolf,'(i11)') nn
               inc = lastc ( numbcols )
               numbcols = numbcols(1:inc)//cncolf
               inc = lastc ( numbcols )
             enddo
           enddo
           m = m + 1
           headlineout(m) = '!'
         endif
       enddo
       nheadout = m
       headlineout(nheadout) = '!~'

       allocate ( catlinerelitent(nextr(1)), alphabe(nwaves), stat=irc )  !!, colorlinerelitent(nextr(1))
       
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (72).'
         stop 72
       endif

! Gather some statistics.

       if (lfinishing_mode) then
         nnoisebgr = 0
         nnotdetec = 0
         nspurious = 0
         nposition = 0
         ntoolarge = 0
         nsubstruc = 0
  
         do j=1,nextr(1)
           if (cno(j)(1:1) .eq. '!') then
             lcno = lastc ( comment(j) ) - 1
             if (index ( comment(j)(1:lcno), ' background or noise' ) .gt. 0) nnoisebgr = nnoisebgr + 1
             if (index ( comment(j)(1:lcno), ' too few detectable'  ) .gt. 0) nnotdetec = nnotdetec + 1
             if (index ( comment(j)(1:lcno), ' spurious (goodness'  ) .gt. 0) nspurious = nspurious + 1
             if (index ( comment(j)(1:lcno), ' position occupied'   ) .gt. 0) nposition = nposition + 1
             if (index ( comment(j)(1:lcno), ' too large at all'    ) .gt. 0) ntoolarge = ntoolarge + 1
           endif
         enddo
           
         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!') then
             do i=1,nwaves
               write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
               if (cfmon(1:1) .eq. '1') then
                 nsubstruc = nsubstruc + 1
                 exit
               endif
             enddo
           endif
         enddo
             
! Find maximum source size over all good, detectable, measurable, positive sources at each wave.

         do i=1,nwaves
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!') then
               write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
               if (quantity(1,j,igodn) .gt. 1.0d0 .and.    !! (cfmon(1:3) .eq. '000' .or. cfmon(1:2) .eq. '10') .and. 
     &             lnormalsigm(i,j) .and. lmeasurable(i,j) .and. lnormalsize(i,j) .and. lnormalgood(i,j) .and.
     &             quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxtb) .gt. almostzero) then
                 dsize = quantity(i,j,iafwh)
                 if (dsize .gt. sizemax(i)) then
                   sizemax(i) = dsize
                 endif
               endif
             endif
           enddo

! Soften the criteria if no maximum size has been found at this wave.

           if (sizemax(i) .lt. almostzero) then
             do j=1,nextr(1)
               if (cno(j)(1:1) .ne. '!') then
                 write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
                 if (   !! (cfmon(1:3) .eq. '000' .or. cfmon(1:3) .eq. '001' .or. cfmon(1:2) .eq. '10') .and.
     &               lmeasurable(i,j) .and. lnormalsize(i,j) .and. lnormalgood(i,j) .and.
     &               quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxtb) .gt. almostzero) then
                   dsize = quantity(i,j,iafwh)
                   if (dsize .gt. sizemax(i)) then
                     sizemax(i) = dsize
                   endif
                 endif
               endif
             enddo
           endif
         enddo

         open ( 65, file='+log.SUMMARY', status='unknown' )
         write (65,'(a,i6)') ' totalbad:', nextrbad
         write (65,'(a,i6)') ' noisebgr:', nnoisebgr
         write (65,'(a,i6)') ' notdetec:', nnotdetec
         write (65,'(a,i6)') ' spurious:', nspurious
         write (65,'(a,i6)') ' position:', nposition
         write (65,'(a,i6)') ' toolarge:', ntoolarge
         write (65,'(a,i6)') ' totalgod:', nextrgood
         write (65,'(a,i6)') ' substruc:', nsubstruc
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           write (65,'(a,1x,f11.5)') ' fwhmmax_'//cwav//':', sizemax(i)
         enddo
         close ( 65 )
       endif

       if (ltiming) then
         cput_semifinalcat = cput_semifinalcat + timer ( 'cpu', cpu_semifinalcat )
         walt_semifinalcat = walt_semifinalcat + timer ( 'wal', wal_semifinalcat )
         write (60,'(a,2(1pe9.2,a))') ' Total ''MAKE SEMIF CAT''  CPU',cput_semifinalcat, ' WALL', cput_semifinalcat, ' sec'
       endif

!----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_finalcats = timer ( 'cpu', 0.0d0 )
         wal_finalcats = timer ( 'wal', 0.0d0 )
       endif

! Write the final catalog's header.

       id = index ( detimagestring(1:ide), '.sw.det.' ) + 7
       ie = index ( detimagestring(id+1:), 'as.an.' ) + 2 + id
                     
       nhrt = 1
       headrelitent(nhrt) = cbars
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'//getstitle(2:)
       nhrt = nhrt + 1
       headrelitent(nhrt) = cbars
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                    //'(william.d.pence@nasa.gov)'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu) '
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! CATALOG OF EXTRACTED SOURCES'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! detected in '//detimagestring(1:id)//'*'//detimagestring(ie:ide)

       do i=1,ndetwaves
         nhrt = nhrt + 1
         ica = lastc ( detimageline(i) )
         headrelitent(nhrt) = '!'//detimageline(i)(1:ica)
       enddo
       
       allocate ( obsimage(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (73).'
         stop 73
       endif

       do i=1,nwaves
      
! Read image just for getting reference pixel and its coordinates.

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsimage, dx, dy, object, ra, dec
     &              , obsname(i)(1:iobs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &              , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )
           
         write (ccrpix1,'(1pe12.5)') crpix1
         write (ccrpix2,'(1pe12.5)') crpix2
         write (ccrval1,'(1pe14.7)') crval1
         write (ccrval2,'(1pe14.7)') crval2
         icrp1 = lastc ( ccrpix1 )
         icrp2 = lastc ( ccrpix2 )
         icrv1 = lastc ( ccrval1 )
         icrv2 = lastc ( ccrval2 )
         coordinates = '(crpix1:'//ccrpix1(1:icrp1)//', crpix2:'//ccrpix2(1:icrp2)//','
     &               //' crval1:'//ccrval1(1:icrv2)//', crval2:'//ccrval2(1:icrv2)//')'
         ica = lastc ( coordinates )
         nhrt = nhrt + 1
         if (i .eq. 1) then
           headrelitent(nhrt) = '! measured in '//obsimagestring(i)(1:iob(i))//' '//coordinates(1:ica)
         else
           headrelitent(nhrt) = '!      and in '//obsimagestring(i)(1:iob(i))//' '//coordinates(1:ica)
         endif
       enddo
       
       deallocate ( obsimage )
       
       nhrt = nhrt + 1
       headrelitent(nhrt) = cbars
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       
       do m=1,nheadout-4
         ic = lastc ( headlineout(m) )
!!         if (index ( headlineout(m)(1:ic), '!   S1 ......' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   S2 ......' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   SX ......' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   FXT_ALT '  ) .eq. 0 .and. 
!!     &       index ( headlineout(m)(1:ic), '!   SCALE ...' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   RADE ....' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   FOFA ....' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   FOOA ....' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   FOOB ....' ) .eq. 0 .and.
!!     &       index ( headlineout(m)(1:ic), '!   FOOT ....' ) .eq. 0) then
         nhrt = nhrt + 1
         if (headlineout(m)(1:32) .eq. '! Tabulated quantities, total of' .or.
     &       headlineout(m)(1:32) .eq. '! TABULATED QUANTITIES, TOTAL OF') then
           headrelitent(nhrt) = '! TABULATED QUANTITIES, TOTAL OF '//cnextrgood(5-igood+1:5)//' SOURCES'
         elseif (headlineout(m)(1:43) .eq. '!   NO ............ Source''s running number' ) then
           headrelitent(nhrt) = headlineout(m)(1:ic)//' may not be sequential (bad sources excluded)'
         else
           headrelitent(nhrt) = headlineout(m)(1:ic)
         endif
!!         endif
       enddo
       
       nhrt = nhrt + 1
       nhdefs1 = nhrt
       headrelitent(nhrt) = '!'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! DEFINITIONS AND COMMENTS:'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 1. Catalog entries may have a value of 0.000E+00 for sources outside the observational mask'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 2. SIGNM has a special value of 9.999E-31 if a source is not visible in clean single scales'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 3. SIGNM has a special value of 7.777E-31 if a source has deconvolved peak intensity equal zero'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 4. FX*_BST and FX*_ERR have a special value of 9.999E-31 if their measurements are < 1.0E-30'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 5. Monochromatic S/N ratios can be computed as SNRP = FXP_BST / FXP_ERR, SNRT = FXT_BST / FXT_ERR'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 6. Meaning of the global flag FG:'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FG = 0 ..... source is isolated: not blended with any other source in any waveband'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FG = 1 ..... source is blended: footprints intersect by more than 20% in at least one waveband'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FG = 2 ..... source is sub-structured: its footprint area contains at least one other source'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FG = 3 ..... source is sub-structuring: causing a larger source to be sub-structured'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! 7. Meaning of the monochromatic flag FM: <~ "negative" when deblending iterations did not converge'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =   0 ... source has no problems identified in waveband'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =   1 ... source sizes are suspicious: sqrt ( AFWHM * BFWHM ) / BEAM < 0.95'
     &                    //' or AFWHM / ASIZE > 1.4 or BFWHM / BSIZE > 1.4'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =   2 ... source is larger than the desired maximum size: sqrt ( FOOA * FOOB ) / FOFA >'
     &                    //' SRCMAXSIZE = '//callsrcmaxsizes(1:iasmx)//' arcsec'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =   4 ... source is too much elongated: AFWHM / BFWHM >'//celongmx(1:iel)
     &                    //' or AFWHM / FOOA is too close to 1.'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =  10 ... source peak intensity is not measurable: FXP_BST / FXP_ERR < '//csn1(1:isn1)
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =  20 ... source total flux is not measurable: FXT_BST / FXT_ERR < '//csn2(1:isn2)
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM =  40 ... source peak intensity FXP_BST < 0 or FXP_BST and total flux FXT_BST have'
     &                    //' opposite signs'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!     FM = 100 ... source is sub-structured: its footprint area contains at least one mesurable'
     &                    //' source'
!!       nhrt = nhrt + 1
!!       headrelitent(nhrt) = '!     FM = 200 ... source monochromatic detection significance is low: SIGNM < '//csnt(1:isnt)

       nhrt = nhrt + 1
       headrelitent(nhrt) = '!  _______________________________________________________________________________ '
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |                                                                               |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! | *!*( SOURCES FROM MULTI-WAVELENGTH CATALOGS SHOULD NEVER BE USED BLINDLY )*!* |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |                                                                               |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |  Select only sufficiently good sources in each waveband, on the basis of the  |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |  quantities provided: SIGNM, GOODM, FM, FXP_BST / FXP_ERR, FXT_BST / FXT_ERR, |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |  AFWHM / BFWHM, FOOA / AFWHM, etc.                                            |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |                                                                               |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! | *!*(   RECOMMENDED OPTIMAL SELECTION CRITERIA BASED ON BENCHMARK TESTS   )*!* |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |                                                                               |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |      abs ( GOODM ) > 1  &  abs ( SIGNM ) > 1  &  FXP_BST / FXP_ERR > 2  &     |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |      FXT_BST / FXT_ERR > 2  &  AFWHM / BFWHM < 2  &  FOOA / AFWHM > 1.15      |'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '! |_______________________________________________________________________________|'
       nhrt = nhrt + 1
       headrelitent(nhrt) = '!'
       nhdefs2 = nhrt
       nhrtstand = nhrt

!----------------------------------------------------------------------------------------------------------------------------------

! Write the semifinal catalog's header.

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//finalcatname(1:ifrt)//''''

       open ( 15, file=finalcatname(1:ifrt), status='unknown' )

! Write the catalog header.

       do m=1,nhrt
         ihc = lastc ( headrelitent(m) )
         iro = index ( headrelitent(m), '! CATALOG OF EXTRACTED' )
         if (iro .eq. 0) then
           write (15,'(a)') headrelitent(m)(1:ihc)
         else
           write (15,'(a)') headrelitent(m)(1:ihc)//' ~> running number may not be sequential'
         endif
       enddo
       
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       if (lwcscoord) then
         write (15,'(a,43x,'//cnwaves//'(128x,a,47x))') '!',(cwave(i)//' µm',i=1,nwaves)
         write (15,'(a,83x,'//cnwaves//'(a))') '!',(cbar(i),i=1,nwaves)
       else
         write (15,'(a,33x,'//cnwaves//'(128x,a,47x))') '!',(cwave(i)//' µm',i=1,nwaves)
         write (15,'(a,73x,'//cnwaves//'(a))') '!',(cbar(i),i=1,nwaves)
       endif

! Write the line with columns' headers.

       ic = lastc ( headlineout(nheadout-2) )
       write (15,'(a)') headlineout(nheadout-2)(1:ic)
       write (15,'(a)') numbcols(1:inc)
       ic = lastc ( headlineout(nheadout-1) )
       write (15,'(a)') headlineout(nheadout-1)(1:ic)
       ic = lastc ( headlineout(nheadout) )
       write (15,'(a)') headlineout(nheadout)(1:1)

       nn = 0
       do j=1,nextr(1)
         jj = nint ( xx(j) )
         if (jj .gt. 0) then
           if (cno(jj)(1:1) .ne. '!') then
             nn = nn + 1
             nok(jj) = nn
           endif
         endif
       enddo

! Write the catalog columns commenting out bad entries.

       do j=1,nextr(1)
         lcno = lastc ( comment(j) ) - 1
         write (cfsflag,'(i3)') sfg(j) * nint ( quantity(1,j,iflag) )
         if (sfg(j) .eq. -1 .and. cfsflag .eq. '  0') cfsflag = ' -0'
         do i=1,nwaves
           write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
           if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
           ifui = lastc ( peakfunits(i) )
           if (peakfunits(i)(1:ifui) .eq. 'H2/cm^2') then
             alphabe(i) = 2.4d0 * sqrt ( quantity(i,j,iafwh) * quantity(i,j,ibfwh) ) * au2cm * distpc * soundspeed10K**2 
     &                  / gravconst / xMsun / max ( quantity(i,j,ifxtg), 1.0d-10 )
           else
             alphabe(i) = quantity(i,j,iscsx)
           endif
         enddo
         
         write (15,'(a,3i3,1x,2f8.1,'//fmtwcs//',a3,2(1pe11.3),'//cnwaves//'(1x,a5,16(1pe11.3)),a)') 
     &              cno(j), ns1(1,j), ns2(1,j), nsx(1,j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(1,j,l), l=ixcoas,iycoas)
     &            , cfsflag, quantity(1,j,isigg), quantity(1,j,igodn), (cfmflag(i), quantity(i,j,isigm), quantity(i,j,igodm)
     &            , (factor(i,j,l) * quantity(i,j,l), l=ifxpb,ifxtg), alphabe(i), (quantity(i,j,l), l=iafwh,nquantities)
     &            , i=1,nwaves), comment(j)(1:lcno)
       enddo

       close ( 15 )

!----------------------------------------------------------------------------------------------------------------------------------

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//finalcatokname(1:ifrtok)//''''

       open ( 15, file=finalcatokname(1:ifrtok), status='unknown' )

! Write the "ok" catalog's header.

       do m=1,nhrt
         ihc = lastc ( headrelitent(m) )
         iro = index ( headrelitent(m), '! CATALOG OF EXTRACTED' )
         if (iro .eq. 0) then
           write (15,'(a)') headrelitent(m)(1:ihc)
         else
           write (15,'(a)') headrelitent(m)(1:ihc)//' ~> ok: resorted and renumbered'
         endif
       enddo

       write (15,'(a)') cbars
       write (15,'(a)') '!'
       if (lwcscoord) then
         write (15,'(a,43x,'//cnwaves//'(128x,a,47x))') '!',(cwave(i)//' µm',i=1,nwaves)
         write (15,'(a,83x,'//cnwaves//'(a))') '!',(cbar(i),i=1,nwaves)
       else
         write (15,'(a,33x,'//cnwaves//'(128x,a,47x))') '!',(cwave(i)//' µm',i=1,nwaves)
         write (15,'(a,73x,'//cnwaves//'(a))') '!',(cbar(i),i=1,nwaves)
       endif
                                  
! Write the line with columns' headers.

       ic = lastc ( headlineout(nheadout-2) )
       write (15,'(a)') headlineout(nheadout-2)(1:ic)
       write (15,'(a)') numbcols(1:inc)
       ic = lastc ( headlineout(nheadout-1) )
       write (15,'(a)') headlineout(nheadout-1)(1:ic)
       ic = lastc ( headlineout(nheadout) )
       write (15,'(a)') headlineout(nheadout)(1:1)

! Write the catalog columns removing bad entries.

       do j=1,nextr(1)
         jj = nint ( xx(j) )
         if (jj .gt. 0) then
           if (cno(jj)(1:1) .ne. '!') then           !! .and. quantity(1,jj,igodn) .ge. 1.0d0
             lcno = lastc ( comment(jj) ) - 1
             write (cfsflag,'(i3)') sfg(jj) * nint ( quantity(1,jj,iflag) )
             if (sfg(jj) .eq. -1 .and. cfsflag .eq. '  0') cfsflag = ' -0'
             do i=1,nwaves
               write (cfmflag(i),'(i5)') sfm(i,jj) * nint ( quantity(i,jj,ifmon) )
               if (sfm(i,jj) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
               ifui = lastc ( peakfunits(i) )
               if (peakfunits(i)(1:ifui) .eq. 'H2/cm^2') then
                 alphabe(i) = 2.4d0 * sqrt ( quantity(i,jj,iafwh) * quantity(i,jj,ibfwh) ) * au2cm * distpc * soundspeed10K**2 
     &                      / gravconst / xMsun / max ( quantity(i,jj,ifxtg), 1.0d-10 )
               else
                 alphabe(i) = quantity(i,jj,iscsx)
               endif
             enddo
         
             write (15,'(i6,3i3,1x,2f8.1,'//fmtwcs//',a3,2(1pe11.3),'//cnwaves//'(1x,a5,16(1pe11.3)),a)') 
     &                  nok(jj), ns1(1,jj), ns2(1,jj), nsx(1,jj), (quantity(1,jj,l), l=ixcopx,iycopx), (quantity(1,jj,l)
     &                , l=ixcoas,iycoas), cfsflag, quantity(1,jj,isigg), quantity(1,jj,igodn), (cfmflag(i), quantity(i,jj,isigm)
     &                , quantity(i,jj,igodm), (factor(i,jj,l) * quantity(i,jj,l), l=ifxpb,ifxtg), alphabe(i), (quantity(i,jj,l)
     &                , l=iafwh,nquantities), i=1,nwaves), comment(jj)(1:lcno)
           endif
         endif
       enddo

       close ( 15 )

       if (ltiming) then
         cput_finalcats = cput_finalcats + timer ( 'cpu', cpu_finalcats )
         walt_finalcats = walt_finalcats + timer ( 'wal', wal_finalcats )
         write (60,'(a,2(1pe9.2,a))') ' Total ''MAKE FINAL CATS'' CPU', cput_finalcats, ' WALL', cput_finalcats, ' sec'
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Create an additional catalog with derived quantities: peak intensities in a matching (worst) beam and background intensities 
! under the sources. Do it only when iterations in GETSF have converged.

       if (lfinishing_mode) then

         if (ltiming) then
           cpu_additioncats = timer ( 'cpu', 0.0d0 )
           wal_additioncats = timer ( 'wal', 0.0d0 )
         endif

         do i=1,nwaves
!!           obscbname(i) = cat(i)(idot1+1:idot4-1)//'.cb.fits'
           obscbname(i) = obsname(i)(1:iobs(i)-5)//'.cb.fits'
           iocb(i) = lastc ( obscbname(i) )
           inquire ( file=obscbname(i)(1:iocb(i)), exist=lfname )
           if (.not.lfname) goto 197
!!           obscbsmoname(i) = cat(i)(idot1+1:idot4-1)//'.cb.smo.fits'
           obscbsmoname(i) = obsname(i)(1:iobs(i)-5)//'.cb.smo.fits'
           iocbs(i) = lastc ( obscbsmoname(i) )
           inquire ( file=obscbsmoname(i)(1:iocbs(i)), exist=lfname )
           if (.not.lfname) goto 198
         enddo
     
         goto 997
 197     continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obscbname(i)(1:iocb(i))//''' not found.'
           stop 36
         endif
 198     continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obscbsmoname(i)(1:iocbs(i))//''' not found.'
           stop 37
         endif
 997     continue
       
         allocate ( obscbimage(nx,ny), obscbsmoimage(nx,ny), stat=irc )
         
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (74).'
           stop 74
         endif
         
         do i=1,nwaves
           
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbimage, dx, dy, object, ra, dec
     &                , obscbname(i)(1:iocb(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )
         
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbsmoimage, dx, dy, object, ra, dec
     &                , obscbsmoname(i)(1:iocbs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )
         
           do j=1,nextr(1)
             nxco = nint ( quantity(1,j,ixcopx) )
             nyco = nint ( quantity(1,j,iycopx) )
             backgint(i,j) = obscbimage(nxco,nyco)
             backgsmoint(i,j) = obscbsmoimage(nxco,nyco)
           enddo
         enddo
                      
         deallocate ( obscbimage, obscbsmoimage )
         
         if (cverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Writing catalog '''//addcatalogrelitent(1:iart)//''''
         endif
                                        
         open ( 75, file=addcatalogrelitent(1:iart), status='unknown' )
         
         write (cobeam,'(1pe9.2)') obsbeammax
         ibo = lastc ( cobeam )
         addhead(1) = '!   PEAK_SRC ...... Estimate of peak intensity ............................... (MJy/sr|H2/cm^2)'
         addhead(2) = '!   PEAK_BGF ...... Estimate of background+filaments intensity ............... (MJy/sr|H2/cm^2)'
         addhead(3) = '!   CONV_SRC ...... Estimate of peak intensity ............................... (MJy/sr|H2/cm^2)'
     &               //' convolved to'//cobeam(1:ibo)//' arcsec resolution'
         addhead(4) = '!   CONV_BGF ...... Estimate of background+filaments intensity ............... (MJy/sr|H2/cm^2)'
     &               //' convolved to'//cobeam(1:ibo)//' arcsec resolution'
         
         do m=1,nhrt
           ihc = lastc ( headrelitent(m) )
           if (index ( headrelitent(m), '!   XCO_R ...' ) .gt. 0 .or. index ( headrelitent(m), '!   WCS_ACOOR ...' ) .gt. 0) exit
           if (index ( headrelitent(m), '! CATALOG OF EXTRACTED SOURCES' ) .gt. 0) then
             write (75,'(a)') '! CATALOG OF ADDITIONAL DERIVED QUANTITIES FOR EXTRACTED SOURCES ~> ok: resorted and renumbered'
           else  
             write (75,'(a)') headrelitent(m)(1:ihc)
           endif
         enddo
         do m=1,4
           ihc = lastc ( addhead(m) )
           write (75,'(a)') addhead(m)(1:ihc)
         enddo

! Write the line with columns' headers.

         ncol = 3
         numbcols = '!    1      2       3'
         inc = lastc ( numbcols )
         headcols = '!   NO    XCO_P   YCO_P'
         ihc = lastc ( headcols )
         
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           headcols = headcols(1:ihc)//' PEAK_SRC'//cwav//' PEAK_BGF'//cwav//' CONV_SRC'//cwav//' CONV_BGF'//cwav
           ihc = lastc ( headcols )
           ncol = ncol + 1
           write (cncolf,'(i9)') ncol
           numbcols = numbcols(1:inc)//cncolf
           inc = lastc ( numbcols )
           do ir=1,3
             ncol = ncol + 1
             write (cncolf,'(i11)') ncol
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )
           enddo
           numbcols = numbcols(1:inc)//'  '
           inc = inc + 2
         enddo
         
         write (75,'(a)') cbars
         write (75,'(a)') '!'
         write (75,'(a)') numbcols(1:inc)
         write (75,'(a)') headcols(1:ihc)
         write (75,'(a)') '!'

! Write the final catalog columns commenting out bad entries.

         do j=1,nextr(1)
           jj = nint ( xx(j) )
           if (jj .gt. 0) then
             if (cno(jj)(1:1) .ne. '!') then
               lcno = lastc ( comment(jj) ) - 1
               write (catlinerelitent(jj),'(i6,1x,2f8.1,'//cnwaves//'(4(1pe11.3)),a)') 
     &                 nok(jj), (quantity(1,jj,l), l=ixcopx,iycopx), (quantity(i,jj,ifxpb), backgint(i,jj)
     &               , factsmoo(i,jj) * quantity(i,jj,ifxpb), backgsmoint(i,jj), i=1,nwaves), comment(jj)(1:lcno)
               icrt = lastc ( catlinerelitent(jj) )
               write (75,'(a)') catlinerelitent(jj)(1:icrt)
             endif
           endif
         enddo
         
         close ( 75 )

       endif
       
       deallocate ( catlinerelitent, alphabe ) !!, colorlinerelitent

!-----------------------------------------------------------------------------------------------------------------------------------
       
! Extract intensity profiles for extracted sources.

       if (lfinishing_mode .and. lcreate_profiles_images) then

         if (ltiming) then
           cpu_profimages = timer ( 'cpu', 0.0d0 )
           wal_profimages = timer ( 'wal', 0.0d0 )
         endif

         if (cverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Computing deblended images and intensity profiles'
         endif
         
         allocate ( profilebd(nwaves,max(nx,ny)), profilebs(nwaves,max(nx,ny)), profileob(nwaves,max(nx,ny)), rad(max(nx,ny))
     &            , rad2(max(nx,ny)), npts(max(nx,ny)), dxco2(max(nx,ny)), dyco2(max(nx,ny)), deblended(nx,ny)
     &            , profilebdrms(nwaves,max(nx,ny)), profileob1st(nwaves,max(nx,ny)), profileob2nd(nwaves,max(nx,ny))
     &            , profileob3rd(nwaves,max(nx,ny)), profileod(nwaves,max(nx,ny)), obsimage(nx,ny), obsfsbsimage(nx,ny)
     &            , bsomask(nx,ny), stat=irc )
         
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (77).'
           stop 77
         endif
              
! Check whether subdirectory of current directory exists.
       
         individintpro = originpath(1:iopa)//'/results/+sources/+profiles'
         indint = lastc ( individintpro )
       
         open (88, file=individintpro(1:indint)//'/README', status='unknown', err=24 )
         goto 25
  24     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Directory '''//individintpro(1:indint)//''' does not exist?..'
         stop 99
  25     continue
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '#'//getstitle(2:)
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         write (88,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (88,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (88,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
         write (88,'(a)') '#'
         write (88,'(a)') '# This directory contains deblended intensity profiles of extracted sources.'
         close (88)
       
         individimages = originpath(1:iopa)//'/results/+sources/+images'
         indimg = lastc ( individimages )
       
         open (88, file=individimages(1:indimg)//'/README', status='unknown', err=26 )
         goto 27
  26     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Directory '''//individimages(1:indimg)//''' does not exist?..'
         stop 99
  27     continue
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '#'//getstitle(2:)
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         write (88,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (88,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (88,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
         write (88,'(a)') '#'
         write (88,'(a)') '# This directory contains individual images of extracted sources, displaying them'
         write (88,'(a)') '# in both the observed images and background-subtracted, deblended images.'
         close (88)
       
         do j=1,nextr(1)
                
           if (cno(j)(1:1) .ne. '!') then
             nxco = nint ( quantity(1,j,ixcopx) )
             nyco = nint ( quantity(1,j,iycopx) )
         
             if (lfinishing_mode) then
               write (czno,'(i6.6)') j
               write (czok,'(i6.6)') nok(j)
         
               open ( 55, file=individintpro(1:indint)//'/'//'sm.intens.pro.ok'//czok(2:6)//'.no'//czno(2:6)//'.dat'
     &                  , status='unknown' )
       
! Write the standard header.

               do m=1,nhrtstand-1
                 ihc = lastc ( headrelitent(m) )
                 iro = index ( headrelitent(m), '! CATALOG OF EXTRACTED' )
                 if (iro .eq. 0) then
                   iro = index ( headrelitent(m), '! COLORS & FLUXES' )
                 endif
                 if (iro .gt. 0) then
                   headrelitent(m) = '! INTENSITY PROFILES OF INDIVIDUAL SOURCES'
                   ihc = lastc ( headrelitent(m) )
                 endif
                 iro = index ( headrelitent(m), ' may not be sequential (bad sources excluded)' )
                 if (iro .gt. 0) then
                   write (55,'(a)') '!   OK'//headrelitent(m)(7:iro-1)//' renumbered sequentially'
                 endif
                 write (55,'(a)') headrelitent(m)(1:ihc)
               enddo
               write (cfsflag,'(i3)') sfg(j) * nint ( quantity(1,j,iflag) )
               if (sfg(j) .eq. -1 .and. cfsflag .eq. '  0') cfsflag = ' -0'
               do i=1,nwaves
                 write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
                 if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
               enddo
               ihc = lastc ( cbars )
               write (55,'(a)') cbars(1:ihc)
               write (55,'(a)') '!'
               write (55,'(a,i5)'  ) '!   OK ............', nok(j)
               write (55,'(a,i5)'  ) '!   NO ............', no(1,j)
               write (55,'(a,f8.1)') '!   XCO_P .........', quantity(1,j,ixcopx)
               write (55,'(a,f8.1)') '!   YCO_P .........', quantity(1,j,iycopx)
               if (lwcscoord) then
                 write (55,'(a,'//fmtwcs//')') '!   WCS_ACOOR .....', quantity(1,j,ixcoas)
                 write (55,'(a,'//fmtwcs//')') '!   WCS_DCOOR .....', quantity(1,j,iycoas)
               else
                 write (55,'(a,'//fmtwcs//')') '!   XCO_R .........', quantity(1,j,ixcoas)
                 write (55,'(a,'//fmtwcs//')') '!   YCO_R .........', quantity(1,j,iycoas)
               endif
               write (55,'(a,a5)')                     '!   FS ............', cfsflag
               write (55,'(a,(1pe11.3))')              '!   SIGN ..........', quantity(1,j,isigg)
               write (55,'(a,(1pe11.3))')              '!   GOOD ..........', quantity(1,j,igodn)
               write (55,'(a,'//cnwaves//'(2x,a5))'  ) '!   FM ............', (cfmflag(i), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   SIGNM .........', (quantity(i,j,isigm), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   GOODM .........', (quantity(i,j,igodm), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXP_BST .......', (quantity(i,j,ifxpb), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXP_ERR .......', (quantity(i,j,ifxpe), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXT_BST .......', (quantity(i,j,ifxtb), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXT_ERR .......', (quantity(i,j,ifxte), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   AFWHM .........', (quantity(i,j,iafwh), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   BFWHM .........', (quantity(i,j,ibfwh), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   ASIZE .........', (quantity(i,j,iasiz), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   BSIZE .........', (quantity(i,j,ibsiz), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   THETA .........', (quantity(i,j,ithet), i=1,nwaves)
               ihc = lastc ( cbars )
               write (55,'(a)') cbars(1:ihc)

               if (lintens .and. lsurfdens) then
                 imgunits = 'MJy/sr|H2/cm^2'
               else if (lintens) then
                 imgunits = 'MJy/sr'
               else
                 imgunits = 'H2/cm^2'
               endif
               imu = lastc ( imgunits )

               write (55,'(a)') '!'
               write (55,'(a)') '! TABULATED QUANTITIES:'
               write (55,'(a)') '!'
               write (55,'(a)') '!   N ........... Running number of radial zone ...............................................'
               write (55,'(a)') '!   RADIUS ...... Radial distance of the radial zone from source position .....................'
     &                        //' (arcsec)'
               write (55,'(a)') '!   INTBD# ...... Intensity profiles at waves (background & filament-subtracted, deblended) ...'
     &                        //' ('//imgunits(1:imu)//') azimuthally averaged'
               write (55,'(a)') '!   INTBS# ...... Intensity profiles at waves (background & filament-subtracted) ..............'
     &                        //' ('//imgunits(1:imu)//') azimuthally averaged'
               write (55,'(a)') '!   INTOB# ...... Intensity profiles at waves (full observed image) ...........................'
     &                        //' ('//imgunits(1:imu)//') azimuthally averaged'
               write (55,'(a)') '!   NPTS ........ Number of pixels used in the azimuthal averaging ............................'
               write (55,'(a)') '!   OSQRTNPTS ... Inverse of the square root of NPTS: 1.0 / sqrt ( NPTS ) .....................'
               write (55,'(a)') '!   RMSBD# ...... Standard deviation of the intensity profiles within radial annuli ...........'
     &                        //' ('//imgunits(1:imu)//') azimuthal direction'
               write (55,'(a)') '!   DE1OB# ...... Logarithmic first derivative of full intensity profile ......................'
     &                        //' ('//imgunits(1:imu)//'/arcsec)'
               write (55,'(a)') '!   DE1OD# ...... Logarithmic first derivative of filament-subtracted & deblended profile .....'
     &                        //' ('//imgunits(1:imu)//'/arcsec)'
               write (55,'(a)') '!   DE2OD# ...... Logarithmic first derivative of filament-subtracted & deblended profile .....'
     &                        //' ('//imgunits(1:imu)//'/arcsec) radially averaged'
               ihc = lastc ( cbars )
               write (55,'(a)') cbars(1:ihc)
       
! Write the line with columns' headers.

               ncol = 3
               numbcols = '!  1      2         3'
               inc = lastc ( numbcols )
               headcols = '!  N   RADIUS '
               ihc = lastc ( headcols ) + 1
               
               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  INTBD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 if (i .gt. 1) then
                   ncol = ncol + 1
                   write (cncolc,'(i11)') ncol
                   numbcols = numbcols(1:inc)//cncolc
                   inc = lastc ( numbcols )
                 endif
               enddo
               
               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  INTBS'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo
               
               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  INTOB'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo
         
               headcols = headcols(1:ihc)//'     NPTS    OSQRTNPTS'
               ihc = lastc ( headcols )
               ncol = ncol + 1
               write (cncolc,'(i11)') ncol
               numbcols = numbcols(1:inc)//cncolc
               inc = lastc ( numbcols )
               ncol = ncol + 1
               write (cncolc,'(i11)') ncol
               numbcols = numbcols(1:inc)//cncolc
               inc = lastc ( numbcols )
         
               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  RMSBD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  DE1OB'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  DE1OD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               do i=1,nwaves
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 headcols = headcols(1:ihc)//'  DE2OD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               write (55,'(a)') '!'
               write (55,'(a)') numbcols(1:inc)
               write (55,'(a)') headcols(1:ihc)
               write (55,'(a)') '!'
             endif

! Compute azimuthally-averaged intensity profiles.

             kmax = 0
             do i=1,nwaves
               kmx = min ( nint ( quantity(i,j,ifooa) / min ( dx, dy ) ), max ( nx - 1, ny - 1 ) )
               if (kmx .gt. kmax) kmax = kmx
             enddo

             do i=1,nwaves

               do k=1,kmax
                 npts(k) = 0.0d0
                 profilebd(i,k) = 0.0d0
                 profilebs(i,k) = 0.0d0
                 profileob(i,k) = 0.0d0
                 profileod(i,k) = 0.0d0
                 profilebdrms(i,k) = 0.0d0
               enddo
               
               do k=1,kmax+1
                 rad(k) = dble ( k - 1 ) * (dx + dy) / 2.0d0
                 rad2(k) = rad(k)**2
                 if (rad(k) .le. quantity(i,j,ibfwh) / 2.0d0) radfwhm = rad(k)
                 if (rad(k) .le. quantity(i,j,ifoob) / 2.0d0) radfoot = rad(k)
               enddo
               
               do l=max(nxco-kmax,1),min(nxco+kmax,nx)
                 dxco2(l) = (dble ( l - nxco ) * dx)**2
               enddo
               do m=max(nyco-kmax,1),min(nyco+kmax,ny)
                 dyco2(m) = (dble ( m - nyco ) * dy)**2
               enddo

! Produce full, background-subtracted, and deblended profiles for each source.
        
               do m=1,ny
                 do l=1,nx
                   deblended(l,m) = 0.0d0
                 enddo
               enddo
     
               call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsimage, dx, dy, object, ra, dec
     &                    , obsname(i)(1:iobs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11
     &                    , cd12, cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )

               call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsfsbsimage, dx, dy, object, ra, dec
     &                    , obsfsbsname(i)(1:iobsfsbs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11
     &                    , cd12, cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )

               call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, bsomask, dx, dy, object, ra, dec
     &                    , bsomaskname(i)(1:ibm(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11
     &                    , cd12, cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )

               sigmaa2 = (quantity(i,j,iafwh) / 2.0d0)**2
               sigmab2 = (quantity(i,j,ibfwh) / 2.0d0)**2
               angle = (90.0d0 - quantity(i,j,ithet)) * convtoradians
               cosa2 = cos ( angle )**2
               sina2 = sin ( angle )**2
               sin2a = sin ( 2.0d0 * angle )
               aa =  cosa2 / sigmaa2 + sina2 / sigmab2
               bb = -sin2a / sigmaa2 + sin2a / sigmab2
               cc =  sina2 / sigmaa2 + cosa2 / sigmab2
               
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr, 1 )
               l2 = min ( l0 + nr, nx )
               m1 = max ( m0 - nr, 1 )
               m2 = min ( m0 + nr, ny )

               do m=m1,m2
                 dblm = dble ( m )
                 dycon = (dblm - quantity(1,j,iycopx)) * dy
                 dycon2 = dycon**2
                 do l=l1,l2
                   dbll = dble ( l )
                   dxcon = (dbll - quantity(1,j,ixcopx)) * dx
                   dxcon2 = dxcon**2

                   if (bsomask(l,m) .gt. 0.9d0) then

                     deblended(l,m) = 0.0d0

                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx)
     &                             , quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ithet) )) then

                       argexp = aa * dxcon2 + bb * dxcon * dycon + cc * dycon2
                       argexpm = min ( argexp / 2.0d0 * log ( 4.0d0 ), 200.0d0 )
                       funn = quantity(i,j,ifxpb) * exp ( - argexpm )
                       funksum = 0.0d0
                     
                       do kk=1,nextr(1)
                         
                         if (kk .ne. j .and. cno(kk)(1:1) .ne. '!') then
                           
                           kxco = nint ( quantity(1,kk,ixcopx ) )
                           kyco = nint ( quantity(1,kk,iycopx ) )

                           if (bsomask(kxco,kyco) .gt. 0.9d0 .and. quantity(i,kk,ifxpb) .gt. almostzero) then
                             
                             dist2 = (quantity(1,j,ixcopx) - quantity(1,kk,ixcopx))**2
     &                             + (quantity(1,j,iycopx) - quantity(1,kk,iycopx))**2
                             
                             if (dist2 .lt. ((quantity(i,j,ifooa) + quantity(i,kk,ifooa)) / (dx + dy))**2) then
                               
                               if (inellipse ( dbll, dblm, dx, dy, quantity(1,kk,ixcopx), quantity(1,kk,iycopx)
     &                                       , quantity(i,kk,ifooa), quantity(i,kk,ifoob), quantity(i,kk,ithet) )) then
                     
                                 sigmaa2 = (quantity(i,kk,iafwh) / 2.0d0)**2
                                 sigmab2 = (quantity(i,kk,ibfwh) / 2.0d0)**2
                                 angle = (90.0d0 - quantity(i,kk,ithet)) * convtoradians
                                 cosa2 = cos ( angle )**2
                                 sina2 = sin ( angle )**2
                                 sin2a = sin ( 2.0d0 * angle )
                                 aak =  cosa2 / sigmaa2 + sina2 / sigmab2
                                 bbk = -sin2a / sigmaa2 + sin2a / sigmab2
                                 cck =  sina2 / sigmaa2 + cosa2 / sigmab2
                             
                                 dxcok  = (dbll - quantity(1,kk,ixcopx)) * dx
                                 dxcok2 = dxcok**2
                                 dycok  = (dblm - quantity(1,kk,iycopx)) * dy
                                 dycok2 = dycok**2
                            
                                 argexp = aak * dxcok2 + bbk * dxcok * dycok + cck * dycok2
                                 argexpm = min ( argexp / 2.0d0 * log ( 4.0d0 ), 200.0d0 )
                                 funksum = funksum + quantity(i,kk,ifxpb) * exp ( - argexpm )
                               endif
                             endif
                           endif
                         endif
                       enddo
                       
                       deblendfactor = 1.0d0
                       if (funn + funksum .ne. 0.0d0) then
                         deblendfactor = funn / (funn + funksum)
                       endif
                       deblended(l,m) = obsfsbsimage(l,m) * deblendfactor
                     endif
                   endif
                 enddo
               enddo
          
               if (lfinishing_mode) then
          
                 allocate ( individ(2*kmax+1,2*kmax+1), stat=irc )
          
                 if (irc .ne. 0) then
                   write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (80).'
                   stop 80
                 endif
               
                 mm = 0
                 do m=nyco-kmax,nyco+kmax
                   mm = mm + 1
                   ll = 0
                   do l=nxco-kmax,nxco+kmax
                     ll = ll + 1
                     if (l .ge. 1 .and. l .le. nx .and. m .ge. 1 .and. m .le. ny) then
                       individ(ll,mm) = deblended(l,m)
                     else
                       individ(ll,mm) = 0.0d0
                     endif
                   enddo
                 enddo
          
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
          
                 deblendname = individimages(1:indimg)//'/'//'sm.'//cowave(1:iow)//'.bgs.fs.dbl.src.'
     &                                                     //'ok'//czok(2:6)//'.no'//czno(2:6)//'.fits'
                 idb = lastc ( deblendname )
          
                 if (cverbose .eq. '-verb2') then
                   ibs = index ( deblendname(1:idb), '/+sources/sm.' ) + 1
                   write (iotty,'(a)') '   Writing '''//deblendname(ibs:idb)//''''
                 endif
          
                 call wfits ( cfitsversion, 2*kmax+1, 2*kmax+1, bunit, ctype1, ctype2, kmax+1.0d0, kmax+1.0d0, quantity(1,j,ixcopx)
     &                      , quantity(1,j,iycopx), individ, dx, dy, object, quantity(1,j,ixcoas), quantity(1,j,iycoas)
     &                      , deblendname(1:idb), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &                      , equinox, bzero, bscale, wave, datamin, datamax, history )
          
                 mm = 0
                 do m=nyco-kmax,nyco+kmax
                   mm = mm + 1
                   ll = 0
                   do l=nxco-kmax,nxco+kmax
                     ll = ll + 1
                     if (l .ge. 1 .and. l .le. nx .and. m .ge. 1 .and. m .le. ny) then
                       individ(ll,mm) = obsimage(l,m)
                     else
                       individ(ll,mm) = 0.0d0
                     endif
                   enddo
                 enddo
          
                 write (cowave,'(i4.4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
          
                 obsindname = individimages(1:indimg)//'/'//'sm.'//cowave(1:iow)//'.obs.src.'
     &                                                    //'ok'//czok(2:6)//'.no'//czno(2:6)//'.fits'
                 idb = lastc ( obsindname )
          
                 if (cverbose .eq. '-verb2') then
                   ibs = index ( obsindname(1:idb), '/+sources/sm.' ) + 1
                   write (iotty,'(a)') '   Writing '''//obsindname(ibs:idb)//''''
                 endif
          
                 call wfits ( cfitsversion, 2*kmax+1, 2*kmax+1, bunit, ctype1, ctype2, kmax+1.0d0, kmax+1.0d0, quantity(1,j,ixcopx)
     &                      , quantity(1,j,iycopx), individ, dx, dy, object, quantity(1,j,ixcoas), quantity(1,j,iycoas)
     &                      , obsindname(1:idb), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &                      , equinox, bzero, bscale, wave, datamin, datamax, history )
     
                 deallocate ( individ )
               endif
               
               do m=max(nyco-kmax,1),min(nyco+kmax,ny)
                 do l=max(nxco-kmax,1),min(nxco+kmax,nx)
                   rxy2 = dxco2(l) + dyco2(m)
                   do k=1,kmax
                     if (rxy2 .ge. rad2(k) .and. rxy2 .lt. rad2(k+1)) then 
                       npts(k) = npts(k) + 1.0d0
                       profilebd(i,k) = profilebd(i,k) + deblended(l,m)
                       profilebs(i,k) = profilebs(i,k) + obsfsbsimage(l,m)
                       profileob(i,k) = profileob(i,k) + obsimage(l,m)
                       profileod(i,k) = profileod(i,k) + (obsimage(l,m) - obsfsbsimage(l,m)) + deblended(l,m)
                     endif
                   enddo
                 enddo
               enddo
          
               do k=1,kmax
                 profilebd(i,k) = profilebd(i,k) / npts(k)
                 profilebs(i,k) = profilebs(i,k) / npts(k)
                 profileob(i,k) = profileob(i,k) / npts(k)
                 profileod(i,k) = profileod(i,k) / npts(k)
                 profileob1st(i,k) = 0.0d0
                 profileob2nd(i,k) = 0.0d0
                 profileob3rd(i,k) = 0.0d0
               enddo

! Compute rms at the current radial distance from the source and logarithmic derivative of intensity profile.

               do m=max(nyco-kmax,1),min(nyco+kmax,ny)
                 do l=max(nxco-kmax,1),min(nxco+kmax,nx)
                   rxy2 = dxco2(l) + dyco2(m)
                   do k=1,kmax
                     if (rxy2 .ge. rad2(k) .and. rxy2 .lt. rad2(k+1)) then 
                       profilebdrms(i,k) = profilebdrms(i,k) + (deblended(l,m) - profilebd(i,k))**2
                     endif
                   enddo
                 enddo
               enddo

               do k=1,kmax-1
                 dlnr = (rad(k+1) - rad(k)) / rad(k)
                 if (profileob(i,k) .gt. almostzero) then
                   profileob1st(i,k) = (profileob(i,k+1) - profileob(i,k)) / profileob(i,k) / dlnr
                 endif
                 if (profileod(i,k) .gt. almostzero) then
                   profileob2nd(i,k) = (profileod(i,k+1) - profileod(i,k)) / profileod(i,k) / dlnr
                 endif
               enddo
               profileob1st(i,kmax) = profileob1st(i,kmax-1)
        
! Finalize rms and average the above intensity derivative over a substantially large range of radial distances.

               do k=1,kmax
                 if (npts(k) .gt. 1.0d0) profilebdrms(i,k) = sqrt ( profilebdrms(i,k) / (npts(k) - 1.0d0) )
                 mm = 1
                 profileob3rd(i,k) = profileob2nd(i,k)
                 do kk=1,max(k-1,1)
                   if (rad(kk) .gt. radfwhm .and. rad(kk) .lt. radfoot) then
                     mm = mm + 1
                     profileob3rd(i,k) = profileob3rd(i,k) + profileob2nd(i,kk)
                   endif
                 enddo
                 profileob3rd(i,k) = profileob3rd(i,k) / dble ( mm )
               enddo
             enddo
             
             if (lfinishing_mode) then
               formt = '(i4,1pe10.2,3('//cnwaves//'(e11.3)),2(e11.3),4('//cnwaves//'(e11.3)))'
               ifmt = lastc ( formt )
               do k=1,kmax
                 write (55,formt(1:ifmt)) 
     &                 k, rad(k), (profilebd(i,k), i=1,nwaves), (profilebs(i,k), i=1,nwaves), (profileob(i,k), i=1,nwaves)
     &               , npts(k), 1.0d0 / sqrt ( npts(k) ), (profilebdrms(i,k), i=1,nwaves), (profileob1st(i,k), i=1,nwaves)
     &               , (profileob2nd(i,k), i=1,nwaves), (profileob3rd(i,k), i=1,nwaves)
               enddo
               close ( 55 )
             endif
             
           endif
         enddo
         
         deallocate ( profilebd, profilebs, profileob, rad, rad2, npts, dxco2, dyco2, deblended, profilebdrms, profileob1st
     &              , profileob2nd, profileob3rd, profileod, obsimage, obsfsbsimage, bsomask )
    
         if (ltiming) then
           cput_profimages = cput_profimages + timer ( 'cpu', cpu_profimages )
           walt_profimages = walt_profimages + timer ( 'wal', wal_profimages )
           write (60,'(a,2(1pe9.2,a))') ' Total ''PROFILES IMAGES'' CPU', cput_profimages, ' WALL', cput_profimages, ' sec'
         endif
       endif
       
!-----------------------------------------------------------------------------------------------------------------------------------

! Correct footprints images.

       if (ltiming) then
         cpu_updatefoots = timer ( 'cpu', 0.0d0 )
         wal_updatefoots = timer ( 'wal', 0.0d0 )
       endif

       if (lfirstiteration) then
         
         do i=1,nwaves
           if (liter_phase1) iter_phase(1) = 1
           if (liter_phase2) iter_phase(1) = 2
           if (liter_phase3) iter_phase(1) = 3
           converge(1,i) = 'n'
           nfootareait(1,i) = 0.0d0
           dfootareait(1,i) = 0.0d0
           dfootarea(i) = 0.0d0
         enddo
         
         nfpiter = 0
         nheadfpit = 21 + nwaves     
         headfpitline( 1) = '#'//cbars(2:)
         headfpitline( 2) = '#'
         headfpitline( 3) = '#'//getstitle(2:)
         headfpitline( 4) = '#'//cbars(2:)
         headfpitline( 5) = '#'
         headfpitline( 6) = '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         headfpitline( 7) = '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         headfpitline( 8) = '#'
         headfpitline( 9) = '# ITERATION OF FOOTPRINT IMAGES TO A RELATIVE ACCURACY OF'//creldiffmax
         headfpitline(10) = '#'
         
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           headfpitline(10+i) = '# FOOTPRINTS AT WAVE'//cwav//': '//finfootname(i)(1:iff(i))
         enddo
         
         headfpitline(11+nwaves) = '#'
         headfpitline(12+nwaves) = '# IT .............. NUMBER OF ITERATION'
         headfpitline(13+nwaves) = '# NGOOD ........... NUMBER OF THE SOURCES CONSIDERED AS GOOD'
         headfpitline(14+nwaves) = '# NBAD ............ NUMBER OF THE SOURCES FLAGGED AS BAD'
         headfpitline(15+nwaves) = '# Q ............... INDICATOR OF THE QUALITY PHASE FOR THE ITERATIONS'
         headfpitline(16+nwaves) = '# C# .............. SHOWS WHETHER ITERATIONS HAVE CONVERGED OR NOT AT WAVE #'
         headfpitline(17+nwaves) = '# DFAREA# ......... RELATIVE CHANGE OF THE TOTAL AREA OF ALL FOOTPRINTS AT WAVE #'
         headfpitline(18+nwaves) = '# TOTFOOTSAREA# ... TOTAL FOOTPRINT AREA OF ALL FOOTPRINTS AT WAVE #'
         headfpitline(19+nwaves) = '#'
         headfpitline(20+nwaves) = '# IT  NGOOD   NBAD   Q'
         
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           ihfp = lastc ( headfpitline(20+nwaves) )
           headfpitline(20+nwaves) = headfpitline(20+nwaves)(1:ihfp)//'  C'//cwav
           ihfp = lastc ( headfpitline(20+nwaves) )
           headfpitline(20+nwaves) = headfpitline(20+nwaves)(1:ihfp)//' DFAREA'//cwav
           ihfp = lastc ( headfpitline(20+nwaves) )
           headfpitline(20+nwaves) = headfpitline(20+nwaves)(1:ihfp)//' TOTFOOTSAREA'//cwav
         enddo
         headfpitline(21+nwaves) = '#'
       else
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading iterations from '''//footitname(1:lfti)//''''
       
         open ( 15, file=footitname(1:lfti), status='old' )
      
         call skipcomm     ( 15, footitname(1:lfti), nheadfpit )
         call linescolumns ( 15, footitname(1:lfti), nheadfpit, nfpiter )
      
         rewind ( 15 )
         
         do ih=1,nheadfpit
           read (15,'(a)') headfpitline(ih)
         enddo
         headfpitline( 9) = '# ITERATION OF FOOTPRINT IMAGES TO A RELATIVE ACCURACY OF'//creldiffmax
      
         do it=1,nfpiter
           read (15,'(i4,2i7,3x,i1,99(3x,a1,f10.5,1pe15.7,0p))') itfp(it), nextrgoodit(it), nextrbadit(it), iter_phase(it)
     &                                                         , (converge(it,i), dfootareait(it,i), nfootareait(it,i), i=1,nwaves)
         enddo
         
         close ( 15 )
       endif
       
       nfpiter = nfpiter + 1
       itfp(nfpiter) = nfpiter
       nextrgoodit(nfpiter) = nextrgood
       nextrbadit(nfpiter) = nextrbad
       if (liter_phase1) iter_phase(nfpiter) = 1
       if (liter_phase2) iter_phase(nfpiter) = 2
       if (liter_phase3) iter_phase(nfpiter) = 3

       if (.not.lfirstiteration) then
         do i=1,nwaves
           converge(nfpiter,i) = 'n'
           if (converge(nfpiter-1,i) .eq. '-') then
             if ((iter_phase(nfpiter) .eq. 2 .and. iter_phase(nfpiter-1) .eq. 1) .or.
     &           (iter_phase(nfpiter) .eq. 3 .and. iter_phase(nfpiter-1) .eq. 2)) then
               converge(nfpiter,i) = '+'
             else
               converge(nfpiter,i) = '-'
             endif
           endif
         enddo
       endif

       if (lfinishing_mode) then
         do i=1,nwaves
           converge(nfpiter,i) = '-'
           nfootareait(nfpiter,i) = 0.0d0
           dfootareait(nfpiter,i) = 0.0d0
           lfdone(i) = .true.
         enddo
       endif
       
       if (.not.lfinishing_mode) then

         do i=1,nwaves
           lfdone(i) = .false.
         enddo

         if (cverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Updating footprints for all sources and wavelengths'
         endif
       
         allocate ( foots(nx,ny), bsomask(nx,ny), flatfoots(nx,ny), stat=irc )
       
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (81).'
           stop 81
         endif

         allocate ( strongfoot(nx,ny), stat=irc )
     
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (82).'
           stop 82
         endif

         if (.not.lhandlesubstruc) then
           
           allocate ( subsfp(nx,ny), stat=irc )
       
           if (irc .ne. 0) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (83).'
             stop 83
           endif
         endif
         
         do i=1,nwaves
           newfootarea(i) = 0.0d0
           if (.not.lfirstiteration) then
             oldfootarea(i) = nfootareait(nfpiter-1,i)
           endif
         enddo

! NOTE: quantity(1,j,iscsx) is very important below, don't remove it! It has to remain in the total radir limits, because
! without it the footprint iterations converge to extremely small footprints, completely unrealistic. This is the property
! of the iterations: there has to be a firm limit like that does not depend directly on the resulting footprint. Only then 
! the iterations seem to converge nicely to stable and reasonable footprints.

         do i=1,nwaves
           do j=1,nextr(1)
           
             if (cno(j)(1:1) .ne. '!') then
            
               if (converge(nfpiter,i) .ne. '-') then 
                  
! Define the new current values of the *full size* of the footprint ellipse, i.e. the full major and minor axes.

                 footobsbeam = abs ( quantity(i,j,ifofa) ) * obsbeam(i)

!!! For unresolved sources, if FWHM smaller than the beam size, that clearly indicates the problem of oversubtracted background. 
!!
!!                 if (quantity(i,j,ibfwh) .lt. obsbeam(i)) then
!!                   elongation = 1.0d0
!!                 else

                 elongation = quantity(i,j,iafwh) / quantity(i,j,ibfwh)

! Put some limits on the footprint elongation by requiring that it should gradually be reduced if a source is poorly measurable.
! Source footprints become more circular, when significances (or S/N ratios) decrease below the critical value.

                 if (abs ( quantity(i,j,ifxpb) ) .gt. almostzero .and. quantity(i,j,ifxpe) .gt. almostzero) then
                   snratio = abs ( quantity(i,j,ifxpb) ) / quantity(i,j,ifxpe)
                 else
                   snratio = quantity(i,j,isigm)
                 endif
                 elonfact = min ( snratio / 200.0d0, 1.0d0 )
                 elongation = 1.0d0 + (elongation - 1.0d0) * elonfact

!!                 endif

! The same correction factor (as in SMEASURE) that translates quantity(i,j,iscsx) into an equivalent-area radius of an ellipse.

                 correction = exp ( (elongation - 1.0d0) / 20.0d0 )
                 quantity(i,j,ifoob) = abs ( quantity(i,j,ifofa) ) * (quantity(i,j,iscsx) / correction) / sqrt ( elongation )
                 quantity(i,j,ifoob) = max ( quantity(i,j,ifoob), footobsbeam )
                 quantity(i,j,ifooa) = quantity(i,j,ifoob) * elongation
                 
                 if (quantity(i,j,ithet) .le. 0.0d0) then
                   quantity(i,j,ithet) = quantity(i,j,ithet) + 180.0d0
                 elseif (quantity(i,j,ithet) .gt. 180.0d0) then
                   quantity(i,j,ithet) = quantity(i,j,ithet) - 180.0d0
                 endif
               endif
             endif
           enddo
         enddo
         
! Determine improved footprints.
                                                        
         do i=1,nwaves

           lcw = lastc ( cwave0(i) )

           do m=1,ny
             do l=1,nx
               if (converge(nfpiter,i) .ne. '-') then 
                 foots(l,m) = 0.0d0
                 flatfoots(l,m) = 0.0d0
                 strongfoot(l,m) = 0.0d0
               endif
               if (.not.lhandlesubstruc) then
                 subsfp(l,m) = 0.0d0
               endif
             enddo
           enddo

!!           lhighsigmono = .false.
!!           do j=1,nextr(1)
!!             if (quantity(i,j,isigm) .gt. 10.0d0) lhighsigmono = .true.
!!           enddo

           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, bsomask, dx, dy, object, ra, dec
     &                , bsomaskname(i)(1:ibm(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )

           do j=1,nextr(1)
!!             semimajor = sqrt ( quantity(i,j,ifooa)**2 + (abs ( quantity(i,j,ifofa) ) * aperture(i))**2 ) / 2.0d0
!!             semimajor = max ( quantity(i,j,ifooa), abs ( quantity(i,j,ifofa) ) * 1.5d0 * aperture(i) ) / 2.0d0

             semimajor = quantity(i,j,ifooa) / 2.0d0
             
             nr = nint ( semimajor / pixsize )
             l0 = nint ( quantity(1,j,ixcopx) )
             m0 = nint ( quantity(1,j,iycopx) )
             l1 = max ( l0 - nr , 1 )
             l2 = min ( l0 + nr , nx )
             m1 = max ( m0 - nr , 1 )
             m2 = min ( m0 + nr , ny )

             if (converge(nfpiter,i) .ne. '-') then 

               if (cno(j)(1:1) .ne. '!' .and. 
     &             lnormalsigm(i,j) .and. lnormalsize(i,j) .and. lnormalgood(i,j)) then   !! .and. lmeasurable(i,j)
                 
                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
                     
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ithet) )) then
                       foots(l,m) = dble ( j )
                     endif
                   enddo
                 enddo

                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
                   
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ithet) )) then

                       flatfoots(l,m) = dble ( j )
                       
!!                       if (lhighsigmono) then
!!                         if (quantity(i,j,isigm) .gt. 10.0d0) then
!!                           newfootarea(i) = newfootarea(i) + bsomask(l,m)
!!                         endif
!!                       else
                       newfootarea(i) = newfootarea(i) + bsomask(l,m)
!!                       endif
                     endif
                   enddo
                 enddo
               endif
             endif
             
             if (.not.lhandlesubstruc) then
               
               if (lsubatwave(i,j)) then
               
                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
               
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ithet) )) then
                       subsfp(l,m) = dble ( j )
                     endif
                   enddo
                 enddo
               endif
             endif
           enddo
           
           if (converge(nfpiter,i) .ne. '-') then 
           
             nfootareait(nfpiter,i) = newfootarea(i)
             
             if (.not.lfirstiteration) then
               dfootarea(i) = 0.0d0
               if (oldfootarea(i) .gt. 0.0d0) then
                 dfootarea(i) = (newfootarea(i) - oldfootarea(i)) / oldfootarea(i)
               endif
               if (dfootarea(i) * dfootareait(nfpiter-1,i) .lt. 0.0d0 .and.
     &             dfootarea(i) + dfootareait(nfpiter-1,i) .lt. 0.01d0 * abs ( dfootareait(nfpiter-1,i) )) then
                 dfootarea(i) = 0.0d0
               endif
             endif
             dfootareait(nfpiter,i) = dfootarea(i)
           else
             nfootareait(nfpiter,i) = oldfootarea(i)
           endif
           
           if (converge(nfpiter,i) .ne. '-') then 
             
             if (cverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing footprints '''//finfootname(i)(1:iff(i))//''''
             endif
           
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, foots, dx, dy, object
     &                  , crval1, crval2, finfootname(i)(1:iff(i)), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11
     &                  , cd12, cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

             if (cverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing flattening footprints '''//'flatfoot.'//cwave0(i)(1:lcw)//'.fits'//''''
             endif
         
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, flatfoots, dx, dy, object
     &                  , crval1, crval2, 'flatfoot.'//cwave0(i)(1:lcw)//'.fits', cdate, ctime, creator, beamd, blank, crota1
     &                  , crota2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )
           endif
    
           if (.not.lhandlesubstruc) then
             
             if (cverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing subs footprints image '''//subsfootpr(i)(1:isf(i))//''''
             endif
        
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, subsfp, dx, dy, object
     &                  , crval1, crval2, subsfootpr(i)(1:isf(i)), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11
     &                  , cd12, cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )
           endif
         enddo 

         if (.not.lfirstiteration) then
           
           lalldiffsmall = .true.
           
           do i=1,nwaves
             lcw = lastc ( cwave0(i) )
             inquire ( file='+wave.'//cwave0(i)(1:lcw)//'.done', exist=lfdone(i) )
             
             if (abs ( dfootarea(i) ) .lt. reldiffmax) then
!!!     &          .or. (converge(nfpiter,i) .ne. 'n' .and. converge(nfpiter-1,i) .eq. '-')) then

               if (converge(nfpiter,i) .ne. '+') then
                 
                 inquire ( file='+wave.'//cwave0(i)(1:lcw)//'.foot', exist=lfoot )
                 if (.not.lfoot) then
                   converge(nfpiter,i) = 'n'
                 else
                   converge(nfpiter,i) = '-'
                 endif
               endif
               
               if (.not.lfdone(i) .and. converge(nfpiter,i) .ne. 'n') then
                 open ( 65, file='+wave.'//cwave0(i)(1:lcw)//'.done', status='new' )
                 write (65,'(a,i2,a)') 'wave '//cwave0(i)(1:lcw)//' converged in ', nfpiter,' iterations.'
                 close ( 65 )
                 lfdone(i) = .true.
               endif
             endif
             if (converge(nfpiter,i) .eq. 'n') lalldiffsmall = .false.
           enddo

           if (nextrgoodvold .gt. 0 .and. nextrgoodold .gt. 0 .and. lalldiffsmall) then 
           
             if (cverbose .eq. '-verb2') then
               write (iotty,'(a,3i5,20(f9.5))') 
     &                      '   Converged: ', nextrgoodvold, nextrgoodold, nextrgoodnew, (dfootarea(i), i=1,nwaves)
             endif
             lconverged = .true.
           else  
             if (cverbose .eq. '-verb2') then
               write (iotty,'(a,3i5,20(f9.5))') 
     &                      '   Iterating: ', nextrgoodvold, nextrgoodold, nextrgoodnew, (dfootarea(i), i=1,nwaves)
             endif
           endif
         endif

         if (liter_phase2 .or. liter_phase3) then
           deallocate ( strongfoot )
         endif
         if (.not.lhandlesubstruc) then
           deallocate ( subsfp )
         endif
         
         deallocate ( foots, bsomask, flatfoots )

! Send a signal (*NEGATIVE* FOOTPRINTS!) to SMEASURE that a source is not good in some way and therefore 
! it should not be considered. NOTE: ABSOLUTE VALUES of the footprints must be used in SMEASURE.
       
         do i=1,nwaves
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!' .and. 
     &           (.not.lnormalsigm(i,j) .or. .not.lnormalsize(i,j) .or. .not.lnormalgood(i,j))) then !! .or. .not.lmeasurable(i,j)
               quantity(i,j,ifooa) = - abs ( quantity(i,j,ifooa) )
               quantity(i,j,ifoob) = - abs ( quantity(i,j,ifoob) )
             endif
           enddo
         enddo
       endif                
       
       if (ltiming) then
         cput_updatefoots = cput_updatefoots + timer ( 'cpu', cpu_updatefoots )
         walt_updatefoots = walt_updatefoots + timer ( 'wal', wal_updatefoots )
         write (60,'(a,2(1pe9.2,a))') ' Total ''UPDATE FOOTS''    CPU', cput_updatefoots, ' WALL', cput_updatefoots, ' sec'
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (cverbose .eq. '-verb2')
     &   write (iotty,'(a)') '   Rewriting smf catalogs at each wave (flagging bad entries)'

       if (ltiming) then
         cpu_updatecats = timer ( 'cpu', 0.0d0 )
         wal_updatecats = timer ( 'wal', 0.0d0 )
       endif
       
       call updatecatsflagbads ( iotty, cverbose, nwavemax, nwaves, cat, icat, nextr, nhead, cno, quantity, isigg, iscsx, iafwh
     &                         , ibfwh, iasiz, ibsiz, ithet, ifooa, ifoob, iflag, ifmon, sfg, sfm, catsubstruc, icats, nconfigend
     &                         , headline, headlineout, catline, comment, ncolskipsigg, ncolskipfsflg, ncolskipssx, ncolskipasi
     &                         , ncolskipfmflg, ncolskipfoo, lfinishing_mode, lhandlesubstruc )

       if (ltiming) then
         cput_updatecats = cput_updatecats + timer ( 'cpu', cpu_updatecats )
         walt_updatecats = walt_updatecats + timer ( 'wal', wal_updatecats )
         write (60,'(a,2(1pe9.2,a))') ' Total ''UPDATE CATS''     CPU', cput_updatecats, ' WALL', cput_updatecats, ' sec'
       endif
       
!-----------------------------------------------------------------------------------------------------------------------------------

       if (cverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing iterations in '''//footitname(1:lfti)//''''
       
       open ( 15, file=footitname(1:lfti), status='unknown' )
       
       do ih=1,nheadfpit
         lhl = lastc ( headfpitline(ih) )
         write (15,'(a)') headfpitline(ih)(1:lhl)
       enddo
       
       do it=1,nfpiter
         write (15,'(i4,2i7,3x,i1,99(3x,a1,f10.5,1pe15.7,0p))') itfp(it), nextrgoodit(it), nextrbadit(it), iter_phase(it)
     &                                                        , (converge(it,i), dfootareait(it,i), nfootareait(it,i), i=1,nwaves)
       enddo
       
       close ( 15 )
       
       deallocate ( no, ns1, ns2, nsx, catline, quantity, factor, factsmoo, cno, comment, flag, badsource, backgint, backgsmoint
     &            , nok, mok, lnormalsigm, lmeasurable, lnormalsize, lnormalgood, lsubatwave !!, snrtglob
     &            , dist2peaks, dist2foots, sfg, sfm, cfmflag, xx, yy )
       
!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_sum = cpu_sum + cput_flagsources + cput_substructured + cput_semifinalcat + cput_finalcats
     &                     + cput_additioncats + cput_profimages + cput_updatefoots + cput_updatecats + cput_backfitsrc
         wal_sum = wal_sum + walt_flagsources + walt_substructured + walt_semifinalcat + walt_finalcats
     &                     + walt_additioncats + walt_profimages + walt_updatefoots + walt_updatecats + walt_backfitsrc

! Total cpu usage, expressed in hours, minutes, and seconds.

         cputot = cpu_sum
         cpuhours = int ( cputot / 3600.0d0 )
         cpumins  = int ( cputot / 60.0d0 ) -  60 * cpuhours
         cpusecs  = int ( cputot + 0.5d0 ) - 3600 * cpuhours - 60 * cpumins

! Final wall clock time, expressed in hours, minutes, and seconds.

         wctot  = wal_sum
         wchours  = int ( wctot / 3600.0d0 )
         wcmins   = int ( wctot / 60.0d0 ) -  60 * wchours
         wcsecs   = int ( wctot + 0.5d0 ) - 3600 * wchours - 60 * wcmins

         write (60,'(a)') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' ACCUMULATED CPU & WALL TIME', cpu_sum, ' sec ', wal_sum, ' sec'
         write (60,'(a,i3.2,a,i2.2,a,i2.2,a,i3.2,a,i2.2,a,i2.2,a,f7.2,a)')
     &             ' ---------------------------',cpuhours,':',cpumins,':',cpusecs, ' ----', wchours,':',wcmins,':',wcsecs, ' ---'
  
         call when ( lunix, ctime, cdate, ndate, 4 )
  
         write (60,'(a)') ' FINALCAT finished: '//cdate//' '//ctime
         close ( 60 )
       endif

       if (cverbose .eq. '-verb2') then
         write (iotty,'(/a)') ' Done.'
       endif

       if (lconverged) then
         open ( 9, file='.converged', status='unknown' )
         write (9,'(a)') 'Iterations have converged.'
         close ( 9 )
       endif

       deallocate ( cat, detimageline, obsfscbname, obsimagestring, obsname, obsfsname, obsfsbsname, obscbname, obscbsmoname
     &            , bsomaskname, finfootname, subsfootpr, headline, headfpitline, addhead, headlineout, headrelitent, cfgline
     &            , nfootareait, dfootareait )

!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine fitshapesintensities

     &            ( nx, ny, iotty, cverbose, nwaves, obsname, obsfsname, obsfscbname, obsfsbsname, iobs, iobsfs, iobsfscb, iobsfsbs
     &            , nextr, cno, quantity, ifooa, ifoob, ithet, ixcopx, iycopx, ifxpb, isigm, igodm, iafwh, ibfwh, obsbeam
     &            , convtoradians, goodminvar, cfitsversion, cdate, ctime, peakfunits, ifxpe, sq_arcsecs_per_sterad, cbars
     &            , getstitle, compda, clibname, xmu, xmH, au2cm, distpc, xMsun, lnormalsigm, lnormalsize  !! , lmeasurable
     &            , lnormalgood )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!
! Compute and write intensity distributions for fitted elliptical sources.
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       
       logical       inellipse, ldofitting, ldone, ltruebs
       
       character*(*) obsfsname(*), obsname(*), obsfscbname(*), obsfsbsname(*), cno(*), ctime, cdate, cverbose, cbars
     &             , getstitle, compda, clibname, cfitsversion
       character*3   cnan
       character*4   cnb, cpmx
       character*10  peakfunits(*)
       character*80  object, creator, ctype1, ctype2, bunit, history
       character*500 finbgrname, finbgrtname, finmoffatrtname, truesrcname
       
       integer       lastc, nx, ny, ifbr, ifbrt, ifmrt, blank, iotty, irc, i, n, l, m, nwaves, ithet, ifooa
     &             , ixcopx, iycopx, ifxpb, ifoob, isigm, igodm, l0, m0, l1, l2, m1, m2, nbeta, ib, il, ig, iafwh
     &             , ibfwh, nfitl, ir, kk, nrmax, nextr(*), iobs(*), iobsfs(*), iobsfscb(*), ifui, nbkgl, ibmin, ilmin, lx
     &             , nr, mx, nbkgl1, nbkgl2, nbkglx, itrue, nprt, ifxpe, npts, npmx, nmed, iobsfsbs(*)
       
       real*8        selectk, gaussfun, moffatfun, dx, dy, ra, dec, funmin, funmax, equinox, bzero, bscale, aak, bkglx
     &             , wave, cd11, cd12, cd21, cd22, crpix1, crpix2, crval1, crval2, beamd, crota1, crota2, datamin, datamax, sigmaa2
     &             , sigmab2, angle, convtoradians, sin2a, sina2, cosa2, aa, bb, cc, semimajor, dxcon, dxcon2, dycon, dycon2, dbll
     &             , dblm, argexp, goodminvar, correctx, chisqmin, modelshape, bbk, elongation, foomin1, foomin2, foomax1
     &             , foomax2, beta1, betan, deblended, argexpm, fitl1, fitln, dbeta, dfitl, convftot, dist2, dxcok, dycok, dxcok2
     &             , dycok2, sq_arcsecs_per_sterad, cck, residualflux, deblendfactor, bkgl1, bkgln, dbkgl, chisqminlb, peakintens
     &             , azimavresidual, funminrt, funmaxrt, snratiocrit, snratio, almostzero, totflux, xmu, xmH, au2cm, distpc, xMsun
       
       real*8        quantity(nwaves,nextr(1),*), asizebest(nextr(1)), bsizebest(nextr(1)), betabest(nextr(1)), fitlbest(nextr(1))
     &             , bkglbest(nextr(1)), obsbeam(*)
       
       logical       lnormalsigm(nwaves,*), lnormalsize(nwaves,*), lnormalgood(nwaves,*)   !! , lmeasurable(nwaves,*)

       real*8      , allocatable :: obsimage(:,:), obsfsimage(:,:), obsfscbimage(:,:), obscbrt(:,:), obscbfsrt(:,:), restrue(:,:)
     &             , resmean(:,:), moffatrt(:,:), footmask(:,:), residual(:,:), nptsrt(:), reswork(:), resmeanrt(:), chisq(:,:,:)
     &             , betax(:), fitlev(:), bkglev(:), funksum(:,:), rad(:), bgsubtracted(:,:), obsfsbsimage(:,:), resskew(:,:)
     &             , reskurt(:,:), resmedir(:), resmedirt(:), resskewx(:,:), reskurtx(:,:)

       parameter   ( ldofitting = .false., beta1 = 1.0d0, betan = 8.0d0, dbeta = 0.05d0, snratiocrit = 30.0d0, almostzero = 1.0d-30
     &             , fitl1 = 1.0d0, fitln = 0.0004d0, dfitl = 0.05d0, bkgl1 = 0.6d0, bkglx = 1.0d0, bkgln = 1.3d0, dbkgl = 0.05d0 )

       external      inellipse, lastc, selectk, rfits, wfits
!__________________________________________________________________________________________________________________________________
!
       if (ldofitting) then
         nbeta = nint ( (log10 ( betan ) - log10 ( beta1 )) / dbeta ) + 1
         nfitl = nint ( (log10 ( fitl1 ) - log10 ( fitln )) / dfitl ) + 1
         nbkgl1 = nint ( (log10 ( bkglx ) - log10 ( bkgl1 )) / dbkgl )
         nbkglx = nbkgl1 + 1
         nbkgl2 = nint ( (log10 ( bkgln ) - log10 ( bkglx )) / dbkgl )
         nbkgl = nbkgl1 + nbkglx + nbkgl2
       else
         nbeta = 0
         nfitl = 1
         nbkgl1 = 0
         nbkglx = 1
         nbkgl2 = 0
         nbkgl = nbkglx
       endif
       write (cnb,'(i4)') (nbeta + 1) * nfitl
       correctx = 0.0d0

       allocate ( obscbrt(nx,ny), obscbfsrt(nx,ny), restrue(nx,ny), resmean(nx,ny), moffatrt(nx,ny), footmask(nx,ny)
     &          , chisq(nbkgl,0:nbeta,nfitl), betax(0:nbeta), fitlev(nfitl), bkglev(nbkgl), obsimage(nx,ny), obsfsimage(nx,ny)
     &          , resskew(nx,ny), reskurt(nx,ny), resskewx(nx,ny), reskurtx(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (84).'
         stop 84
       endif
       cnan = 'NAN'

       betax(0) = 10.0d0
       do ib=nbeta,1,-1
         betax(nbeta-ib+1) = 10.0d0**(dbeta * dble ( ib - 1 ))
       enddo
       do il=1,nfitl
         fitlev(il) = 10.0d0**(log10 ( fitl1 ) - dfitl * dble ( il - 1 ))
       enddo
       do ig=1,nbkgl
         bkglev(ig) = 10.0d0**(log10 ( bkglx ) + dbkgl * dble ( ig - nbkglx ))
       enddo
       
       do i=1,nwaves
         truesrcname = obsname(i)(1:iobs(i)-8)//'.back.true.fits'
         itrue = lastc ( truesrcname )
         inquire ( file=truesrcname(1:itrue), exist=ltruebs )
         
         if (.not.ltruebs) then
           allocate ( obsfscbimage(nx,ny), stat=irc )
         else
           allocate ( obsfsbsimage(nx,ny), stat=irc )
         endif
      
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (85).'
           stop 85
         endif

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsimage, dx, dy, object, ra, dec
     &              , obsname(i)(1:iobs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21
     &              , cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsfsimage, dx, dy, object, ra, dec
     &              , obsfsname(i)(1:iobsfs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12, cd21
     &              , cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )

         if (.not.ltruebs) then
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsfscbimage, dx, dy, object, ra, dec
     &                , obsfscbname(i)(1:iobsfscb(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )
         else
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsfsbsimage, dx, dy, object, ra, dec
     &                , obsfsbsname(i)(1:iobsfsbs(i)), iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history, cverbose )
         endif
     
         convftot = 1.0d0
         ifui = lastc ( peakfunits(i) )

         if (peakfunits(i)(1:ifui) .eq. 'MJy/sr') then
           convftot = 1.0d6 * dx * dy / sq_arcsecs_per_sterad  !<-- intensity in MJy/sr to flux in Jy
         endif           
         if (peakfunits(i)(1:ifui) .eq. 'H2/cm^2') then
           convftot = dx * dy * xmu * xmH * (au2cm * distpc)**2 / xMsun  !<-- surface density in H2/cm^2 to mass in Msun
         endif           

         do m=1,ny
           do l=1,nx
             obscbrt(l,m) = obsimage(l,m)
             obscbfsrt(l,m) = obsfsimage(l,m)
             moffatrt(l,m) = 0.0d0
             restrue(l,m) = 0.0d0
             resmean(l,m) = 0.0d0
             resskew(l,m) = 0.0d0
             reskurt(l,m) = 0.0d0
             resskewx(l,m) = 0.0d0
             reskurtx(l,m) = 0.0d0
             footmask(l,m) = 0.0d0
           enddo
         enddo

         open ( 15, file=obsfsname(i)(1:iobsfs(i)-5)//'.chisq.dat', status='unknown' )
         write (15,'(a)') '#'//cbars(2:)
         write (15,'(a)') '#'
         write (15,'(a)') '#'//getstitle(2:)
         write (15,'(a)') '#'//cbars(2:)
         write (15,'(a)') '#'
         write (15,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         write (15,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (15,'(a)') '# Used '//clibname//' library version'//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (15,'(a)') '#'
         write (15,'(a,18x,a)') '# FITTING ELLIPTICAL SHAPES (GAUSSIAN + MOFFAT)'
     &                        , 'Discretized BETA and FITLEVEL values & tabulated CHISQ values'
         write (15,'(a,6x,a)') '# WITH VARIABLE BACKGRD LEVEL & MOFFAT BETA & FITLEVEL'
     &            ,'___________________________________________________________________________________________________________'
         write (15,'(a)') '#'
         write (15,'(a,59x,'//cnb//'(1x,f5.2,3x))') '#', ((betax(ib), il=1,nfitl), ib=0,nbeta)
         write (15,'(a,'//cnb//'(f9.6))') '#  NO    ASIZE     BSIZE    BETF   FITLF   BKGLF   CHISQF  '
     &                                  , ((fitlev(il), il=1,nfitl), ib=0,nbeta)
         write (15,'(a)') '#'

         do n=1,nextr(1)
           
           if (cno(n)(1:1) .ne. '!' .and. quantity(i,n,igodm) .gt. goodminvar .and.
     &         lnormalsigm(i,n) .and. lnormalsize(i,n) .and. lnormalgood(i,n)) then     !! .and. lmeasurable(i,n)  
               
             chisqmin = 1.0d99
             if (abs ( quantity(i,n,ifxpb) ) .gt. almostzero .and. quantity(i,n,ifxpe) .gt. almostzero) then
               snratio = abs ( quantity(i,n,ifxpb) ) / quantity(i,n,ifxpe)
             elseif (quantity(i,n,isigm) .gt. almostzero) then
               snratio = quantity(i,n,isigm)
             else
               snratio = 0.0d0
             endif
             asizebest(n) = max ( quantity(i,n,iafwh), obsbeam(i) )
             bsizebest(n) = max ( quantity(i,n,ibfwh), obsbeam(i) )
             betabest(n) = betax(0)
             fitlbest(n) = fitlev(1)
             bkglbest(n) = bkglev(nbkglx)
             ldone = .false.
             
             do ig=1,nbkgl
               do ib=0,nbeta
                 do il=1,nfitl
                   chisq(ig,ib,il) = 0.0d0
                 enddo
               enddo
             enddo

             l0 = nint ( quantity(1,n,ixcopx) )
             m0 = nint ( quantity(1,n,iycopx) )
             angle = (90.0d0 - quantity(i,n,ithet)) * convtoradians
                 
! Now fit the 2D shapes to the observed filament-subtracted image to obtain best power-law exponent.
               
             sigmaa2 =(asizebest(n) / 2.0d0 )**2
             sigmab2 =(bsizebest(n) / 2.0d0 )**2
             cosa2 = cos ( angle )**2
             sina2 = sin ( angle )**2
             sin2a = sin ( 2.0d0 * angle )
             aa =  cosa2 / sigmaa2 + sina2 / sigmab2
             bb = -sin2a / sigmaa2 + sin2a / sigmab2
             cc =  sina2 / sigmaa2 + cosa2 / sigmab2
             semimajor = quantity(i,n,ifooa) / 2.0d0
             nr = nint ( semimajor / min ( dx, dy ) )
             l1 = max ( l0 - nr, 1 )
             l2 = min ( l0 + nr, nx )
             m1 = max ( m0 - nr, 1 )
             m2 = min ( m0 + nr, ny )

             allocate ( funksum(l2-l1+1,m2-m1+1), residual(l2-l1+1,m2-m1+1), bgsubtracted(l2-l1+1,m2-m1+1), stat=irc )
         
             if (irc .ne. 0) then
               write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (79).'
               stop 79
             endif
               
             do ig=1,nbkgl

               ibmin = 0
               ilmin = 1
               chisqminlb = 1.0d99
               if (.not.ltruebs) then
                 peakintens = quantity(i,n,ifxpb) + obsfscbimage(l0,m0) * (1.0d0 - bkglev(ig))
               else
                 peakintens = quantity(i,n,ifxpb)
               endif

               do ib=0,nbeta
                 
                 if (ib .ge. 1) correctx = 2.0d0**(1.0d0 / betax(ib)) - 1.0d0
                   
                 do il=1,nfitl
                   
                   do m=m1,m2
                     dblm = dble ( m )
                     dycon = (dblm - quantity(1,n,iycopx)) * dy
                     dycon2 = dycon**2
                     mx = m - m1 + 1
                     
                     do l=l1,l2
                       dbll = dble ( l )
                       dxcon = (dbll - quantity(1,n,ixcopx)) * dx
                       dxcon2 = dxcon**2
                       lx = l - l1 + 1
                       
                       if (inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), quantity(i,n,ifooa)
     &                               , quantity(i,n,ifoob), quantity(i,n,ithet) )) then
                        
! Fit a linear combination of a Gaussian and a Moffat shape; the latter is scaled to have various fitting (transition) levels.
                     
                         argexp = aa * dxcon2 + bb * dxcon * dycon + cc * dycon2
                         argexpm = min ( argexp / 2.0d0 * log ( 4.0d0 ), 200.0d0 )
                         gaussfun = peakintens * exp ( - argexpm )
                       
                         modelshape = gaussfun
                         if (ib .ge. 1) then
                           moffatfun = peakintens / (1.0d0 + correctx * argexp)**betax(ib)
                           modelshape = fitlev(il) * moffatfun + (1.0d0 - fitlev(il)) * gaussfun
                         endif
                         funksum(lx,mx) = 0.0d0
                
                         do kk=1,nextr(1)
                           
                           if (kk .ne. n .and. cno(kk)(1:1) .ne. '!' .and.
     &                         lnormalsigm(i,kk) .and. lnormalsize(i,kk) .and. lnormalgood(i,kk)) then  !! .and. lmeasurable(i,kk)
                             
                             dist2 = (quantity(1,n,ixcopx) - quantity(1,kk,ixcopx))**2
     &                             + (quantity(1,n,iycopx) - quantity(1,kk,iycopx))**2
                             
                             if (dist2 .lt. ((quantity(i,n,ifooa) + quantity(i,kk,ifooa)) / (dx + dy))**2) then
                               
                               if (inellipse ( dbll, dblm, dx, dy, quantity(1,kk,ixcopx), quantity(1,kk,iycopx)
     &                                       , quantity(i,kk,ifooa), quantity(i,kk,ifoob), quantity(i,kk,ithet) )) then
                             
                                 sigmaa2 = (max ( quantity(i,kk,iafwh), obsbeam(i) ) / 2.0d0)**2
                                 sigmab2 = (max ( quantity(i,kk,ibfwh), obsbeam(i) ) / 2.0d0)**2
                                 angle = (90.0d0 - quantity(i,kk,ithet)) * convtoradians
                                 cosa2 = cos ( angle )**2
                                 sina2 = sin ( angle )**2
                                 sin2a = sin ( 2.0d0 * angle )
                                 aak =  cosa2 / sigmaa2 + sina2 / sigmab2
                                 bbk = -sin2a / sigmaa2 + sin2a / sigmab2
                                 cck =  sina2 / sigmaa2 + cosa2 / sigmab2
                                 dxcok  = (dbll - quantity(1,kk,ixcopx)) * dx
                                 dycok  = (dblm - quantity(1,kk,iycopx)) * dy
                                 dxcok2 = dxcok**2
                                 dycok2 = dycok**2
                
                                 argexp = aak * dxcok2 + bbk * dxcok * dycok + cck * dycok2
                                 argexpm = min ( argexp / 2.0d0 * log ( 4.0d0 ), 200.0d0 )
                                 funksum(lx,mx) = funksum(lx,mx) + quantity(i,kk,ifxpb) * exp ( - argexpm )
                               endif
                             endif
                           endif
                         enddo

                         deblendfactor = 1.0d0
                         if (gaussfun + funksum(lx,mx) .ne. 0.0d0) then
                           deblendfactor = gaussfun / (gaussfun + funksum(lx,mx))
                         endif
                         if (.not.ltruebs) then
                           deblended = (obsfsimage(l,m) - obsfscbimage(l,m) * bkglev(ig)) * deblendfactor
                         else
                           deblended = obsfsbsimage(l,m) * deblendfactor
                         endif
                         residual(lx,mx) = deblended - modelshape
                         
! Weight CHISQ by BETAX to bias the quantity to prefer steeper shapes.
                         
                         chisq(ig,ib,il) = chisq(ig,ib,il) + residual(lx,mx)**2 
     &                                   * max ( bkglev(ig), 1.0d0 / bkglev(ig) ) / sqrt ( sqrt ( betax(ib) ) )
                       endif
                     enddo
                   enddo

! Mark the beta and fitlevel values that give a lower chisq value.

                   if (chisq(ig,ib,il) .lt. chisqminlb .and. chisq(ig,ib,il) .lt. chisqmin) then
                     betabest(n) = betax(ib)
                     fitlbest(n) = fitlev(il)
                     bkglbest(n) = bkglev(ig)
                     ibmin = ib
                     ilmin = il
                     chisqminlb = chisq(ig,ib,il)
                   endif
                 enddo
                 if (ib .gt. ibmin) then
                   exit
                 endif
               enddo

               if (chisq(ig,ibmin,ilmin) .lt. chisqmin) then
                 chisqmin = chisq(ig,ibmin,ilmin)
                 write (15,'(i5,1x,2(1pe10.3),1x,0pf5.2,2f8.5,1pe10.3,1x,'//cnb//'(2e9.2))') n, asizebest(n), bsizebest(n)
     &                    , betabest(n), fitlbest(n), bkglbest(n), chisqmin, ((chisq(ig,ib,il), il=1,nfitl), ib=0,ibmin)
               else
                 exit
               endif
             enddo
             
             write (15,'()')

             do m=m1,m2
               dblm = dble ( m )
               mx = m - m1 + 1
               do l=l1,l2
                 dbll = dble ( l )
                 lx = l - l1 + 1

                 if (.not.ltruebs) then
                   bgsubtracted(lx,mx) = obsfsimage(l,m) - obsfscbimage(l,m)
                 else
                   bgsubtracted(lx,mx) = obsfsbsimage(l,m)
                 endif
               enddo
             enddo
             
             peakintens = quantity(i,n,ifxpb)
             totflux = 0.0d0
             
! Accumulate the source shapes and subtract them from the observed image to obtain a background estimate free of sources.
              
             if (betabest(n) .le. 9.89d0) correctx = 2.0d0**(1.0d0 / betabest(n)) - 1.0d0
             
             do m=m1,m2
               dblm = dble ( m )
               dycon = (dblm - quantity(1,n,iycopx)) * dy
               dycon2 = dycon**2
               mx = m - m1 + 1
               
               do l=l1,l2
                 dbll = dble ( l )
                 dxcon = (dbll - quantity(1,n,ixcopx)) * dx
                 dxcon2 = dxcon**2
                 lx = l - l1 + 1
                 
                 if (inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), quantity(i,n,ifooa)
     &                         , quantity(i,n,ifoob), quantity(i,n,ithet) )) then
                   
                   argexp = aa * dxcon2 + bb * dxcon * dycon + cc * dycon2
                   argexpm = min ( argexp / 2.0d0 * log ( 4.0d0 ), 200.0d0 )
                   gaussfun = peakintens * exp ( - argexpm )

                   modelshape = gaussfun
                   if (betabest(n) .le. 9.89d0) then
                     moffatfun = peakintens / (1.0d0 + correctx * argexp)**betabest(n)
                     modelshape = fitlbest(n) * moffatfun + (1.0d0 - fitlbest(n)) * gaussfun
                   endif

                   deblendfactor = 1.0d0
                   if (gaussfun + funksum(lx,mx) .ne. 0.0d0) then
                     deblendfactor = gaussfun / (gaussfun + funksum(lx,mx))
                   endif
                   deblended = bgsubtracted(lx,mx) * deblendfactor

! In general, there are systematic residuals due to the fact that the actual (complex) intensity shape 
! of a real source cannot be described by a Gaussian or a power-law Moffat shape nor their combination.
                   
                   residual(lx,mx) = deblended - modelshape
                   totflux = totflux + modelshape

                   if (quantity(i,n,igodm) .ge. goodminvar) then
                     moffatrt (l,m) = moffatrt (l,m) + modelshape
                     obscbrt  (l,m) = obscbrt  (l,m) - modelshape
                     obscbfsrt(l,m) = obscbfsrt(l,m) - modelshape
                     restrue(l,m) = restrue(l,m) + residual(lx,mx)
                   endif
                 endif
               enddo
             enddo
             
             deallocate ( funksum, bgsubtracted )

! Azimuthally averaging residuals and subtracting them to remove circular artefacts in resolved power-law sources.
! This recovers noise fluctuations on smallest scales and allows reconstruction of fluctuating background within footprints.

             elongation = quantity(i,n,ifooa) / quantity(i,n,ifoob)
             nrmax = min ( nr, max ( nx - 1, ny - 1 ) ) + 1

             allocate ( rad(nrmax+1), nptsrt(nrmax+1), resmeanrt(nrmax+1), reswork(nrmax+1)
     &                , resmedir(4*(nr+1)*(nr+1)), resmedirt(4*(nr+1)*(nr+1)), stat=irc )
         
             if (irc .ne. 0) then
               write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (78).'
               stop 78
             endif

             do ir=1,nrmax+1
               nptsrt(ir) = 0.0d0
               resmeanrt(ir) = 0.0d0
               reswork(ir) = 0.0d0
               rad(ir) = (dble ( ir - 1 ) + 0.5d0) * (dx + dy) / 2.0d0
             enddo

             do ir=1,nrmax
               nprt = 0
               funminrt = 1.0d99
               funmaxrt = -1.0d99
               foomin1 = 2.0d0 * rad(ir)
               foomin2 = 2.0d0 * rad(ir+1)
               foomax1 = foomin1 * elongation
               foomax2 = foomin2 * elongation
                 
               do m=m1,m2
                 dblm = dble ( m )
                 mx = m - m1 + 1
                 do l=l1,l2
                   dbll = dble ( l )
                   lx = l - l1 + 1
                 
                   if (inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), quantity(i,n,ifooa)
     &                           , quantity(i,n,ifoob), quantity(i,n,ithet) )) then
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), foomax2, foomin2
     &                             , quantity(i,n,ithet) )) then
                       if (.not.inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), foomax1, foomin1
     &                                    , quantity(i,n,ithet) )) then
                  
                         if (quantity(i,n,igodm) .ge. goodminvar) then
                           nptsrt(ir) = nptsrt(ir) + 1.0d0
                           resmeanrt(ir) = resmeanrt(ir) + residual(lx,mx)
                           nprt = nint ( nptsrt(ir) )
                           resmedirt(nprt) = residual(lx,mx)
                           funminrt = min ( funminrt, resmedirt(nprt) )
                           funmaxrt = max ( funmaxrt, resmedirt(nprt) )
                         endif
                       endif
                     endif
                   endif
                 enddo
               enddo
  
               if (nprt .gt. 0) resmeanrt(ir) = selectk ( (nprt + 1) / 2, nprt, resmedirt )
             enddo

! Taking into account the azimuthally-averaged (smoothed) residuals within footprints.

             npts = 4
             write (cpmx,'(i4.4)') 2 * npts + 1
             npmx = int ( log10 ( dble ( 2 * npts + 1 ) ) ) + 1
!!             if (cverbose .eq. '-verb2') then
!!!!               write (iotty,'(a,i1,a)') '   Median filtering in a window of D = '//cpmx(4-npmx+1:4)//' pixels'
!!               write (iotty,'(a,i1,a)') '   Mean filtering in a window of D = '//cpmx(4-npmx+1:4)//' pixels'
!!             endif
             do ir=1,nrmax
               nmed = 0
               resmedirt(1) = 0.0d0
               do m=max(ir-npts,1),min(ir+npts,nrmax)
                 nmed = nmed + 1
!!                 resmedirt(nmed) = resmeanrt(m)
                 resmedirt(1) = resmedirt(1) + resmeanrt(m)
               enddo
               if (nmed .ge. 1) then
!!                 reswork(ir) = selectk ( (nmed + 1) / 2, nmed, resmedirt )
                 reswork(ir) = resmedirt(1) / dble ( nmed )
               endif
             enddo
             do ir=1,nrmax
               resmeanrt(ir) = reswork(ir)
             enddo

             deallocate ( residual, resmedir, resmedirt, reswork )

             residualflux = 0.0d0
             
             do ir=1,nrmax
               foomin1 = 2.0d0 * rad(ir)
               foomin2 = 2.0d0 * rad(ir+1)
               foomax1 = foomin1 * elongation
               foomax2 = foomin2 * elongation

               do m=m1,m2
                 dblm = dble ( m )
                 do l=l1,l2
                   dbll = dble ( l )
                   
                   if (inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), quantity(i,n,ifooa)
     &                           , quantity(i,n,ifoob), quantity(i,n,ithet) )) then
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), foomax2, foomin2
     &                             , quantity(i,n,ithet) )) then
                       if (.not.inellipse ( dbll, dblm, dx, dy, quantity(1,n,ixcopx), quantity(1,n,iycopx), foomax1, foomin1
     &                                    , quantity(i,n,ithet) )) then

! For faint sources (such as the cores appearing in the 160 um image), noise and background fluctuations tend 
! to artificially enhance total fluxes. The next lines try to compensate for the bias by adding a smaller fraction 
! of the positive residuals for less significant sources.

                         if (resmeanrt(ir) .gt. 0.0d0) then
                           azimavresidual = resmeanrt(ir) * min ( snratio / snratiocrit, 1.0d0 )**2
                         else
                           azimavresidual = resmeanrt(ir)
                         endif
                         residualflux = residualflux + azimavresidual

                         if (quantity(i,n,igodm) .ge. goodminvar) then
                           moffatrt (l,m) = moffatrt (l,m) + azimavresidual
                           obscbrt  (l,m) = obscbrt  (l,m) - azimavresidual
                           obscbfsrt(l,m) = obscbfsrt(l,m) - azimavresidual
                           resmean(l,m) = resmean(l,m) + azimavresidual
                           restrue(l,m) = restrue(l,m) - azimavresidual
                         endif
                       endif
                     endif
                   endif
                 enddo
               enddo
             enddo
             
             totflux = (totflux + residualflux) * convftot

             deallocate ( rad, nptsrt, resmeanrt )
           endif
         enddo

         close ( 15 )
         
! Median filtering to smooth the resulting images.

!!         call medianfilter ( nx, ny, 1, nx, 1, ny, 1, footmask, obscbr )
!!         call medianfilter ( nx, ny, 1, nx, 1, ny, 1, footmask, obscbrt )
!!         call medianfilter ( nx, ny, 1, nx, 1, ny, 1, footmask, obscbfsr )
!!         call medianfilter ( nx, ny, 1, nx, 1, ny, 1, footmask, obscbfsrt )
!!         call medianfilter ( nx, ny, 1, nx, 1, ny, 1, footmask, restrue )
!!         call medianfilter ( nx, ny, 1, nx, 1, ny, 1, footmask, resmean )

         finbgrname = obsname(i)(1:iobs(i)-9)//'.fitshapes.res.true.fits'
         ifbr = lastc ( finbgrname )
    
         if (cverbose .eq. '-verb2')
     &     write (iotty,'(a)') '   Writing (true fluctuating) fitting residuals '''//finbgrname(1:ifbr)//''''
    
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, restrue, dx, dy, object
     &              , crval1, crval2, finbgrname(1:ifbr), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12, cd21
     &              , cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

         finbgrtname = obsname(i)(1:iobs(i)-9)//'.fitshapes.res.mean.fits'
         ifbrt = lastc ( finbgrtname )
    
         if (cverbose .eq. '-verb2')
     &     write (iotty,'(a)') '   Writing (azimuthally-averaged) fitting residuals '''//finbgrtname(1:ifbrt)//''''
    
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, resmean, dx, dy, object
     &              , crval1, crval2, finbgrtname(1:ifbrt), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12, cd21
     &              , cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

         finbgrtname = obsname(i)(1:iobs(i)-9)//'.fitshapes.bground.fits'
         ifbrt = lastc ( finbgrtname )
         
         if (cverbose .eq. '-verb2')
     &     write (iotty,'(a)') '   Writing (filamentary) background '''//finbgrtname(1:ifbrt)//''''

         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbrt, dx, dy, object
     &              , crval1, crval2, finbgrtname(1:ifbrt), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12, cd21
     &              , cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

!!         finbgfsrtname = obsname(i)(1:iobs(i)-9)//'.fitshapes.fsbground.fits'
!!         ifgrt = lastc ( finbgfsrtname )
!!         
!!         if (cverbose .eq. '-verb2')
!!     &     write (iotty,'(a)') '   Writing (filament-subtracted) background '''//finbgfsrtname(1:ifgrt)//''''
!!
!!         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbfsrt, dx, dy, object
!!     &              , crval1, crval2, finbgfsrtname(1:ifgrt), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12
!!     &              , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

         finmoffatrtname = obsname(i)(1:iobs(i)-9)//'.fitshapes.sources.fits'
         ifmrt = lastc ( finmoffatrtname )
         
         if (cverbose .eq. '-verb2')
     &     write (iotty,'(a)') '   Writing sources (as deblending shapes) '''//finmoffatrtname(1:ifmrt)//''''

         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, moffatrt, dx, dy, object
     &              , crval1, crval2, finmoffatrtname(1:ifmrt), cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12
     &              , cd21, cd22, equinox, bzero, bscale, wave, datamin, datamax, history )

         if (.not.ltruebs) then
           deallocate ( obsfscbimage )
         else
           deallocate ( obsfsbsimage )
         endif
       enddo

       deallocate ( obsimage, obsfsimage, obscbrt, obscbfsrt, restrue, resmean, resskew, reskurt, resskewx
     &            , reskurtx, moffatrt, footmask, chisq, betax, fitlev, bkglev )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine updatecatsflagbads
       
     &            ( iotty, cverbose, nwavemax, nwaves, cat, icat, nextr, nhead, cno, quantity, isigg, iscsx, iafwh, ibfwh
     &            , iasiz, ibsiz, ithet, ifooa, ifoob, iflag, ifmon, sfg, sfm, catsubstruc, icats, nconfigend, headline
     &            , headlineout, catline, comment, ncolskipsigg, ncolskipfsflg, ncolskipssx, ncolskipasi, ncolskipfmflg
     &            , ncolskipfoo, lfinishing_mode, lhandlesubstruc )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       
       logical       lfinishing_mode, lhandlesubstruc
       
       character*3   cfmon, cfsflag
       character*5   cfmflag
       character*(*) cno(*), cat(*), comment(*), cverbose, catsubstruc, headlineout(*)
       
       integer       lastc, iotty, nwavemax, nwaves, i, j, k, m, lh, lhl, lcl, lcno, icats, iflag, ifmon, ncolumn, nconfigend
     &             , iscsx, iafwh, ibfwh, ifooa, ifoob, ncolskipfsflg, ncolskipssx, ncolskipasi, ncolskipfmflg, ncolskipfoo
     &             , ncolskipsigg, nsubstruc, iasiz, ibsiz, ithet, isigg, icat(*), nhead(*), nextr(*), sfm(nwaves,*), sfg(*)

       character*(*) headline(nwavemax,*), catline(nwaves,*)
       
       real*8        quantity(nwaves,nextr(1),*)
       
       external      lastc
!__________________________________________________________________________________________________________________________________
!
       do i=1,nwaves       
         
         if (cverbose .eq. '-verb2')
     &     write (iotty,'(a)') '   Updating catalog '''//cat(i)(1:icat(i))//''''
      
         open ( 15, file=cat(i)(1:icat(i)), status='unknown' )
      
         m = 0
         do k=1,nhead(i)
           lhl = lastc ( headline(i,k) )
           ncolumn = index ( headline(i,k)(1:lhl), '# Configuration parameters ' )
           if (ncolumn .eq. 0) then
             ncolumn = index ( headline(i,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
           endif
           if (ncolumn .gt. 0 .or. (m .gt. 0 .and. m .le. nconfigend)) then
             m = m + 1
             lh = lastc ( headlineout(m) )
             write (15,'(a)') '#'//headlineout(m)(2:lh)
           else
             write (15,'(a)') headline(i,k)(1:lhl)
           endif
         enddo

         lcl = lastc ( headline(i,nhead(i)-1) )
         
         do j=1,nextr(i)
           catline(i,j)(1:1) = cno(j)(1:1)                                                                                                       
           lcno = lastc ( comment(j) ) - 1

           write (cfsflag,'(i3)') sfg(j) * nint ( quantity(i,j,iflag) )
           if (sfg(j) .eq. -1 .and. cfsflag .eq. '  0') cfsflag = ' -0'

           write (cfmflag,'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
           if (sfm(i,j) .eq. -1 .and. cfmflag .eq. '    0') cfmflag = '   -0'

! Update the values of FS, FOOAMAJO, FOOBMINO, and foots modified above.

           write (catline(i,j)(ncolskipsigg+1:ncolskipsigg+11),'(1pe11.3)') quantity(1,j,isigg)
           write (catline(i,j)(ncolskipfsflg+1:ncolskipfsflg+3),'(a3)') cfsflag
           write (catline(i,j)(ncolskipfmflg+1:ncolskipfmflg+5),'(a5)') cfmflag
           write (catline(i,j)(ncolskipssx+1:ncolskipssx+33),'(3(1pe11.3))') 
     &           quantity(i,j,iscsx), quantity(i,j,iafwh), quantity(i,j,ibfwh)
           write (catline(i,j)(ncolskipasi+1:ncolskipasi+33),'(3(1pe11.3))') 
     &           quantity(i,j,iasiz), quantity(i,j,ibsiz), quantity(i,j,ithet)
           write (catline(i,j)(ncolskipfoo+1:ncolskipfoo+22),'(2(1pe11.3))') 
     &           quantity(i,j,ifooa), quantity(i,j,ifoob)
           write (15,'(a)') catline(i,j)(1:lcl+11)//comment(j)(1:lcno)
         enddo

         close ( 15 )
       enddo
       
       nsubstruc = 0

       if (lfinishing_mode .and. lhandlesubstruc) then
         
         do i=1,nwaves       
           
           catsubstruc = cat(i)(1:icat(i)-4)//'.substruc.cat'
           icats = lastc ( catsubstruc )
           
           do j=1,nextr(i)
             write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
             if (cno(j)(1:1) .eq. '!' .and. cfmon(1:1) .eq. '1') then
               nsubstruc = nsubstruc + 1
               exit
             endif
           enddo
           if (cverbose .eq. '-verb2')
     &       write (iotty,'(a)') '   Updating catalog '''//catsubstruc(1:icats)//''''
        
           open ( 17, file=catsubstruc(1:icats), status='unknown' )
        
           m = 0
           do k=1,nhead(i)
             lhl = lastc ( headline(i,k) )
             ncolumn = index ( headline(i,k)(1:lhl), '# Configuration parameters ' )
             if (ncolumn .eq. 0) then
               ncolumn = index ( headline(i,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
             endif
             if (ncolumn .gt. 0 .or. (m .gt. 0 .and. m .le. nconfigend)) then
               m = m + 1
               lh = lastc ( headlineout(m) )
               write (17,'(a)') '#'//headlineout(m)(2:lh)
             else
               write (17,'(a)') headline(i,k)(1:lhl)
             endif
           enddo

           lcl = lastc ( headline(i,nhead(i)-1) )
         
           do j=1,nextr(i)
             write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
             if (cfmon(1:1) .eq. '1') then
               catline(i,j)(1:1) = ' '
               lcno = lastc ( comment(j) ) - 1

               write (cfsflag,'(i3)') sfg(j) * nint ( quantity(i,j,iflag) )
               if (sfg(j) .eq. -1 .and. cfsflag .eq. '  0') cfsflag = ' -0'

               write (cfmflag,'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
               if (sfm(i,j) .eq. -1 .and. cfmflag .eq. '    0') cfmflag = '   -0'

! Update the values of FS, FOOAMAJO, FOOBMINO, and foots modified above.

               write (catline(i,j)(ncolskipsigg+1:ncolskipsigg+11),'(1pe11.3)') quantity(1,j,isigg)
               write (catline(i,j)(ncolskipfsflg+1:ncolskipfsflg+3),'(a3)') cfsflag
               write (catline(i,j)(ncolskipfmflg+1:ncolskipfmflg+5),'(a5)') cfmflag
               write (catline(i,j)(ncolskipssx+1:ncolskipssx+33),'(3(1pe11.3))') 
     &               quantity(i,j,iscsx), quantity(i,j,iafwh), quantity(i,j,ibfwh)
               write (catline(i,j)(ncolskipasi+1:ncolskipasi+33),'(3(1pe11.3))') 
     &               quantity(i,j,iasiz), quantity(i,j,ibsiz), quantity(i,j,ithet)
               write (catline(i,j)(ncolskipfoo+1:ncolskipfoo+22),'(2(1pe11.3))')
     &               quantity(i,j,ifooa), quantity(i,j,ifoob)
               write (17,'(a)') catline(i,j)(1:lcl)//comment(j)(1:lcno)
             endif
           enddo
        
           close ( 17 )
         enddo
       endif
       
       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
       
       subroutine medianfilter 
         
     &            ( nx, ny, l1, l2, m1, m2, npoints, mask, image )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       integer       nx, ny, l1, l2, m1, m2, l, m, j, k, npoints, nk, n1, n2, k1, k2
       real*8        selectk, mask(nx,ny), image(nx,ny), worker(nx,ny), funx((2*npoints+1)*(2*npoints+1))
       external      selectk
!__________________________________________________________________________________________________________________________________
!
       do m=m1,m2
         do l=l1,l2
           worker(l,m) = image(l,m)
         enddo
       enddo
       do m=m1,m2
         n1 = max ( m - npoints, m1 )
         n2 = min ( m + npoints, m2 )
         do l=l1,l2
           if (mask(l,m) .gt. 0.9d0) then
             k1 = max ( l - npoints, l1 )
             k2 = min ( l + npoints, l2 )
             nk = 0
             do k=k1,k2
               do j=n1,n2
                 if (mask(k,j) .gt. 0.9d0) then
                   nk = nk + 1
                   funx(nk) = worker(k,j)
                 endif
               enddo
             enddo
             if (nk .ne. 0) then
               image(l,m) = selectk ( (nk + 1) / 2, nk, funx )
             endif
           endif
         enddo
       enddo
         
       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, iotty, iolog, creator
     &            , beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamn, datamx
     &            , history, cverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       
       logical       simple, extend, anynull, myfile
       character*3   cnan
       character*25  cdatetime
       character*80  comment
       character*(*) ctype1, ctype2, creator, fname, bunit, object, history, cverbose
       
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, iotty, iolog, maxdim, rw
     &             , nfound, blank, stat05, stat06, stat07, stat08, stat09, stat10, stat11, stat12, stat13, stat14, stat15, stat16
     &             , stat17, stat18, stat19, stat20, stat21, stat22, stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30
     &             , stat31, stat32, stat0
       
       parameter   ( maxdim = 2 )
       
       integer       naxes(maxdim)
       
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22, almostzero, as2deg, datamx, datamn, sign1, arg1, arg2, argm
     &             , sinrota, cosrota, pi, angle
       
       real*8        fun(nx,ny)
       
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       
       external      ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr, ftgkyj, ftg2dd
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

!!       call ftgphx ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, bscale, bzero, blank, nblank, stat )

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:21) .eq. 'Alexander Menshchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'FINALCAT'
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. Maybe
! there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat0 = stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15 + stat16 + stat17 + stat18
     &       + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28 + stat30 + stat31

       if (cverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = '<Name>'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       if (stat17 .ne. 0) then
         rot2 = 0.0d0
       endif
       rot1 = rot2

       if (stat29 .eq. 0 .and. stat30 .ne. 0) then
         equinox = epoch
       endif

! CDELT* is absent or error.

       if (stat24 .ne. 0 .or. stat25 .ne. 0) then

! CD1* and CD2* are defined correctly: determine CDELT* and ROTA*.

         if (stat18 .eq. 0 .and. stat19 .eq. 0 .and. stat20 .eq. 0 .and. stat21 .eq. 0) then
           sign1 = sign ( 1.0d0, cd11 * cd22 - cd12 * cd21 )
           dxdeg = sign1 * sqrt ( cd11**2 + cd21**2 )
           dydeg = sqrt ( cd12**2 + cd22**2 )
           arg1 = sign1 * cd12 / cd22
           arg2 = -sign1 * cd21 / cd11
           argm = (arg1 + arg2) / 2.0d0
           if (abs ( arg1 - arg2 ) / argm .gt. 1.0d-10) then
             write (iotty,'(/a/)') '   RFITS: WARNING: Coordinate axes are not orthogonal'
           endif
           rot2 = atan ( argm )
           sinrota = sin ( rot2 )
           cosrota = cos ( rot2 )
           rot2 = rot2 * 180.0d0 / pi
           if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
             rot1 = rot2
           elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
             rot1 = 180.0d0 - rot2
           elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
             rot1 = 180.0d0 + rot2
           elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
             rot1 = - rot2
           endif
           rot2 = rot1
         endif
       endif

! CD1* and CD2* are absent or error.

       if (stat18 .ne. 0 .or. stat19 .ne. 0 .or. stat20 .ne. 0 .or. stat21 .ne. 0) then

! CDELT* are defined correctly: determine CD1* and CD2*.

         if (stat24 .eq. 0 .and. stat25 .eq. 0) then
           angle = rot2 * pi / 180.0d0
           cd11 = dxdeg * cos ( angle )
           cd12 = abs ( dydeg ) * sign ( 1.0d0, dxdeg ) * sin ( angle )
           cd21 = - abs ( dxdeg ) * sign ( 1.0d0, dydeg ) * sin ( angle )
           cd22 = dydeg * cos ( angle )
           if (abs ( cd12 ) .lt. almostzero) cd12 = 0.0d0
           if (abs ( cd21 ) .lt. almostzero) cd21 = 0.0d0
         endif
       endif

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       cnan = 'NAN'
       do j=1,ny
         do i=1,nx
           if (.not.isnan ( fun(i,j) )) then
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
           if (int ( fun(i,j) ) .eq. blank .and. blank .ne. 0) then  
             read (cnan,*) fun(i,j)
           endif
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, cdate
     &            , ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamn, datamx
     &            , history )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, rot1, rot2, equinox, datamn
     &             , datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      fdelete, ftgiou, ftinit, ftphpr, ftpkys, ftpcom, ftpkyd, ftpkyj, ftphis, ftp2dd, ftclos, ftfiou, printerr
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny
       
! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           if (.not.isnan ( fun(i,j) )) then
             if (fun(i,j) .lt. datamn ) datamn = fun(i,j)
             if (fun(i,j) .gt. datamx ) datamx = fun(i,j)
           endif
         enddo
       enddo

! When packing numbers using the formulas below, I got values of the function different in the 5-th digit from DATAMIN and
!  DATAMAX placed in the header when writing the data. From now on I will use bzero = 0 bscale = 1 and bitpix = -32, as these
! seem to cure the problem.

cc!      bitpix = 16
cc!      bzero  = 0.5d0 * (funmin + funmax)
cc!      bscale = dabs ( funmax - bzero ) / 32767.0d0

       bitpix = -32     !<-- single precision floating-point values
       bzero  = 0.0d0
       bscale = 1.0d0
       blank = blank

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Menshchikov, DAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = - dx * as2deg
       dydeg = dy * as2deg

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
!!       if  (blank .gt. 0)
!!     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , dxdeg , 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, 'equinox', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||