!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program fmeasure
!__________________________________________________________________________________________________________________________________
!
! Measure and catalog properties of filaments.
!
! GETSF • Multi-Scale Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay  
!__________________________________________________________________________________________________________________________________
!                 
       implicit      none

       logical      inellipse, lfnama, lfnamb, lunix, ldone, ldebug, lsidea, lsideb, lnobranches, lfnvers

       character*2   cnpw
       character*3   dot
       character*4   cnextr, clk1, clk2, clk3, clk
       character*5   cnmax
       character*6   cfitsversion, cverbose, ck
       character*7   clibname, cx, cy, regcolor
       character*8   ctime, cfpptime, cdistpc
       character*10  cdate
       character*21  compda
       character*80  object, bunit, bunit1, bunit2, ctype1, ctype2, ctype11, ctype12, ctype21, ctype22, object1, object2, creator
     &             , history, history1, history2
       character*128 cathead0
       character*141 getstitle
       character*165 cbars
       character*500 filenama, filenamb, outname, filename, individprofs, individimages, path, arg1, arg2, arg3, arg4, arg5, arg6
     &             , arg7, arg8, arg9, versfile

       integer       firstb, lastc, lasts, i, j, fnlen1, fnlen2, nx, ny, nx1, ny1, nx2, ny2, ia1, ia2, ia3, ia4, ia5, ia6, ia7, ia8
     &             , ia9, isp1, isp2, blank, blank1, blank2, irc, lb, nextr, k, m, iotty, l, ll, idp, npxmax, ipd, ipn, npw, npa
     &             , npts, ia, ib, ja, jb, n, indp, iopa, lm1, lp1, idot1, idot2, idot3, ion, is1, npxstep, ndate, npta, ipw, nptb
     &             , nptsa, nptsb, nptsm, lk1, ilc0, nsel, i1, j1, i2, j2, ncx, ncy, l1, l2, npwm, m1, m2, lver, npts3, nptsa3
     &             , nptsb3, nptsm3, isc, indi, ind, nck

       real          fitsvers
       real*8        selectk, dx, dy, dx1, dy1, dx2, dy2, ra, dec, beam, imagelow, imagehalf, dxp, dyp, funmin1, funmax1, xmu, xmH
     &             , beam1, beam2, equinox, equinox1, equinox2, ra1, ra2, dec1, dec2, bzero, bscale, dr
     &             , bzero1, bzero2, bscale1, bscale2, funmin2, funmax2, crpix11, crpix12, crval11, crval12, datamin1, datamax1
     &             , crpix1, crpix2, crval1, crval2, crota11, crota12, crota1, crota2, datamin2, datamax2, datamin, datamax, dist
     &             , crpix21, crpix22, crval21, crval22, crota21, crota22, cd11, cd12, cd21, cd22, wave, wave1, wave2, almostzero
     &             , cd111, cd112, cd121, cd122, cd211, cd212, cd221, cd222, segmlen, pi, dxdt, dydt, d2xdt2, dbll, xo, yo
     &             , d2ydt2, dxm, dym, dxt, dyt, dxmdt, dxpdt, dymdt, dypdt, distm, distp, distt, curvsmo, hwhm, sigm2g, dblm
     &             , dely, rad2, argex, xa, ya, xb, yb, dr1, dr2, sqpixel, x1, y1, x2, y2, dlogim, radius2, drad2, sigm2, hwidthza
     &             , hwidthzb, factnpt, distpc, as2pc, slopemeanmax, slopemeanamax, slopemeanbmax, slopemedianmax, slopemedianamax
     &             , slopemedianbmax, slopeamax, slopebmax, xMsun, drad, flength, wmed, wmeda, wmedb, wmean, flenas, wmedas
     &             , wmeana, wmeanb, wmeastd, wmeastda, wmeastdb, flindenp, flindenm, flindstd, filmass, au2cm, distok, dist1
     &             , distn, footmajora, footminora, footmajorb, footminorb, flindena, flindenb, dista, distb, filmassa, filmassb
     &             , flindenpa, flindenpb, nmaskamea, nmaskbmea, nmaskamed, nmaskbmed

       character*11, allocatable :: cxpixm(:), cypixm(:)
       character*200, allocatable :: cathead(:)

       integer, allocatable :: npixfil(:), iwidth(:,:), ihwidtha(:,:), ihwidthb(:,:), np(:), napa(:), nama(:), navpa(:), navma(:)
     &                       , napb(:), namb(:), navpb(:), navmb(:), nap(:), nam(:), navp(:), navm(:), ilc(:), navc(:), nptw(:)
     &                       , nptwa(:), nptwb(:), nwin(:), ix(:), iy(:)

       real*8, allocatable :: imagefil(:,:), imageske(:,:), filmean(:,:), pixd(:), xpix(:), ypix(:), xpixok(:,:), ypixok(:,:)
     &                      , pixdist(:,:), normals(:,:), rad(:), profilea(:,:), profileb(:,:), xpixmean(:,:), ypixmean(:,:)
     &                      , length(:), cosa(:,:), sina(:,:), cosb(:,:), sinb(:,:), profmeana(:), profmeanb(:), profmeasdpa(:)
     &                      , profmeasdma(:), profmeasdpb(:), profmeasdmb(:), profmean(:), profmeasdp(:), profmeasdm(:)
     &                      , widthmean(:), widthstd(:), hwidtha(:,:), hwidthb(:,:)
     &                      , sangle(:,:), nanglea(:,:), nangleb(:,:), curvature(:,:), curvmean(:), curvstd(:), curvtota(:)
     &                      , curvmedi(:), funmed(:), worker(:,:), curvsmoo(:,:), profmediana(:), profmedianb(:), profmedsdpa(:)
     &                      , profmedsdpb(:), profmedsdma(:), profmedsdmb(:), profmedian(:), profmedsdp(:), profmedsdm(:)
     &                      , profmeda(:), profmedb(:), widsmo(:), slopemeana(:)
     &                      , slopemeanb(:), slopemean(:), slopemediana(:), slopemedianb(:), slopemedian(:), crestmed(:), maska(:)
     &                      , widthmeana(:), widthmeanb(:), width(:,:), widthstda(:), widthstdb(:), profile(:,:), profa(:), profb(:)
     &                      , maskb(:), slopea(:), slopeb(:), nmaska(:), nmaskb(:), widthmed(:), widthmeda(:), lindenma(:)
     &                      , widthmedb(:), creststd(:), lindentwo(:), lindenm(:), lindenmb(:), lindenp(:), lindstd(:), cosx(:,:)
     &                      , filamass(:), snrwmea(:), snrwmeaa(:), snrwmeab(:), snrlind(:), widtha(:,:), widthb(:,:), sinx(:,:)
     &                      , lindena(:,:), lindenb(:,:), filamasa(:), filamasb(:), foota(:,:), footb(:,:), lindenpa(:)
     &                      , lindenpb(:), lindentwa(:), lindentwb(:)

       parameter   ( iotty = 6, almostzero = 1.0d-30, factnpt = 3.0d0, pi = 3.14159265358979d0, dot = '•' )

       parameter   ( xmu = 2.8, xmH = 1.6726E-24, au2cm = 1.495978707e13, xMsun = 1.98892e+33 )      !!, pc2cm = 3.085678e+18

       external      firstb, lastc, selectk, rfits, wfits, when, inellipse, osystem, ftvers, lasts, getfitshead, makedir, slopes
     &             , traceskels
!__________________________________________________________________________________________________________________________________
!
! Determine operating system

       call osystem ( lunix )
       call ftvers ( fitsvers )
       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       cfpptime = cfpptime(1:5)
       compda = __DATE__//' '//cfpptime

! Get command line parameters (file names).

       call getarg ( 1, arg1 )
       call getarg ( 2, arg2 )
       call getarg ( 3, arg3 )
       call getarg ( 4, arg4 )
       call getarg ( 5, arg5 )
       call getarg ( 6, arg6 )
       call getarg ( 7, arg7 )
       call getarg ( 8, arg8 )
       call getarg ( 9, arg9 )

       ia1 = lastc ( arg1 )
       ia2 = lastc ( arg2 )
       ia3 = lastc ( arg3 )
       ia4 = lastc ( arg4 )
       ia5 = lastc ( arg5 )
       ia6 = lastc ( arg6 )
       ia7 = lastc ( arg7 )
       ia8 = lastc ( arg8 )
       ia9 = lastc ( arg9 )

       cverbose = '-verb2'
       if (ia9 .gt. 0 .and. arg9(1:ia9-1) .eq. '-verb') cverbose = arg9(1:ia9)
       if (ia8 .gt. 0 .and. arg8(1:ia8-1) .eq. '-verb') cverbose = arg8(1:ia8)
       if (ia7 .gt. 0 .and. arg7(1:ia7-1) .eq. '-verb') cverbose = arg7(1:ia7)

       if (cverbose .eq. '-verb2') then
         write (iotty,'( )')
         if (arg1(1:ia1) .eq. ':') write (iotty,'(a$)') ' '
         write (iotty,'(a$)') ' FMEASURE '//dot//' Measure & Catalog Filaments '//dot//' '//compda
       endif
       if (arg1(1:ia1) .eq. ':') stop
       if (cverbose .eq. '-verb2') then
         write (iotty,'( )')
         write (iotty,'(a)') ' Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
         write (iotty,'(a)') ' Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       endif
       if (ia6 .eq. 0 .or. arg6(1:2) .eq. '-o' .or. arg6(1:2) .eq. '-v') then
         write (iotty,'( )')   
         write (iotty,'(a)') ' fmeasure <filaments> <segskels> <distpc> [+]<npxstep> <regcolor> <outpath> [-o <outname>]'
     &                     //' [-verb{0|1|2}]'
         write (iotty,'( )')   
         write (iotty,'(a)') ' This is a GETSF utility that computes profiles and many other'
         write (iotty,'(a)') ' properties of filaments. <FILAMENTS> & <SEGSKELS> are input images'
         write (iotty,'(a)') ' of the filaments and of the segmented skeletons produced by GETSF.'
         write (iotty,'(a)') ' <DISTPC> is the distance (pc) to the region imaged; distance = 0 is'
         write (iotty,'(a)') ' ignored, which means that quantities that depend on distance (such'
         write (iotty,'(a)') ' as linear sizes and masses) are not computed. <NPXSTEP> is the step'
         write (iotty,'(a)') ' over skeleton pixels: an interval by which profiles are separated'
         write (iotty,'(a)') ' along the skeletons. An optional "+" sign signals to the code that'
         write (iotty,'(a)') ' a user wants to produce more catalogs and images than by default.'
         write (iotty,'(a)') ' <regcolor> is the color of skeletons in the DS9 region files created,'
         write (iotty,'(a)') ' one of the following: red green blue cyan magenta brown orange gold'
         write (iotty,'(a)') ' yellow white black. <OUTPATH> is a path, where the output images and'
         write (iotty,'(a)') ' catalogs are placed; if it does not exist, it will be created. The'
         write (iotty,'(a)') ' optional <OUTNAME> allows the user to change the default output'
         write (iotty,'(a)') ' names. -VERB# defines verbosity level.'
         stop 99
       endif
       cbars = '#_______________________________________________________________________________________________________________'
     &       //'_____________________________________________________'

       versfile='+log.VERSION'
       lver = lastc ( versfile )
       getstitle='# GETSF '//dot//' Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men''shchikov,'
     &                     //' DAp IRFU CEA Saclay'
       inquire ( file=versfile(1:lver), exist=lfnvers )
       if (lfnvers) then
         open ( 25, file=versfile(1:lver), status='old' )
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading version file '''//versfile(1:lver)//''''
         do i=1,3
           read (25,'(a)',end=67,err=61) getstitle
         enddo
         getstitle = getstitle(1:1)//getstitle(4:)
         goto 67
  61     continue
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble reading file '''//versfile(1:lver)//'''.'
         close (25)
         stop 32
  67     continue
         close (25)
       else        
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') '   FMEASURE: WARNING: File '''//versfile(1:lver)//''' not found.'
       endif

       filenama = arg1(1:ia1)
       fnlen1 = lastc ( filenama )
       
       filenamb = arg2(1:ia2)
       fnlen2 = lastc ( filenamb )
       
       cdistpc = arg3(1:ia3)
       idp = ia3
       read (cdistpc(1:idp),*,err=8) distpc
       as2pc = 4.848074355e-6 * distpc   !<-- conversion factor from arcseconds to parsecs
       
       ldebug = .false.
       if (arg4(1:1) .eq. '+') ldebug = .true.
       read (arg4(1:ia4),'(i5)',err=9) npxstep


!!       npxstep = 1


       regcolor = arg5(1:ia5)
       isc = lastc ( regcolor )

       path = arg6(1:ia6)
       iopa = lastc ( path )

! Check if the input file exists and open it.

       inquire ( file=filenama(1:fnlen1), exist=lfnama )
       if (.not.lfnama .and. filenama(fnlen1-4:fnlen1) .ne. '.fits') then
         filenama = filenama(1:fnlen1)//'.fits'
         fnlen1 = lastc ( filenama )
         inquire ( file=filenama(1:fnlen1), exist=lfnama )
       endif

! Check if the input file exists and open it.

       inquire ( file=filenamb(1:fnlen2), exist=lfnamb )
       if (.not.lfnamb .and. filenamb(fnlen2-4:fnlen2) .ne. '.fits') then
         filenamb = filenamb(1:fnlen2)//'.fits'
         fnlen2 = lastc ( filenamb )
         inquire ( file=filenamb(1:fnlen2), exist=lfnamb )
       endif
                             
       isp1 = lasts ( filenama ) + 1
       isp2 = lasts ( filenamb ) + 1
       
       idot1 = index ( filenamb(isp2:fnlen2-5), '.' )
       idot2 = index ( filenamb(isp2+idot1:fnlen2-5), '.' ) + idot1
       idot3 = index ( filenamb(isp2+idot2:fnlen2-5), '.' ) + idot2

       if (arg7(1:2) .eq. '-o') then
         outname = arg8
         ion = lastc ( outname )
         is1 = lasts ( outname ) + 1
         if (outname(max(ion-4,1):ion) .eq. '.fits') then
           outname = outname(is1:ion-5)
         else
           outname = outname(is1:ion)
         endif
       else
         outname = filenama(isp1:fnlen1-5)//'~'//filenamb(isp2+idot3:fnlen2-5)
       endif
       ion = lastc ( outname )
       
       if (cverbose .eq. '-verb1') write (iotty,'(/a)') ' FMEASURE: '//filenama(isp1:fnlen1-5)//' '//filenamb(isp2:fnlen2-5)
     &                                                //' '//arg3(1:ia3)//' '//arg4(1:ia4)//' '//path(1:iopa)
       if (.not.lfnama) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: File '''//filenama(1:fnlen1-5)//''' not found.'
         stop 1
       endif
       if (.not.lfnamb) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: File '''//filenamb(1:fnlen2-5)//''' not found.'
         stop 2
       endif
       goto 10
   8   continue
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble reading DISTPC from command line.'
         stop 3
   9   continue
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble reading NPXSTEP from command line.'
         stop 4
  10   continue       

! Determine numbers of pixels in the FITS image.

       call getfitshead ( filenama(1:fnlen1), nx1, ny1, dx1, dy1, bunit )

! Allocate the image arrays.
       
       allocate ( imagefil(nx1,ny1), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (10).'
         stop 10
       endif
       
       write (cx,'(i7)') nx1
       write (cy,'(i7)') ny1
       ncx = int ( log10 ( dble ( nx1 ) ) ) + 1
       ncy = int ( log10 ( dble ( ny1 ) ) ) + 1

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading filaments ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                               //filenama(1:fnlen1)//''''

       call rfits ( nx1, ny1, bunit1, ctype11, ctype12, crpix11, crpix12, crval11, crval12, imagefil, dx1, dy1, object1, ra1
     &            , dec1, filenama(1:fnlen1), iotty, 0, creator, beam1, funmin1, funmax1, blank1, crota11, crota12, cd111, cd112
     &            , cd121, cd122, equinox1, bzero1, bscale1, wave1, datamin1, datamax1, history1, cverbose )

       if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin1, funmax1

! Determine numbers of pixels in the FITS image.

       call getfitshead ( filenamb(1:fnlen2), nx2, ny2, dx2, dy2, bunit )

       allocate ( imageske(nx2,ny2), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (20).'
         stop 20
       endif

       write (cx,'(i7)') nx2
       write (cy,'(i7)') ny2
       ncx = int ( log10 ( dble ( nx2 ) ) ) + 1
       ncy = int ( log10 ( dble ( ny2 ) ) ) + 1

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Reading skeletons ('//cx(7-ncx+1:7)//' x '//cy(7-ncy+1:7)//') '''
     &                                               //filenamb(1:fnlen2)//''''

       call rfits ( nx2, ny2, bunit2, ctype21, ctype22, crpix21, crpix22, crval21, crval22, imageske, dx2, dy2, object2, ra2, dec2
     &            , filenamb(1:fnlen2), iotty, 0, creator, beam2, funmin2, funmax2, blank2, crota21, crota22, cd211, cd212, cd221
     &            , cd222, equinox2, bzero2, bscale2, wave2, datamin2, datamax2, history2, cverbose )

       if (cverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin2, funmax2

       if (beam1 .eq. beam2) then
         beam = beam1
       else
         beam = 0.0d0
       endif

       if (nx1 .ne. nx2 .or. ny1 .ne. ny2) then
         write (iotty, '(/a)') '   FMEASURE: ERROR: The images have different numbers of pixels:'
         write (iotty, '(a )') '                   '//filenama(1:fnlen1)
         write (iotty, '(a )') '                   '//filenamb(1:fnlen2)
         stop 3
       endif
       nx = nx1
       ny = ny1
       bunit = bunit1
       ctype1 = ctype11
       ctype2 = ctype12
       dx = dx1
       dy = dy1
       crpix1 = crpix11
       crpix2 = crpix12
       crval1 = crval11
       crval2 = crval12
       blank = blank1
       crota1 = crota11
       crota2 = crota12
       cd11 = cd111
       cd12 = cd112
       cd21 = cd121
       cd22 = cd122
       equinox = equinox1
       object = object1
       ra = ra1
       dec = dec1
       bzero = bzero1
       bscale = bscale1
       wave = wave1
       history = history1
       sqpixel = dx * dy

       nextr = nint ( funmax2 )
       if (nextr .eq. 0 .or. funmax1 .lt. almostzero) goto 999

! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )

       ind = lasts ( path(1:iopa) )
       if (path(ind+1:ind+1) .eq. '~') then
         individprofs = path(1:ind-1)//'/+profiles/'//path(ind+2:iopa)
         individimages = path(1:ind-1)//'/+images/'//path(ind+2:iopa)
       else
         ind = lastc ( path(1:iopa) )
         individprofs = path(1:ind)//'/+profiles'
         individimages = path(1:ind)//'/+images'
       endif
       indp = lastc ( individprofs )
       indi = lastc ( individimages )
       
       call makedir ( individprofs(1:indp) )
       call makedir ( individimages(1:indi) )

       open (44, file=individprofs(1:indp)//'/+README', status='unknown', err=24 )
       goto 25
 24    continue
       write (iotty,'(/a)') '   FMEASURE: ERROR: Directory '''//individprofs(1:indp)//''' does not exist?..'
       stop 99
 25    continue
       write (44,'(a)') cbars
       write (44,'(a)') '#'
       write (44,'(a)') '#'//getstitle(2:)
       write (44,'(a)') cbars
       write (44,'(a)') '#'
       write (44,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FMEASURE compiled on '//compda
       write (44,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (44,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence'
     &                //' (william.d.pence@nasa.gov)'
       write (44,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
       write (44,'(a)') '#'
       write (44,'(a)') '# This directory contains catalogs of various measurements of filaments,'
       write (44,'(a)') '# created by the following command:'
       write (44,'(a)') '#'
       write (44,'(a)') '# fmeasure '//arg1(1:ia1)//' '//arg2(1:ia2)//' '//arg3(1:ia3)//' '//arg4(1:ia4)//' '//arg5(1:ia5)
     &                //' '//arg6(1:ia6)//' '//arg7(1:ia7)//' '//arg8(1:ia8)//' '//arg9(1:ia9)
       close (44)
     
       open (44, file=individimages(1:indi)//'/+README', status='unknown', err=241 )
       goto 251
 241   continue
       write (iotty,'(/a)') '   FMEASURE: ERROR: Directory '''//individimages(1:indi)//''' does not exist?..'
       stop 99
 251   continue
       write (44,'(a)') cbars
       write (44,'(a)') '#'
       write (44,'(a)') '#'//getstitle(2:)
       write (44,'(a)') cbars
       write (44,'(a)') '#'
       write (44,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FMEASURE compiled on '//compda
       write (44,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (44,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence'
     &                //' (william.d.pence@nasa.gov)'
       write (44,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
       write (44,'(a)') '#'
       write (44,'(a)') '# This directory contains images related to various measurements of filaments,'
       write (44,'(a)') '# created by the following command:'
       write (44,'(a)') '#'
       write (44,'(a)') '# fmeasure '//arg1(1:ia1)//' '//arg2(1:ia2)//' '//arg3(1:ia3)//' '//arg4(1:ia4)//' '//arg5(1:ia5)
     &                //' '//arg6(1:ia6)//' '//arg7(1:ia7)//' '//arg8(1:ia8)//' '//arg9(1:ia9)
       close (44)
     
       allocate ( pixdist(nx,ny), np(nextr), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (30).'
         stop 30
       endif

! Find number of pixels belonging to each filament.

       npxmax = 0
       do k=1,nextr
         np(k) = 0
         do j=1,ny
           do i=1,nx
             if (k .eq. nint ( imageske(i,j) )) then
               np(k) = np(k) + 1
             endif
           enddo
         enddo
         if (np(k) .gt. npxmax) npxmax = np(k)
       enddo
       write (cnmax,'(i5)') npxmax
         
       allocate ( npixfil(nextr), xpix(npxmax), ypix(npxmax), pixd(npxmax), xpixok(nextr,npxmax), ypixok(nextr,npxmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (40).'
         stop 40
       endif

       call traceskels ( nx, ny, imageske, filenamb(1:fnlen2), iotty, nextr, npixfil, np, xpix, ypix, xpixok, ypixok, pixd
     &                 , pixdist, cverbose, almostzero, lnobranches )

       allocate ( iwidth(nextr,npxmax), ihwidtha(nextr,npxmax), ihwidthb(nextr,npxmax), hwidtha(nextr,npxmax), hwidthb(nextr,npxmax)
     &          , length(nextr), xpixmean(nextr,npxmax), ypixmean(nextr,npxmax), cosa(nextr,npxmax), sina(nextr,npxmax)
     &          , cosb(nextr,npxmax), sinb(nextr,npxmax), sangle(nextr,npxmax), nanglea(nextr,npxmax), nangleb(nextr,npxmax)
     &          , curvature(nextr,npxmax), curvmean(nextr), curvstd(nextr), navc(nextr), nptw(nextr), nptwa(nextr), crestmed(nextr)
     &          , curvtota(nextr), nptwb(nextr), curvmedi(nextr), funmed(npxmax), curvsmoo(nextr,npxmax), width(nextr,npxmax)
     &          , creststd(nextr), lindentwo(npxmax), lindenm(nextr), lindenma(nextr), lindenmb(nextr), lindenp(nextr)
     &          , lindstd(nextr), filamass(nextr), snrwmea(nextr), snrwmeaa(nextr), snrwmeab(nextr), widtha(nextr,npxmax)
     &          , cosx(nextr,npxmax), sinx(nextr,npxmax), widthb(nextr,npxmax), lindena(nextr,npxmax), lindenb(nextr,npxmax)
     &          , snrlind(nextr), filamasa(nextr), filamasb(nextr), lindenpa(nextr), lindenpb(nextr), lindentwa(npxmax)
     &          , lindentwb(npxmax), cxpixm(npxmax), cypixm(npxmax), ix(npxmax), iy(npxmax), stat=irc )    !!, color(nextr)

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (50).'
         stop 50
       endif
       
       do k=1,nextr
         do m=1,npxmax
           iwidth(k,m) = 0
           ihwidtha(k,m) = 0
           ihwidthb(k,m) = 0
           xpixmean(k,m) = 0.0d0
           ypixmean(k,m) = 0.0d0
         enddo
       enddo
       
       npw = 3

! Average pixel coordinates in a window of 2*NPW+1 pixels to make skeletons smoother on a (sub-)pixel scale.

       do k=1,nextr
         do l=1,np(k)
!!           npw = min ( 6, l - 1, np(k) - l )
!!           distmax = 1.45d0 * dble ( npw )
           l1 = max ( l - npw, 1 )
           l2 = min ( l + npw, np(k) )
           npa = 0
           do ll=l1,l2
!!             dist = sqrt ( (xpixok(k,ll) - xpixok(k,l))**2 + (ypixok(k,ll) - ypixok(k,l))**2 )
!!             if (dist .le. distmax) then
             npa = npa + 1
             xpixmean(k,l) = xpixmean(k,l) + xpixok(k,ll)
             ypixmean(k,l) = ypixmean(k,l) + ypixok(k,ll)
!!             endif
           enddo
           xpixmean(k,l) = xpixmean(k,l) / dble ( npa )
           ypixmean(k,l) = ypixmean(k,l) / dble ( npa )
         enddo
       enddo
       
! Find lengths of the filaments.

       do k=1,nextr
         length(k) = 0.0d0
         do l=2,np(k)
           distok = sqrt ( (xpixok(k,l) - xpixok(k,l-1))**2 + (ypixok(k,l) - ypixok(k,l-1))**2 )
           dist = sqrt ( (dx * (xpixmean(k,l) - xpixmean(k,l-1)))**2 + (dy * (ypixmean(k,l) - ypixmean(k,l-1)))**2 )
           if (distok .le. 1.45d0) then
             length(k) = length(k) + dist
           else
             write (iotty,'(/a,i4,3(a,i4),a)') '   FMEASURE: ERROR: Branch found for skeleton:', k, ' point:', l, ' at ('
     &                                       , nint ( xpixok(k,l) ), ',', nint ( ypixok(k,l) ), ')'
             write (iotty,*) dist, xpixok(k,l-1), xpixok(k,l), ypixok(k,l-1), ypixok(k,l)
             write (iotty,'(a)') '   FMEASURE: Image: '//filenamb(1:fnlen2)
             stop 99
           endif
         enddo
       enddo
         
       if (ldebug) then

         filename = individimages(1:indi)//'/'//outname(1:ion)//'~pixdist.fits'
         ipd = lastc ( filename )
         datamin =  1.0d+30
         datamax = -1.0d+30
         do j=1,ny
           do i=1,nx
             if (pixdist(i,j) .gt. datamax) datamax = pixdist(i,j)
             if (pixdist(i,j) .lt. datamin) datamin = pixdist(i,j)
           enddo
         enddo

         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing orig pix distances '''//filename(1:ipd)//''''
        
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, pixdist, dx, dy, object, crval1
     &              , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wave, datamin, datamax, history )
        
         deallocate ( pixdist, pixd, xpix, ypix )

         allocate ( filmean(nx,ny), stat=irc )

         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (60).'
           stop 60
         endif
         do j=1,ny
           do i=1,nx
             filmean(i,j) = min ( imageske(i,j), 0.50d0 )
           enddo
         enddo
         do k=1,nextr
           do l=1,np(k)
             ia = nint ( xpixmean(k,l) )
             ja = nint ( ypixmean(k,l) )
             filmean(ia,ja) = 1.0d0
           enddo
         enddo
         filename = individimages(1:indi)//'/'//outname(1:ion)//'~pts.hires.fits'
         ipd = lastc ( filename )
  
         datamin =  1.0d+30
         datamax = -1.0d+30
         do j=1,ny
           do i=1,nx
             if (filmean(i,j) .gt. datamax) datamax = filmean(i,j)
             if (filmean(i,j) .lt. datamin) datamin = filmean(i,j)
           enddo
         enddo
  
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing high-res skeletons '''//filename(1:ipd)//''''
  
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, filmean, dx, dy, object, crval1
     &              , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wave, datamin, datamax, history )
       
         deallocate ( filmean )

         if (cverbose .eq. '-verb2') 
     &      write (iotty,'(a)') '   Writing skeleton coords '''//individprofs(1:indp)//'/'//outname(1:ion)//'~coo.pix.cat'//''''
         
         open ( 55, file=individprofs(1:indp)//'/'//outname(1:ion)//'~coo.pix.cat', status='unknown' )
         write (55,'(a)') cbars
         write (55,'(a)') '#'
         write (55,'(a)') '#'//getstitle(2:)
         write (55,'(a)') cbars
         write (55,'(a)') '#'
         write (55,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
         write (55,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
         write (55,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
         write (55,'(a)') '#'
         write (55,'(a)') '# CATALOG OF ORIGINAL SKELETONS (DOCUMENTING ALL PIXELS)'
         write (55,'(a)') '#'
         write (55,'(a)') '# Filaments: '//filenama(1:fnlen1)
         write (55,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
         write (55,'(a)') '#'
         write (55,'(a)') '# TABULATED QUANTITIES:'
         write (55,'(a)') '#'
         write (55,'(a)') '#   NS ..... Skeleton (filament) number ........'
         write (55,'(a)') '#   PIXS ... Number of pixels in a skeleton ....'
         write (55,'(a)') '#   N# ..... Skeleton pixel number .............'
         write (55,'(a)') '#   X# ..... Skeleton pixel X-coordinate ....... pixels from the lower-left corner (1,1)'
         write (55,'(a)') '#   Y# ..... Skeleton pixel Y-coordinate ....... pixels from the lower-left corner (1,1)'
         write (55,'(a)') '#'
         write (55,'(a)') '#  NS   PIXS    N1   X1   Y1    N2   X2   Y2    N3   X3   Y3     etc.~>'
         write (55,'(a)') '#'
         do k=1,nextr
           write (55,'(i5,i7,'//cnmax//'(i6,i5,i5))') k, npixfil(k), (l, nint ( xpixok(k,l) ), nint ( ypixok(k,l) ), l=1,np(k))
         enddo
        
         close (55)
       endif

! Compute curvature of skeletons (filaments).

       do k=1,nextr
         do m=1,npxmax
           curvature(k,m) = 9.9999d+30
         enddo
       enddo
       
! Curvature of y=y(x) in Cartesian coordinates is defined as: curva = d2y/dx2 / [ 1 + (dy/dx)^2 ]^(3/2)
! For a parametrically defined curve x=x(t), y=y(t): curva = (dxdt * d2ydt2 - dydt * d2xdt2) / (dxdt**2 + dydt**2)^(3/2)

       do k=1,nextr
         do l=2,np(k)-1
           lm1 = max ( l - 1, 1 )
           lp1 = min ( l + 1, np(k) )
           dxt = xpixmean(k,lp1) - xpixmean(k,lm1)
           dyt = ypixmean(k,lp1) - ypixmean(k,lm1)
           dxm = xpixmean(k,l) - xpixmean(k,lm1)
           dym = ypixmean(k,l) - ypixmean(k,lm1)
           dxp = xpixmean(k,lp1) - xpixmean(k,l)
           dyp = ypixmean(k,lp1) - ypixmean(k,l)
           distt = sqrt ( dxt**2 + dyt**2 )
           distm = sqrt ( dxm**2 + dym**2 )
           distp = sqrt ( dxp**2 + dyp**2 )
           if (distt .le. 3.0d0 .and. distm .le. 1.45d0 .and. distp .le. 1.45d0) then
             dxdt = 0.0d0
             dydt = 0.0d0
             if (abs ( distt ) .gt. almostzero) dxdt = dxt / distt
             if (abs ( distt ) .gt. almostzero) dydt = dyt / distt
             dxmdt = 0.0d0
             dxpdt = 0.0d0
             if (abs ( distm ) .gt. almostzero) dxmdt = dxm / distm
             if (abs ( distp ) .gt. almostzero) dxpdt = dxp / distp
             dymdt = 0.0d0
             dypdt = 0.0d0
             if (abs ( distm ) .gt. almostzero) dymdt = dym / distm
             if (abs ( distp ) .gt. almostzero) dypdt = dyp / distp
             d2xdt2 = 0.0d0
             d2ydt2 = 0.0d0
             if (abs ( distt ) .gt. almostzero) d2xdt2 = (dxpdt - dxmdt) / distt
             if (abs ( distt ) .gt. almostzero) d2ydt2 = (dypdt - dymdt) / distt
             curvature(k,l) = (dxdt * d2ydt2 - dydt * d2xdt2) / sqrt ( dxdt**2 + dydt**2 )**3
           endif
         enddo
       enddo

! Smooth curvatures in a sliding window of 2*NPW+1 pixels along skeleton.

       do k=1,nextr
         do l=1,np(k)
           curvsmo = 0.0d0
           npa = 0
           do ll=max(l-npw,1),min(l+npw,np(k))
!!             dist = sqrt ( (xpixok(k,ll) - xpixok(k,l))**2 + (ypixok(k,ll) - ypixok(k,l))**2 )
             if (curvature(k,ll) .lt. 9.99d+30) then         !! dist .le. distmax .and. 
               npa = npa + 1
               curvsmo = curvsmo + abs ( curvature(k,ll) )
             endif
           enddo
           if (npa .gt. 0) then
             curvsmoo(k,l) = curvsmo / dble ( npa )
           else
             curvsmoo(k,l) = 9.9999d+30
           endif
         enddo
       enddo

       do k=1,nextr
         curvmean(k) = 0.0d0
         curvmedi(k) = 0.0d0
         curvtota(k) = 0.0d0
         navc(k) = 0
         do l=2,np(k)-1
           lm1 = max ( l - 1, 1 )
           lp1 = min ( l + 1, np(k) )
           dxm = xpixmean(k,l) - xpixmean(k,lm1)
           dym = ypixmean(k,l) - ypixmean(k,lm1)
           dxp = xpixmean(k,lp1) - xpixmean(k,l)
           dyp = ypixmean(k,lp1) - ypixmean(k,l)
           distm = sqrt ( dxm**2 + dym**2 )
           distp = sqrt ( dxp**2 + dyp**2 )
           if (curvsmoo(k,l) .lt. 9.99d+30) then
             if (l .gt. npw .and. l .le. np(k) - npw) then
               navc(k) = navc(k) + 1
               curvmean(k) = curvmean(k) + curvsmoo(k,l)
               curvtota(k) = curvtota(k) + curvsmoo(k,l) * (distm + distp) / 2.0d0
               funmed(navc(k)) = curvsmoo(k,l)
             endif
           endif
         enddo
         if (navc(k) .gt. 0) then
           curvmean(k) = curvmean(k) / dble ( navc(k) )
         endif
         if (navc(k) .gt. 1) then
           curvmedi(k) = selectk ( (navc(k) + 1) / 2, navc(k), funmed )
         endif
       enddo

       do k=1,nextr
         curvstd(k) = 0.0d0
         navc(k) = 0
         do l=2,np(k)-1
           if (curvsmoo(k,l) .lt. 9.99d+30) then
             if (l .gt. npw .and. l .le. np(k) - npw) then
               navc(k) = navc(k) + 1
               curvstd(k) = curvstd(k) + (curvsmoo(k,l) - curvmedi(k))**2
             endif
           endif
         enddo
         if (navc(k) .gt. 1) curvstd(k) = sqrt ( curvstd(k) / (dble ( navc(k) ) - 1.0d0) )

         curvmean(k) = abs ( curvmean(k) )
         curvmedi(k) = abs ( curvmedi(k) )
         curvtota(k) = abs ( curvtota(k) )
       enddo

! Find sine and cosine defining direction of a skeleton segment, as well as
! the sine and cosine of the left (a) and right (b) normals to the segment (+- pi/2).

       do k=1,nextr
         do l=1,np(k)
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           lm1 = max ( l - 1, 1 )
           lp1 = min ( l + 1, np(k) )
           dxp = xpixmean(k,lp1) - xpixmean(k,lm1)
           dyp = ypixmean(k,lp1) - ypixmean(k,lm1)
           segmlen = sqrt ( dxp**2 + dyp**2 )
           if (segmlen .gt. almostzero) then
             cosx(k,l) = dxp / segmlen
             sinx(k,l) = dyp / segmlen
           else
             cosx(k,l) = 1.0d0
             sinx(k,l) = 0.0d0
           endif
           cosa(k,l) = - sinx(k,l)
           sina(k,l) = + cosx(k,l)
           cosb(k,l) = + sinx(k,l)
           sinb(k,l) = - cosx(k,l)
             
! Position angle of the skeleton segment.

           sangle(k,l) = acos ( cosx(k,l) ) * 180.0d0 / pi
           if (sinx(k,l) .ge. 0.0d0) then
             sangle(k,l) = sangle(k,l) - 90.0d0
           else
             sangle(k,l) = 360.0d0 - sangle(k,l) - 90.0d0
           endif

! Position angle of the left normal to the skeleton segment.
             
           nanglea(k,l) = acos ( cosa(k,l) ) * 180.0d0 / pi
           if (sina(k,l) .ge. 0.0d0) then
             nanglea(k,l) = nanglea(k,l) - 90.0d0
           else
             nanglea(k,l) = 360.0d0 - nanglea(k,l) - 90.0d0
           endif

! Position angle of the right normal to the skeleton segment.
             
           nangleb(k,l) = acos ( cosb(k,l) ) * 180.0d0 / pi
           if (sinb(k,l) .ge. 0.0d0) then
             nangleb(k,l) = nangleb(k,l) - 90.0d0
           else
             nangleb(k,l) = 360.0d0 - nangleb(k,l) - 90.0d0
           endif
         enddo
       enddo

       if (cverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing skeletons '''//individprofs(1:indp)//'/'//outname(1:ion)//'~coo.hires.cat'''
       ipw = 1
       write (cnpw,'(i2)') 2 * npw + 1
       if (cnpw(1:1) .eq. ' ') ipw = ipw + 1
       open ( 66, file=individprofs(1:indp)//'/'//outname(1:ion)//'~coo.hires.cat', status='unknown' )
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '#'//getstitle(2:)
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (66,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
       write (66,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (66,'(a)') '#'
       write (66,'(a)') '# CATALOG OF HIGH-RESOLUTION SKELETONS (AVERAGED OVER '//cnpw(ipw:2)//' NEAREST PIXELS)'
       write (66,'(a)') '#'
       write (66,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (66,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (66,'(a)') '#'
       write (66,'(a,i2)') '# Window size over skeleton points for smoothing their coordinates and curvatures:', 2*npw+1
       write (66,'(a)') '#'
       write (66,'(a)') '# TABULATED QUANTITIES:'
       write (66,'(a)') '#'
       write (66,'(a)') '#   NS ...... Skeleton (filament) number ..........'
       write (66,'(a)') '#   PIXS .... Number of skeleton points ...........'
       write (66,'(a)') '#   N# ...... Skeleton point number ...............'
       write (66,'(a)') '#   X# ...... Skeleton point X-coordinate ......... pixels from the lower-left corner (1,1)'
       write (66,'(a)') '#   Y# ...... Skeleton point Y-coordinate ......... pixels from the lower-left corner (1,1)'
       write (66,'(a)') '#   CURV# ... Skeleton |curvature| (smoothed) ..... 1/arcsec,'
     &                //' CURV = (DXDT * D2YDT2 - DYDT * D2XDT2) / sqrt ( DXDT^2 + DYDT^2 )^3'
       write (66,'(a)') '#   SPA# .... Skeleton direction position angle ... degrees left of the vertical axis'
       write (66,'(a)') '#   NAPA# ... Left normal position angle .......... degrees left of the vertical axis'
       write (66,'(a)') '#   NBPA# ... Right normal position angle ......... degrees left of the vertical axis'
       write (66,'(a)') '#'
       write (66,'(a)') '#  NS   PIXS    N1      X1          Y1        |CURV1|    SPA1    NAPA1   NBPA1'
     &                //'    N2      X2          Y2        |CURV2|    SPA2    NAPA2   NBPA2    N3'
     &                //'      X3          Y3        |CURV3|    SPA3    NAPA3   NBPA3     etc. ~>'
       write (66,'(a)') '#'
       write (cnmax,'(i5)') npxmax
       do k=1,nextr
         write (66,'(i5,i7,'//cnmax//'(i6,3(1pe12.4),3(0pf8.2)))') k, npixfil(k), (l, xpixmean(k,l), ypixmean(k,l), curvsmoo(k,l)
     &                                                           , sangle(k,l), nanglea(k,l), nangleb(k,l), l=1,np(k))
       enddo
       close (66)
       
       if (cverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing skeletons '''//individimages(1:indi)//'/'//outname(1:ion)//'~coo.hires.phy.reg'''
       ipw = 1
       write (cnpw,'(i2)') 2 * npw + 1
       if (cnpw(1:1) .eq. ' ') ipw = ipw + 1
       open ( 67, file=individimages(1:indi)//'/'//outname(1:ion)//'~coo.hires.phy.reg', status='unknown' )
       write (67,'(a)') cbars
       write (67,'(a)') '#'
       write (67,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (67,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
       write (67,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (67,'(a)') '#'
       write (67,'(a)') '# DS9 REGION FILE WITH HIGH-RESOLUTION SKELETONS (AVERAGED OVER '//cnpw(ipw:2)//' NEAREST PIXELS)'
       write (67,'(a)') '#'
       write (67,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (67,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (67,'(a)') '#'
       write (67,'(a,i2)') '# Window size over skeleton points for smoothing their coordinates and curvatures:', 2*npw+1
       write (67,'(a)') cbars
       write (67,'(a)') '#'
       write (67,'(a)') '# SYMBOLIC COLOR NAMES RECOGNIZED BY DS9 (https://www.tcl.tk/man/tcl/TkCmd/colors.html'
     &                //' Tcl8.6.11/Tk8.6.11 Documentation > Tk Commands > colors)'
       write (67,'(a)') '# '
       write (67,'(a)') '# AliceBlue AntiqueWhite AntiqueWhite1 AntiqueWhite2 AntiqueWhite3 AntiqueWhite4 agua aquamarine'
     &                //' aquamarine1 aquamarine2 aquamarine3 aquamarine4 azure azure1'
       write (67,'(a)') '# azure3 azure4 beige bisque bisque1 bisque2 bisque3 bisque4 black BlanchedAlmond blue blue1 blue2'
     &                //' blue3 blue4 BlueViolet brown brown1 brown2 brown3 brown4 azure2 '
       write (67,'(a)') '# burlywood burlywood1 burlywood2 burlywood3 burlywood4 CadetBlue CadetBlue1 CadetBlue2 CadetBlue3'
     &                //' CadetBlue4 chartreuse chartreuse1 chartreuse2 chartreuse3'
       write (67,'(a)') '# chartreuse4 chocolate chocolate1 chocolate2 chocolate3 chocolate4 coral coral1 coral2 coral3 coral4'
     &                //' CornflowerBlue cornsilk cornsilk1 cornsilk2 cornsilk3'
       write (67,'(a)') '# cornsilk4 crymson cyan cyan1 cyan2 cyan3 cyan4 dark blue dark cyan dark goldenrod DarkBlue DarkCyan'
     &                //' DarkGoldenrod DarkGoldenrod1 DarkGoldenrod2 DarkGoldenrod3'
       write (67,'(a)') '# DarkGoldenrod4 DarkGray DarkGreen DarkKhaki DarkMagenta DarkOliveGreen DarkOliveGreen1'
     &                //' DarkOliveGreen2 DarkOliveGreen3 DarkOliveGreen4 DarkOrange DarkOrange1'
       write (67,'(a)') '# DarkOrange2 DarkOrange3 DarkOrange4 DarkOrchid DarkOrchid1 DarkOrchid2 DarkOrchid3 DarkOrchid4'
     &                //' DarkRed DarkSalmon DarkSeaGreen DarkSeaGreen1 DarkSeaGreen2'
       write (67,'(a)') '# DarkSeaGreen3 DarkSeaGreen4 DarkSlateBlue DarkSlateGray DarkSlateGray1 DarkSlateGray2 DarkSlateGray3'
     &                //' DarkSlateGray4 DarkSlateGrey DarkTurquoise DarkViolet'
       write (67,'(a)') '# DeepPink DeepPink1 DeepPink2 DeepPink3 DeepPink4 DeepSkyBlue DeepSkyBlue1 DeepSkyBlue2 DeepSkyBlue3'
     &                //' DeepSkyBlue4 DimGray DodgerBlue DodgerBlue1 DodgerBlue2'
       write (67,'(a)') '# DodgerBlue3 DodgerBlue4 firebrick firebrick1 firebrick2 firebrick3 firebrick4 FloralWhite ForestGreen'
     &                //' fuchsia gainsboro GhostWhite gold gold1 gold2 gold3 gold4'
       write (67,'(a)') '# goldenrod goldenrod1 goldenrod2 goldenrod3 goldenrod4 gray gray0 gray1 gray2 gray3 gray4 gray5 gray6'
     &                //' gray7 gray8 gray9 gray10 gray11 gray12 gray13 gray14 gray15'
       write (67,'(a)') '# gray16 gray17 gray18 gray19 gray20 gray21 gray22 gray23 gray24 gray25 gray26 gray27 gray28 gray29'
     &                //' gray30 gray31 gray32 gray33 gray34 gray35 gray36 gray37 gray38'
       write (67,'(a)') '# gray39 gray40 gray41 gray42 gray43 gray44 gray45 gray46 gray47 gray48 gray49 gray50 gray51 gray52'
     &                //' gray53 gray54 gray55 gray56 gray57 gray58 gray59 gray60 gray61'
       write (67,'(a)') '# gray62 gray63 gray64 gray65 gray66 gray67 gray68 gray69 gray70 gray71 gray72 gray73 gray74 gray75'
     &                //' gray76 gray77 gray78 gray79 gray80 gray81 gray82 gray83 gray84'
       write (67,'(a)') '# gray85 gray86 gray87 gray88 gray89 gray90 gray91 gray92 gray93 gray94 gray95 gray96 gray97 gray98'
     &                //' gray99 gray100 green green1 green2 green3 green4 GreenYellow'
       write (67,'(a)') '# honeydew honeydew1 honeydew2 honeydew3 honeydew4 HotPink HotPink1 HotPink2 HotPink3 HotPink4'
     &                //' IndianRed IndianRed1 IndianRed2 IndianRed3 IndianRed4 indigo ivory'
       write (67,'(a)') '# ivory1 ivory2 ivory3 ivory4 khaki khaki1 khaki2 khaki3 khaki4 lavender LavenderBlush LavenderBlush1'
     &                //' LavenderBlush2 LavenderBlush3 LavenderBlush4 LawnGreen'
       write (67,'(a)') '# LemonChiffon LemonChiffon1 LemonChiffon2 LemonChiffon3 LemonChiffon4 LightBlue LightBlue1 LightBlue2'
     &                //' LightBlue3 LightBlue4 LightCoral LightCyan LightCyan1'
       write (67,'(a)') '# LightCyan2 LightCyan3 LightCyan4 LightGoldenrod LightGoldenrod1 LightGoldenrod2 LightGoldenrod3'
     &                //' LightGoldenrod4 LightGoldenrodYellow LightGray LightGreen'
       write (67,'(a)') '# LightGrey LightPink LightPink1 LightPink2 LightPink3 LightPink4 LightSalmon LightSalmon1 LightSalmon2'
     &                //' LightSalmon3 LightSalmon4 LightSeaGreen LightSkyBlue'
       write (67,'(a)') '# LightSkyBlue1 LightSkyBlue2 LightSkyBlue3 LightSkyBlue4 LightSlateBlue LightSlateGray LightSlateGrey'
     &                //' LightSteelBlue LightSteelBlue1 LightSteelBlue2'
       write (67,'(a)') '# LightSteelBlue3 LightSteelBlue4 LightYellow LightYellow1 LightYellow2 LightYellow3 LightYellow4 lime'
     &                //' LimeGreen linen magenta magenta1 magenta2 magenta3 magenta4'
       write (67,'(a)') '# maroon maroon1 maroon2 maroon3 maroon4 red MediumAquamarine MediumBlue MediumOrchid MediumOrchid1'
     &                //' MediumOrchid2 MediumOrchid3 MediumOrchid4 MediumPurple'
       write (67,'(a)') '# MediumPurple1 MediumPurple2 MediumPurple3 MediumPurple4 MediumSeaGreen MediumSlateBlue'
     &                //' MediumSpringGreen MediumTurquoise MediumVioletRed MidnightBlue MintCream'
       write (67,'(a)') '# MistyRose MistyRose1 MistyRose2 MistyRose3 MistyRose4 moccasin NavajoWhite NavajoWhite1 NavajoWhite2'
     &                //' NavajoWhite3 NavajoWhite4 navy NavyBlueOldLace olive'
       write (67,'(a)') '# OliveDrab OliveDrab1 OliveDrab2 OliveDrab3 OliveDrab4 orange orange1 orange2 orange3 orange4'
     &                //' OrangeRed OrangeRed1 OrangeRed2 OrangeRed3 OrangeRed4 orchid orchid1'
       write (67,'(a)') '# orchid2 orchid3 orchid4 red PaleGoldenrod PaleGreen PaleGreen1 PaleGreen2 PaleGreen3 PaleGreen4'
     &                //' PaleTurquoise PaleTurquoise1 PaleTurquoise2 PaleTurquoise3'
       write (67,'(a)') '# PaleTurquoise4 PaleVioletRed PaleVioletRed1 PaleVioletRed2 PaleVioletRed3 PaleVioletRed4 PapayaWhip'
     &                //' PeachPuff PeachPuff1 PeachPuff2 PeachPuff3 PeachPuff4 peru'
       write (67,'(a)') '# pink pink1 pink2 pink3 pink4 plum plum1 plum2 plum3 plum4 PowderBlue purple purple1 purple2 purple3'
     &                //' purple4 red red1 red2 red3 red4 RosyBrown RosyBrown1'
       write (67,'(a)') '# RosyBrown2 RosyBrown3 RosyBrown4 RoyalBlue RoyalBlue1 RoyalBlue2 RoyalBlue3 RoyalBlue4 SaddleBrown'
     &                //' salmon salmon1 salmon2 salmon3 salmon4 SandyBrown SeaGreen'
       write (67,'(a)') '# SeaGreen1 SeaGreen2 SeaGreen3 SeaGreen4 seashell seashell1 seashell2 seashell3 seashell4 sienna'
     &                //' sienna1 sienna2 sienna3 sienna4 silver SkyBlue SkyBlue1 SkyBlue2'
       write (67,'(a)') '# SkyBlue3 SkyBlue4 SlateBlue SlateBlue1 SlateBlue2 SlateBlue3 SlateBlue4 SlateGray SlateGray1'
     &                //' SlateGray2 SlateGray3 SlateGray4 SlateGrey snow snow1 snow2 snow3'
       write (67,'(a)') '# snow4 SpringGreen SpringGreen1 SpringGreen2 SpringGreen3 SpringGreen4 steel blue SteelBlue SteelBlue1'
     &                //' SteelBlue2 SteelBlue3 SteelBlue4 tan tan1 tan2 tan3 tan4'
       write (67,'(a)') '# teal thistle thistle1 thistle2 thistle3 thistle4 tomato tomato1 tomato2 tomato3 tomato4 turquoise'
     &                //' turquoise1 turquoise2 turquoise3 turquoise4 violet VioletRed'
       write (67,'(a)') '# VioletRed1 VioletRed2 VioletRed3 VioletRed4 wheat wheat1 wheat2 wheat3 wheat4 white WhiteSmoke yellow'
     &                //' yellow1 yellow2 yellow3 yellow4 YellowGreen'
       write (67,'(a)') cbars
       write (67,'(a)') '#'
       write (67,'(a)') '# Region file format: DS9 version 4.1'
       write (67,'(a)') '#'
       write (67,'(a)') '# GETSF COLORS ARE DEFINED BY THEIR HEXADECIMAL VALUES:'
       write (67,'(a)') '#'
       write (67,'(a)') '# red #f0194b, green #3ce04b, yellow #fff019, blue #7383ff, orange #ff9241, purple #a14eff,'
     &                //' cyan #66ffff, magenta #ff52ff, lime #bcf60c, pink #ffb5b5,'
       write (67,'(a)') '# teal #00a0a0, lavender #e6beff, brown #ba7334, beige #f2f2ca, maroon #aa0000, mint #aaffc3,'
     &                //' olive #a5b500, apricot #ffd8b1, gray #909090, white #ffffff, black #000000'
       write (67,'(a)') '#'
!!       write (67,'(a)') '# #e6194b #3cb44b #ffe119 #4363d8 #f58231 #911eb4 #42d4f4 #f032e6 #bfef45 #fabed4 #469990 #dcbeff'
!!     &                //'   #9a6324 #fffac8 #800000 #aaffc3 #808000 #ffd8b1 #000075 #a9a9a9 #ffffff #000000'
!!       write (67,'(a)') '# red     green   yellow  blue    orange  purple  cyan    magenta lime    pink    teal    lavender'
!!     &                //'   brown   beige   maroon  mint    olive   apricot navy    gray    white   black'
       write (67,'(a)') '#'
       write (67,'(a)') 'global color='//regcolor(1:isc)//' width=3 dashlist=8 3 font="helvetica 10 normal roman" select=1'
     &                //' highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1'
       write (67,'(a)') 'physical'
       do k=1,nextr
         write (ck,'(i6)') k
         nck = int ( log10 ( dble ( k ) ) ) + 1
         do l=1,np(k)
           ix(l) = int ( log10 ( max ( xpixmean(k,l), 1.0d0 ) ) ) + 1
           iy(l) = int ( log10 ( max ( ypixmean(k,l), 1.0d0 ) ) ) + 1
           write (cxpixm(l),'(f11.4)') xpixmean(k,l)
           write (cypixm(l),'(f11.4)') ypixmean(k,l)
           cxpixm(l) = cxpixm(l)(6-ix(l)+1:11)
           cypixm(l) = cypixm(l)(6-iy(l)+1:11)
           ix(l) = lastc ( cxpixm(l) )
           iy(l) = lastc ( cypixm(l) )
         enddo
         write (67,'(a,'//cnmax//'(2(a,a)))') 'segment(',(cxpixm(l)(1:ix(l)),',',cypixm(l)(1:iy(l)),',', l=1,np(k)-1),
     &                                        cxpixm(np(k))(1:ix(np(k))),',',cypixm(np(k))(1:iy(np(k))),') # '//ck(6-nck+1:6)
       enddo
       write (67,'(a)') '#'
       write (67,'(a)') 'global color=black width=7 dashlist=8 3 font="helvetica 10 normal roman" select=1'
     &                //' highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1'
       write (67,'(a)') 'physical'
       do k=1,nextr
         write (ck,'(i6)') k
         nck = int ( log10 ( dble ( k ) ) ) + 1
         do l=1,np(k)
           ix(l) = int ( log10 ( max ( xpixmean(k,l), 1.0d0 ) ) ) + 1
           iy(l) = int ( log10 ( max ( ypixmean(k,l), 1.0d0 ) ) ) + 1
           write (cxpixm(l),'(f11.4)') xpixmean(k,l)
           write (cypixm(l),'(f11.4)') ypixmean(k,l)
           cxpixm(l) = cxpixm(l)(6-ix(l)+1:11)
           cypixm(l) = cypixm(l)(6-iy(l)+1:11)
           ix(l) = lastc ( cxpixm(l) )
           iy(l) = lastc ( cypixm(l) )
         enddo
         write (67,'(a,'//cnmax//'(2(a,a)))') 'segment(',(cxpixm(l)(1:ix(l)),',',cypixm(l)(1:iy(l)),',', l=1,np(k)-1),
     &                                        cxpixm(np(k))(1:ix(np(k))),',',cypixm(np(k))(1:iy(np(k))),') # '//ck(6-nck+1:6)
       enddo
       close (67)
       
       deallocate ( cxpixm, cypixm, ix, iy )  !!, color
       
! Filament half-maximum half-widths.

       npta = nint ( sqrt ( dble ( nx )**2 + dble ( ny )**2 ) )
       nptb = nint ( sqrt ( dble ( nx )**2 + dble ( ny )**2 ) )
       
       do k=1,nextr
         do l=1,np(k)
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           imagehalf = imagefil(i,j) / 2.0d0
           imagelow = imagefil(i,j) / 100.0d0
           hwidtha(k,l) = 0.0d0
           hwidthb(k,l) = 0.0d0
           hwidthza = 0.0d0
           hwidthzb = 0.0d0
           
! Gaussian interpolation to obtain accurate values of full width at half-maximum for Gaussian-like shapes.
! From two equations: ln(G1) - ln(G2) = -x1^2 + x2^2 / (2 sigma^2) and ln(G1) - ln(Gh) = -x1^2 + xh^2 / (2 sigma^2):
! (2 sigma^2) = (x2^2 - x1^2) / (ln(G1) - ln(G2)) and xh = sqrt ( x1^2 + (2 sigma^2) * (ln(G1) - ln(Gh)) )
                 
           if (imagefil(i,j) .gt. almostzero) then
             do m=1,npta
               dr1 = dble ( m - 1 )
               dr2 = dble ( m )
               x1 = xpixmean(k,l) + cosa(k,l) * dr1
               y1 = ypixmean(k,l) + sina(k,l) * dr1
               i1 = nint ( x1 )
               j1 = nint ( y1 )
               x2 = xpixmean(k,l) + cosa(k,l) * dr2
               y2 = ypixmean(k,l) + sina(k,l) * dr2
               i2 = nint ( x2 )
               j2 = nint ( y2 )
               if (i1 .ge. 1 .and. i1 .le. nx .and. j1 .ge. 1 .and. j1 .le. ny .and.
     &             i2 .ge. 1 .and. i2 .le. nx .and. j2 .ge. 1 .and. j2 .le. ny) then
                 if (imagefil(i1,j1) .gt. imagelow .and. hwidtha(k,l) .lt. almostzero) then
                   if (imagefil(i1,j1) .ge. imagehalf .and. 
     &                 imagefil(i2,j2) .lt. imagehalf .and. imagefil(i2,j2) .gt. almostzero) then
                     dlogim = log ( imagefil(i,j) ) - log ( imagehalf )
                     radius2 = (dble ( i1 - i )**2 + dble ( j1 - j )**2) * sqpixel
                     drad2 = (dble ( i2 - i1 )**2 + dble ( j2 - j1 )**2) * sqpixel
                     sigm2 = drad2 / (log ( imagefil(i1,j1) ) - log ( imagefil(i2,j2) ))
                     hwidtha(k,l) = sqrt ( radius2 + sigm2 * dlogim )
                   endif
                 endif
                 if (imagefil(i2,j2) .le. imagelow .and. hwidthza .lt. almostzero) then
                   hwidthza = sqrt ( (dble ( i1 - i )**2 + dble ( j1 - j )**2) * sqpixel )
                 endif
                 if (hwidtha(k,l) .gt. almostzero .and. hwidthza .gt. almostzero) then
                   exit
                 endif
               endif
             enddo
             do m=1,nptb
               dr1 = dble ( m - 1 )
               dr2 = dble ( m )
               x1 = xpixmean(k,l) + cosb(k,l) * dr1
               y1 = ypixmean(k,l) + sinb(k,l) * dr1
               i1 = nint ( x1 )
               j1 = nint ( y1 )
               x2 = xpixmean(k,l) + cosb(k,l) * dr2
               y2 = ypixmean(k,l) + sinb(k,l) * dr2
               i2 = nint ( x2 )
               j2 = nint ( y2 )
               if (i1 .ge. 1 .and. i1 .le. nx .and. j1 .ge. 1 .and. j1 .le. ny .and.
     &             i2 .ge. 1 .and. i2 .le. nx .and. j2 .ge. 1 .and. j2 .le. ny) then
                 if (imagefil(i1,j1) .gt. imagelow .and. hwidthb(k,l) .lt. almostzero) then
                   if (imagefil(i1,j1) .ge. imagehalf .and.
     &                 imagefil(i2,j2) .lt. imagehalf .and. imagefil(i2,j2) .gt. almostzero) then
                     dlogim = log ( imagefil(i,j) ) - log ( imagehalf )
                     radius2 = (dble ( i1 - i )**2 + dble ( j1 - j )**2) * sqpixel
                     drad2 = (dble ( i2 - i1 )**2 + dble ( j2 - j1 )**2) * sqpixel
                     sigm2 = drad2 / (log ( imagefil(i1,j1) ) - log ( imagefil(i2,j2) ))
                     hwidthb(k,l) = sqrt ( radius2 + sigm2 * dlogim )
                   endif
                 endif
                 if (imagefil(i2,j2) .le. imagelow .and. hwidthzb .lt. almostzero) then
                   hwidthzb = sqrt ( (dble ( i1 - i )**2 + dble ( j1 - j )**2) * sqpixel )
                 endif
                 if (hwidthb(k,l) .gt. almostzero .and. hwidthzb .gt. almostzero) then
                   exit
                 endif
               endif
             enddo
           endif
           ihwidtha(k,l) = min ( nint ( max ( factnpt * hwidtha(k,l), hwidthza ) / sqrt ( sqpixel ) ), npixfil(k) )
           ihwidthb(k,l) = min ( nint ( max ( factnpt * hwidthb(k,l), hwidthzb ) / sqrt ( sqpixel ) ), npixfil(k) )
         enddo
       enddo
       
! Image of normals to skeletons to visualize them.

       allocate ( normals(nx,ny), worker(nx,ny), foota(nx,ny), footb(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (70).'
         stop 70
       endif
       
       do j=1,ny
         do i=1,nx
           normals(i,j) = 0.0d0
           foota(i,j) = 0.0d0
           footb(i,j) = 0.0d0
         enddo
       enddo

! Compute and catalog filament profiles.

       allocate ( widthmean(nextr), widthmeana(nextr), widthmeanb(nextr), widthmed(nextr), widthmeda(nextr), widthmedb(nextr)
     &          , widthstd(nextr), widthstda(nextr), widthstdb(nextr), stat=irc )
     
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (80).'
         stop 80
       endif

       do k=1,nextr
         write (cnextr,'(i4.4)') k
         lk1 = max ( (np(k) - int ( dble ( np(k) ) / dble ( npxstep ) ) * npxstep) / 2, 1 )
         do j=1,ny
           do i=1,nx
             worker(i,j) = 0.0d0
           enddo
         enddo
         widthmean(k) = 1.0d-31
         widthmeana(k) = 1.0d-31
         widthmeanb(k) = 1.0d-31
         widthmed(k) = 1.0d-31
         widthmeda(k) = 1.0d-31
         widthmedb(k) = 1.0d-31
         widthstda(k) = 1.0d-31
         widthstdb(k) = 1.0d-31
         widthstd(k) = 1.0d-31
         nptwa(k) = 0
         nptwb(k) = 0
         nptw(k) = 0

         do l=1,np(k)
           width(k,l) = 0.0d0
           if (hwidtha(k,l) .gt. almostzero .and. hwidthb(k,l) .gt. almostzero) then
             width(k,l) = 2.0d0 * min ( hwidtha(k,l), hwidthb(k,l) )
           elseif (hwidtha(k,l) .gt. almostzero) then
             width(k,l) = 2.0d0 * hwidtha(k,l)
           elseif (hwidthb(k,l) .gt. almostzero) then
             width(k,l) = 2.0d0 * hwidthb(k,l)
           endif
           widtha(k,l) = 2.0d0 * hwidtha(k,l)
           widthb(k,l) = 2.0d0 * hwidthb(k,l)
         enddo

         nptsa = 0
         nptsb = 0
         do l=1,np(k)
           nptsa = max ( nptsa, ihwidtha(k,l) )
           nptsb = max ( nptsb, ihwidthb(k,l) )
         enddo
         nptsa3 = 3 * nptsa
         nptsb3 = 3 * nptsb

         npts = max ( nptsa, nptsb )
         npts3 = 3 * npts
         nptsm = min ( nptsa, nptsb )
         nptsm3 = 3 * min ( nptsa, nptsb )
         if (npts .eq. 0) goto 888

         allocate ( profile(npxmax,npts3), profilea(npxmax,npts3), profileb(npxmax,npts3), profmeda(npxmax), profmedb(npxmax)
     &            , rad(npts3), napa(npts), nama(npts), navpa(npts), navma(npts), napb(npts), namb(npts), navpb(npts), navmb(npts)
     &            , nap(npts), nam(npts), navp(npts), navm(npts), profmeana(npts), profmeanb(npts), profmean(npts), slopea(npts)
     &            , profmeasdpa(npts), profmeasdma(npts), profmeasdpb(npts), profmeasdmb(npts), profmeasdp(npts), profmeasdm(npts)
     &            , profmediana(npts), profmedianb(npts), profmedian(npts)
     &            , profmedsdpa(npts), profmedsdpb(npts), profmedsdma(npts), profmedsdmb(npts), profmedsdp(npts), profmedsdm(npts)
     &            , slopemeana(npts), slopemeanb(npts), slopemean(npts)
     &            , slopemediana(npts), slopemedianb(npts), slopemedian(npts), nwin(npts), profa(npts), profb(npts), maska(npts)
     &            , maskb(npts), nmaska(npxmax), nmaskb(npxmax), slopeb(npts), stat=irc )

         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (90).'
           stop 90
         endif

         do m=1,npts3
           rad(m) = max ( dble ( m - 1 ) * dx, 0.1d0 * dx )
           do n=1,npxmax
             profile(n,m) = 1.0d-31
             profilea(n,m) = 1.0d-31
             profileb(n,m) = 1.0d-31
           enddo
         enddo

         do m=1,npts
           profmean(m) = 1.0d-31
           profmeana(m) = 1.0d-31
           profmeanb(m) = 1.0d-31
           profmeasdp(m) = 1.0d-31
           profmeasdm(m) = 1.0d-31
           profmeasdpa(m) = 1.0d-31
           profmeasdma(m) = 1.0d-31
           profmeasdpb(m) = 1.0d-31
           profmeasdmb(m) = 1.0d-31
           profmedian(m) = 1.0d-31
           profmediana(m) = 1.0d-31
           profmedianb(m) = 1.0d-31
           profmedsdp(m) = 1.0d-31
           profmedsdm(m) = 1.0d-31
           profmedsdpa(m) = 1.0d-31
           profmedsdpb(m) = 1.0d-31
           profmedsdma(m) = 1.0d-31
           profmedsdmb(m) = 1.0d-31
           napa(m) = 0
           nama(m) = 0
           navpa(m) = 0
           navma(m) = 0
           napb(m) = 0
           namb(m) = 0
           navpb(m) = 0
           navmb(m) = 0
           nap(m) = 0
           nam(m) = 0
           navp(m) = 0
           navm(m) = 0
         enddo

! Profiles at each skeleton point are saved only in the debug mode.

         do l=1,np(k)
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           if (imagefil(i,j) .gt. almostzero) then
             ldone = .false.
             do m=1,nptsa3
               dr = dble ( m - 1 )
               ia = nint ( xpixmean(k,l) + cosa(k,l) * dr )
               ja = nint ( ypixmean(k,l) + sina(k,l) * dr )
               if (.not.ldone .and. ia .ge. 1 .and. ia .le. nx .and. ja .ge. 1 .and. ja .le. ny) then
                 profilea(l,m) = max ( imagefil(ia,ja), 1.0d-31 )
                 if (profilea(l,m) .lt. almostzero) then
                   ldone = .true.
                   exit
                 endif
               endif
             enddo
             ldone = .false.
             do m=1,nptsb3
               dr = dble ( m - 1 )
               ib = nint ( xpixmean(k,l) + cosb(k,l) * dr )
               jb = nint ( ypixmean(k,l) + sinb(k,l) * dr )
               if (.not.ldone .and. ib .ge. 1 .and. ib .le. nx .and. jb .ge. 1 .and. jb .le. ny) then
                 profileb(l,m) = max ( imagefil(ib,jb), 1.0d-31 )
                 if (profileb(l,m) .lt. almostzero) then
                   ldone = .true.
                   exit
                 endif
               endif
             enddo
             do m=1,nptsm3
               profile(l,m) = sqrt ( profilea(l,m) * profileb(l,m) )
             enddo
           endif
         enddo

         if (ldebug) then
           if (cverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'~profiles.fi.????.allpts.cat'//''''
           if (npts .gt. 1) then
             write (clk1,'(i4.4)') 1
             write (clk2,'(i4.4)') 2
             write (clk3,'(i4.4)') 3
             open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'~profiles.fi.'//cnextr//'.allpts.cat', status='unknown' )
             write (77,'(a)') cbars
             write (77,'(a)') '#'
             write (77,'(a)') '#'//getstitle(2:)
             write (77,'(a)') cbars
             write (77,'(a)') '#'
             write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
             write (77,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
             write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
             write (77,'(a)') '#'
             write (77,'(a)') '# CATALOG OF FILAMENT PROFILES (EACH SKELETON POINT)'
             write (77,'(a)') '#'
             write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
             write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
             write (77,'(a)') '#'
             write (77,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
             write (77,'(a)') '#'
             write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
             write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
             write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
             write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
             write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', npixfil(k)
             write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', 1
             write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', 1
             write (77,'(a)') '#'
             write (77,'(a)') '# TABULATED QUANTITIES:'
             write (77,'(a)') '#'
             write (77,'(a)') '#   NR ........ Number of radial point ...............'
             write (77,'(a)') '#   ANGLE ..... Angular distance from the skeleton ... arcsec'
             write (77,'(a)') '#   RADIUS .... Radial distance from the skeleton .... pc (at '//cdistpc(1:idp)//' pc)'
             write (77,'(a)') '#   PROF_# .... Filament profile on both sides ....... sqrt ( PROFA_# * PROFB_# )'
             write (77,'(a)') '#   PROFA_# ... Filament profile on the left side .... image units'
             write (77,'(a)') '#   PROFB_# ... Filament profile on the right side ... image units'
             write (77,'(a)') '#'
             allocate ( cathead(np(k)), ilc(np(k)), stat=irc )
             if (irc .ne. 0) then
               write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (41).'
               stop 41
             endif
             cathead0 = '#  NR    ANGLE       RADIUS  |'
             ilc0 = lastc ( cathead0 ) - 1
             do l=1,np(k)
               write (clk,'(i4.4)') l
               cathead(l) = '    PROF_'//clk//'  PROFA_'//clk//'  PROFB_'//clk
               ilc(l) = lastc ( cathead(l) )
             enddo
             write (77,'(a,'//cnmax//'(a))') cathead0(1:ilc0), (cathead(l)(1:ilc(l)), l=1,np(k))
             write (77,'(a)') '#'
             do m=1,npts3
               write (77,'(i5,2(1pe12.4),'//cnmax//'(1x,3(1pe12.4)))') m, rad(m), max ( rad(m) * as2pc, 1.0d-31 ), (profile(l,m)
     &                                                               , profilea(l,m), profileb(l,m), l=1,np(k))
             enddo
             close (77)
             deallocate ( cathead, ilc )
           endif
         endif

         if (npts .gt. 1) then
           if (cverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing selected profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'~profiles.fi.????.sel.cat'//''''
           write (clk1,'(i4.4)') lk1
           write (clk2,'(i4.4)') lk1+npxstep
           write (clk3,'(i4.4)') lk1+npxstep+npxstep
           open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'~profiles.fi.'//cnextr//'.sel.cat', status='unknown' )
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '#'//getstitle(2:)
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
           write (77,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
           write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
           write (77,'(a)') '#'
           write (77,'(a)') '# CATALOG OF FILAMENT PROFILES (FOR SELECTED SKELETON POINTS)'
           write (77,'(a)') '#'
           write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
           write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
           write (77,'(a)') '#'
           write (77,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
           write (77,'(a)') '#'
           write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
           write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
           write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
           write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
           write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', npixfil(k)
           write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', lk1
           write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', npxstep
           write (77,'(a)') '#'
           write (77,'(a)') '# TABULATED QUANTITIES:'
           write (77,'(a)') '#'
           write (77,'(a)') '#   NR ........ Number of radial point ...............'
           write (77,'(a)') '#   ANGLE ..... Angular distance from the skeleton ... arcsec'
           write (77,'(a)') '#   RADIUS .... Radial distance from the skeleton .... pc (at '//cdistpc(1:idp)//' pc)'
           write (77,'(a)') '#   PROF_# .... Filament profile on both sides ....... sqrt ( PROFA_# * PROFB_# )'
           write (77,'(a)') '#   PROFA_# ... Filament profile on the left side .... image units'
           write (77,'(a)') '#   PROFB_# ... Filament profile on the right side ... image units'
           write (77,'(a)') '#'
           allocate ( cathead(np(k)), ilc(np(k)), stat=irc )
           if (irc .ne. 0) then
             write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (42).'
             stop 42
           endif
           cathead0 = '#  NR    ANGLE       RADIUS  |'
           ilc0 = lastc ( cathead0 ) - 1
           do l=lk1,np(k),npxstep
             write (clk,'(i4.4)') l
             cathead(l) = '    PROF_'//clk//'  PROFA_'//clk//'  PROFB_'//clk
             ilc(l) = lastc ( cathead(l) )
           enddo
           write (77,'(a,'//cnmax//'(a))') cathead0(1:ilc0), (cathead(l)(1:ilc(l)), l=lk1,np(k),npxstep)
           write (77,'(a)') '#'
           do m=1,npts3
             write (77,'(i5,2(1pe12.4),'//cnmax//'(1x,3(1pe12.4)))') m, rad(m), max ( rad(m) * as2pc, 1.0d-31 ), (profile(l,m)
     &                                                             , profilea(l,m), profileb(l,m), l=lk1,np(k),npxstep)
           enddo
           close (77)
           deallocate ( cathead, ilc )
         endif

! Compute logarithmic slopes of the profiles.

         nmaskamea = 0.0d0
         nmaskbmea = 0.0d0
         nmaskamed = 0.0d0
         nmaskbmed = 0.0d0

         do l=1,np(k)
           do m=1,nptsa
             profa(m) = profilea(l,m)
             maska(m) = 1.0d0
           enddo
           do m=1,nptsb
             profb(m) = profileb(l,m)
             maskb(m) = 1.0d0
           enddo
  
! The slopes will define MASKA and MASKB, the maximum extents of the profiles and normals.

           call slopes ( nptsa, rad, profa, maska, nwin, slopea, slopeamax, almostzero )
           call slopes ( nptsb, rad, profb, maskb, nwin, slopeb, slopebmax, almostzero )

           nmaska(l) = 1.0d0
           nmaskb(l) = 1.0d0
           do m=1,nptsa
             if (maska(m) .gt. almostzero) nmaska(l) = dble ( m )
           enddo
           do m=1,nptsb
             if (maskb(m) .gt. almostzero) nmaskb(l) = dble ( m )
           enddo
           nmaskamea = nmaskamea + nmaska(l)
           nmaskbmea = nmaskbmea + nmaskb(l)
         enddo

! Limit the radial extension along normals by a median value along the skeleton.

         nmaskamea = nmaskamea / dble ( np(k) )
         nmaskbmea = nmaskbmea / dble ( np(k) )

         do l=1,np(k)
           nmaska(l) = min ( nmaska(l), nmaskamea )
           nmaskb(l) = min ( nmaskb(l), nmaskbmea )
         enddo

!!! Limit the radial extension along normals by a median value along the skeleton.
!!
!!         nmaskamed = selectk ( (np(k) + 1) / 2, np(k), nmaska )
!!         nmaskbmed = selectk ( (np(k) + 1) / 2, np(k), nmaskb )
!!
!!         do l=1,np(k)
!!           nmaska(l) = min ( nmaska(l), nmaskamed )
!!           nmaskb(l) = min ( nmaskb(l), nmaskbmed )
!!         enddo

! Selected one-sided mean values and standard deviations of the profiles.

         do m=1,nptsa
           napa(m) = 0
           do l=1,np(k)
             if (profilea(l,m) .gt. almostzero .and. m .le. nint ( nmaska(l) )) then
               napa(m) = napa(m) + 1
               profmeana(m) = profmeana(m) + profilea(l,m)
               profmeda(napa(m)) = profilea(l,m)
             endif
           enddo
           if (napa(m) .gt. 0) profmeana(m) = profmeana(m) / dble ( napa(m) )
           if (napa(m) .gt. 1) then
             profmediana(m) = selectk ( (napa(m) + 1) / 2, napa(m), profmeda )
           endif
           napa(m) = 0
           nama(m) = 0
           navpa(m) = 0
           navma(m) = 0
           do l=1,np(k)
             if (profilea(l,m) .gt. almostzero .and. m .le. nint ( nmaska(l) )) then
               if (profilea(l,m) - profmeana(m) .ge. 0.0d0) then
                 napa(m) = napa(m) + 1
                 profmeasdpa(m) = profmeasdpa(m) + (profilea(l,m) - profmeana(m))**2
               endif
               if (profilea(l,m) - profmeana(m) .le. 0.0d0) then
                 nama(m) = nama(m) + 1
                 profmeasdma(m) = profmeasdma(m) + (profilea(l,m) - profmeana(m))**2
               endif
               if (profilea(l,m) - profmediana(m) .ge. 0.0d0) then
                 navpa(m) = navpa(m) + 1
                 profmedsdpa(m) = profmedsdpa(m) + (profilea(l,m) - profmediana(m))**2
               endif
               if (profilea(l,m) - profmediana(m) .le. 0.0d0) then
                 navma(m) = navma(m) + 1
                 profmedsdma(m) = profmedsdma(m) + (profilea(l,m) - profmediana(m))**2
               endif
             endif
           enddo
           if (napa(m) .gt. 1) then
             profmeasdpa(m) = sqrt ( profmeasdpa(m) / (dble ( napa(m) ) - 1.0d0) )
           endif
           if (nama(m) .gt. 1) then
             profmeasdma(m) = sqrt ( profmeasdma(m) / (dble ( nama(m) ) - 1.0d0) )
           endif
           if (navpa(m) .gt. 1) then
             profmedsdpa(m) = sqrt ( profmedsdpa(m) / (dble ( navpa(m) ) - 1.0d0) )
           endif
           if (navma(m) .gt. 1) then
             profmedsdma(m) = sqrt ( profmedsdma(m) / (dble ( navma(m) ) - 1.0d0) )
           endif
         enddo

         do m=1,nptsb
           napb(m) = 0
           do l=1,np(k)
             if (profileb(l,m) .gt. almostzero .and. m .le. nint ( nmaskb(l) )) then
               napb(m) = napb(m) + 1
               profmeanb(m) = profmeanb(m) + profileb(l,m)
               profmedb(napb(m)) = profileb(l,m)
             endif
           enddo
           if (napb(m) .gt. 0) profmeanb(m) = profmeanb(m) / dble ( napb(m) )
           if (napb(m) .gt. 1) then
             profmedianb(m) = selectk ( (napb(m) + 1) / 2, napb(m), profmedb )
           endif
           napb(m) = 0
           namb(m) = 0
           navpb(m) = 0
           navmb(m) = 0
           do l=1,np(k)
             if (profileb(l,m) .gt. almostzero .and. m .le. nint ( nmaskb(l) )) then
               if (profileb(l,m) - profmeanb(m) .ge. 0.0d0) then
                 napb(m) = napb(m) + 1
                 profmeasdpb(m) = profmeasdpb(m) + (profileb(l,m) - profmeanb(m))**2
               endif
               if (profileb(l,m) - profmeanb(m) .le. 0.0d0) then
                 namb(m) = namb(m) + 1
                 profmeasdmb(m) = profmeasdmb(m) + (profileb(l,m) - profmeanb(m))**2
               endif
               if (profileb(l,m) - profmedianb(m) .ge. 0.0d0) then
                 navpb(m) = navpb(m) + 1
                 profmedsdpb(m) = profmedsdpb(m) + (profileb(l,m) - profmedianb(m))**2
               endif
               if (profileb(l,m) - profmedianb(m) .le. 0.0d0) then
                 navmb(m) = navmb(m) + 1
                 profmedsdmb(m) = profmedsdmb(m) + (profileb(l,m) - profmedianb(m))**2
               endif
             endif
           enddo
           if (napb(m) .gt. 1) then
             profmeasdpb(m) = sqrt ( profmeasdpb(m) / (dble ( napb(m) ) - 1.0d0) )
           endif
           if (namb(m) .gt. 1) then
             profmeasdmb(m) = sqrt ( profmeasdmb(m) / (dble ( namb(m) ) - 1.0d0) )
           endif
           if (navpb(m) .gt. 1) then
             profmedsdpb(m) = sqrt ( profmedsdpb(m) / (dble ( navpb(m) ) - 1.0d0) )
           endif
           if (navmb(m) .gt. 1) then
             profmedsdmb(m) = sqrt ( profmedsdmb(m) / (dble ( navmb(m) ) - 1.0d0) )
           endif
         enddo

! Selected full (two-sided) mean values and standard deviations of the profiles.

         do m=1,nptsm
           profmean(m) = sqrt ( profmeana(m) * profmeanb(m) )
           profmedian(m) = sqrt ( profmediana(m) * profmedianb(m) )
           nap(m) = 0
           nam(m) = 0
           navp(m) = 0
           navm(m) = 0
           do l=1,np(k)
             if (profilea(l,m) .gt. almostzero .and. m .le. nint ( nmaska(l) )) then
               if (profilea(l,m) - profmean(m) .ge. 0.0d0) then
                 nap(m) = nap(m) + 1
                 profmeasdp(m) = profmeasdp(m) + (profilea(l,m) - profmean(m))**2
               endif
               if (profilea(l,m) - profmean(m) .le. 0.0d0) then
                 nam(m) = nam(m) + 1
                 profmeasdm(m) = profmeasdm(m) + (profilea(l,m) - profmean(m))**2
               endif
               if (profilea(l,m) - profmedian(m) .ge. 0.0d0) then
                 navp(m) = navp(m) + 1
                 profmedsdp(m) = profmedsdp(m) + (profilea(l,m) - profmedian(m))**2
               endif
               if (profilea(l,m) - profmedian(m) .le. 0.0d0) then
                 navm(m) = navm(m) + 1
                 profmedsdm(m) = profmedsdm(m) + (profilea(l,m) - profmedian(m))**2
               endif
             endif
             if (profileb(l,m) .gt. almostzero .and. m .le. nint ( nmaskb(l) )) then
               if (profileb(l,m) - profmean(m) .ge. 0.0d0) then
                 nap(m) = nap(m) + 1
                 profmeasdp(m) = profmeasdp(m) + (profileb(l,m) - profmean(m))**2
               endif
               if (profileb(l,m) - profmean(m) .le. 0.0d0) then
                 nam(m) = nam(m) + 1
                 profmeasdm(m) = profmeasdm(m) + (profileb(l,m) - profmean(m))**2
               endif
               if (profilea(l,m) - profmedian(m) .ge. 0.0d0) then
                 navp(m) = navp(m) + 1
                 profmedsdp(m) = profmedsdp(m) + (profileb(l,m) - profmedian(m))**2
               endif
               if (profileb(l,m) - profmedian(m) .le. 0.0d0) then
                 navm(m) = navm(m) + 1
                 profmedsdm(m) = profmedsdm(m) + (profileb(l,m) - profmedian(m))**2
               endif
             endif
           enddo
           if (nap(m) .gt. 1) then
             profmeasdp(m) = sqrt ( profmeasdp(m) / (dble ( nap(m) ) - 1.0d0) )
           endif
           if (nam(m) .gt. 1) then
             profmeasdm(m) = sqrt ( profmeasdm(m) / (dble ( nam(m) ) - 1.0d0) )
           endif
           if (navp(m) .gt. 1) then
             profmedsdp(m) = sqrt ( profmedsdp(m) / (dble ( navp(m) ) - 1.0d0) )
           endif
           if (navm(m) .gt. 1) then
             profmedsdm(m) = sqrt ( profmedsdm(m) / (dble ( navm(m) ) - 1.0d0) )
           endif
         enddo
         
! Compute logarithmic slopes of the profiles.

         call slopes ( nptsm, rad, profmean,  profmeasdp,  nwin, slopemean,  slopemeanmax,  almostzero )
         call slopes ( nptsm, rad, profmean,  profmeasdm,  nwin, slopemean,  slopemeanmax,  almostzero )
         call slopes ( nptsa, rad, profmeana, profmeasdpa, nwin, slopemeana, slopemeanamax, almostzero )
         call slopes ( nptsa, rad, profmeana, profmeasdma, nwin, slopemeana, slopemeanamax, almostzero )
         call slopes ( nptsb, rad, profmeanb, profmeasdpb, nwin, slopemeanb, slopemeanbmax, almostzero )
         call slopes ( nptsb, rad, profmeanb, profmeasdmb, nwin, slopemeanb, slopemeanbmax, almostzero )

         if (npts .gt. 1) then
           if (cverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing mean profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'~profiles.fi.????.mea.cat'//''''

           open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'~profiles.fi.'//cnextr//'.mea.cat', status='unknown' )
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '#'//getstitle(2:)
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
           write (77,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
           write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
           write (77,'(a)') '#'
           write (77,'(a)') '# CATALOG OF MEAN FILAMENT PROFILES (ALONG SKELETON)'
           write (77,'(a)') '#'
           write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
           write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
           write (77,'(a)') '#'
           write (77,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
           write (77,'(a)') '#'
           write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
           write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
           write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
           write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
           write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', npixfil(k)
           write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', 1
           write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', 1
           write (77,'(a)') '#'
           write (77,'(a)') '# TABULATED QUANTITIES:'
           write (77,'(a)') '#'
           write (77,'(a)') '#   NR ......... Number of radial point ..............................'
           write (77,'(a)') '#   ANGLE ...... Angular distance from the skeleton .................. arcsec'
           write (77,'(a)') '#   RADIUS ..... Radial distance from the skeleton ................... pc (at '
     &                    //cdistpc(1:idp)//' pc)'
           write (77,'(a)') '#   PROFILE .... Mean filament profile on both sides ................. sqrt ( PROFILEA * PROFILEB )'
           write (77,'(a)') '#   PROFSD+ .... Standard deviations about PROFILE along filament ....'
           write (77,'(a)') '#   PROFSD- .... Standard deviations about PROFILE along filament ....'
           write (77,'(a)') '#   NPT ........ Number of points used for PROFSD+- ..................'
           write (77,'(a)') '#   PROFILEA ... Left-side mean intensity profile ....................'
           write (77,'(a)') '#   PROFSDA+ ... Standard deviations about PROFILEA along filament ...'
           write (77,'(a)') '#   PROFSDA- ... Standard deviations about PROFILEA along filament ...'
           write (77,'(a)') '#   NPTA ....... Number of points used for PROFSDA+- .................'
           write (77,'(a)') '#   PROFILEB ... Right-side mean intensity profile ...................'
           write (77,'(a)') '#   PROFSDB+ ... Standard deviations about PROFILEB along filament ...'
           write (77,'(a)') '#   PROFSDB- ... Standard deviations about PROFILEB along filament ...'
           write (77,'(a)') '#   NPTB ....... Number of points used for PROFSDB+- .................'
           write (77,'(a)') '#   SLOPE ...... Logarithmic slope of PROFILE ........................ negated, mean-filtered'
           write (77,'(a)') '#   SLOPEA ..... Logarithmic slope of PROFILEA ....................... negated, mean-filtered'
           write (77,'(a)') '#   SLOPEB ..... Logarithmic slope of PROFILEB ....................... negated, mean-filtered'
           write (77,'(a)') '#   NWIN ....... Window radius for smoothing SLOPE, SLOPEA, SLOPEB ...'
           write (77,'(a)') '#   RW+/RW- .... Ratio of the radii of the smoothing window edges ....'
           write (77,'(a)') '#'
           write (77,'(a)') '#  NR    ANGLE       RADIUS     PROFILE     PROFSD+     PROFSD-     NPT   PROFILEA    PROFSDA+'
     &                    //'    PROFSDA-   NPTA   PROFILEB    PROFSDB+    PROFSDB-   NPTB    SLOPE      SLOPEA     SLOPEB  NWIN'
     &                    //'   RW+/RW-   SLOPEMAX   SLOPEAMAX  SLOPEBMAX'
           write (77,'(a)') '#'
           do m=1,npts
             if (nap(m)+nam(m) .gt. 1) then
               
               if (profmeasdp(m)  .lt. 1.0d-30 .and. profmeasdm(m)  .lt. 1.0d-30) profmean(m) = 0.0d0
               if (profmeasdpa(m) .lt. 1.0d-30 .and. profmeasdma(m) .lt. 1.0d-30) profmeana(m) = 0.0d0
               if (profmeasdpb(m) .lt. 1.0d-30 .and. profmeasdmb(m) .lt. 1.0d-30) profmeanb(m) = 0.0d0
               if (profmeasdp(m)  .lt. 1.0d-30 .and. profmeasdm(m)  .lt. 1.0d-30) slopemean(m) = 0.0d0
               if (profmeasdpa(m) .lt. 1.0d-30 .and. profmeasdma(m) .lt. 1.0d-30) slopemeana(m) = 0.0d0
               if (profmeasdpb(m) .lt. 1.0d-30 .and. profmeasdmb(m) .lt. 1.0d-30) slopemeanb(m) = 0.0d0

               write (77,'(i5,2(1pe12.4),3(3(1pe12.4),i6),3(1pe11.3),i5,4(1pe11.3))') m, rad(m), max ( rad(m) * as2pc, 1.0d-31 )
     &                  , profmean(m), profmeasdp(m), profmeasdm(m), nap(m)+nam(m), profmeana(m), profmeasdpa(m), profmeasdma(m)
     &                  , napa(m)+nama(m), profmeanb(m), profmeasdpb(m), profmeasdmb(m), napb(m)+namb(m), slopemean(m)
     &                  , slopemeana(m), slopemeanb(m), nwin(m), rad(min(m+nwin(m),npts)) / rad(max(m-nwin(m),1)), slopemeanmax
     &                  , slopemeanamax, slopemeanbmax
             endif
           enddo
           close (77)
         endif

! Compute logarithmic slopes of the profiles.

         call slopes ( nptsm, rad, profmedian,  profmedsdp,  nwin, slopemedian,  slopemedianmax,  almostzero )
         call slopes ( nptsm, rad, profmedian,  profmedsdm,  nwin, slopemedian,  slopemedianmax,  almostzero )
         call slopes ( nptsa, rad, profmediana, profmedsdpa, nwin, slopemediana, slopemedianamax, almostzero )
         call slopes ( nptsa, rad, profmediana, profmedsdma, nwin, slopemediana, slopemedianamax, almostzero )
         call slopes ( nptsb, rad, profmedianb, profmedsdpb, nwin, slopemedianb, slopemedianbmax, almostzero )
         call slopes ( nptsb, rad, profmedianb, profmedsdmb, nwin, slopemedianb, slopemedianbmax, almostzero )

         if (npts .gt. 1) then
           if (cverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing median profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'~profiles.fi.????.med.cat'//''''

           open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'~profiles.fi.'//cnextr//'.med.cat', status='unknown' )
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '#'//getstitle(2:)
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
           write (77,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
           write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
           write (77,'(a)') '#'
           write (77,'(a)') '# CATALOG OF MEDIAN FILAMENT PROFILES (ALONG SKELETON)'
           write (77,'(a)') '#'
           write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
           write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
           write (77,'(a)') '#'
           write (77,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
           write (77,'(a)') '#'
           write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
           write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
           write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
           write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
           write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', npixfil(k)
           write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', 1
           write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', 1
           write (77,'(a)') '#'
           write (77,'(a)') '# TABULATED QUANTITIES:'
           write (77,'(a)') '#'
           write (77,'(a)') '#   NR ......... Number of radial point ..............................'
           write (77,'(a)') '#   ANGLE ...... Angular distance from the skeleton .................. arcsec'
           write (77,'(a)') '#   RADIUS ..... Radial distance from the skeleton ................... pc (at '
     &                    //cdistpc(1:idp)//' pc)'
           write (77,'(a)') '#   PROFILE .... Median filament intensity profile on both sides ..... sqrt ( PROFILEA * PROFILEB )'
           write (77,'(a)') '#   PROFSD+ .... Standard deviations about PROFILE along filament ....'
           write (77,'(a)') '#   PROFSD- .... Standard deviations about PROFILE along filament ....'
           write (77,'(a)') '#   NPT ........ Number of points used for PROFSD+- ..................'
           write (77,'(a)') '#   PROFILEA ... Left-side median intensity profile ..................'
           write (77,'(a)') '#   PROFSDA+ ... Standard deviations about PROFILEA along filament ...'
           write (77,'(a)') '#   PROFSDA- ... Standard deviations about PROFILEA along filament ...'
           write (77,'(a)') '#   NPTA ....... Number of points used for PROFSDA+- .................'
           write (77,'(a)') '#   PROFILEB ... Right-side median intensity profile .................'
           write (77,'(a)') '#   PROFSDB+ ... Standard deviations about PROFILEB along filament ...'
           write (77,'(a)') '#   PROFSDB- ... Standard deviations about PROFILEB along filament ...'
           write (77,'(a)') '#   NPTB ....... Number of points used for PROFSDB+- .................'
           write (77,'(a)') '#   SLOPE ...... Logarithmic slope of PROFILE ........................ negated, median-filtered'
           write (77,'(a)') '#   SLOPEA ..... Logarithmic slope of PROFILEA ....................... negated, median-filtered'
           write (77,'(a)') '#   SLOPEB ..... Logarithmic slope of PROFILEB ....................... negated, median-filtered'
           write (77,'(a)') '#   NWIN ....... Window radius for smoothing SLOPE, SLOPEA, SLOPEB ...'
           write (77,'(a)') '#   RW+/RW- .... Ratio of the radii of the smoothing window edges ....'
           write (77,'(a)') '#'
           write (77,'(a)') '#  NR    ANGLE       RADIUS     PROFILE     PROFSD+     PROFSD-     NPT   PROFILEA    PROFSDA+'
     &                    //'    PROFSDA-   NPTA   PROFILEB    PROFSDB+    PROFSDB-   NPTB    SLOPE      SLOPEA     SLOPEB  NWIN'
     &                    //'   RW+/RW-   SLOPEMAX   SLOPEAMAX  SLOPEBMAX'
           write (77,'(a)') '#'
           do m=1,npts
             if (navp(m)+navm(m) .gt. 1) then

               if (profmedsdp(m)  .lt. 1.0d-30 .and. profmedsdm(m)  .lt. 1.0d-30) profmedian(m) = 0.0d0
               if (profmedsdpa(m) .lt. 1.0d-30 .and. profmedsdma(m) .lt. 1.0d-30) profmediana(m) = 0.0d0
               if (profmedsdpb(m) .lt. 1.0d-30 .and. profmedsdmb(m) .lt. 1.0d-30) profmedianb(m) = 0.0d0
               if (profmedsdp(m)  .lt. 1.0d-30 .and. profmedsdm(m)  .lt. 1.0d-30) slopemedian(m) = 0.0d0
               if (profmedsdpa(m) .lt. 1.0d-30 .and. profmedsdma(m) .lt. 1.0d-30) slopemediana(m) = 0.0d0
               if (profmedsdpb(m) .lt. 1.0d-30 .and. profmedsdmb(m) .lt. 1.0d-30) slopemedianb(m) = 0.0d0

               write (77,'(i5,2(1pe12.4),3(3(1pe12.4),i6),3(1pe11.3),i5,4(1pe11.3))') m, rad(m), max ( rad(m) * as2pc, 1.0d-31 )
     &                  , profmedian(m), profmedsdp(m), profmedsdm(m), navp(m)+navm(m), profmediana(m), profmedsdpa(m)
     &                  , profmedsdma(m), navpa(m)+navma(m), profmedianb(m), profmedsdpb(m), profmedsdmb(m), navpb(m)+navmb(m)
     &                  , slopemedian(m), slopemediana(m), slopemedianb(m), nwin(m)
     &                  , rad(min(m+nwin(m),npts)) / rad(max(m-nwin(m),1)), slopemedianmax, slopemedianamax, slopemedianbmax
             endif
           enddo
           close (77)
         endif
         
! Make sure that profiles are placed symmetrically about filament end points.

         do l=lk1,np(k),npxstep
           
           if (nmaska(l) .gt. 1.0d0) then
             do m=1,nint(nmaska(l))
               dr = dble ( m - 1 )
               xa = xpixmean(k,l) + cosa(k,l) * dr
               ya = ypixmean(k,l) + sina(k,l) * dr
               ia = nint ( xa )
               ja = nint ( ya )
               if (ia .ge. 1 .and. ia .le. nx .and. ja .ge. 1 .and. ja .le. ny) then
                 normals(ia,ja) = 0.5d0
               endif
             enddo
           endif
           
           if (nmaskb(l) .gt. 1.0d0) then
             do m=1,nint(nmaskb(l))
               dr = dble ( m - 1 )
               xb = xpixmean(k,l) + cosb(k,l) * dr
               yb = ypixmean(k,l) + sinb(k,l) * dr
               ib = nint ( xb )
               jb = nint ( yb )
               if (ib .ge. 1 .and. ib .le. nx .and. jb .ge. 1 .and. jb .le. ny) then
                 normals(ib,jb) = 0.6d0
               endif
             enddo
           endif
         enddo

         filamass(k) = 0.0d0
         filamasa(k) = 0.0d0
         filamasb(k) = 0.0d0
         lindenp(k) = 0.0d0
         lindenpa(k) = 0.0d0
         lindenpb(k) = 0.0d0

         do l=1,np(k)
           lsidea = .false.
           lsideb = .false.
           if (hwidtha(k,l) .gt. almostzero .and. hwidthb(k,l) .gt. almostzero) then
             lsidea = .true.
             lsideb = .true.
           elseif (hwidtha(k,l) .gt. almostzero) then
             lsidea = .true.
           elseif (hwidthb(k,l) .gt. almostzero) then
             lsideb = .true.
           endif

           lindena(k,l) = 0.0d0
           if (lsidea .and. nmaska(l) .gt. 1.0d0) then
             do m=1,nint(nmaska(l))
               dr = dble ( m - 1 )
               xa = xpixmean(k,l) + cosa(k,l) * dr
               ya = ypixmean(k,l) + sina(k,l) * dr
               ia = nint ( xa )
               ja = nint ( ya )
               if (ia .ge. 1 .and. ia .le. nx .and. ja .ge. 1 .and. ja .le. ny) then
                 drad = sqrt ( cosa(k,l)**2 + sina(k,l)**2 ) * dx
                 lindena(k,l) = lindena(k,l) + 2.0d0 * xmu * xmH * imagefil(ia,ja) * drad
               endif
             enddo
           endif

           lindenb(k,l) = 0.0d0
           if (lsideb .and. nmaskb(l) .gt. 1.0d0) then
             do m=1,nint(nmaskb(l))
               dr = dble ( m - 1 )
               xb = xpixmean(k,l) + cosb(k,l) * dr
               yb = ypixmean(k,l) + sinb(k,l) * dr
               ib = nint ( xb )
               jb = nint ( yb )
               if (ib .ge. 1 .and. ib .le. nx .and. jb .ge. 1 .and. jb .le. ny) then
                 drad = sqrt ( cosb(k,l)**2 + sinb(k,l)**2 ) * dx
                 lindenb(k,l) = lindenb(k,l) + 2.0d0 * xmu * xmH * imagefil(ib,jb) * drad
               endif
             enddo
           endif

           if (lsidea .and. lsideb) then
             lindentwo(l) = (lindena(k,l) + lindenb(k,l)) / 2.0d0
             lindentwa(l) = lindena(k,l)
             lindentwb(l) = lindenb(k,l)
           elseif (lsidea) then
             lindentwo(l) = lindena(k,l)
             lindentwa(l) = lindena(k,l)
             lindentwb(l) = lindena(k,l)
           else
             lindentwo(l) = lindenb(k,l)
             lindentwa(l) = lindenb(k,l)
             lindentwb(l) = lindenb(k,l)
           endif

! Determine footprints of filaments by filling up circles of diameters of leftnormal or rigthnormal at each skeleton point.

           xo = xpixmean(k,l)
           yo = ypixmean(k,l)
           l1 = max ( nint ( xo - max ( nmaska(l), nmaskb(l) ) ), 1 )
           l2 = min ( nint ( xo + max ( nmaska(l), nmaskb(l) ) ), nx )
           m1 = max ( nint ( yo - max ( nmaska(l), nmaskb(l) ) ), 1 )
           m2 = min ( nint ( yo + max ( nmaska(l), nmaskb(l) ) ), ny )

           footmajora = nmaska(l) / 2.0d0
           xa = xo + cosa(k,l) * footmajora
           ya = yo + sina(k,l) * footmajora
           footmajorb = nmaskb(l) / 2.0d0
           xb = xo + cosb(k,l) * footmajorb
           yb = yo + sinb(k,l) * footmajorb
           
! This is a minimum distance from the center of the ellipse to the skeleton to fix (reduce) the minor axis of the ellipse.

           dista = 1.0d99
           distb = 1.0d99
           do ll=1,np(k)
             dista = min ( dista, sqrt ( dble ( xa - xpixmean(k,ll) )**2 + dble ( ya - ypixmean(k,ll) )**2 ) )
             distb = min ( distb, sqrt ( dble ( xb - xpixmean(k,ll) )**2 + dble ( yb - ypixmean(k,ll) )**2 ) )
           enddo
           dist1 = sqrt ( dble ( xpixmean(k,1) - xo )**2 + dble ( ypixmean(k,1) - yo )**2 )
           distn = sqrt ( dble ( xpixmean(k,np(k)) - xo )**2 + dble ( ypixmean(k,np(k)) - yo )**2 )

           footminora = 2.0d0 * max ( min ( footmajora, dist1, distn, dista ), 0.2d0 * footmajora ) * dx
           footminorb = 2.0d0 * max ( min ( footmajorb, dist1, distn, distb ), 0.2d0 * footmajorb ) * dx
           footmajora = 2.0d0 * footmajora * dx
           footmajorb = 2.0d0 * footmajorb * dx

! The left and right footprints may sometimes slightly overlap near the skeleton.
           
           do m=m1,m2
             dblm = dble ( m )
             do n=l1,l2
               dbll = dble ( n )
               if (inellipse ( dbll, dblm, dx, dy, xa, ya, footmajora, footminora, nanglea(k,l) )) then
                 foota(n,m) = max ( foota(n,m), dble ( k ) )
               endif
               if (inellipse ( dbll, dblm, dx, dy, xb, yb, footmajorb, footminorb, nangleb(k,l) )) then
                 footb(n,m) = max ( footb(n,m), dble ( k ) )
               endif
             enddo
           enddo
           
! Avoid taking the same values twice in those left-side footprint pixels that happen to overlap between the sides.

           do m=m1,m2
             dblm = dble ( m )
             do n=l1,l2
               dbll = dble ( n )
               if (inellipse ( dbll, dblm, dx, dy, xa, ya, footmajora, footminora, nanglea(k,l) )) then
                 if (nint ( worker(n,m) ) .ne. -k) then
                   if (nint ( foota(n,m) ) .eq. k .and. nint ( footb(n,m) ) .eq. k) then
                     filamasa(k) = filamasa(k) + xmu * xmH * imagefil(n,m) * dx * dy
                   else if (nint ( foota(n,m) ) .eq. k) then
                     filamasa(k) = filamasa(k) + 2.0d0 * xmu * xmH * imagefil(n,m) * dx * dy
                   endif
                 endif
                 worker(n,m) = -dble ( k )
               endif
             enddo
           enddo

! Avoid taking the same values twice in those right-side footprint pixels that happen to overlap between the sides.

           do m=m1,m2
             dblm = dble ( m )
             do n=l1,l2
               dbll = dble ( n )
               if (inellipse ( dbll, dblm, dx, dy, xb, yb, footmajorb, footminorb, nangleb(k,l) )) then
                 if (nint ( worker(n,m) ) .ne. k) then
                   if (nint ( footb(n,m) ) .eq. k .and. nint ( foota(n,m) ) .eq. k) then
                     filamasb(k) = filamasb(k) + xmu * xmH * imagefil(n,m) * dx * dy
                   else if (nint ( footb(n,m) ) .eq. k) then
                     filamasb(k) = filamasb(k) + 2.0d0 * xmu * xmH * imagefil(n,m) * dx * dy
                   endif
                 endif
                 worker(n,m) = dble ( k )
               endif
             enddo
           enddo
         enddo
         
         filamass(k) = (filamasa(k) + filamasb(k)) / 2.0d0
         lindenm(k)  = filamass(k) / (length(k) + almostzero)
         lindenma(k) = filamasa(k) / (length(k) + almostzero)
         lindenmb(k) = filamasb(k) / (length(k) + almostzero)
         
! Median-averaged linear density integrated over normals.

         if (np(k) .gt. 0) then
           lindenp(k)  = selectk ( (np(k) + 1) / 2, np(k), lindentwo )
           lindenpa(k) = selectk ( (np(k) + 1) / 2, np(k), lindentwa )
           lindenpb(k) = selectk ( (np(k) + 1) / 2, np(k), lindentwb )
         endif
         
         lindstd(k) = 0.0d0
         do l=1,np(k)
           lindstd(k) = lindstd(k) + (lindentwo(l) - lindenp(k))**2
         enddo
         if (np(k) .gt. 1) lindstd(k) = sqrt ( lindstd(k) / (dble ( np(k) ) - 1.0d0) )

         snrlind(k) = 0.0d0
         if (lindenp(k) .gt. almostzero .and. lindstd(k) .gt. almostzero) snrlind(k) = lindenp(k) / lindstd(k)

         if (npts .gt. 1) then
           if (cverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing linear densities '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'~lindens.fi.????.cat'//''''

           open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'~lindens.fi.'//cnextr//'.cat', status='unknown' )
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '#'//getstitle(2:)
           write (77,'(a)') cbars
           write (77,'(a)') '#'
           write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
           write (77,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
           write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
           write (77,'(a)') '#'
           write (77,'(a)') '# CATALOG OF LINEAR DENSITIES ALONG A FILAMENT'
           write (77,'(a)') '#'
           write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
           write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
           write (77,'(a)') '#'
           write (77,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
           write (77,'(a)') '#'
           write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
           write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
           write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
           write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
           write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', npixfil(k)
           write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', lk1
           write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', npxstep
           write (77,'(a)') '#'
           write (77,'(a)') '# TABULATED QUANTITIES:'
           write (77,'(a)') '#'
           write (77,'(a)') '#   NP ........ Number of the point along skeleton ...... Msun/pc (at '//cdistpc(1:idp)//' pc)'
           write (77,'(a)') '#   LINDEN .... Linear density from both sides .......... Msun/pc (at '//cdistpc(1:idp)//' pc)'
     &                    //' LINDEN = (LINDENA + LINDENB) / 2'
           write (77,'(a)') '#   LINDENA ... Linear density from the left profile .... Msun/pc (at '//cdistpc(1:idp)//' pc)'
           write (77,'(a)') '#   LINDENB ... Linear density from the right profile ... Msun/pc (at '//cdistpc(1:idp)//' pc)'
           write (77,'(a)') '#'
           write (77,'(a)') '#  NP    LINDEN      LINDENA     LINDENB'
           write (77,'(a)') '#'
           do l=1,np(k)
             flindena = max ( 2.0d0 * lindena(k,l) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
             flindenb = max ( 2.0d0 * lindenb(k,l) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
             write (77,'(i5,3(1pe12.4))') l, (flindena + flindenb) / 2.0d0, flindena, flindenb
           enddo
           close (77)
         endif

         deallocate ( profile, profilea, profileb, profmeda, profmedb, rad, napa, nama, navpa, navma, napb, namb, navpb, navmb, nap
     &              , nam, navp, navm, profmeana, profmeanb, profmean, profmeasdpa, profmeasdma, profmeasdpb, profmeasdmb
     &              , profmeasdp, profmeasdm, profmediana, profmedianb, profmedian, profmedsdpa, profmedsdma, profmedsdpb
     &              , profmedsdmb, profmedsdp, profmedsdm, slopemeana, slopemeanb, slopemean, slopemediana, slopemedianb
     &              , slopemedian, nwin, profa, profb, slopea, slopeb, maska, maskb, nmaska, nmaskb )

 888     continue     
       enddo

       if (cverbose .eq. '-verb2' .and. k .eq. 1) 
     &    write (iotty,'(a)') '   Writing selected widths '''//individprofs(1:indp)//'/'//outname(1:ion)//'~selwidth.cat'//''''
       
       open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'~selwidth.cat', status='unknown' )
       write (77,'(a)') cbars
       write (77,'(a)') '#'
       write (77,'(a)') '#'//getstitle(2:)
       write (77,'(a)') cbars
       write (77,'(a)') '#'
       write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (77,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
       write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (77,'(a)') '#'
       write (77,'(a)') '# CATALOG OF ONE-SIDED AND TWO-SIDED FULL WIDTHS (OVER SELECTED NORMALS TO SKELETONS)'
       write (77,'(a)') '#'
       write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (77,'(a)') '#'
       write (77,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
       write (77,'(a)') '#'
       write (77,'(a,i3)') '# Step over skeleton points for computing widths:', npxstep
       write (77,'(a,i2)') '# Window size over skeleton points for smoothing their coordinates:', 2*npw+1
       write (77,'(a)') '#'
       write (77,'(a)') '# TABULATED QUANTITIES:'
       write (77,'(a)') '#'
       write (77,'(a)') '#   NF ......... Number of a filament (skeleton) .................'
       write (77,'(a)') '#   PIXS ....... Number of points in the skeleton ................'
       write (77,'(a)') '#   NSEL ....... Number of a selected normal in the skeleton .....'
       write (77,'(a)') '#   WIDTH_# .... Full width obtained from both sides (minimum) ... pc (at '//cdistpc(1:idp)//' pc)'
     &                //' WIDTH = 2 * min ( WIDTHA, WIDTHB ) or WIDTH = 2 * WIDTHA or WIDTH = 2 * WIDTHB'
       write (77,'(a)') '#   WIDTHA_# ... Full width obtained from the left side .......... pc (at '//cdistpc(1:idp)//' pc)'
       write (77,'(a)') '#   WIDTHB_# ... Full width obtained from the right side ......... pc (at '//cdistpc(1:idp)//' pc)'
       write (77,'(a)') '#'
       allocate ( cathead(npxmax), ilc(npxmax), stat=irc )
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (422).'
         stop 422
       endif
       cathead0 = '#  NF   PIXS   NSEL|'
       lk1 = max ( (npxmax - int ( dble ( npxmax ) / dble ( npxstep ) ) * npxstep) / 2, 1 )
       ilc0 = lastc ( cathead0 ) - 1
       do l=lk1,npxmax,npxstep
         write (clk,'(i4.4)') l
         cathead(l) = '   WIDTH_'//clk//' WIDTHA_'//clk//' WIDTHB_'//clk
         ilc(l) = lastc ( cathead(l) )
       enddo
       write (77,'(a,'//cnmax//'(a))') cathead0(1:ilc0), (cathead(l)(1:ilc(l)), l=lk1,npxmax,npxstep)
       write (77,'(a)') '#'
       deallocate ( cathead, ilc )
       do k=1,nextr
         lk1 = max ( (np(k) - int ( dble ( np(k) ) / dble ( npxstep ) ) * npxstep) / 2, 1 )
         nsel = 0
         do l=lk1,np(k),npxstep
           nsel = nsel + 1
         enddo
         write (77,'(i5,2i7,'//cnmax//'(1x,3(1pe12.4)))') k, npixfil(k), nsel, (max ( width(k,l) * as2pc, 1.0d-31 )
     &                                                 , max ( widtha(k,l) * as2pc, 1.0d-31 ), max ( widthb(k,l) * as2pc, 1.0d-31 )
     &                                                 , l=lk1,np(k),npxstep)
       enddo
       close (77)

! Mean and median widths of a filament.

       do k=1,nextr
         nptwa(k) = 0
         do l=1,np(k)
           if (widtha(k,l) .gt. almostzero) then
             nptwa(k) = nptwa(k) + 1
             widthmeana(k) = widthmeana(k) + widtha(k,l)
           endif
         enddo
         if (nptwa(k) .gt. 0) widthmeana(k) = widthmeana(k) / dble ( nptwa(k) )

         nptwb(k) = 0
         do l=1,np(k)
           if (widthb(k,l) .gt. almostzero) then
             nptwb(k) = nptwb(k) + 1
             widthmeanb(k) = widthmeanb(k) + widthb(k,l)
           endif
         enddo
         if (nptwb(k) .gt. 0) widthmeanb(k) = widthmeanb(k) / dble ( nptwb(k) )

         if (widthmeana(k) .gt. almostzero .and. widthmeanb(k) .gt. almostzero) then
           widthmean(k) = sqrt ( widthmeana(k) * widthmeanb(k) )
         elseif (widthmeana(k) .gt. almostzero) then
           widthmean(k) = widthmeana(k)
         elseif (widthmeanb(k) .gt. almostzero) then
           widthmean(k) = widthmeanb(k)
         endif

         nptwa(k) = 0
         do l=1,np(k)
           if (widtha(k,l) .gt. almostzero) then
             nptwa(k) = nptwa(k) + 1
             funmed(nptwa(k)) = widtha(k,l)
           endif
         enddo
         if (nptwa(k) .gt. 0) widthmeda(k) = selectk ( (nptwa(k) + 1) / 2, nptwa(k), funmed )

         nptwb(k) = 0
         do l=1,np(k)
           if (widthb(k,l) .gt. almostzero) then
             nptwb(k) = nptwb(k) + 1
             funmed(nptwb(k)) = widthb(k,l)
           endif
         enddo
         if (nptwb(k) .gt. 0) widthmedb(k) = selectk ( (nptwb(k) + 1) / 2, nptwb(k), funmed )

         if (widthmeda(k) .gt. almostzero .and. widthmedb(k) .gt. almostzero) then
           widthmed(k) = sqrt ( widthmeda(k) * widthmedb(k) )
         elseif (widthmeda(k) .gt. almostzero) then
           nptw(k) = nptwa(k)
           widthmed(k) = widthmeda(k)
         elseif (widthmedb(k) .gt. almostzero) then
           nptw(k) = nptwb(k)
           widthmed(k) = widthmedb(k)
         endif

! Standard deviations of widths along filament.

         nptw(k) = 0
         do l=1,np(k)
           if (widthmean(k) .gt. almostzero) then
             nptw(k) = nptw(k) + 1
             widthstd(k) = widthstd(k) + (width(k,l) - widthmean(k))**2
           endif
         enddo
         if (nptw(k) .gt. 1) widthstd(k) = max ( sqrt ( widthstd(k) / (dble ( nptw(k) ) - 1.0d0) ), 1.0d-31 )

         nptwa(k) = 0
         do l=1,np(k)
           if (widthmeana(k) .gt. almostzero) then
             nptwa(k) = nptwa(k) + 1
             widthstda(k) = widthstda(k) + (widtha(k,l) - widthmeana(k))**2
           endif
         enddo
         if (nptwa(k) .gt. 1) widthstda(k) = max ( sqrt ( widthstda(k) / (dble ( nptwa(k) ) - 1.0d0) ), 1.0d-31 )

         nptwb(k) = 0
         do l=1,np(k)
           if (widthmeanb(k) .gt. almostzero) then
             nptwb(k) = nptwb(k) + 1
             widthstdb(k) = widthstdb(k) + (widthb(k,l) - widthmeanb(k))**2
           endif
         enddo
         if (nptwb(k) .gt. 1) widthstdb(k) = max ( sqrt ( widthstdb(k) / (dble ( nptwb(k) ) - 1.0d0) ), 1.0d-31 )

         crestmed(k) = 0.0d0
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           funmed(l) = imagefil(ia,ja)
         enddo
         if (np(k) .gt. 0) then
           crestmed(k) = selectk ( (np(k) + 1) / 2, np(k), funmed )
         endif
  
         creststd(k) = 0.0d0
         do l=1,np(k)
           creststd(k) = creststd(k) + (funmed(l) - crestmed(k))**2
         enddo
         if (np(k) .gt. 1) creststd(k) = sqrt ( creststd(k) / (dble ( np(k) ) - 1.0d0) )

! Signal-to-noise ratios for filaments widths.

         snrwmea(k) = 0.0d0
         snrwmeaa(k) = 0.0d0
         snrwmeab(k) = 0.0d0
         if (widthmean(k) .gt. almostzero .and. widthstd(k) .gt. almostzero) snrwmea(k) = widthmean(k) / widthstd(k)
         if (widthmeana(k) .gt. almostzero .and. widthstda(k) .gt. almostzero) snrwmeaa(k) = widthmeana(k) / widthstda(k)
         if (widthmeanb(k) .gt. almostzero .and. widthstdb(k) .gt. almostzero) snrwmeab(k) = widthmeanb(k) / widthstdb(k)
       enddo

       if (cverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing half-max widths '''//individprofs(1:indp)//'/'//outname(1:ion)//'~widths.cat'//''''
     
       open ( 66, file=individprofs(1:indp)//'/'//outname(1:ion)//'~widths.cat', status='unknown' )
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '#'//getstitle(2:)
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (66,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
       write (66,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (66,'(a)') '#'
       write (66,'(a)') '# CATALOG OF AVERAGE FULL WIDTHS AT HALF-MAXIMUM'
       write (66,'(a)') '#'
       write (66,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (66,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (66,'(a)') '#'
       write (66,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
       write (66,'(a)') '#'
       write (66,'(a,i3)') '# Step over skeleton points for computing widths:', npxstep
       write (66,'(a,i2)') '# Window size over skeleton points for smoothing their coordinates:', 2*npw+1
       write (66,'(a)') '#'
       write (66,'(a)') '# TABULATED QUANTITIES:'
       write (66,'(a)') '#'
       write (66,'(a)') '#   NF ......... Number of a filament (skeleton) .............'
       write (66,'(a)') '#   LENGAS ..... Total filament (skeleton) length ............ arcsec'
       write (66,'(a)') '#   WIDAS ...... Filament FWHM from both sides ............... arcsec'
     &                //' WIDAS = sqrt ( WIDTHA * WIDTHB )'
       write (66,'(a)') '#   LENGTH ..... Total filament (skeleton) length ............ pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   WIDTH ...... Filament FWHM from both sides ............... pc (at '//cdistpc(1:idp)//' pc)'
     &                //' WIDTH = sqrt ( WIDTHA * WIDTHB )'
       write (66,'(a)') '#   WIDTHA ..... Filament FWHM from the left side ............ pc (at '//cdistpc(1:idp)//' pc) median'
       write (66,'(a)') '#   WIDTHB ..... Filament FWHM from the right side ........... pc (at '//cdistpc(1:idp)//' pc) median'
       write (66,'(a)') '#   WIDTHM ..... Filament FWHM from both sides ............... pc (at '//cdistpc(1:idp)//' pc)'
     &                //' WIDTH = sqrt ( WIDTHMA * WIDTHMB )'
       write (66,'(a)') '#   WIDTHMA .... Filament FWHM from the left side ............ pc (at '//cdistpc(1:idp)//' pc) mean'
       write (66,'(a)') '#   WIDTHMB .... Filament FWHM from the right side ........... pc (at '//cdistpc(1:idp)//' pc) mean'
       write (66,'(a)') '#   WIDSTD ..... Standard deviation about WIDTHM ............. pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   WIDSTDA .... Standard deviation about WIDTHMA ............ pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   WIDSTDB .... Standard deviation about WIDTHMB ............ pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   NPTW ....... Number of points used for WIDTHM & WIDSTD ...'
       write (66,'(a)') '#   SNRWM ...... Signal-to-noise ratio WIDTHM / WIDSTD .......'
       write (66,'(a)') '#   SNRWMA ..... Signal-to-noise ratio WIDTHMA / WIDSTDA .....'
       write (66,'(a)') '#   SNRWMB ..... Signal-to-noise ratio WIDTHMB / WIDSTDB .....'
       write (66,'(a)') '#   CRESTMED ... Filament crest value (on skeleton) .......... image units; median'
       write (66,'(a)') '#   CRESTSTD ... Standard deviation about CRESTMED ........... image units'
       write (66,'(a)') '#'
       write (66,'(a)') '#  NF    LENGAS      WIDAS     LENGTH      WIDTH      WIDTHA     WIDTHB     WIDTHM    WIDTHMA    WIDTHMB'
     &                //'     WIDSTD    WIDSTDA    WIDSTDB  NPTW     SNRWM      SNRWMA     SNRWMB    CRESTMED   CRESTSTD'
       write (66,'(a)') '#'
       do k=1,nextr
         flenas   = max ( length(k)            , 1.0d-31 )
         wmedas   = max ( widthmed(k)          , 1.0d-31 )
         flength  = max ( length(k)     * as2pc, 1.0d-31 )
         wmed     = max ( widthmed(k)   * as2pc, 1.0d-31 )
         wmeda    = max ( widthmeda(k)  * as2pc, 1.0d-31 )
         wmedb    = max ( widthmedb(k)  * as2pc, 1.0d-31 )
         wmean    = max ( widthmean(k)  * as2pc, 1.0d-31 )
         wmeana   = max ( widthmeana(k) * as2pc, 1.0d-31 )
         wmeanb   = max ( widthmeanb(k) * as2pc, 1.0d-31 )
         wmeastd  = max ( widthstd(k)   * as2pc, 1.0d-31 )
         wmeastda = max ( widthstda(k)  * as2pc, 1.0d-31 )
         wmeastdb = max ( widthstdb(k)  * as2pc, 1.0d-31 )
!!         if (snrwmea(k) .gt. 1.0d0) then
           write (66,'(i5,3(1pe11.3),1x,9(1pe11.3),i5,1x,5(1pe11.3))') k, flenas, wmedas, flength, wmed, wmeda, wmedb, wmean, wmeana
     &              , wmeanb, wmeastd, wmeastda, wmeastdb, nptw(k), snrwmea(k), snrwmeaa(k), snrwmeab(k), crestmed(k), creststd(k) 
!!         endif
       enddo
       close (66)

       if (cverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing linear densities '''//individprofs(1:indp)//'/'//outname(1:ion)//'~lindens.cat'//''''
     
       open ( 66, file=individprofs(1:indp)//'/'//outname(1:ion)//'~lindens.cat', status='unknown' )
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '#'//getstitle(2:)
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (66,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
       write (66,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (66,'(a)') '#'
       write (66,'(a)') '# CATALOG OF AVERAGE LINEAR DENSITIES AND MASSES'
       write (66,'(a)') '#'
       write (66,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (66,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (66,'(a)') '#'
       write (66,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
       write (66,'(a)') '#'
       write (66,'(a,i3)') '# Step over skeleton points for computing widths:', npxstep
       write (66,'(a,i2)') '# Window size over skeleton points for smoothing their coordinates:', 2*npw+1
       write (66,'(a)') '#'
       write (66,'(a)') '# TABULATED QUANTITIES:'
       write (66,'(a)') '#'
       write (66,'(a)') '#   NF ......... Number of a filament (skeleton) .............'
       write (66,'(a)') '#   LENGTH ..... Total filament (skeleton) length ............ pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   LINDENP .... Linear density: median integrated profile ... Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   LINDENPA ... Linear density: median integrated profile ... Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   LINDENPB ... Linear density: median integrated profile ... Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   LINDENM .... Linear density: FILMASS / LENGTH ............ Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   LINDENMA ... Linear density: FILMASSA / LENGTH ........... Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   LINDENMB ... Linear density: FILMASSB / LENGTH ........... Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   FILMASS .... Filament mass derived from both sides ....... Msun (FILMASSA + FILMASSB) / 2'
       write (66,'(a)') '#   FILMASSA ... Filament mass derived from the left side .... Msun'
       write (66,'(a)') '#   FILMASSB ... Filament mass derived from the right side ... Msun'
       write (66,'(a)') '#   LINDSTD .... Standard deviation about LINDENP ............ Msun/pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   SNRLIND .... Signal-to-noise ratio LINDENP / LINDSTD .....'
       write (66,'(a)') '#   CRESTMED ... Filament crest value on skeleton ............ image units; median'
       write (66,'(a)') '#   CRESTSTD ... Standard deviation about CRESTMED ........... image units'
       write (66,'(a)') '#'
       write (66,'(a)') '#  NF    LENGTH     LINDENP    LINDENPA   LINDENPB    LINDENM    LINDENMA   LINDENMB    FILMASS'
     &                //'    FILMASSA   FILMASSB    LINDSTD    SNRLIND    CRESTMED   CRESTSTD'
       write (66,'(a)') '#'
       do k=1,nextr
         flength   = max ( length(k) * as2pc, 1.0d-31 )
         flindenp  = max ( lindenp(k)  * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         flindenpa = max ( lindenpa(k) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         flindenpb = max ( lindenpb(k) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         flindstd  = max ( lindstd(k)  * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         flindenm  = max ( lindenm(k)  * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         flindena  = max ( lindenma(k) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         flindenb  = max ( lindenmb(k) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
         filmassa  = max ( filamasa(k) * (au2cm * distpc)**2 / xMsun, 1.0d-31 )
         filmassb  = max ( filamasb(k) * (au2cm * distpc)**2 / xMsun, 1.0d-31 )
         filmass   = max ( filamass(k) * (au2cm * distpc)**2 / xMsun, 1.0d-31 )
!!         if (snrlind(k) .gt. 1.0d0) then
           write (66,'(i5,1pe11.3,3(1x,3(1pe11.3)),1x,4(1pe11.3))') k, flength, flindenp, flindenpa, flindenpb, flindenm, flindena
     &                                    , flindenb, filmass, filmassa, filmassb, flindstd, snrlind(k), crestmed(k), creststd(k)
!!         endif
       enddo
       close (66)

       if (cverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing smoothed curvatures '''//individprofs(1:indp)//'/'//outname(1:ion)//'~curva.cat'//''''
     
       open ( 66, file=individprofs(1:indp)//'/'//outname(1:ion)//'~curva.cat', status='unknown' )
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '#'//getstitle(2:)
       write (66,'(a)') cbars
       write (66,'(a)') '#'
       write (66,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (66,'(a)') '# Alexander Men''shchikov, DAp IRFU CEA Saclay, France.'
       write (66,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (66,'(a)') '#'
       write (66,'(a)') '# CATALOG OF AVERAGED (SMOOTHED) CURVATURES'
       write (66,'(a)') '#'
       write (66,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (66,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (66,'(a)') '#'
       write (66,'(a)') '# Distance: '//cdistpc(1:idp)//' pc (if the actual distance is different, quantities can be scaled)'
       write (66,'(a)') '#'
       write (66,'(a,i2)') '# Step over skeleton points for computing curvatures:', 1
       write (66,'(a,i2)') '# Window size over skeleton points for smoothing their coordinates:', 2*npw+1
       write (66,'(a)') '#'
       write (66,'(a)') '# TABULATED QUANTITIES:'
       write (66,'(a)') '#'
       write (66,'(a)') '#   NF .......... Number of a filament (skeleton) ...........'
       write (66,'(a)') '#   LENGTH ...... Total filament (skeleton) length .......... pc (at '//cdistpc(1:idp)//' pc)'
       write (66,'(a)') '#   CURVTOTAL ... Filament total smoothed curvature ......... CURVTOTAL = sum ( |CURV| * DS ),'
     &                //' CURV = ( DXDT * D2YDT2 - DYDT * D2XDT2 ) / sqrt ( DXDT^2 + DYDT^2 )^3'
       write (66,'(a)') '#   CURVMEDI .... Filament median smoothed curvature ........ 1/arcsec'
       write (66,'(a)') '#   CURVMEAN .... Filament mean smoothed curvature .......... 1/arcsec'
       write (66,'(a)') '#   CURVSTD ..... Standard deviation about CURVMEAN ......... 1/arcsec'
       write (66,'(a)') '#   NPTC ........ Number of points used for CURVSTD .........'
       write (66,'(a)') '#   CRESTMED .... Median filament crest value on skeleton ... image units'
       write (66,'(a)') '#   CRESTSTD .... Standard deviation about CRESTMED ......... image units'
       write (66,'(a)') '#'
       write (66,'(a)') '#  NF    LENGTH    CURVTOTAL   CURVMEDI   CURVMEAN   CURVSTD  NPTC   CRESTMED   CRESTSTD'
       write (66,'(a)') '#'
       do k=1,nextr
         flength = max ( length(k) * as2pc, 1.0d-31 )
         write (66,'(i5,1pe11.3,1x,4(1pe11.3),i5,2(1pe11.3))') k, flength, curvtota(k), curvmedi(k), curvmean(k), curvstd(k)
     &                                                         , navc(k), crestmed(k), creststd(k)
       enddo
       close (66)

       do k=1,nextr
         do l=1,np(k)
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           normals(i,j) = dble ( k )
         enddo
       enddo

       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (normals(i,j) .gt. datamax) datamax = normals(i,j)
           if (normals(i,j) .lt. datamin) datamin = normals(i,j)
         enddo
       enddo

       filename = individimages(1:indi)//'/'//outname(1:ion)//'~normals.fits'
       ipn = lastc ( filename )

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing normals '''//filename(1:ipn)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, normals, dx, dy, object, crval1
     &            , crval2, filename(1:ipn), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )
  
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (foota(i,j) .gt. datamax) datamax = foota(i,j)
           if (foota(i,j) .lt. datamin) datamin = foota(i,j)
         enddo
       enddo
  
       filename = individimages(1:indi)//'/'//outname(1:ion)//'~footsa.fits'
       ipn = lastc ( filename )
  
       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing filament footprints '''//filename(1:ipn)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, foota, dx, dy, object, crval1
     &            , crval2, filename(1:ipn), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )

       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (footb(i,j) .gt. datamax) datamax = footb(i,j)
           if (footb(i,j) .lt. datamin) datamin = footb(i,j)
         enddo
       enddo
  
       filename = individimages(1:indi)//'/'//outname(1:ion)//'~footsb.fits'
       ipn = lastc ( filename )
  
       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing filament footprints '''//filename(1:ipn)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, footb, dx, dy, object, crval1
     &            , crval2, filename(1:ipn), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )

       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           worker(i,j) = foota(i,j) + footb(i,j)
           if (footb(i,j) .gt. datamax) datamax = worker(i,j)
           if (footb(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo
  
       filename = individimages(1:indi)//'/'//outname(1:ion)//'~foots.fits'
       ipn = lastc ( filename )
  
       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing filament footprints '''//filename(1:ipn)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipn), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )
  
       deallocate ( widthmean, widthmeana, widthmeanb, widthmed, widthmeda, widthmedb, widthstd, widthstda, widthstdb, normals
     &            , foota, footb )

       do j=1,ny
         do i=1,nx
           worker(i,j) = 0.0d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           if (curvsmoo(k,l) .lt. 9.99d+30) then
             worker(ia,ja) = curvsmoo(k,l)
           endif
         enddo
       enddo
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (worker(i,j) .gt. datamax) datamax = worker(i,j)
           if (worker(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo

       filename = individimages(1:indi)//'/'//outname(1:ion)//'~curvsmo.fits'
       ipd = lastc ( filename )

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing smoothed curvatures '''//filename(1:ipd)//''''

       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )
     
       do j=1,ny
         do i=1,nx
           worker(i,j) = -0.1d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           worker(ia,ja) = curvtota(k)
         enddo
       enddo
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (worker(i,j) .gt. datamax) datamax = worker(i,j)
           if (worker(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo

       filename = individimages(1:indi)//'/'//outname(1:ion)//'~curvtot.fits'
       ipd = lastc ( filename )

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing total curvatures '''//filename(1:ipd)//''''

       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )
     
       do j=1,ny
         do i=1,nx
           worker(i,j) = -0.1d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           worker(ia,ja) = curvmean(k)
         enddo
       enddo
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (worker(i,j) .gt. datamax) datamax = worker(i,j)
           if (worker(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo
  
       filename = individimages(1:indi)//'/'//outname(1:ion)//'~curvmea.fits'
       ipd = lastc ( filename )
  
       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing mean curvatures '''//filename(1:ipd)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )
 
       do j=1,ny
         do i=1,nx
           worker(i,j) = 0.0d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           if (sangle(k,l) .ge. 0.0d0) then
             worker(ia,ja) = sangle(k,l)
           else
             worker(ia,ja) = max ( 180.0d0 + sangle(k,l), 0.0d0 )
           endif
         enddo
       enddo
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (worker(i,j) .gt. datamax) datamax = worker(i,j)
           if (worker(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo
  
       filename = individimages(1:indi)//'/'//outname(1:ion)//'~angles.fits'
       ipd = lastc ( filename )
  
       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing skeleton angles '''//filename(1:ipd)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )

       do j=1,ny
         do i=1,nx
           worker(i,j) = 0.0d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           flindena = max ( lindena(k,l) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
           flindenb = max ( lindenb(k,l) * (au2cm * distpc)**2 / xMsun / as2pc, 1.0d-31 )
           worker(ia,ja) = flindena + flindenb
         enddo
       enddo
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (worker(i,j) .gt. datamax) datamax = worker(i,j)
           if (worker(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo
  
       filename = individimages(1:indi)//'/'//outname(1:ion)//'~lindens.fits'
       ipd = lastc ( filename )
  
       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing linear densities '''//filename(1:ipd)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )
  
! Smooth filament widths by median-filtering with a sliding window of 2*NPW+1 pixels along skeleton.

       npwm = 5

       allocate ( widsmo(2*npwm+1), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (62).'
         stop 62
       endif

       do j=1,ny
         do i=1,nx
           worker(i,j) = 0.0d0
         enddo
       enddo
       do k=1,nextr
!!         if (snrwmea(k) .gt. 1.0d0) then
           do l=1,np(k)
             ia = nint ( xpixmean(k,l) )
             ja = nint ( ypixmean(k,l) )
             npa = 0
             do ll=max(l-npwm,1),min(l+npwm,np(k))
               if (width(k,ll) .gt. 0.0d0) then
                 npa = npa + 1
                 widsmo(npa) = width(k,ll)
               endif
             enddo
             if (npa .gt. 0) then
               worker(ia,ja) = selectk ( (npa + 1) / 2, npa, widsmo )
             else
               worker(ia,ja) = 0.0d0
             endif
           enddo
!!         endif
       enddo
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (worker(i,j) .gt. datamax) datamax = worker(i,j)
           if (worker(i,j) .lt. datamin) datamin = worker(i,j)
         enddo
       enddo

       filename = individimages(1:indi)//'/'//outname(1:ion)//'~widths.fits'
       ipd = lastc ( filename )

       if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing filament widths '''//filename(1:ipd)//''''
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &            , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &            , equinox, bzero, bscale, wave, datamin, datamax, history )

       if (ldebug) then
         do j=1,ny
           do i=1,nx
             worker(i,j) = 0.0d0
           enddo
         enddo
         do k=1,nextr
!!           if (snrwmea(k) .gt. 1.0d0) then
             do l=1,np(k)
               ia = nint ( xpixmean(k,l) )
               ja = nint ( ypixmean(k,l) )
               npa = 0
               do ll=max(l-npwm,1),min(l+npwm,np(k))
                 if (width(k,ll) .gt. 0.0d0) then
                   npa = npa + 1
                   widsmo(npa) = width(k,ll)
                 endif
               enddo
               if (npa .gt. 0) then
                 beam = selectk ( (npa + 1) / 2, npa, widsmo )
                 hwhm = beam / 2.0d0
                 sigm2g = hwhm**2 / log ( 4.0d0 )
                 do j=1,ny
                   dely = (dble ( j - ja ) * dy)**2
                   do i=1,nx
                     rad2 = (dble ( i - ia ) * dx)**2 + dely
                     argex = min ( rad2 / (2.0d0 * sigm2g), 100.0d0 )
                     worker(i,j) = max ( worker(i,j), imagefil(ia,ja) * exp ( -argex ) )
                   enddo
                 enddo
               endif
             enddo
!!           endif
         enddo
         datamin =  1.0d+30
         datamax = -1.0d+30
         do j=1,ny
           do i=1,nx
             if (worker(i,j) .gt. datamax) datamax = worker(i,j)
             if (worker(i,j) .lt. datamin) datamin = worker(i,j)
           enddo
         enddo
  
         filename = individimages(1:indi)//'/'//outname(1:ion)//'~shapes.fits'
         ipd = lastc ( filename )
         
         if (cverbose .eq. '-verb2') write (iotty,'(a)') '   Writing filament shapes '''//filename(1:ipd)//''''
         
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy, object, crval1
     &              , crval2, filename(1:ipd), cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21, cd22
     &              , equinox, bzero, bscale, wave, datamin, datamax, history )
       endif

       deallocate ( widsmo )
       deallocate ( np, npixfil, xpixok, ypixok, iwidth, ihwidtha, ihwidthb, hwidtha, hwidthb, xpixmean, ypixmean, length, cosa
     &            , sina, cosb, sinb, sangle, nanglea, nangleb, curvature, curvmean, curvstd, navc, nptw, curvtota, curvmedi, funmed
     &            , curvsmoo, width, worker, imagefil, imageske, crestmed, creststd, nptwa, nptwb, lindentwo, lindenm, lindenma
     &            , lindenp, lindstd, filamass, snrwmea, snrwmeaa, snrwmeab, snrlind, widtha, widthb, sinx, cosx, lindena, lindenb
     &            , filamasa, filamasb, lindenmb, lindenpa, lindenpb, lindentwa, lindentwb )

 999   continue
       if (nextr .gt. 0) then
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') ' Done.'
       else
         if (cverbose .eq. '-verb2') write (iotty,'(/a)') ' Nothing to do: no filaments found'
       endif

!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine slopes

     &            ( npts, rad, profile, profilestd, nwin, slope, slopemax, almostzero )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       lsdone
       integer       m, mm, nm, j, npts, nsmax
       integer       nwin(npts)
       real*8        slopemean, dlogr, slopemax, almostzero, selectk !! ,rflg
       real*8        rad(npts), profile(npts), profilestd(npts), slope(npts), slo(npts), slom(npts)
       external      selectk
!__________________________________________________________________________________________________________________________________
!
       if (npts .gt. 1) then
         do m=2,npts-1
!!           dlogr = log ( rad(m+1) ) - log ( rad(m-1) )
!!           slope(m) = (log ( profile(m-1) ) - log ( profile(m+1) )) / dlogr
           dlogr = log ( rad(m) ) - log ( rad(m-1) )
           slope(m) = - (log ( profile(m) ) - log ( profile(m-1) )) / dlogr
         enddo
         slope(1) = slope(2)
         slope(npts) = slope(npts-1)

! Make the window cover a factor of rflg in radial distance.

!!         rflg = 0.1d0
         do m=1,npts
!!           dlogr = log ( rad(m+1) ) - log ( rad(m) )
!!           nwin(m) = nint ( rflg / dlogr / 2.0d0 ) 
           nwin(m) = 7
         enddo

! Smooth the slopes by median filtering.

         do m=1,npts
           nm = 0
           do j=max(m-nwin(m),1),min(m+nwin(m),npts)
             nm = nm + 1
             slo(nm) = slope(j)
           enddo
           if (nm .ge. 1) then
             slom(m) = selectk ( (nm + 1) / 2, nm, slo )
           else
             slom(m) = slope(m)
           endif
         enddo

!!         do m=1,npts
!!           slope(m) = slom(m)
!!         enddo

         lsdone = .false.
         nsmax = 0
         slopemax = -1.0d30
         slopemean = 0.0d0

         do m=1,npts
           
! Find the steepest slope and its radial point.
           
           if (slom(m) .gt. 1.0d0 .and. slom(m) .gt. slopemax) then
             slopemax = slom(m)
             nsmax = m
           endif

! Find the average slope between the point of the steepest slope and the current radial point.
           
           if (nsmax .gt. 0 .and. .not.lsdone) then
             slopemean = 0.0d0
             do mm=nsmax,m
               slopemean = slopemean + slom(mm)
             enddo
             slopemean = slopemean / dble ( m - nsmax + 1 )
           endif

! Determine the last radial point of the normal and radial profile, signaled by a small value of profilestd(m) = 1.0d-31.

           if ((slopemean .gt. 1.0d0 .and. slom(m) .lt. slopemean / 10.0d0) .or. profile(m) .lt. almostzero .or. 
     &         slom(m) .lt. -0.5d0 .or. lsdone) then
             lsdone = .true.
             profilestd(m) = 1.0d-31
           else
             slope(m) = slopemean
           endif
         enddo
       endif

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, iotty, iolog, creator
     &            , beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamn, datamx
     &            , history, cverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, bunit, object, history, cverbose
       character*3   cnan
       character*25  cdatetime
       character*80  comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, iotty, iolog, maxdim, rw
     &             , nfound, blank, stat05, stat06, stat07, stat08, stat09, stat10, stat11, stat12, stat13, stat14, stat15, stat16
     &             , stat17, stat18, stat19, stat20, stat21, stat22, stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30
     &             , stat31, stat32, stat0
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22, almostzero, as2deg, datamx, datamn, sign1, arg1, arg2, argm
     &             , sinrota, cosrota, pi, angle
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr, ftgkyj, ftg2dd
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

!!       call ftgphx ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, bscale, bzero, blank, nblank, stat )

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:21) .eq. 'Alexander Menshchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'FMEASURE'
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. 
! Maybe there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat0 = stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15 + stat16 + stat17 + stat18
     &       + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28 + stat30 + stat31

       if (cverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = '<Name>'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       if (stat17 .ne. 0) then
         rot2 = 0.0d0
       endif
       rot1 = rot2

       if (stat29 .eq. 0 .and. stat30 .ne. 0) then
         equinox = epoch
       endif

! CDELT* is absent or error.

       if (stat24 .ne. 0 .or. stat25 .ne. 0) then

! CD1* and CD2* are defined correctly: determine CDELT* and ROTA*.

         if (stat18 .eq. 0 .and. stat19 .eq. 0 .and. stat20 .eq. 0 .and. stat21 .eq. 0) then
           sign1 = sign ( 1.0d0, cd11 * cd22 - cd12 * cd21 )
           dxdeg = sign1 * sqrt ( cd11**2 + cd21**2 )
           dydeg = sqrt ( cd12**2 + cd22**2 )
           arg1 = sign1 * cd12 / cd22
           arg2 = -sign1 * cd21 / cd11
           argm = (arg1 + arg2) / 2.0d0
           if (abs ( arg1 - arg2 ) / argm .gt. 1.0d-10) then
             write (iotty,'(/a/)') '   RFITS: WARNING: Coordinate axes are not orthogonal'
           endif
           rot2 = atan ( argm )
           sinrota = sin ( rot2 )
           cosrota = cos ( rot2 )
           rot2 = rot2 * 180.0d0 / pi
           if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
             rot1 = rot2
           elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
             rot1 = 180.0d0 - rot2
           elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
             rot1 = 180.0d0 + rot2
           elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
             rot1 = - rot2
           endif
           rot2 = rot1
         endif
       endif

! CD1* and CD2* are absent or error.

       if (stat18 .ne. 0 .or. stat19 .ne. 0 .or. stat20 .ne. 0 .or. stat21 .ne. 0) then

! CDELT* are defined correctly: determine CD1* and CD2*.

         if (stat24 .eq. 0 .and. stat25 .eq. 0) then
           angle = rot2 * pi / 180.0d0
           cd11 = dxdeg * cos ( angle )
           cd12 = abs ( dydeg ) * sign ( 1.0d0, dxdeg ) * sin ( angle )
           cd21 = - abs ( dxdeg ) * sign ( 1.0d0, dydeg ) * sin ( angle )
           cd22 = dydeg * cos ( angle )
           if (abs ( cd12 ) .lt. almostzero) cd12 = 0.0d0
           if (abs ( cd21 ) .lt. almostzero) cd21 = 0.0d0
         endif
       endif

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       cnan = 'NAN'
       do j=1,ny
         do i=1,nx
           if (.not.isnan ( fun(i,j) )) then  
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
           if (int ( fun(i,j) ) .eq. blank .and. blank .ne. 0) then  
             read (cnan,*) fun(i,j)
           endif
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, cdate, ctime
     &            , creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, equinox, bzero, bscale, wave, datamn, datamx
     &            , history )
!__________________________________________________________________________________________________________________________________
!
! GETSF • Multi-Scale Multi-Wavelength Source & Filament Extraction • Alexander Men'shchikov, DAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, rot1, rot2, equinox, datamn
     &             , datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      fdelete, ftgiou, ftinit, ftphpr, ftpkys, ftpcom, ftpkyd, ftpkyj, ftphis, ftp2dd, ftclos, ftfiou, printerr
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           if (.not.isnan ( fun(i,j) )) then
             if (fun(i,j) .lt. datamn ) datamn = fun(i,j)
             if (fun(i,j) .gt. datamx ) datamx = fun(i,j)
           endif
         enddo
       enddo

! When packing numbers using the formulas below, I got values of the function different in the 5-th digit from DATAMIN and
!  DATAMAX placed in the header when writing the data. From now on I will use bzero = 0 bscale = 1 and bitpix = -32, as these
! seem to cure the problem.

cc!      bitpix = 16
cc!      bzero  = 0.5d0 * (funmin + funmax)
cc!      bscale = dabs ( funmax - bzero ) / 32767.0d0

       bitpix = -32     !<-- single precision floating-point values
       bzero  = 0.0d0
       bscale = 1.0d0
       blank = blank

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Menshchikov, DAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = - dx * as2deg
       dydeg = dy * as2deg

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
!!       if  (blank .gt. 0)
!!     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , dxdeg , 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, 'equinox', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||